	MODULE conncalc_parms
! ==========================================================
!   Array and global variable declarations
!	for sincalc
! ==========================================================
	implicit none
	integer,dimension(:),   allocatable :: ntypat,nzt
	integer,dimension(:),   allocatable :: kx,ky,kz
	integer,dimension (:,:,:),allocatable :: lattice
	real,dimension (:),     allocatable :: hit_det,hitprob,hit_integral
	real,dimension (:),     allocatable :: x,y,z
	real,dimension (:),     allocatable :: sigx, sigy,sigz
	real,dimension (:),     allocatable :: sigx_1,sigy_1,sigz_1,sigxyz
	real,dimension (:),     allocatable :: sigma,bltot_int
	real,dimension (:),     allocatable :: d_max2,sc_imp_par,dmax2
	real,dimension (:),     allocatable :: rmt,vx,vy,vz,scthet
	real,dimension (:),     allocatable :: bltot,x_imp,y_imp,z_imp
	real,dimension (:,:),   allocatable :: deflection,blo_integral
    real,dimension (:,:,:), allocatable :: distri,shadow
	real,dimension (:,:), allocatable  :: blocking
!	,bllay, bltyp
	real::			 gauss(2001)
      	real		::   expon(0:25000)                     
	integer::		 arrdim(19),mode(8)
	real,dimension(2) :: 	x_shift,y_shift
	integer,dimension(2) :: lx,ly,lz
	character(80):: status_file,text
      	character(24):: hour
      	integer::		nat,nan,nel,ngx,ngy,ngz,nx1,ny1,nz1,iat,ian
      	integer::		zi,kxpr, kypr, kzpr,choice,iel,nzi,ntypov
	integer	::		numb,ndate
	real::			xper,yper
	real::			cor_cof, cor_dis, cor_red, cor_re3
	real::			cov,def_rms
	real::			phi, thet, thet2
	real::			nproj, npreal
	real::			zmin,zmax
	real::			fake_cs, real_cs
	real::			energy, el_loss_fac
	real::			rmi
	real::			degrad,pi
	real::			xpr, ypr, zpr
	real::			sinphi, cosphi, sinth, costh, tanth
	real::			coscos, cossin, sincos, sinsin
	real::			tancos, tansin,chthet,chphi
	real::			sico2, sisi2, coth2
	real::			e1, e2, isignx, isigny
	real::			last_atom, x_cor, y_cor
	real::			xr, yr, zr, d, u
	real::			xt, yt, zt,dmax
	real::			coulomb,scrlen,fluxc,fluxb,factor,step
	real::			cosp_beam, sinp_beam
	integer ::	    dot

	END MODULE conncalc_parms
	
	module conncalc_code
	private
	public conncalc
	contains
        SUBROUTINE CONNCALC(INPUT_NAME,OUTPUT_NAME)
!*******************************************************************************
!       H    H  EEEEEE   AAAA   DDDDD   LL      EEEEEE   SSSSS   SSSSS         *
!       H    H  E       A    A  D    D  LL      E       S       S              *
!       HHHHHH  EEEEEE  AAAAAA  D    D  LL      EEEEEE   SSSS    SSSS          *
!       H    H  E       A    A  D    D  LL      E            S       S         *
!       H    H  EEEEEE  A    A  DDDDD   LLLLLL  EEEEEE  SSSSS   SSSSS          *
!*******************************************************************************
!
!               nat                                     !Number of atoms
!               nel                                     !Number of elements
!               ngx                                     !Number of X-groups
!               ngy                                     !Number of Y-groups
!               ngz                                     !Number of Z-groups
!               nx1                                     ! ngx+1
!               ny1                                     ! ngy+1
!               nz1                                     ! ngz+1
!               nan                                     !Number of bl. angles

	use conncalc_parms
	implicit none
	INTEGER :: i,nprojtot,new,ntype,iu,iv,iud,iub,ierr
	real    :: cxu,cyu,czu,cxv,cyv,r,s,t,rst,o,p,q
	real    :: cos_scat,sin_scat
	real    :: sin_sc_1
	real    :: cxub,cyub,czub,cxud,cyud,czud,xv,yv,ww
	real    :: xud,yud,zud,xub,yub,zub,centre,width
	integer :: iud_lo,iud_up,igz,igx,igy,iout
	real    :: disuw,chtot,chlay
	REAL    :: zmax1,trajec,e_old,scetmin,scthetc,flux
	real    :: cost_beam,sint_beam,coco_beam,cosi_beam
	real    :: sico_beam,sisi_beam
	real    :: rmit,scm_old	
	
	character(80)  :: input_name,output_name
	


!------------------------------------ START -----------------------------------*

        call fdate (hour)


        write (6, *) '---------------'					&
             ,' STATUS-REPORT OF "CONNCALC" RUN'		&
             ,' --------------'
        write (6, *) 'Inputfile:  '// input_name
        write (6, *) 'Outputfile: '// output_name
        write (6, *) hour								&
             , '  I''ve just begun.'


        pi = 4.*atan(1.)                                !Calculation of pi
        degrad = pi/180.                                !Degrees -> radians

        do i = 0,25000                                  !Production of the array
          expon(i) = exp(-(0.5+i)/125.)                 ! 'EXPON', which works
        end do                                          ! faster than exp(X)

	call gaussian
	call readin(input_name)
	call random_seed()


        lattice  = 0			                   !Blanking aux. lattice

        zmin		= 0.
        zmax1		= 0.

        if (mode(2) .eq. 1) then                        !Number of elements
          ntype = nel-1                                 ! in the crystalline
          do iat = 1,nat                                ! part of the substrate,
            if (ntypat(iat) .eq. ntypov) ntype = nel    ! not including the
          end do                                        ! amorphous overlayer.
        else
          ntype = nel
        end if

        do iat = 1,nat
          zmin = min (zmin, z(iat))                     !Minimum z-coordinate
          zmax1 = max (zmax1, z(iat))                   !Maximum z-coordinate
          lattice(kx(iat), ky(iat), kz(iat)) = iat      !Filling up aux. lattice
          sigx_1(iat) = 1./sigx(iat)                    !Inverse vibration amps.
          sigy_1(iat) = 1./sigy(iat)
          sigz_1(iat) = 1./sigz(iat)
          sigma(iat)  = sqrt(((sigx(iat))**2        &    !'Average' vibration
                     &     +(sigy(iat))**2          &    ! amplitude, used to
                     &     +(sigz(iat))**2)/3.)          ! scale flux meshes...
          sigxyz(iat) =							  &
     		   &   0.5/(pi*sigx(iat)*sigy(iat)*sigz(iat))  !For normalizing hit.pr.
        end do

        vx(nx1) = xper                                  !The first x,y planes
        vy(ny1) = yper                                  ! are repeated

        phi 		= phi*degrad                                !Conversion
        chthet  	= chthet*degrad                          ! degrees -> radians
        scthet(1) 	= scthet(1)*degrad
        step 		= step*degrad
        do ian = 1,nan
          scthet(ian) 	= scthet(1)+(ian-1)*step          !Scattering angles
        end do

        cosp_beam = cos(phi)                            !Beam goniometry
        sinp_beam = sin(phi)
        cost_beam = cos(chthet)
        sint_beam = sin(chthet)
        coco_beam = cost_beam*cosp_beam
        cosi_beam = cost_beam*sinp_beam
        sico_beam = sint_beam*cosp_beam
        sisi_beam = sint_beam*sinp_beam

!--------------------------------- SHADOWING ----------------------------------*
        hit_det		= 0.                            !Set hitt.probs. to zero
        if (mode(2) .eq. 1) then                        !Set rms. defl. angle in
          def_rms 	= 0.                            ! overlayer to zero
        end if
        ian 	= 0                                     !Scatt. angle nr. 'zero'
        chphi 	= phi                                   !Azimuthal angle of beam
        thet 	= chthet                                !Polar angle of beam
        scthetc = (scthet(1)+scthet(nan))*0.5           !Average scatt. angle
        thet2 	= thet+scthetc                          !Corresp. polar angle
        nproj 	= fluxc*xper*yper*cos(thet)             !Number of ch. ions
        el_loss_fac = 1.                                !Energy=primary energy
        e_old = 1.

        call potent                                     !Calc. deflection table
        call scat_imp (scthetc, sc_imp_par)             !Impact par. for backsc.

        trajec = zmax1/cos(thet)                        !Aver. trajectory length
        scetmin = 0.1/trajec                            !Minimum deflection
        scetmin = min (scetmin, 0.1*degrad)             ! angle which is to be
        scetmin = max (scetmin, 0.01*degrad)            ! properly treated
        scm_old = scetmin
        call scat_imp (scetmin, dmax2)                  !Maximum imp. parameter
        do iel = 1,nel
          dmax = max(dmax, dmax2(iel))
          dmax2(iel) = 1./(dmax2(iel)**2)
        end do
        zmax = zmax1+dmax                               !Calculation depth
        vz(nz1) = zmax

        call track                                      !Actual calculation

        call fdate (hour)

        write (6, *) hour							&
             , '  Just finished the shadowing'		&
             , ' bit'

        flux = npreal/(xper*yper*cos(thet))             !Real flux
        nprojtot = npreal
        do iat = 1,nat
          hitprob(iat) = hit_det(iat)        &           !Hitting probabilities
                  &   *sigxyz(iat)           &           ! are normalized
                  &   /(fake_cs*flux)
          hit_det(iat) = 0.
        end do

! --------------------- INTEGRATION OVER CIRCLES ---------------------------
        do iu = -40,40                                  !Shadowing flux is
          do iv = -40,40                                ! normalized
            do iat = 1,nat
              shadow(iat, iv, iu) = distri(iat, iv, iu)	&
                                /(fake_cs*flux			&
                                *(0.1*sigma(iat))**2)
            end do
          end do
        end do
        do iat = 1,nat                                  !INTEGRATE OVER 2D-MESH
          hit_integral(iat) = shadow(iat, 0, 0)         !Centre of mesh
          cxu = coco_beam*sigma(iat)*sigx_1(iat)        !constants
          cyu = cosi_beam*sigma(iat)*sigy_1(iat)
          czu =-sint_beam*sigma(iat)*sigz_1(iat)
          cxv =-sinp_beam*sigma(iat)*sigx_1(iat)
          cyv = cosp_beam*sigma(iat)*sigy_1(iat)
          r   = sico_beam*sigx_1(iat)
          s   = sisi_beam*sigy_1(iat)
          t   = cost_beam*sigz_1(iat)
          rst = 1./sqrt(r*r+s*s+t*t)
          r   = r*rst
          s   = s*rst
          t   = t*rst
          do iu = 1,40
            o = iu*cxu
            p = iu*cyu
            q = iu*czu
            hit_integral(iat) = hit_integral(iat)   &    ! Lines:
           +expo(o**2+p**2+q**2-(o*r+p*s+q*t)**2)	  &
          *(shadow(iat, 0, iu)                      & !  v=0
           +shadow(iat, 0,-iu))
            o = iu*cxv
            p = iu*cyv
            hit_integral(iat) = hit_integral(iat)   &
           +expo(o**2+p**2-(o*r+p*s)**2)			  &
          *(shadow(iat, iu, 0)                      & !  u=0
           +shadow(iat,-iu, 0))
            do iv = 1,maxmin(sqrt(40.5**2-iu**2))
              o = iu*cxu+iv*cxv
              p = iu*cyu+iv*cyv
              q = iu*czu
              hit_integral(iat) = hit_integral(iat) &    ! 4 remaining sections
             +expo(o**2+p**2+q**2-(o*r+p*s+q*t)**2) &    !  of circle around iat:
            *(shadow(iat, iv, iu)                   &    !  u>0  v>0
             +shadow(iat,-iv,-iu))                       !  u<0  v<0
              o = iu*cxu-iv*cxv
              p = iu*cyu-iv*cyv
              hit_integral(iat) = hit_integral(iat) &
             +expo(o**2+p**2+q**2-(o*r+p*s+q*t)**2) & 
            *(shadow(iat,-iv, iu)                   & !  u>0  v<0
             +shadow(iat, iv,-iu))                    !  u<0  v>0
            end do
          end do
          hit_integral(iat) = hit_integral(iat)	  &
                           *rst*sigxyz(iat)		  &
                           *(0.1*sigma(iat))**2
         end do

!----------------------------------- BLOCKING ---------------------------------
        phi = phi+pi                                    !Azimuth changed by pi
        thet2 = pi-chthet                               !Polar angle of beam
        rmit = rmi+rmt(ntypat(nat))                     !Ion mass + target mass

        do ian = 1, nan                                 !Loop over det. angles
          thet = thet2-scthet(ian)                      !Polar angle of detector
          nproj = fluxb*xper*yper*cos(thet)             !Number of bl. ions
          el_loss_fac = (rmi*cos(scthet(ian))/rmit  &   !Elastic
       +sqrt((rmi*cos(scthet(ian))/rmit)**2.        &   ! energy loss
       +(rmt(ntypat(nat))-rmi)/rmit))**2.               !  factor
          if (abs(el_loss_fac-e_old) .gt. 0.02) then
            call potent                                 !New deflection angles
            e_old = el_loss_fac
            new = 1
          else
            new = 0
          end if
          call scat_imp (scthet(ian), sc_imp_par)       !Impact par. for backsc.
          trajec = zmax1/cos(thet)
          scetmin = 0.1/trajec                          !See shadowing part
          scetmin = min (scetmin, 0.1*degrad)           ! for comments.
          scetmin = max (scetmin, 0.01*degrad)
          if (abs(scetmin-scm_old) .gt. 0.01*degrad  &
                       .or. new .eq. 1) then
            call scat_imp (scetmin, dmax2)
            do iel = 1,nel
              dmax = max(dmax, dmax2(iel))
              dmax2(iel) = 1./(dmax2(iel)**2)
            end do
            scm_old = scetmin
            zmax = zmax1+dmax
            vz(nz1) = zmax
          end if

           distri = 0.0                !Clear flux distribution

          call track                                    !Actual calculation

          call fdate (hour)

          write (6, *) hour							 &
             , '  Ready with blocking angle    '		 &
             ,ian

          flux = npreal/(xper*yper*cos(thet))
          nprojtot = nprojtot+npreal
          do iat = 1,nat
            blocking(iat, ian) = hitprob(iat)          & !Backscattering signal
                              *hit_det(iat)            & ! = hitting probability
                              *sigxyz(iat)             & ! * detect. probability
                             /(fake_cs*flux)
            hit_det(iat) = 0.
          end do

!-------------------------- INTEGRATION OVER SPHERES --------------------------*
          cos_scat = cos(scthet(ian))
          sin_scat = sin(scthet(ian))
          sin_sc_1 = 1./sin_scat

          do iu = -40,40                                !Detection 'flux' is
            do iv = -40,40                              ! 'normalized'...
              do iat = 1,nat                            ! such that combined
                distri(iat, iv, iu) =              &     ! with the beam flux it
               distri(iat, iv, iu)                 &  ! gives a normalized
               *sigxyz(iat)*0.1*sigma(iat)         &  ! result.
               /(sqrt(2.*pi)*sin_scat*fake_cs*flux)
              end do
            end do
          end do

          do iat = 1,nat                                !INTEGRATE OVER 3D-MESH
          blo_integral(iat, ian) =                 &     ! Centre point
          shadow(iat ,0 ,0)						 &
         *distri(iat ,0 ,0)
            cxub = (coco_beam                      &     ! constants
                +sico_beam*cos_scat*sin_sc_1)		 &
                *sigma(iat)*sigx_1(iat)
            cyub = (cosi_beam						 &	
                +sisi_beam*cos_scat*sin_sc_1)		 &
                *sigma(iat)*sigy_1(iat)
            czub =(-sint_beam						 & 
                +cost_beam*cos_scat*sin_sc_1)		 &
                *sigma(iat)*sigz_1(iat)
            cxud = -sico_beam*sin_sc_1			 &
                *sigma(iat)*sigx_1(iat)
            cyud = -sisi_beam*sin_sc_1			 &
                *sigma(iat)*sigy_1(iat)
            czud = -cost_beam*sin_sc_1			 &
                *sigma(iat)*sigz_1(iat)
            cxv  = -sinp_beam*sigma(iat)*sigx_1(iat)
            cyv  =  cosp_beam*sigma(iat)*sigy_1(iat)
            do iv = 1,40
              xv = iv*cxv
              yv = iv*cyv
              blo_integral(iat, ian) =             &     ! line:	
             blo_integral(iat, ian)				 &
             +expo(xv**2+yv**2)*					 &
             (shadow(iat, iv, 0)                   &  !  ub=0  ud=0
             *distri(iat, iv, 0)					 &
             +shadow(iat,-iv, 0)					 &
             *distri(iat,-iv, 0))
            end do
            do iud = 1,maxmin(40.*sin_scat)
              ww = (iud*sin_sc_1)**2
              xud = iud*cxud
              yud = iud*cyud
              zud = iud*czud
              blo_integral(iat, ian) =             &     ! line:
             blo_integral(iat, ian)				 &
             +expo(xud**2+yud**2+zud**2)			 &
             *shadow(iat, 0, 0)                    &  !  ub=0  v=0
            *(distri(iat, 0, iud)					 &
             +distri(iat, 0,-iud))
              do iv = 1,maxmin(					 &	
                     sqrt(max(0., 1600.-ww)))
                xv = iv*cxv
                yv = iv*cyv
                blo_integral(iat, ian) =           &     ! 4 sections of circle
               blo_integral(iat, ian)				 &
               +expo((xud+xv)**2                   &  !  in plane ub=0:
                    +(yud+yv)**2+zud**2)			 &
              *(shadow(iat, iv, 0)                 &  !  ud>0  v>0
              *distri(iat, iv, iud)				 &
               +shadow(iat,-iv, 0)                 &  !  ud<0  v<0
               *distri(iat,-iv,-iud))				 &
               +expo((xud-xv)**2					 &
                    +(yud-yv)**2+zud**2)			 &
              *(shadow(iat, iv, 0)                 &  !  ud<0  v>0
               *distri(iat, iv,-iud)				 &
               +shadow(iat,-iv, 0)                 &  !  ud>0  v<0
               *distri(iat,-iv, iud))
              end do
            end do
            do iub = 1,40
              xub = iub*cxub
              yub = iub*cyub
              zub = iub*czub
              centre = iub*cos_scat
              width  = sin_scat*sqrt(1600.-iub**2)
              iud_lo = max(-40, nint(centre-width))
              iud_up = min( 40, nint(centre+width))
              do iud = iud_lo,iud_up
                xud = iud*cxud
                yud = iud*cyud
                zud = iud*czud
                ww = ((iud-iub*cos_scat)*sin_sc_1)**2
                disuw = iub**2+ww
                blo_integral(iat, ian) =           &     ! 2 sections of circle
               blo_integral(iat, ian)				 &
               +expo((xub+xud)**2+(yub+yud)**2     &  !  in plane v=0:
                    +(zub+zud)**2)				 &
              *(shadow(iat, 0, iub)                &  !  ub>0  ud>0
               *distri(iat, 0, iud)				 &
               +shadow(iat, 0,-iub)                &  !  ubz0  ud<0
               *distri(iat, 0,-iud))
                do iv = 1,maxmin(					 &
               sqrt(max(0., 1600.-disuw)))
                  xv = iv*cxv
                  yv = iv*cyv
                  blo_integral(iat, ian) =         &     ! 4 remaining sections
                 blo_integral(iat, ian)			 &
                 +expo((xub+xud+xv)**2             &  !  of sphere around iat:
                      +(yub+yud+yv)**2			 &
                      +(zub+zud)**2)				 &
                *(shadow(iat, iv, iub)             &  !  ub>0  ud>0  v>0
                 *distri(iat, iv, iud)			 &
                 +shadow(iat,-iv,-iub)             &  !  ub<0  ud<0  v<0
                 *distri(iat,-iv,-iud))			 &
                 +expo((xub+xud-xv)**2			 &
                      +(yub+yud-yv)**2			 &
                      +(zub+zud)**2)				 &
                *(shadow(iat, iv,-iub)             &  !  ub<0  ud<0  v>0
                 *distri(iat, iv,-iud)			 &
                 +shadow(iat,-iv, iub)             &  !  ub>0  ud>0  v<0
                 *distri(iat,-iv, iud))			 
                end do
              end do
            end do
          end do

        end do                                          !End loop det. angles

!------------------------------------- OUTPUT ---------------------------------*
70      continue

        open  (1, file = output_name, status = 'unknown')
        write (1, 100) mode, arrdim                   &    !General output
             , ndate, numb							&
             , input_name, output_name, text			&
             , nzi, rmi, energy, fluxc
        if (mode(1) .eq. 0) then
          write (1, 110) 'regular'
        else
          write (1, 110) 'random'
        end if
        write (1, 120) chthet/degrad, chphi/degrad
        if (mode(3) .eq. 0) then
          write (1, 130) 'Moliere'
        else
          write (1, 130) 'Biersack universal'
        end if
        write (1, 140)
        write (1, 150)
        do iel = 1, nel
          write (1, 160) iel, nzt(iel), rmt(iel)
        end do
        write (1, 170) xper, yper, factor
        if (mode(2) .eq. 1) then                        !Amorphous overlayer:
          def_rms = sqrt(def_rms/nprojtot)/degrad       ! rms deflection angle
          write (1, 190) cov, ntypov, def_rms
        end if
        write (1, 200)
        chtot = 0.                                      !Shadowing output
        do igz = 1, ngz
          chlay = 0.
          write (1, 210)
          do igx = 1, ngx
            do igy = 1, ngy
              iat = lattice(igx, igy, igz)
              if (iat .ne. 0) then
                write (1, 220) iat, ntypat(iat)		&
             , x(iat), y(iat), z(iat)					&
             , sigx(iat), sigy(iat), sigz(iat)		&
             , hit_integral(iat), hitprob(iat)		
                chlay = chlay+hit_integral(iat)		
              end if
            end do
          end do
          chlay = chlay/factor
          chtot = chtot+chlay
          write (1, 230) igz, chlay
        end do
        write (1, 240) ngz, chtot

        write (1, 250) fluxb                            !Blocking output

!        blmax = 0.
        do ian = 1,nan                                  !Loop over angles
          bltot(ian) = 0.
          bltot_int(ian) = 0.
!          do igz = 1, ngz
!            bllay(igz, ian) = 0.
!          end do
!          do iel = 1, nel
!            bltyp(iel, ian) = 0.
!          end do
          do iat = 1, nat
            bltot(ian) =							&
             bltot(ian)							&
             +blocking(iat, ian)
            bltot_int(ian) =						&
             bltot_int(ian)						&
             +blo_integral(iat, ian)
 !           bllay(kz(iat), ian) =					&
 !           bllay(kz(iat), ian)					&
 !            +blo_integral(iat, ian)
 !           bltyp(ntypat(iat), ian) =				&
 !            bltyp(ntypat(iat), ian)				&
 !            +blo_integral(iat, ian)
          end do
          bltot(ian) = bltot(ian)/factor
          bltot_int(ian) = bltot_int(ian)/factor
    !      blmax = max (blmax, bltot_int(ian))
    !      do igz = 1, ngz
    !        bllay(igz, ian) = bllay(igz, ian)/factor
    !      end do
    !      do iel = 1, nel
    !        bltyp(iel, ian) = bltyp(iel, ian)/factor
    !      end do
          do iout = 0, nat-1, 10
            if (iout .eq. 0) then 
             write (1, 270) scthet(ian)/degrad, bltot(ian),	&
             (blo_integral(iat, ian) 							&
             , iat = iout+1, min(nat, iout+10))
     	    end if
            if (iout .ne. 0) then 
             write (1, 280)									&
             (blo_integral(iat, ian)							&
             , iat = iout+1, min(nat, iout+10))
     	    end if 
          end do
        end do
!        blmax = 1.1*blmax
        close (1)                                       !End outputfile
80      continue

        write (6, *) '-----------------'						&
             , ' JOB SUCCESSFULLY COMPLETED'					&
             , ' -----------------'

        
		deallocate (x, y, z,STAT=ierr)
		if(ierr.eq.0) write(*,*) 'Deallocated x,y,x'
        deallocate (ntypat)
        deallocate (kx, ky, kz)           
        deallocate (sigx, sigy, sigz)       
        deallocate (sigx_1, sigy_1, sigz_1) 
        deallocate (sigxyz)
        deallocate (hit_det)              
        deallocate (hitprob)              
        deallocate (blocking)        
        deallocate (sc_imp_par,dmax2)           
        deallocate (nzt, rmt)        
        deallocate (vx, vy, vz) 
        deallocate (scthet)               
        deallocate (bltot)                
!		deallocate (bllay)                
!        deallocate (bltyp)
	deallocate (x_imp,y_imp,z_imp)           
	deallocate ( lattice )
	deallocate (deflection)
	deallocate (bltot_int)
	deallocate (sigma)
	deallocate (hit_integral)
	deallocate (distri)
	deallocate (shadow)
	deallocate (blo_integral)
	stop
!---------------------------- FORMAT STATEMENTS -------------------------------*
100     format  (1X, 8I2, 19I4											&
            ,/,/														&
            ,/, ' GENERAL INFORMATION:'									&
            ,/, ' --------------------'									&
            ,/, ' Output from CONNCALC dd ', I6, ' run ', I2, '.'		&
            ,/, ' Inputfile :  ', A										&
            ,/, ' Outputfile:  ', A										&
            ,/, ' Comment   :  ', A										&
            ,/,/														&
            ,/, ' BEAM PARAMETERS:'										&
            ,/, ' ----------------'									    &
            ,/, ' Ions with atomic number', I2						    &
              , ' , atomic mass', F6.3, ' and energy ', F6.1, ' keV'	&
            ,/, ' Flux = ', E8.3, ' ions/square angstrom.')
110     format  (   ' Ions impinge from ', A, ' starting positions.')
120     format  (   ' Polar angle (with respect to normal)   =  ', F7.2	&
             ,/, ' Azimuthal angle (with resp to x-axis)  =  ', F7.2)
130     format  (' ', A, ' scattering potential')
140     format  (   ' In and outgoing ion trajectories are CONNECTED: '	&
               , ' Output between (brackets) is for unconnected'		&
              , ' trajectories.')
150     format  (/														&
             ,/, ' TARGET PARAMETERS:'									&
             ,/, ' ------------------'									&
             ,/, ' Atom-type  atomic number  atomic mass')
160     format  (5X, I1, 13X, I2, 9X, F7.2)
170     format  (/, ' X-repeat distance =  ', F8.3						&
             ,/, ' Y-repeat distance =  ', F8.3							&
             ,/, ' Nr. of atoms per layer =', F6.1)
190     format  (/, ' An amorphous overlayer, containing', E10.2,		&
					' atoms/cm2'										&
               , ' of type ', I1,' covers the substrate.'				&
             ,/, ' Rms  deflection angle in overlayer = ',E10.2,		&
			 '  degree')
200     format  (/														&
             ,/, ' SHADOWING OUTPUT:'									&
             ,/, ' -----------------'									&
             ,/															&
             ,/, ' Atom Type     X        Y        Z      sigma-X'		&
               , ' sigma-Y sigma-Z             Hitting probability'		&
             ,/, ' ')														
210     format  (   ' -------------------------------------------------'&
              , '-------------')
220     format  (1X, I3, 4X, I1, 3(1X, F8.3), 2X, 3(2X, F6.3), 15X,		&
				F7.3, '(', F6.3, ')')								
230     format  (   ' -------------------------------------------------'&
               , '-------------'										&
             ,/, ' Hitting probability of layer ', I3, '  = ', F7.3		&
             ,/, ' ')
240     format  (   ' -------------------------------------------------'&
               , '-------------'										&
             ,/, ' Summed hitting probability('							&
               , I3, ' layers)  = ', F7.3)
250     format  (/,/,/,/,/                                              &  
            ,/, ' BLOCKING OUTPUT:'										&
            ,/, ' ----------------'										&
            ,/, ' ', E8.3, ' ions/sq.angst. per detection angle.'		&
            ,/,/														&
            ,/,  '  Angle   Total signal'								&
              ,'  atom 1    atom 2    atom 3    atom 4    atom 5  '		&
              , '  atom 6    atom 7    atom 8    atom 9    atom 10  '	&
             ,/, ' ',  ' (deg)     (layers)    ', 97('-')				&
             ,/, ' ')
270     format  (1X, F7.2, 3X, F7.3, 5X, 20(F7.3, 3X))
280     format  (23X, 20(F7.3, 3X))
		contains



        SUBROUTINE TRACK
!*******************************************************************************
!       TTTTTT  RRRRR    AAAA    CCCC   K    K                                 *
!         TT    R    R  A    A  C    C  K  KK                                  *
!         TT    RRRRR   AAAAAA  C       KKK                                    *
!         TT    R  R    A    A  C    C  K  KK                                  *
!         TT    R   RR  A    A   CCCC   K    K                                 *
!********************************************************************************
       use conncalc_parms	
       implicit none
	real    :: a,b,tanphi,cotphi,spread,ystart,xstart,zstart
	real    :: delx,dely,gonio,sgonio,delta,e11,e21
	real    :: z_i1,y_i1,x_i1,sinan,cosan,tasi1
	real    :: taco1,sisi1,sico1,cosi1,coco1
	real    :: tath1,sith1,sith2,coth1,coph1,siph1,random
	real    :: over,oversize,sico3,sisi3,coth3,v,t,tan_def,dur,dvr
	real    :: cosdef,dummy
	integer :: nover,new_dir,iover
	integer :: ix,iy,kxstrt,kystrt,numx,numy,isy1,isx1,dot1
	
       
!--------------------------- GENERAL INITIALIZATION ---------------------------*
        last_atom = 0
        siph1 = sin(phi)                        !phi = initial azimuthal angle
        coph1 = cos(phi)
        sith1 = sin(thet)                       !thet = initial polar angle
        coth1 = cos(thet)
        sith2 = sin(thet2)                      !thet2 = polar angle after
        coth2 = cos(thet2)                      ! backscattering
        tath1 = sith1/coth1
        coco1 = coth1*coph1
        cosi1 = coth1*siph1
        sico1 = sith1*coph1
        sisi1 = sith1*siph1
        sico2 = sith2*coph1
        sisi2 = sith2*siph1
        taco1 = tath1*coph1
        tasi1 = tath1*siph1
        dot1  = sign(1., coph1*cosp_beam  &      !dot is used in subr. 'impact'
                    +siph1*sinp_beam)        ! to know 'left' from 'right'
        isx1  = int(sign(1., coph1))            !Moving in pos/neg x-direction
        isy1  = int(sign(1., siph1))            !Moving in pos/neg y-direction
        cosan = sith1*sith2+coth1*coth2         !Cosine of initial scatt. angle
        sinan = sqrt(1.-cosan**2)               !Sine of initial scatt. angle
        x_i1 = (sico2-cosan*sincos)/sinan       !Unit vector in the direction of
        y_i1 = (sisi2-cosan*sinsin)/sinan       ! the (initial) impact parameter
        z_i1 = (coth2-cosan*costh )/sinan       ! for backscattering
        fake_cs = 1./((cosan-1.)**2)            !CS = (sine(scatt.ang./2.))**-4
        x_shift(1) = 0.
        y_shift(1) = 0.
        e11 = abs(taco1)                        !X-comp/Z-comp of initial veloc.
        e21 = abs(tasi1)                        !Y-comp/Z-comp of initial veloc.

        if (e11 .gt. 1. .or. e21 .gt. 1.) then  !Initial z-coord. of track for
          zstart = zmin-dmax/sith1              ! start in x- or y-direction
        else                                    ! and for
          zstart = 0.                           ! start in z-direction
        end if

!       Projection of amorphous overlayer perpendicular to the beam. The full
!       overlayer is divided into 'nover' layers with a density of approximately
!       1 atom per 2.5x2.5 sq.Angstrom, such that the total number of atoms per
!       cm**2 encountered by the ions corresponds to the required coverage
!       density 'cov':
        if (mode(2) .eq. 1) then
          over = cov*1.e-16/coth1               !Nr. of atoms/A**2 perp. to beam
          nover = 1+int(over*6.25)              !Nr. of layers
          oversize = sqrt(float(nover)/over)    !'Unit cell' size in the layers
        end if

! ---------------------------- START MAIN LOOP -------------------------------*
        delta = 1/sqrt(nproj/(xper*yper*coth1)) !The ions are regularly
        gonio = coco1*coco1+siph1*siph1         ! distributed over the surface
        sgonio = sqrt(gonio)                    ! unit cell. To this end the
        numx = max(1, nint(xper*sgonio/delta))  ! total number of ions is
        numy = max(1, nint(yper*coth1          & ! adjusted a little bit.
                     /(delta*sgonio)))
        npreal = numx*numy                      !Resulting no. of ions
        delx = xper/numx                        !Stepsize in x-direction
        dely = yper/numy                        !Stepsize in y-direction

        kxstrt = 2
        if (mode(1) .eq. 0) then
          xstart = -delx/2.                     !Start positions on mesh
        else
          xstart = -delx                        !Start positions random
        end if

        do 100 ix = 0, numx-1                   !Loop over x-coord. of startpos.
        xstart = xstart+delx
        do while (vx(kxstrt) .lt. xstart)
          kxstrt = kxstrt+1
        end do

        kystrt = 2
        if (mode(1) .eq. 0) then
          ystart = -dely/2.
        else
          ystart = -dely
        end if

        do 100 iy = 0, numy-1                   !Loop over y-coord. of startpos.
        ystart = ystart+dely
        do while (vy(kystrt) .lt. ystart)
          kystrt = kystrt+1
        end do

! ----------------------- INITIALIZATION PER TRACK -------------------------*
        xpr = xstart
        ypr = ystart
        if (mode(1) .eq. 1) then
          call random_number(random)
          xpr = xpr+random*delx
          call random_number(random)          
          ypr = ypr+random*dely
          if (xpr .gt. xper) xpr = xpr-xper     !This might occur due to
          if (ypr .gt. yper) ypr = ypr-yper     ! rounding errors.
        end if
        zpr = zstart
        kxpr = kxstrt
        kypr = kystrt
        kzpr = 1

!       The width of the beam spot, 0.5mm/90mm, as well as the  width of the
!       entrance slit, 1.0mm/90mm, are accounted for in the calculation of
!       detection probabilities:
        if (ian .ne. 0) then
          call random_number(random)
          spread = (random-0.5)*.005555555 
          call random_number(random)          
          spread = spread+(random-0.5)*.01111111  !Out of plane angle of detection
          a = sico1-spread*siph1
          b = sisi1+spread*coph1
          call direction (a, b, coth1)
          new_dir = 1
        else
          cosphi = coph1
          sinphi = siph1
          costh  = coth1
          sinth  = sith1
          coscos = coco1
          cossin = cosi1
          sincos = sico1
          sinsin = sisi1
          new_dir = 0
        end if

        if (mode(2) .eq. 1) then                !Deflection in amorph overlayer
          sico3 = sincos
          sisi3 = sinsin
          coth3 = costh
          do iover = 1,nover
            call random_number(random)
            u = oversize*(random-0.5)        !Relative coordinates of ion
            call random_number(random)
            v = oversize*(random-0.5)        ! with respect to overlayer atom
            t = sqrt(u*u+v*v)                   !Impact parameter
            tan_def = deflection(ntypov     &    !Deflection contribution in
             , nint(min(10000., 2000.*t)))   ! layer nover
            dur = tan_def*u/t                   !Total deflection in u-direction
            dvr = tan_def*v/t                   !Total deflection in v-direction
            if (costh-dur*sinth .le. 0.)    &    !Stop in case of backscattering
             goto 100
            a = sincos+dur*coscos-dvr*sinphi    !Compute new direction
            b = sinsin+dur*cossin+dvr*cosphi
            call direction (a, b, costh)
          end do
          cosdef = sincos*sico3+sinsin*sisi3 &   !Cosine of deflection angle in
                +costh*coth3                 ! overlayer
          cosdef = min(1., cosdef)              !Avoiding rounding errors
          def_rms = def_rms+(acos(cosdef))**2   !Total squared deflection angle
          new_dir = 1
        end if

        if (new_dir .eq. 1) then                !If necessary calculate new
          call new_gonio                        ! goniometry of track
          dot = sign(1., cosphi*cosp_beam	   &
                     +sinphi*sinp_beam)
        else
          tanth   = tath1                       !Otherwise use initial
          tancos  = taco1                       ! goniometry
          tansin  = tasi1
          dot     = dot1
          isignx  = isx1
          isigny  = isy1
          real_cs = fake_cs
          do iel = 1, nel
            x_imp(iel) = x_i1*sc_imp_par(iel)
            y_imp(iel) = y_i1*sc_imp_par(iel)
            z_imp(iel) = z_i1*sc_imp_par(iel)
          end do
          e1 = e11
          e2 = e21
        end if

        if (e1 .gt. e2 .and. e1 .gt. 1.) then
          tanphi = sinphi/cosphi
          if (mode(1) .eq. 1) call seek_plane  &
             (vx, nx1, xpr, kxpr)
          goto 80
        else if (e2 .ge. e1 .and. e2 .gt. 1.) then
          cotphi = cosphi/sinphi
          if (mode(1) .eq. 1) call seek_plane   &
             (vy, ny1, ypr, kypr)
          goto 50
        else
          if (mode(1) .eq. 1) then
            call seek_plane (vx, nx1, xpr, kxpr)
            call seek_plane (vy, ny1, ypr, kypr)
          end if
          goto 20
        end if
!---------------------------- EXTRAPOLATION OF TRACK --------------------------*
!--------------------------------- Z-DIRECTION --------------------------------*
10      if (kzpr .eq. ngz) goto 100
        kzpr = kzpr+1                                   !Step to next z-plane
        xpr = xpr+(vz(kzpr)-zpr)*tancos
        ypr = ypr+(vz(kzpr)-zpr)*tansin
        zpr = vz(kzpr)

        call period_bound (xpr, xper, dummy)            !Periodic boundary
        call period_bound (ypr, yper, dummy)            ! conditions xpr,ypr

        call seek_plane (vx, nx1, xpr, kxpr)            !New plane numbers
        call seek_plane (vy, ny1, ypr, kypr)            ! kxpr,kypr

!       Seek for the closest atom. Calculate hitting probabilities. If one of
!       the atoms is close enough compute deflection.
!       No deflection  -> continue in this direction,   i.e. goto 10:
!       Deflection     -> find new direction,           i.e. goto 90:
!       Backscattering -> stop this ion track,          i.e. goto 100:
20      lx(1) = kxpr-1
        if (kxpr .eq. nx1) then
          lx(2) = 1
          x_shift(2) = -xper
        else
          lx(2) = kxpr
          x_shift(2) = 0.
        end if
        ly(1) = kypr-1
        if (kypr .eq. ny1) then
          ly(2) = 1
          y_shift(2) = -yper
        else
          ly(2) = kypr
          y_shift(2) = 0.
        end if
        lz(1) = kzpr
        call impact (2, 2, 1, *10, *90, *100)

!--------------------------------- Y-DIRECTION --------------------------------*
30      cotphi = cosphi/sinphi
40      kypr = kypr+isigny                              !Step to next y-plane
50      if (kypr .eq. 0) then
          kypr = ngy
          ypr = ypr+yper
        else if (kypr .eq. ny1) then
          kypr = 1
          ypr = ypr-yper
        end if
        xpr = xpr+(vy(kypr)-ypr)*cotphi
        zpr = zpr+(vy(kypr)-ypr)/tansin
        ypr = vy(kypr)
        if (zpr .gt. zmax) goto 100

        call period_bound (xpr, xper, dummy)            !Periodic boundary cond
        call seek_plane (vx, nx1, xpr, kxpr)            !New plane numbers
        do while (vz(kzpr) .lt. zpr)                    ! kxpr,kzpr
          kzpr = kzpr+1
        end do

!       Seek for the closest atom. Calculate hitting probabilities. If one of
!       the atoms is close enough compute deflection.
!       No deflection  -> continue in this direction,   i.e. goto 40:
!       Deflection     -> find new direction,           i.e. goto 90:
!       Backscattering -> stop this ion track,          i.e. goto 100:
        lx(1) = kxpr-1
        if (kxpr .eq. nx1) then
          lx(2) = 1
          x_shift(2) = -xper
        else
          lx(2) = kxpr
          x_shift(2) = 0.
        end if
        ly(1) = kypr
        if (kzpr .eq. 1) then
          lz(1) = 1
          call impact (2, 1, 1, *40, *90, *100)
        else if (kzpr .eq. nz1) then
          lz(1) = ngz
          call impact (2, 1, 1, *40, *90, *100)
        else
          lz(1) = kzpr-1
          lz(2) = kzpr
          call impact (2, 1, 2, *40, *90, *100)
        end if

!----------------------------------- X-DIRECTION ------------------------------*
60      tanphi = sinphi/cosphi
70      kxpr = kxpr+isignx                              !Step to next x-plane
80      if (kxpr .eq. 0) then
          kxpr = ngx
          xpr = xpr+xper
        else if (kxpr .eq. nx1) then
          kxpr = 1
          xpr = xpr-xper
        end if
        ypr = ypr+(vx(kxpr)-xpr)*tanphi
        zpr = zpr+(vx(kxpr)-xpr)/tancos
        xpr = vx(kxpr)
        if (zpr .gt. zmax) goto 100

        call period_bound (ypr, yper, dummy)            !Periodic boundary cond

        call seek_plane (vy, ny1, ypr, kypr)            !New plane numbers
        do while (vz(kzpr) .lt. zpr)                    ! kypr,kzpr
          kzpr = kzpr+1
        end do
!       Seek for the closest atom. Calculate hitting probabilities. If one of
!       the atoms is close enough compute deflection.
!       No deflection  -> continue in this direction,   i.e. goto 70:
!       Deflection     -> find new direction,           i.e. goto 90:
!       Backscattering -> stop this ion track,          i.e. goto 100:
        lx(1) = kxpr
        ly(1) = kypr-1
        if (kypr .eq. ny1) then
          ly(2) = 1
          y_shift(2) = -yper
        else
          ly(2) = kypr
          y_shift(2) = 0.
        end if
        if (kzpr .eq. 1) then
          lz(1) = 1
          call impact (1, 2, 1, *70, *90, *100)
        else if (kzpr .eq. nz1) then
          lz(1) = ngz
          call impact (1, 2, 1, *70, *90, *100)
        else
          lz(1) = kzpr-1
          lz(2) = kzpr
          call impact (1, 2, 2, *70, *90, *100)
        end if

!----------------------------- AFTER A COLLISION ------------------------------*
90      dot = sign(1., cosphi*cosp_beam		&
                    +sinphi*sinp_beam)
        if (e1 .gt. e2 .and. e1 .gt. 1.) then           !Find main velocity
          goto 60                                       ! component
        else if (e2 .ge. e1 .and. e2 .gt. 1.) then
          goto 30
        else
          goto 10
        end if
!------------------------------- END MAIN LOOP --------------------------------*
100     continue
        return
        end subroutine track



        SUBROUTINE IMPACT (nvx, nvy, nvz, *, *, *)
!********************************************************************************
!*       IIIIII  MM    MM  PPPPP    AAAA    CCCC   TTTTTT                       *
!*         II    M M  M M  P    P  A    A  C    C    TT                         *
!*         II    M  MM  M  PPPPP   AAAAAA  C         TT                         *
!*         II    M      M  P       A    A  C    C    TT                         *
!*       IIIIII  M      M  P       A    A   CCCC     TT                         *
!********************************************************************************
	USE CONNCALC_PARMS
	implicit none	
	integer  :: jat,nhulp,nvx,nvy,nvz,ivx,ivy,ivz
	integer  :: iu,iv
	real :: o,p,q,r,s,t,u1,d1,v1
	real :: dred,u_xt,u_yt,u_zt
	real :: xt1,yt1,zt1
	real :: xr1,yr1,zr1,dred1
	real :: random(3)
        iat = 0
        dred = 1.
	call random_number(random)
        u_xt = gauss(1+nint(2000.*random(1)))           !Unit random thermal
        u_yt = gauss(1+nint(2000.*random(2)))           ! displacements
        u_zt = gauss(1+nint(2000.*random(3)))

!-------------------------- LOOP OVER LATTICE POINTS --------------------------*
        do ivx = 1,nvx                                  !Search for atom on
          do ivy = 1,nvy                                ! location (ivx,ivy,ivz)
            do ivz = 1,nvz
              jat = lattice(lx(ivx), ly(ivy), lz(ivz))
              if (jat .eq. 0) goto 10

              xr1 = xpr-x(jat)+x_shift(ivx)             !Relative ion coord.
              yr1 = ypr-y(jat)+y_shift(ivy)             ! (xr1,yr1,zr1)
              zr1 = zpr-z(jat)

              u1 = (xr1-x_imp(ntypat(jat)))*coscos  &    !Projections normal to
               +(yr1-y_imp(ntypat(jat)))*cossin     & ! ion track
               -(zr1-z_imp(ntypat(jat)))*sinth
              v1 = (yr1-y_imp(ntypat(jat)))*cosphi  &
               -(xr1-x_imp(ntypat(jat)))*sinphi

              iu = nint(u1*10./sigma(jat))              !Coordinates on square
              iv = nint((v1*dot*10./sigma(jat)))        ! mesh around atom jat
              if (iu .ge. -40 .and. iu .le. 40 .and. &
               iv .ge. -40 .and. iv .le. 40)		   &
             distri(jat, iv, iu) =                   & !Ion is counted
               distri(jat, iv, iu)				   &
               +real_cs

              o = (xr1-x_imp(ntypat(jat)))*sigx_1(jat)  !Reduced relative ion
              p = (yr1-y_imp(ntypat(jat)))*sigy_1(jat)  ! coordinates (o,p,q),
              q = (zr1-z_imp(ntypat(jat)))*sigz_1(jat)  ! corrected for imp.
                                                        ! par. for backsc.

              r = sincos*sigx_1(jat)                    !Reduced direction of
              s = sinsin*sigy_1(jat)                    ! motion (r,s,t)
              t = costh *sigz_1(jat)

!---------------------- HITTING/DETECTION PROBABILITY -----------------------*
              hit_det(jat) = hit_det(jat)           &    !Contribution to hitting
             +exp(0.5*                              &    ! probability of atom
             ((o*r+p*s+q*t)**2                      &     ! jat
             /(r*r+s*s+t*t)						  &
              -o*o-p*p-q*q))						  &
             *real_cs/(sqrt(r*r+s*s+t*t))

              xt1 = u_xt*sigx(jat)                      !Thermal displacement of
              yt1 = u_yt*sigy(jat)                      ! atom jat
              zt1 = u_zt*sigz(jat)

              xr1 = xr1-xt1                             !New relative position
              yr1 = yr1-yt1                             ! of the ion
              zr1 = zr1-zt1

              u1 = xr1*coscos+yr1*cossin-zr1*sinth      !Projections normal to
              v1 = yr1*cosphi-xr1*sinphi                ! ion track
              d1 = u1**2+v1**2                          !Square of imp.parameter
              nhulp = ntypat(jat)
              dred1 = d1*dmax2(nhulp)                   !Reduced sq. imp.par.

!             Is atom jat closer than previous atoms? And if so, is it also
!             close enough for a non-negligible deflection?
              if (dred1 .gt. dred) goto 10

!----------------------------- COLLISION PARTNER ----------------------------*
              iat  = jat                                !Closest atom iat:
              dred = dred1                              ! reduced sq. imp.par.
              d    = d1                                 ! square of impact par.
              u    = u1                                 ! impact coordinate
              xr   = xr1                                ! relative x, y and z
              yr   = yr1                                ! coordinates of the ion
              zr   = zr1                                ! and
              xt   = xt1                                ! thermal displacements
              yt   = yt1                                ! in x, y and z
              zt   = zt1                                ! directions

10            continue

!------------------------ END LOOP OVER LATTICE POINTS ------------------------*
            end do
          end do
        end do

!------------------------------- DEFLECTION? ----------------------------------*
        if (iat .eq. 0) then
          return 1                                      !No deflection
        else
          call collision (*20)                          !Deflection
          return 2                                      !Normal deflection
20        return 3                                      !Backscattering
        end if
        end subroutine impact


        SUBROUTINE COLLISION (*)
!********************************************************************************
!*        CCCC    OOOO   LL      LL      IIIIII   SSSSS  IIIIII   OOOO   NN    N*
!*       C    C  O    O  LL      LL        II    S         II    O    O  N N   N*
!*       C       O    O  LL      LL        II     SSSS     II    O    O  N  N  N*
!*       C    C  O    O  LL      LL        II         S    II    O    O  N   N N*
!*        CCCC    OOOO   LLLLLL  LLLLLL  IIIIII  SSSSS   IIIIII   OOOO   N    NN*
!********************************************************************************
	use conncalc_parms
	implicit none
	REAL :: t,tan_def,s,delfac,a,b	
        t = sqrt(d)                                     !Impact parameter

!       Deflection angle xphi:
        tan_def = deflection(ntypat(iat)       &         !Tangent of deflection
             , nint(min(10000., 2000.*t)))           ! angle

        s = u*tanth
        delfac = tan_def/(t-s*tan_def)

        if (delfac .lt. 0.) return 1                    !Stop track in case of
                                                       ! backscattering
!       Relative coordinates with respect to atom iat of point with z-coordinate
!       equal to that of atom iat:
        xr = xr-zr*tancos
        yr = yr-zr*tansin
!
        xpr = xr+xt+x(iat)-sincos*s                     !Absolute coordinates of
        ypr = yr+yt+y(iat)-sinsin*s                     ! inflection point
        zpr =    zt+z(iat)-costh *s
        kxpr = kx(iat)
        kypr = ky(iat)
        kzpr = kz(iat)

        a = sincos+delfac*xr                            !Distances for new
        b = sinsin+delfac*yr                            ! goniometry

        call direction (a, b, costh)
        call new_gonio

        return
        end subroutine collision





        SUBROUTINE DIRECTION (a, b, c)
!********************************************************************************
!
! Given positions x,y,z (a,b,c) calculate distances 
! and relevent angles 
!
!********************************************************************************
	use conncalc_parms
	IMPLICIT NONE
	REAL :: a,b,c,disxy,disxyz

        disxy		= sqrt((a*a)+(b*b))
        disxyz		= sqrt((a*a)+(b*b)+(c*c))

        if(disxy.eq.0.0) disxy  = 1.e-6

        if(disxyz.eq.0.0) disxyz = 1.e-6

        cosphi		= a/disxy
        sinphi		= b/disxy
        costh		= c/disxyz
        sinth		= disxy/disxyz
        coscos		= costh*cosphi
        cossin		= costh*sinphi
        sincos		= sinth*cosphi
        sinsin		= sinth*sinphi

        return
        end subroutine direction


        SUBROUTINE NEW_GONIO
!********************************************************************************
!
! Calculate new angles
!
!********************************************************************************
	use conncalc_parms
	IMPLICIT NONE
	REAL :: sinan,cosan

        if (costh .ne. 0.) then
          tanth  = sinth/costh
        else
          tanth = sinth*1.e-6
        end if
        tancos		= tanth*cosphi
        tansin		= tanth*sinphi
        isignx		= int(sign(1., cosphi))
        isigny		= int(sign(1., sinphi))
        cosan		= sico2*sincos+sisi2*sinsin+coth2*costh
        sinan		= sqrt(1.-cosan*cosan)
        real_cs		= 1./((cosan-1.)**2)
        x_imp(:)   	= sc_imp_par(:)*(sico2-cosan*sincos)/sinan
        y_imp(:)   	= sc_imp_par(:)*(sisi2-cosan*sinsin)/sinan
        z_imp(:)   	= sc_imp_par(:)*(coth2-cosan*costh )/sinan
        e1			= abs(tancos)
        e2			= abs(tansin)

        return
        end subroutine new_gonio


	SUBROUTINE SEEK_PLANE (plane, nr_of_planes, position, i_plane)
!*******************************************************************************
!
!	determines plane next to /greater than current ion position
!
!*******************************************************************************
	use conncalc_parms
	IMPLICIT NONE
	integer :: nr_of_planes,i_plane
	real,dimension(nr_of_planes) ::plane
	real :: position,test
	test=position-plane(i_plane)	
		if(test.lt.0.0) then
   
		do while(plane(i_plane).gt.position)	
			i_plane=i_plane-1
		end do
		i_plane=i_plane+1
		else if(test.eq.0.0) then
			i_plane=min(i_plane+1,nr_of_planes)
		else

		do while(plane(i_plane).lt.position)
		   i_plane=i_plane+1
		end do
		end if
	end subroutine seek_plane


        SUBROUTINE PERIOD_BOUND (position, period, change)
!*******************************************************************************
!
! Apply looped boundary conditions	
!
!*******************************************************************************
	IMPLICIT NONE
	real :: shift,position,change,period

        shift		= -period*nint(position/period-0.5)
        position	=  position+shift
        change		=  change+shift

        return
        end subroutine period_bound



        SUBROUTINE POTENT
!********************************************************************************
!
!	subroutine calculates a deflection table by integrating 
!	the collision integral using gauss-mehler method
!
!********************************************************************************

	use conncalc_parms
	implicit none
	real :: weight,v,f,g,ang1,ang2,s,qm,l,r
	real :: ener,relen
	integer i_defl,i
	ener = el_loss_fac*energy                         !Elastic energy loss
    	zi   = nzi                                        !Ion atomic number

element : do iel = 1,nel
          zt = nzt(iel)                                 !Target atomic number
          qm = rmi/rmt(iel)                             !Ion/target mass ratio
          relen = ener*rmt(iel)/(rmt(iel)+rmi)          !Relative energy (29/6/87)
          call screening_length                         !Evaluate scrlen
          coulomb = .014402*zt*zi
          deflection(iel, 0) = -1.E-6
s_parm :  do i_defl = 1,10000
            s = i_defl/2000.                            !Impact parameter
            r = rclose(s, relen)                        !Dist. of closest appr.
            deflection(iel, i_defl) = 0.                !Numerical evaluation collision integral
	    f=0.0
integrate :	do i=1,30
			l=30.0-i+1
			ang1=(2.*l-1)*(pi/120.0)
			ang2=(2.*i-1)*(pi/120.0)
			weight=cos(ang1)
			v=cos(ang2)
			g=1.0/sqrt(1-(pot(r/v)/relen)-((s**2)*(v**2)/(r**2)))
			f=f+(weight*g)
		end do integrate

        f=f*pi/(60.0*r)
        deflection(iel, i_defl) =pi-2.*s*f

!       Conversion CM-system -> LAB-system. Subroutine 'COLLISION' only
!       needs the tangent of the LAB-deflection angle:

        deflection(iel, i_defl)=sin(deflection(iel, i_defl))/(cos(deflection(iel,i_defl))+qm)
		end do s_parm
        end do element
        return
        end subroutine potent





        FUNCTION EXPO (argument)
!*******************************************************************************
!       EEEEEE  XX   XX  PPPPP    OOOO                                         *
!       E        XX XX   P    P  O    O                                        *
!       EEEEEE    XXX    PPPPP   O    O                                        *
!       E        XX XX   P       O    O                                        *
!       EEEEEE  XX   XX  P        OOOO                                         *
!******************************************************************************
        use conncalc_parms 
	implicit none
        real  :: expo,argument
        expo = expon(int(0.625*argument))
        return
        end function expo


        FUNCTION MAXMIN (real_number)
!*******************************************************************************
!       MM    MM   AAAA   XX   XX  MM    MM  IIIIII  NN    N                   *
!       M M  M M  A    A   XX XX   M M  M M    II    N N   N                   *
!       M  MM  M  AAAAAA    XXX    M  MM  M    II    N  N  N                   *
!       M      M  A    A   XX XX   M      M    II    N   N N                   *
!       M      M  A    A  XX   XX  M      M  IIIIII  N    NN                   *
!*******************************************************************************
	implicit none
	integer :: maxmin
	real    :: real_number
        maxmin = max(1, min(40, nint(real_number)))
        return
        end function maxmin


        FUNCTION RCLOSE (s, relen)
!********************************************************************************
!
!		Find distance of closest approach rclose
!		i.e value of r when f=1-s^2/r^2-pot(r)/E =0 
!		Uses bisection method
!
!********************************************************************************
		implicit none
		integer :: j
        	real:: step,f
		real:: rclose,r,s,relen,temp
		real:: rmin,rmax,rtbis,xmid,fmid,dx

        r = s
        step = .1
		rmax = r
		rmin = r
!		Bracket the root
		f = 1.-s*s/(r*r)-pot(r)/relen

		if( f < 0.) then
				do while(f<0.0)
					r=r+0.1
					f = 1.-s*s/(r*r)-pot(r)/relen
				end do
				rmax = r
		else
				temp = r
				do while(f > 0.0)
							temp=r-0.5*step
							f = 1.-s*s/(temp*temp)-pot(temp)/relen
				end do
				rmin = temp
		endif


!		BRACKETED NOW 
!		Bisection Method 
		
		f = 1.-s*s/(rmin*rmin)-pot(rmin)/relen		
		if(f.lt.0) then
			rtbis = rmin
			dx = rmax-rmin
		else
			rtbis=rmax
			dx = rmin-rmax
		end if

bisect : do j=1,100
			dx =dx*0.5
			xmid = rtbis+dx
			fmid = 1.-s*s/(xmid*xmid)-pot(xmid)/relen			
			if(fmid <= 0.0) rtbis = xmid
			if(abs(dx) < 1E-8 .or. fmid == 0.) exit bisect 
		 end do bisect
		rclose = xmid
		end function RCLOSE







        FUNCTION POT (r)
!******************************************************************************
!
!	Calculates Moliere or Biersack potential
!
!********************************************************************************
		use conncalc_parms
		IMPLICIT NONE
		real ::		r,r_redt,pot
        pot			= coulomb/r
        r_redt		= r*scrlen

		potential: select case (mode(3))
		case(0)
          pot		= pot*			&
			& (.10*exp(-6.0*r_redt)	&
			& +.55*exp(-1.2*r_redt)	&	
			& +.35*exp(-0.3*r_redt))

		case(1)
          pot		= pot*				&
			& (.1818  *exp(-3.2*r_redt)	&
			& +.5099  *exp(-0.9423*r_redt)	&
			& +.2802  *exp(-0.4029*r_redt)	&
			& +.02817 *exp(-0.2016*r_redt))
		
		end select potential		
		return
        end function pot


        SUBROUTINE SCAT_IMP (angle, dist)
!********************************************************************************
!
! returns scattering impact parameter for a given element for a given angle
! by looking angle up in the deflection table.
!
!********************************************************************************
		use conncalc_parms
		IMPLICIT NONE
		real		:: dist(nel)
		real		:: angle,deflect
		integer		:: i_defl
		logical		:: found

		do iel = 1,nel                                  
			found=.FALSE.
			i_defl		= 0                                    
			do while(.not.found)
				found=.TRUE.
				deflect= atan(deflection(iel, i_defl))		  
				if (deflect < 0.)	 deflect = deflect+pi
				if (deflect > angle) then
					i_defl= i_defl+1
					found=.FALSE.
				endif
			end do
			dist(iel) = i_defl/2000.
        end do
        return
        end subroutine scat_imp



        SUBROUTINE SCREENING_LENGTH
!********************************************************************************
!
!  Calculate (1 / (screening length)) for the different choices of potential
!  Mode(3) determines if Moliere or Biersack is used
!
!********************************************************************************
	use conncalc_parms
	implicit none
        if (mode(3) .eq. 0) then                                
		if ( zi .eq. 1.) then                             
                 scrlen = ( zt ** 0.333333333) / (0.88534*0.529)
               else                                             
                scrlen = (0.5*zi)**0.5 + zt**0.5	!Pq Note This isn't right ?
                scrlen = scrlen**0.666666667
                scrlen = scrlen / (0.88534*0.529)
               endif
        else                                                    
	          scrlen = (zi**0.23+zt**0.23)/(0.88534*0.529)

        endif

        return
        end  subroutine	SCREENING_LENGTH



	subroutine gaussian
! ==========================================
!
! Generates a general gaussian distribution
! from which the vibrations are calculated
!
! ==========================================
	use conncalc_parms,only : gauss
	IMPLICIT NONE		
	REAL :: dx,dg,ix,grens,cum1,cum2,prefac,x1,x2
	INTEGER :: ig,choice
	
        dx			= 0.0001                             
        dg			= 0.0005                             
        ig			= 1002                              
        ix			= 0.0                                
        grens		= dg                             
        cum1		= 0.0
        cum2		= 0.0
        prefac		= dx/sqrt(8.*atan(1.))
	choice		= 1
	do while(ig.ne.2002)
	select case(choice)
		case(1)
			ix		= ix+1
			x1		= (ix-0.5)*dx
			x2		= ix*dx
			cum2		= cum1+exp(-x1*x1*.5)*prefac
			choice		= 2
		case(2)
		        if ((cum2-grens)<0.) then			
		        cum1		= cum2
		        choice		= 1
			else
			choice		= 3
			end if				
		case(3)
			gauss(ig)	= x2-dx*(cum2-grens)/(cum2-cum1)
			ig		= ig+1
			grens		= (ig-1001)*dg
			if (ig .eq. 2001) grens = grens-0.1*dg
			choice=2
		end select
		end do
        gauss(1001)   =  0.0
	gauss(1:1000) = -gauss(1002:2001)	
        end subroutine gaussian




	subroutine readin(input_name)
!=================================================================================
!
!Reads in input parameters
!
!=================================================================================
	use conncalc_parms
	character(80) :: input_name
	    open (1, file = input_name, status = 'old',	&
				&	access = 'sequential', form = 'formatted')
        read (1, *)		                text
        read (1, *)                     ndate, numb
        read (1, *)                     (mode(i), i = 1,8)
        if (mode(7) .ne. 1) then
		close (1)
		write(6,*) 'Wrong program'
          stop
        end if
! Array dimensions

        read (1, *)                     (arrdim(i), i = 1,19)
	    nat					=arrdim(1)
	    nel					=arrdim(2)
	    ngx					=arrdim(3)
	    ngy					=arrdim(4)
	    ngz					=arrdim(5)
	    nx1					=arrdim(6)
  	    ny1					=arrdim(7)
	    nz1					=arrdim(8)
	    nan					=arrdim(9)
!
!	Allocate the arrays
!
        allocate (x(nat), y(nat), z(nat))
        allocate (ntypat(nat))
        allocate (kx(nat), ky(nat), kz(nat))           
        allocate (sigx(nat), sigy(nat), sigz(nat))       
        allocate (sigx_1(nat), sigy_1(nat), sigz_1(nat)) 
        allocate (sigxyz(nat))
        allocate (hit_det(nat))              
        allocate (hitprob(nat))              
        allocate (blocking(nat, nan))
!	allocate (bltyp(nel, nan))
!	allocate (bllay(ngz, nan))
        allocate (sc_imp_par(nel),dmax2(nel))           
        allocate (nzt(nel), rmt(nel))        
        allocate (vx(nx1), vy(ny1), vz(nz1)) 
        allocate (scthet(nan))               
        allocate (bltot(nan))                
	allocate (x_imp(nel),y_imp(nel),z_imp(nel))           
	allocate ( lattice(ngx,ngy,ngz) )
	allocate (deflection(nel, 0:10000))
	allocate (bltot_int(nat))
	allocate (sigma(nat))
	allocate (hit_integral(nat))
	allocate (distri(nat,-40:40,-40:40))
	allocate (shadow(nat,-40:40,-40:40))
	allocate (blo_integral(nat,nan))


        read (1, *)	(nzt(iel), rmt(iel),iel=1,nel)
        read (1, *)	ntypov, cov
        read (1, *)	cor_cof, cor_dis
        do iat = 1,nat
          read (1, *)       x(iat),y(iat),z(iat),		&
     &                      kx(iat),ky(iat),kz(iat),		&
     &                      sigx(iat),sigy(iat),sigz(iat),	&
     &                      ntypat(iat)
        end do
        read (1, *)         xper, yper
	    read (1, *)			(vx(i),i=1,ngx)
        read (1, *)         (vy(i),i=1,ngy)
        read (1, *)         (vz(i),i=1,ngz)
        read (1, *)         phi,chthet,scthet(1),step,factor
        read (1, *)         nzi,rmi,energy, fluxc,fluxb
        close (1)
		write(*,*) 'Input File has beed successfully read in'
!	Finished Readin
	end subroutine readin
    end subroutine conncalc
	end module conncalc_code

