#  defn.tcl

proc {Add_OMS MAXv6000_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]

   set CurrentVMEServer  $server

   define-vme-register $name MAXv X.Command.WriteOnly	"-a$A16addrbase -xX -pwo -n0"
   define-vme-register $name MAXv X.Command.WriteRead	"-a$A16addrbase -xX -prw -n1"
   define-vme-register $name MAXv Y.Command.WriteOnly	"-a$A16addrbase -xY -pwo -n0"
   define-vme-register $name MAXv Y.Command.WriteRead	"-a$A16addrbase -xY -prw -n1"
   define-vme-register $name MAXv Z.Command.WriteOnly	"-a$A16addrbase -xZ -pwo -n0"
   define-vme-register $name MAXv Z.Command.WriteRead	"-a$A16addrbase -xZ -prw -n1"
   define-vme-register $name MAXv T.Command.WriteOnly	"-a$A16addrbase -xT -pwo -n0"
   define-vme-register $name MAXv T.Command.WriteRead	"-a$A16addrbase -xT -prw -n1"
   define-vme-register $name MAXv U.Command.WriteOnly	"-a$A16addrbase -xU -pwo -n0"
   define-vme-register $name MAXv U.Command.WriteRead	"-a$A16addrbase -xU -prw -n1"
   define-vme-register $name MAXv V.Command.WriteOnly	"-a$A16addrbase -xV -pwo -n0"
   define-vme-register $name MAXv V.Command.WriteRead	"-a$A16addrbase -xV -prw -n1"

   define-vme-register $name xVME CommandMailbox	"-a$A16addrbase -o0x4c -w16 -d32  -pro"
}

proc {XXX OMS MAXv6000_DAQ-reset} {args} {
#   MAXv
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[write-vme-register $module.X.Command.WriteRead "WY;"] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}


proc {OMS MAXv6000_DAQ-reset} {args} {
# The above crashes the stepper program.
# Do nothing for now, while we investigate. scl 25/08/09
}

proc {OMS MAXv6000_DAQ-flush} {args} {
#   MAXv
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {OMS MAXv6000_DAQ-go} {args} {
#   MAXv
    global CurrentVMEServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {OMS MAXv6000_DAQ-halt} {args} {
#   MAXv
    global CurrentVMEServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {OMS MAXv6000_DAQ-setup} {args} {
#   MAXv
    global CurrentVMEServer RegisterServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

#   for parameter save/restore
set {OMS MAXv6000_registersavepatterns} {}
