#     June 1996    TK version    VP

proc make-reg-name args {
	set mname [first $args]
	set rname [second $args]
	if {$rname!=""} then {set mname $mname.$rname}
	return "$mname"
}

proc write-reg {r v} {
	global server
	set rr $server/[make-reg-name $r]
	EG "register :pattern '$rr' :value '$v'"
}

proc read-reg {r} {
	global server
	set reg $server/[make-reg-name $r]
	EG "register :name '$reg' ?value"
}

proc read-regs {r} {
	global server 
	set reg $server/[make-reg-name $r]
	EG "register :pattern '$reg' ?names-and-values"
}

proc inquire-regs {r} {
	global server 
	set reg $server/[make-reg-name $r]
	EG "register :pattern '$reg' ?names"
}

proc define-meis-register {mname class rname attributes} {
   global server
   set reg $server/[make-reg-name $mname $rname]
   EG "register :name '$reg' :class '$class' !new"
   EG "register :name '$reg' :object '$attributes'"
}

proc read-attributes {r} {
   global server
   set reg $server/[make-reg-name $r]
   EG "register :name '$reg' ?object"
}

proc write-attributes {r a} {
   global server
   set reg $server/[make-reg-name $r]
   EG "register :name '$reg' :object '$a'"
}

proc update-request {w v a} {
   set slider [first $w]
   set number [second $w]
   set values [split $v .]
   set whole  [first $values]
#   set tenth  [string index [second $values] 0]
   set tenth  [string trimleft [first [second $values]] 0]
   if {[string length $tenth] == 0} then {set tenth 0}

   :modify $slider :value $whole
   :modify $number :value $tenth
}

proc update-gauge {w v m} {
	set gauge [first $w]
	set text  [second $w]
	set value [first [split [expr {[first $v]*$m}] .]]

	:modify $text :value "$v"
        :modify $gauge :value $value
}

proc update-int {w v a} {:modify $w :value [scan-int $v]}

proc update-neg {w v a} {:modify $w :value [expr {[scan-int $v] ^ 1}]}

proc update-clr {w v a} {:modify $w :value 0}

proc update-txt {w v a} {:modify $w :value "$v"}

proc update-slider {w v m} {

	set value [first [split [expr {[scan-num $v]*$m}] .]]
	:modify $w :value $value
}

# a "special" for the Xycom the cards - extract the Version from the id block
proc update-version {w v a} {
   set ss ""
   append ss [string index $v 0x42]
   append ss [string index $v 0x46]
   append ss "."
   append ss [string index $v 0x4a]
   append ss [string index $v 0x4e]

   :modify $w :value "$ss"
}

proc update-pair {p} {
	global debug table

	set reg [first $p]
	set val [second $p]
	catch {
		set func   [first  $table($reg)]
		set widget [second $table($reg)]
		set arg    [third  $table($reg)]
	        if {$debug != 0} then {puts stderr "update-pair: $p $func $widget $val $arg"}

		$func $widget $val $arg
	}
}

proc click-null {r v a} {}

proc click-txt {r v a} {
	global debug
	if {$debug} then {puts stderr "click-txt $r $v $a"}

	write-reg $r "$v"
}

proc click-int {r v a} {
	global debug
	if {$debug} then {puts stderr "click-int $r $v $a"}

	write-reg $r $v
}

proc click-con {r v a} {
	global debug
	if {$debug} then {puts stderr "click-con $r $v $a"}

	write-reg $r $v
}

proc click-neg {r v a} {
	global debug
	if {$debug} then {puts stderr "click-neg $r $v $a"}

	write-reg $r [expr {$v ^ 1}]
}

proc click-set {r v a} {
	global debug
	if {$debug} then {puts stderr "click-set $r $v $a"}

	write-reg $r 1
}

proc click-msk {r v a} {
	global debug
	if {$debug} then {puts stderr "click-msk $r $v $a"}

	set x [read-reg $r]
	write-reg $r [expr $v^$x]
}

proc click-slider {r v a} {
	global debug 
	if {$debug} then {puts stderr "click-slider $r $v $a"}

	set v $v.0

	set m      [first $a]
	set step   [second $a]
	set unit   [third $a]

	set value  [read-reg $r]
	set oldv   [expr {[scan-num $value] * $m}]

	if {$v > $oldv && $v < [expr $oldv+$step]} then {set v [expr $oldv+$step]}
	if {$v < $oldv && $v > [expr $oldv-$step]} then {set v [expr $oldv-$step]}

	set v "[expr {$v / $m}] $unit"
	write-reg $r $v
	click-redisplay
	set-footer "$r set to $v..."
}

proc click-show {s v a} {
	global SpectrumServer
	set spec /$SpectrumServer/$s
	inform sd "show $spec"
	set-footer "Showing $spec..."
}

proc click-on {w v} {
	global debug table  

	if {$debug} then {puts stderr "click on $w $v"}
	set func [first $table($w)]
	set reg  [second $table($w)]
	set arg  [third $table($w)]

	if {$debug} then {puts stderr "calling $func $reg $v $arg"}
	$func $reg $v $arg
}

proc kill-after {id} {after cancel $id}

proc is-started {task} {
    inform $task inquire started
}
