# Some common procedures used for accessing the control system's MPX subsystem

set mpxserver "/mpx"

proc write-MPX-intrinsic {r v} {
   global mpxserver
#   EG  "register :name '/$mpxserver/MPX.$r'  :value '$v'"
}

proc read-MPX-intrinsic {r} {
   global mpxserver
#   EG "register :name '/$mpxserver/MPX.$r'  ?value"
return 0x12
}

# These routines map 1 to 1 with the "non-mpx" versions
# they just temporarily change the server name to do the call

proc define-mpx-register {mname class rname attributes} {
   global server mpxserver
   set temp $server; set server $mpxserver
#   define-meis-register $mname $class $rname $attributes
   set server $temp
}

proc write-mpx-reg {r v} {
   global server mpxserver
   write-mpx-register-attributes $r "-f0x02"
   set temp $server; set server $mpxserver
#   write-reg $r $v
   set server $temp
}

proc write-mpx-bits {r m sc} {
# m is a mask defining which bits should be selectively modified
# sc specifies whether they should be cleared (sc==0) or set (sc!=0) 
   global server mpxserver
   set attr "-f0x06"
   if {$sc} then {set attr "-f0x04"}
   write-mpx-register-attributes $r $attr
   set temp $server; set server $mpxserver
#   write-reg $r $m
   set server $temp
}

proc set-mpx-bits {r m} {
   global server mpxserver
   write-mpx-register-attributes $r "-f0x04"
   set temp $server; set server $mpxserver
#   write-reg $r $m
   set server $temp
}

proc clear-mpx-bits {r m} {
   global server mpxserver
   write-mpx-register-attributes $r "-f0x06"
   set temp $server; set server $mpxserver
#   write-reg $r $m
   set server $temp
}

proc read-mpx-reg {r} {
   global server mpxserver
   write-mpx-register-attributes $r "-f0x08"
   set temp $server; set server $mpxserver
#   set v [read-reg $r]
set v 0x34
   set server $temp
   return $v
}

proc read-mpx-regs {r} {
   global server mpxserver
   write-mpx-registers-attributes $r "-f0x08"
   set temp $server; set server $mpxserver
#   set vs [read-regs $r]
set vs {{A 1} {Z 26}}
   set server $temp
   return $vs
}

proc write-mpx-register-attributes {r a} {
   global server mpxserver
   set temp $server; set server $mpxserver
#   write-attributes $r $a
   set server $temp
}

# These routines implement some procs not available in "non-mpx" versions

proc write-mpx-registers-attributes {rs a} {
   global mpxserver
   set regs $mpxserver/[make-reg-name $rs]
#   EG "register :pattern '$regs' :object '$a'"
}

proc read-mpx-attributes {r} {
   global mpxserver
   set reg $mpxserver/[make-reg-name $r]
#   set v [EG "register :name '$reg' ?object"]
set v "-m -p -x"
   return $v
}

proc read-mpx-names-and-attributes {r} {
   global mpxserver
   set reg $mpxserver/[make-reg-name $r]
#   set v [EG "register :pattern '$reg' ?names-and-objects"]
set v {{M -m} {P -p} {X -x}}
   return $v
}

proc query-mpx-names {p} {
   global mpxserver
   set pat $mpxserver/[make-reg-name $p]
#   set n [EG "register :pattern '$pat' ?names"]
set n "M P X"
   return $n
}

