
# add .ascii as the default extension
# add "Calibrated" as a conversion type to write out calibrated data too
#

if {$frame == "EXP"} then {
   set treatments    [linsert $treatments 0 "Add .ascii"]
   set formats       [linsert $formats 0 "Calibrated"]
}

if {$frame == "EXP"} then {
   proc click-execute {args} {
      upvar #0 src-dirlist directorylist
      upvar #0 src-selection selection
      global format formats treatments ext savedir

      set from [get-directory src]
      set to [get-directory destn]

      :file mkdir [file join $to $savedir]

      set total 0
      foreach i $selection {
         set target [lindex $directorylist $i]
         set file [last $target]
         if {[first $target] == "d"} then {set-footer "ignoring $target since it's a directory"}

         set egfile [do-extension [lindex $treatments $ext] $file]
         set fromfile [file join $from $file]
         set tofile   [file join $to $savedir $egfile]
         set-footer "exporting $fromfile as $tofile ..."
         set z [catch {switch -- $format {
             0   {exec spec-to-ascii $fromfile $tofile}
             1   {exec eg-to-ascii -spectrum $fromfile > $tofile}
             2   {exec eg-to-ascii -spectrum $fromfile -format xy > $tofile}
             3   {exec eg-to-ascii -spectrum $fromfile -format 5y > $tofile}
             4   {exec eg-to-ascii -spectrum $fromfile -format c > $tofile}
             5   {exec eg-to-ascii -spectrum $fromfile -format r > $tofile}
         }} m]
         if {$z == 0} then {
            set-footer "$m"
            incr total
         } else {
            midas-warning "$m"
         }
      }
      set-footer "$total [pluralise-spectrum $total] successfully exported"
   }
}
