#
# Patch to change naming convetions
# Asume x => angle, y => energy
# A bit of a hack as it directly modifies the widget strings
# but the widget name could be changed in cut.tcl and
# then this wouldn't work
#

proc start args {
   global started spectrum
   global peaklow peakhigh backlow backhigh subtract

   if {[llength $args] == 1} then {set args [first $args]}
   if {$started == 0} then {make-frame; set started 1} else {open-frame}  
   if {[llength $args] > 0} then {set spectrum [first $args]}
   set subtract 0
   set peaklow 0; set peakhigh 0; set backlow 0; set backhigh 0

   set f [self frame-name]
   $f.p1.direction.button0 configure -text "Angle-axis"
   $f.p1.direction.button1 configure -text "Energy-axis"

   click-redisplay
}

proc do-project {} {
   global env debug spectrum directory resultdirectory resultname EGallow
   global direction autoshow env
   set d $direction
   set D [uppercase $d]

   set name energy; set axisname angle
   if {$d=="x"} then {set name angle; set axisname energy}

   clear-footer
   if {"$spectrum" == ""} then {
      set-footer "You haven't selected a spectrum yet!!!"
      return
   }
   if {"$directory" == ""} then {set resultdirectory [file-front $spectrum]} \
          else {set resultdirectory $directory}
   set resultname "[file-last $spectrum]-$name-projection"
#set egallow $EGallow
#set EGallow 0x30004
#   set z [catch {EG "spectrum :name '[file join $resultdirectory $resultname]' ?spec"} m]
#set EGallow $egallow
#   if {$z==0 && $m!=0x30004} then {
# prevents unbalanced brace in comment error }
   set z [catch {eg "(spectrum :name '[file join $resultdirectory $resultname]' ?spec)"} m]
   if {$z==0} then {
       if {[confirm-action [file join $resultdirectory $resultname]] == 0} then {
          set-footer "action cancelled"
          return
       }
   }

#    check for and is necessary create a temporary directory
   if {[midas-check-for-temp] == 0} {return}

   set-footer "Projecting $spectrum. This may take some seconds..."
   frame-busy
   catch {:file delete [file join $env(MIDASTempDir) tcl[pid] progress]}
   set z [catch {exec specproj -$d  -result [file join $resultdirectory $resultname] \
      -spectrum $spectrum -progress [file join $env(MIDASTempDir) tcl[pid] progress] } m]
   catch {:file delete [file join $env(MIDASTempDir) tcl[pid] progress]}
   frame-idle
   if {$z != 0} then {set-footer $m; return}
   if {"$m" != ""} then {set-footer $m; return} 
   set-footer "Total $name projection [file join $resultdirectory $resultname] created"
   send sb "redisplay-if-showing $resultdirectory"
   if {$autoshow} then {inform sd show [file join $resultdirectory $resultname]}
}

proc do-slice {} {
   global debug spectrum directory resultdirectory resultname subtract autoshow EGallow
   global peaklow peakhigh backlow backhigh
   global direction autoshow
   set d $direction
   set slicedir x
   if {$d=="x"} then {set slicedir y}
   set D [uppercase $slicedir]

   set name energy; set axisname angle
   if {$d=="x"} then {set name angle; set axisname energy}

   clear-footer
   if {"$spectrum" == ""} then {
      set-footer "You haven't selected a spectrum yet!!!"
      return
   }
   if {"$directory" == ""} then {set resultdirectory [file-front $spectrum]} \
      else {set resultdirectory $directory}
   set resultname "[file-last $spectrum].$name@$slicedir=$peaklow-$peakhigh"
#set egallow $EGallow
#set EGallow 0x30004
#set EGallow 0x30000
#   set z [catch {EG "spectrum :name '[file join $resultdirectory $resultname]' ?spec"} m]
#set EGallow $egallow
#   if {$z==0 && $m!=0x30004} then {
# prevents unbalanced brace in comment error }
   set z [catch {eg "(spectrum :name '[file join $resultdirectory $resultname]' ?spec)"} m]
   if {$z==0} then {
       if {[confirm-action [file join $resultdirectory $resultname]] == 0} then {
          set-footer "action cancelled"
          return
       }
   }
   if {!$subtract} then \
      {set limits [lsort -integer [list $peaklow $peakhigh]]} \
   else {set limits [concat [lsort -integer [list $peaklow $peakhigh]] \
                            [lsort -integer [list $backlow $backhigh]]]}
   set-footer "Slicing $spectrum. This may take some seconds..."
   frame-busy
   set z [catch {eval exec specslice -result \{[file join $resultdirectory $resultname]\} \
      -spectrum $spectrum -$slicedir -limit $limits } m]
   frame-idle
   if {$z != 0} then {set-footer $m; return}
   if {"$m" != ""} then {set-footer $m; return} 
   set-footer "$name slice onto $axisname axis: [file join $resultdirectory $resultname] created"
   send sb "redisplay-if-showing $resultdirectory"
   if {$autoshow} then {inform sd show [file join $resultdirectory $resultname]}
}
