#    Meis PSU control
#      June 1996   TK version  VP

set frame DPS
set frametitle "Detector Power Supplies"
set icontitle "MCP PSUs"

set server /VME

#
#                      proc          register                       args
#
set table(VOLTS-REQ)   {click-slider Detector.Volts.Request         {1 1 V }}
set table(CURRENT-REQ) {click-slider Detector.Current.Request       {1 1 uA}}
set table(VOLTS-TXT)   {click-null   Detector.Volts.Request         {1 1 V }}
set table(CURRENT-TXT) {click-null   Detector.Current.Request       {1 1 uA}}
#
#                                   proc            widgets      args
#
set table(Detector.Volts)           {update-psu     VOLTS        {}}
set table(Detector.Current)         {update-psu     CURRENT      {}}
set table(Detector.Volts.Request)   {update-slider  VOLTS-REQ     1}
set table(Detector.Current.Request) {update-slider  CURRENT-REQ   1}

proc click-help {} {inform mb goto {XVME-560 Setup}}

proc update-psu {w v a} {
   :modify $w-TXT :value "$v"
   :modify $w-GGE :value [scan-int $v]
}

proc click-redisplay {} {
   set list [read-regs D*]
   foreach pair $list {update-pair $pair}
}

proc click arg {
   global debug 
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit; return}
   switch $w {
      RAMP	{inform dpsr start}
      REDISPLAY {click-redisplay}
      HELP      {click-help}
      default   {click-on $w $v}
   }
}

proc make-frame {} {

    set gw 110

   :frame [self frame-name] :label "[self frame-title]" :resize F :show-footer T  \
       :icon-name "[self icon-title]"

   :panel P :padx 5 :pady 5
   :layout H; :row-gap 10; :col-gap 10
   :slider  VOLTS-REQ  :label "Voltage (V) :" :min 0 :max 3500 :valuex 15c :bold T :resolution 1
   :next-row T
   :text   VOLTS-TXT :w 7 :deaf T :label "Monitor :" :valuex 15c :bold T
   :gauge  VOLTS-GGE :label "" :min 0 :max 3500 :max-tick-label 3.5kV :ticks 8 :gauge-width $gw
   :next-row T
   :slider  CURRENT-REQ  :label "Current (uA) :" :min 0 :max 1000 :valuex 15c :bold T :resolution 1
   :next-row T
   :text   CURRENT-TXT :w 7 :deaf T :label "Monitor :" :valuex 15c :bold T
   :gauge  CURRENT-GGE :label "" :min 0 :max 1000 :max-tick-label 1mA :ticks 11 :gauge-width $gw
   :next-row T
   :button RAMP :label "Ramp Voltage..."
   :button REDISPLAY
   :button HELP

   :show T

position-frame 5 640

}

