# 
# May 2003 -  MEIS (v785n) DA
# Based on standard DA code
# at end loadsources (code based on) previous MEIS DA
#

# This is here temporarily 'cos define_VME_addresses sets it up at the moment
# should be in sys.meis
set dataangle 27.5

    set z [catch {open [file join $env(MIDASBASE) meis config RangeAngle] r} f]
    if {$z==0} then {
       set temp [gets $f]
       close $f
       if {$temp!=0} then {set dataangle $temp}
    }
    

set VERSION "MEIS"

set env(RDOUThdwre) VME

loadsource sys.common

set moduletype v785n
set V785_Base 1

set VMEPresent 1

set VMEEnable 1

set X2VBPresent 0

set TSPresent 0
set TSPresent 0

set RDOUTEnable 1

set histPresent 1
set histEnable 1

set NamesPres 0
set Names {}

set txEnable 0
set ebtxEnable 0

if {[info exists env(RDOUThdwre)] == 0} then {set hdwre VME} else {set hdwre $env(RDOUThdwre)}
set RDOUThdwre $hdwre

set DelayTicks 6

#    append to common lists

set SetupMessage "\n\
Are you sure you wish to SETUP the data acquisition system?\n\n\
SETUP will STOP data acquisition.\n\
It will also recreate all histograms.\n\
If you decide to continue please wait for the SETUP sequence to complete and DO NOT touch the system while it is in progress.
"
proc make_785_details {} {
  global specdetails
  set specdetails(V785.adc0)	{4096	    {1 0}}
  set specdetails(V785.adc2)	{4096	    {1 2}}
  set specdetails(V785.adc4)	{4096	    {1 4}}
  set specdetails(V785.adc6)	{4096	    {1 6}}
  set specdetails(V785.adc8)	{4096	    {1 8}}
  set specdetails(V785.adc10)	{4096	    {1 10}}
  set specdetails(V785.adc12)	{4096	    {1 12}}
  set specdetails(V785.adc14)	{4096	    {1 14}}
  set specdetails(V785.adc16)	{4096	    {1 16}}
  set specdetails(V785.adc18)	{4096	    {1 18}}
  set specdetails(V785.adc20)	{4096	    {1 20}}
  set specdetails(V785.adc24)	{4096	    {1 24}}
  set specdetails(V785.adc26)	{4096	    {1 26}}
  set specdetails(V785.adc28)	{4096	    {1 28}}
  set specdetails(V785.adc30)	{4096	    {1 30}}
}

set especdetails(2d.erda1)	{{183   93} {252 1}}
set especdetails(2d.erda2)	{{183   93} {252 2}}
set especdetails(2d.erda3)	{{183   93} {252 3}}
set especdetails(TAC)		{4096	    {252 4}}

set specdetails(angle)		{256	    {253 1}}
set specdetails(energy)		{1023	    {253 2}}
set specdetails(2d.full)	{{256 1023} {253 3}}
set specdetails(2d.data)	{{183   93} {253 4}}
set specdetails(scan.tilt)	{100	    {254 1}}
set specdetails(scan.spin)	{100	    {254 2}}
set specdetails(scan.rotation)	{100	    {254 3}}
set specdetails(scan.height)	{100	    {254 4}}

set tspecdetails(test.adc-A)	{4096	    {255 1}}
set tspecdetails(test.adc-B)	{4096	    {255 2}}
set tspecdetails(test.adc-C)	{4096	    {255 3}}
set tspecdetails(test.adc-D)	{4096	    {255 4}}
set tspecdetails(test.adc-PHD)	{16384	    {255 5}}


# The codes (see above) for the spectra are made up of group/item pairs
# The values must match what is expected by the DA program
# The are defined in MEIS_histogramming.h and copied here
# The RAW group is included for completeness it comes directly from the ADC
#define MIN_GROUP 1
#define MAX_GROUP 255
#define MIN_ITEM  0
#define MAX_ITEM  63

#define RAW_GROUP 1
# ITEM numbers are set dynamically depending on which ADC channels are used
#define ITEM_A ?
#define ITEM_B ?
#define ITEM_C ?
#define ITEM_D ?
#define ITEM_T ?

#define CORNER_A ((RAW_GROUP << 6) + ITEM_A)
#define CORNER_B ((RAW_GROUP << 6) + ITEM_B)
#define CORNER_C ((RAW_GROUP << 6) + ITEM_C)
#define CORNER_D ((RAW_GROUP << 6) + ITEM_D)
#define TAC_VAL  ((RAW_GROUP << 6) + ITEM_T)

#define ERDA_GROUP (MAX_GROUP-3)
#define SP_ERDA1 1
#define SP_ERDA2 2
#define SP_ERDA3 3
#define SP_TAC   4

#define CALC_GROUP (MAX_GROUP-2)
#define SP_ANGLE 1
#define SP_ENERGY 2
#define SP_2D 3
#define SP_DATA 4

#define SCAN_GROUP (MAX_GROUP-1)
#define SP_TILT 1
#define SP_SPIN 2
#define SP_ROTA 3
#define SP_HEIGHT 4

#define TEST_GROUP (MAX_GROUP-0)
#define SP_A 1
#define SP_B 2
#define SP_C 3
#define SP_D 4
#define SP_PHD 5
#define SP_T 6

proc delete_spectra {} {
   global SpectrumServer
}

proc SpectrumName n {return $n}


proc create_V785n_spectra {args} {
   global SpectrumServer V785_Base EGallow

#insert-debug "create_V785n_spectra"

   make_785_details

   set maxmodule [inform vmecontrol inquire v785ncount]
# up to 16 channels numbered 0,2,4... 30
   set maxadc 32
   if {[llength $args]>0} {set maxadc [first $args]; if {$maxadc>32} {set maxadc 32}}
# starting from ?
   set minadc 0
   if {[llength $args]==2} {set minadc [expr (([second $args]+1) / 2) * 2]}

   set egallow $EGallow
   set EGallow 0x30004

   set k 0

   for {set i 1} {$i <= $maxmodule} {incr i} {

    set-footer "creating spectra for module v785n#$i"

    for {set j $minadc} {$j < [expr $maxadc]} {incr j 2} {

      set spectrumname [SpectrumName v785n#$i.adc$j]
      set z [catch {EG "spectrum :path '/$SpectrumServer' :range 4096 :name '$spectrumname' !new" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum  $spectrumname"
          clear-footer
          error $m
      } else {
          incr k
          set group [expr $V785_Base - 1 + $i]
          map_spectrum  "$spectrumname $group $j"
      }
    }
   }
   set EGallow $egallow
   return $k
}

proc create_v785n_spectra {args} {
   global SpectrumServer VMEserver V785_Base specdetails EGallow

#insert-debug "create_v785n_spectra"

#   if {[llength $args]} {create_V785n_spectra $args; return}

   set maxmodule [inform vmecontrol inquire v785ncount]
   set z [catch {EG "register :pattern '$VMEserver/v785n#$maxmodule.*.Channel'  ?names-and-values" } m]
   if {$z} {return}

   set egallow $EGallow
   set EGallow 0x30004

   set k 0
   foreach adcchan $m {
      set i $maxmodule
      set j [second $adcchan]

      set spectrumname [SpectrumName v785n#$i.adc$j]
      set specdetails($spectrumname) [list 4096 [list 1 $j]]

      set z [catch {EG "spectrum :path '/$SpectrumServer' :range 4096 :name '$spectrumname' !new" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum  $spectrumname"
          clear-footer
          error $m
      } else {
          incr k
          set group [expr $V785_Base - 1 + $i]
          map_spectrum  "$spectrumname $group $j"
      }
   }
   set EGAllow $egallow
   redisplay-spectra
   return $k
}

proc delete_v785n_spectra {args} {
   global SpectrumServer VMEserver V785_Base specdetails

#insert-debug "delete_v785n_spectra"


   set maxmodule [inform vmecontrol inquire v785ncount]
   set z [catch {EG "register :pattern '$VMEserver/v785n#$maxmodule.*.Channel'  ?names-and-values" } m]
   if {$z} {return}

   set k 0
   foreach adcchan $m {
      set i $maxmodule
      set j [second $adcchan]

      set spectrumname [SpectrumName v785n#$i.adc$j]
      catch {unset specdetails($spectrumname)}

      set z [catch {unmap_spectrum  "$spectrumname"} d]
      set z [catch {EG "spectrum :path '/$SpectrumServer' :name '$spectrumname' !delete" } m]
      incr k
   }
   redisplay-spectra
   return $k
}

proc remake_2d_details r {
   global especdetails specdetails

   set rr [lreplace [first $specdetails(2d.data)] 1 1 $r]
   set specdetails(2d.data) [lreplace $specdetails(2d.data) 0 0 $rr]

   foreach s {1 2 3} {
     set rr [lreplace [first $especdetails(2d.erda$s)] 1 1 $r]
     set especdetails(2d.erda$s) [lreplace $especdetails(2d.erda$s) 0 0 $rr]
  }
}

proc create_2d_erda_spectra {args} {
   global SpectrumServer especdetails specdetails EGallow

   set egallow $EGallow
   set EGallow 0x30004
   foreach s [list 2d.erda1 2d.erda2 2d.erda3] {
      set name [SpectrumName $s]
      set specdetails($name) $especdetails($name)
      set range [first $specdetails($name)]
      set z [catch {EG "spectrum :path '/$SpectrumServer' :range [first $range] :range2 [second $range] :type 4 :name '$name' !new" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum  $name"
          clear-footer
          error $m
      } else {
          set groupitem [second $specdetails($name)]
#insert-debug "Mapping $name [first $groupitem] [second $groupitem]"
          set v [map_spectrum "$name [first $groupitem] [second $groupitem]"]
      }
   }
   set EGallow $egallow
}

proc create_erda_spectra {args} {
   global SpectrumServer especdetails specdetails EGallow

   create_2d_erda_spectra

   set egallow $EGallow
   set EGallow 0x30004

      set name [SpectrumName TAC]
      set specdetails($name) $especdetails($name)
      set range [first $specdetails($name)]
      set z [catch {EG "spectrum :path '/$SpectrumServer' :range $range :type 4 :name '$name' !new" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum  $name"
          clear-footer
          error $m
      } else {
          set groupitem [second $specdetails($name)]
#insert-debug "Mapping $name [first $groupitem] [second $groupitem]"
          set v [map_spectrum "$name [first $groupitem] [second $groupitem]"]
      }

   set EGallow $egallow
   redisplay-spectra
}

proc delete_2d_erda_spectra {args} {
   global SpectrumServer specdetails EGallow

#insert-debug "delete_2d_erda_spectra"

   set egallow $EGallow
   set EGallow 0x30004
   foreach s [list 2d.erda1 2d.erda2 2d.erda3] {
      set name [SpectrumName $s]
      catch {unset specdetails($name)}

      set z [catch {unmap_spectrum  "$name"} d]
      set z [catch {EG "spectrum :path '/$SpectrumServer' :name '$name' !delete" } m]
   }
   set EGallow $egallow
}

proc delete_erda_spectra {args} {
   global SpectrumServer specdetails EGallow

#insert-debug "delete_erda_spectra"

   delete_2d_erda_spectra

   set egallow $EGallow
   set EGallow 0x30004

      set name [SpectrumName TAC]
      catch {unset specdetails($name)}

      set z [catch {unmap_spectrum  "$name"} d]
      set z [catch {EG "spectrum :path '/$SpectrumServer' :name '$name' !delete" } m]

   set EGallow $egallow
   redisplay-spectra
}

proc create_test_spectra {args} {
   global SpectrumServer tspecdetails specdetails EGallow

   set egallow $EGallow
   set EGallow 0x30004
   foreach s [list A B C D PHD] {
      set name [SpectrumName test.adc-$s]
      set specdetails($name) $tspecdetails($name)
      set range [first $specdetails($name)]
      set z [catch {EG "spectrum :path '/$SpectrumServer' :range $range :type 4 :name '$name' !new" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum  $name"
          clear-footer
          error $m
      } else {
          set groupitem [second $specdetails($name)]
#insert-debug "Mapping $name [first $groupitem] [second $groupitem]"
          set v [map_spectrum "$name [first $groupitem] [second $groupitem]"]
      }
   }
   set EGallow $egallow
   redisplay-spectra
}

proc delete_test_spectra {args} {
   global SpectrumServer specdetails EGallow

#insert-debug "delete_test_spectra"

   set egallow $EGallow
   set EGallow 0x30004
   foreach s [list A B C D PHD] {
      set name [SpectrumName test.adc-$s]
      catch {unset specdetails($name)}

      set z [catch {unmap_spectrum  "$name"} d]
      set z [catch {EG "spectrum :path '/$SpectrumServer' :name '$name' !delete" } m]
   }
   set EGallow $egallow
   redisplay-spectra
}

proc create_2d_data_spectrum {args} {
   global SpectrumServer tspecdetails specdetails EGallow

   set egallow $EGallow
   set EGallow 0x30004
   set s 2d.data
      set name [SpectrumName $s]
      set range [first $specdetails($name)]
      set z [catch {EG "spectrum :path '/$SpectrumServer' :range [first $range] :range2 [second $range] :type 4 :name '$name' !new" } m]
#    Allow "Spectrum already exists" so that further spectra can be created
      if {$m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum  $name"
          clear-footer
          error $m
      } else {
          set groupitem [second $specdetails($name)]
#insert-debug "Mapping $name [first $groupitem] [second $groupitem]"
          set v [map_spectrum "$name [first $groupitem] [second $groupitem]"]
      }

   set EGallow $egallow

}

proc delete_2d_data_spectrum {args} {
   global SpectrumServer specdetails EGallow

#insert-debug "delete_test_spectra"

   set egallow $EGallow
   set EGallow 0x30004
   set s 2d.data
      set name [SpectrumName $s]
#      catch {unset specdetails($name)}

      set z [catch {unmap_spectrum  "$name"} d]
      set z [catch {EG "spectrum :path '/$SpectrumServer' :name '$name' !delete" } m]

   set EGallow $egallow

}

proc recreate_2d_data_spectrum {args} {
   delete_2d_data_spectrum
   create_2d_data_spectrum
}

proc recreate_2d_erda_spectra {args} {
   delete_2d_erda_spectra
   create_2d_erda_spectra
}

proc recreate_2d_spectra r {
   if {[read-reg MEIS.Go]} {
      display-error-report self "ERROR" "Data Acquisition in Progress" "Attempting to change 2D data spectra"
      return
   }
   remake_2d_details $r
   if {[read-reg ERDA.Enable]} {
      recreate_2d_erda_spectra
   } else {
      recreate_2d_data_spectrum
   }
}

proc create_spectra {} {
    global SpectrumServer specdetails EGallow
    global moduletype

    set i 0
#    set i [create_v785n_spectra]

#   set z [catch {EG "spectrum :path '/$SpectrumServer' :range 512 :name 'Stat' !new" } m]
#   set z [catch {EG "spectrum :path '/$SpectrumServer' :range 512 :name 'Rate' !new" } m]

set egallow $EGallow
set EGallow 0x30004
  foreach name [array names specdetails] {
    set range [first $specdetails($name)]
    set z [catch {eg "(spectrum :path '/$SpectrumServer' :name '$name' ?spec)" } m]
    if {!$z} then {continue}
#    if {!$z} then {if {$m != "0x30004"} {continue}}
    if {[llength $range]==2} then {
      set z [catch {EG "spectrum :path '/$SpectrumServer' :range [first $range] :range2 [second $range] :type 4 :name '$name' !new" } m]
    } else {
      set z [catch {EG "spectrum :path '/$SpectrumServer' :range $range :type 4 :name '$name' !new" } m]
    }
    incr i
  }
set EGallow $egallow
   
#     any other spectra created by the software histogram interface
    map_spectra
}

proc map_spectra {} {
   global EGreport env
   global RDOUThdwre
   global RDOUTEnable
   global specdetails

   if {$RDOUTEnable == 0} then {return}
   
#   inform shist start
#   inform shist close-frame

   set EGreport_SAVE $EGreport
   set EGreport -1
   
#   map_spectrum "Stat 0 0"

   set l [spectra-names]
   set n 0
   foreach item $l {
      set name [second $item]
      set z [catch {set specdetails($name)} d]
      if {!$z} then {
         set groupitem [second $d]
         if {"$groupitem" == ""} then {
            set v 1
         } else {
#insert-debug "Mapping $name [first $groupitem] [second $groupitem]"
            set v [map_spectrum "$name [first $groupitem] [second $groupitem]"]
         }
         if {"$v" != ""} then {incr n}
       }
   }

   if {$n == 0} then {write-register NetVar.DACQ.Cspectramapped 1}

   set EGreport $EGreport_SAVE

   set-footer "mapped [llength $l] spectra"
}

proc Check-DA {} {
   global OS RDOUThdwre Alive

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

#    this check only works if GOING

   set state [read-register NetVar.DACQ.Sstate]
   if {$state != 2} then {return}

   set-footer "Checking Data Acqusition Program"

   set Alive [read-register NetVar.DACQ.CAlive]
   write-register NetVar.DACQ.CAlive 0

   if {$Alive == 0} then {
#        midas-warning "Warning - Check the Data Acquisition Program - It may have crashed"
         set-footer "Warning - No data being received or the DA Program has crashed"
   } else {
         set-footer "Data Acquisition running OK"
   }
#   clear-footer
   after 5000 Check-DA
}


proc redisplay-histenable {} {}
proc redisplay-rdout {} {}
proc update_button_states {} {}



# define_v785n_config based on /MIDAS/Data_Acq/tcl/sys.common.tcl

proc define_v785n_config {} {
   global VMEserver moduletype V785_Base

   set maxmodule [inform vmecontrol inquire [set moduletype]count]
   if {$maxmodule > 0} then {DefineConfig "785 0 [format "0x%x" $V785_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {EG "register :name '$VMEserver/[set moduletype]#$i.Output_Buffer'  ?object" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register [set moduletype]#$i.Output_Buffer"
          clear-footer
          error $m
      }
      DefineConfig "785 $i [string range [first $m] 2 end]"
   }
}

# Code below based on /MIDAS/CAEN/tcl/...
proc define_VME_addresses {} {
   global VMEserver env
   global dataangle

#    load hardware configuration into readout software

   ClearConfig

#    first the DA ADC (V785/N)

   define_v785n_config

#    then the OMS Stepper motor controller (MAXv)

   set maxmodule [inform vmecontrol inquire MAXvcount]
   for {set i 1} {$i <= $maxmodule} {incr i} {
      set z [catch {EG "register :name '$VMEserver/MAXv#$i.X.Command.WriteOnly'  ?object" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register srs122#$i.Status"
          clear-footer
          error $m
      }
      write-register MAXVaddress [string range [first $m] 2 end]
   }

#    and the digital board so scan can control the current integrator

   set maxmodule [inform vmecontrol inquire xvme240count]
   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {EG "register :name '$VMEserver/xvme240#$i.CSR'  ?object" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register xvme240#$i.CSR"
          clear-footer
          error $m
      }
      write-register Detector.Scan.ControlAddress [string range [first $m] 2 end]
   }

# Some miscellaneous bits of setup that need to be done somewhere
    set z [catch {open [file join $env(MIDASBASE) meis config RangeEnergy] r} f]
    if {$z!=0} then {return}
    set temp [gets $f]
    close $f
    if {$temp==0} then {return}
    write-register 2D.Energy.Range $temp
    recreate_2d_spectra $temp

    set z [catch {open [file join $env(MIDASBASE) meis config BaseAngle] r} f]
    if {$z!=0} then {return}
    set temp [gets $f]
    close $f
    if {$temp==0} then {return}
    write-register 2D.Base.Angle $temp

    set z [catch {open [file join $env(MIDASBASE) meis config RangeAngle] r} f]
    if {$z!=0} then {return}
    set temp [gets $f]
    close $f
    if {$temp==0} then {return}
    set dataangle $temp
}

proc click-vme {action} {

   starttask vmecontrol

    switch $action {
      0    {set p DAQ-halt}
      1    {set p DAQ-go}
      2    {set p DAQ-reset}
      3    {set p DAQ-setup}
    }
 
   set-footer "sending $p to VME control task"
   set-busy

   set z [catch {send vmecontrol $p} m]

   clear-busy
   if {$m == ""} then {clear-footer} else {set-footer $m}

   if {$action == 3} then {define_VME_addresses}

   redisplay-vme
}
proc redisplay-vme {} {}

proc click-tapes {a} {}

loadsource sys.meis

#start
