#  defn.tcl

proc {Add_Daresbury SRS122_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]

   set CurrentVMEServer  $server

   define-vme-register $name xVME Reset		"-a$A16addrbase -o0x00 -w16 -d8 -pwo -zd"
   define-vme-register $name xVME Channel		"-a$A16addrbase -o0x01 -w16 -d8 -pwo -zd -i0"
   define-vme-register $name xVME Int.Enable		"-a$A16addrbase -o0x02 -w16 -d8 -pwo -zd"
   define-vme-register $name xVME Int.Disable		"-a$A16addrbase -o0x03 -w16 -d8 -pwo -zd"
   define-vme-register $name xVME Step.Reset		"-a$A16addrbase -o0x04 -w16 -d8 -prw -zd"
   define-vme-register $name xVME Step.Hi		"-a$A16addrbase -o0x05 -w16 -d8 -prw -zd -i0"
   define-vme-register $name xVME Step.Lo		"-a$A16addrbase -o0x06 -w16 -d16 -prw -zd -i0"
   define-vme-register $name xVME Encoder.Reset	"-a$A16addrbase -o0x08 -w16 -d8 -prw -zd"
   define-vme-register $name xVME Encoder.Hi		"-a$A16addrbase -o0x09 -w16 -d8 -prw -zd -i0"
   define-vme-register $name xVME Encoder.Lo		"-a$A16addrbase -o0x0a -w16 -d16 -prw -zd -i0"
   define-vme-register $name xVME Decel.Hi		"-a$A16addrbase -o0x0c -w16 -d16 -pwo -zd -i0"
   define-vme-register $name xVME Decel.Lo		"-a$A16addrbase -o0x0e -w16 -d16 -pwo -zd -i0"
   define-vme-register $name xVME HS.Range		"-a$A16addrbase -o0x10 -w16 -d8 -prw -zd"
   define-vme-register $name xVME Int			"-a$A16addrbase -o0x11 -w16 -d8 -pro -b0 -l4 -zx"
   define-vme-register $name xVME Int.Mask		"-a$A16addrbase -o0x11 -w16 -d8 -prw -b4 -l4 -zx -i0"

   define-vme-register $name xVME Status		"-a$A16addrbase -o0x12 -w16 -d16 -pro -b0 -l4 -zd"
   define-vme-register $name xVME Go			"-a$A16addrbase -o0x12 -w16 -d16 -prw -b4 -l1 -zd -i0"
   define-vme-register $name xVME Boost		"-a$A16addrbase -o0x12 -w16 -d16 -prw -b5 -l1 -zd -i0"
   define-vme-register $name xVME Feedback		"-a$A16addrbase -o0x12 -w16 -d16 -prw -b6 -l1 -zd -i1"
   define-vme-register $name xVME Direction		"-a$A16addrbase -o0x12 -w16 -d16 -prw -b7 -l1 -zd -i1"
   define-vme-register $name xVME Encoder.Dir		"-a$A16addrbase -o0x12 -w16 -d16 -pro -b8 -l1 -zd"
   define-vme-register $name xVME Slow		"-a$A16addrbase -o0x12 -w16 -d16 -pro -b9 -l1 -zd"
   define-vme-register $name xVME Stop		"-a$A16addrbase -o0x12 -w16 -d16 -prw -b10 -l1 -zd -i0"

   define-vme-register $name aVME Speed		"-a$A16addrbase -o0x14 -w16 -d16 -prw -q -tHz -n0 -r0:10240Hz,0xffff:40Hz -i400Hz"
}

proc {Daresbury SRS122_DAQ-reset} {args} {
#   SRS122
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.Status] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {Daresbury SRS122_DAQ-flush} {args} {
#   SRS122
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Daresbury SRS122_DAQ-go} {args} {
#   SRS122
    global CurrentVMEServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Daresbury SRS122_DAQ-halt} {args} {
#   SRS122
    global CurrentVMEServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Daresbury SRS122_DAQ-setup} {args} {
#   SRS122
    global CurrentVMEServer RegisterServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

#   for parameter save/restore
set {Daresbury SRS122_registersavepatterns} {}
