# spectrum information info.tcl

proc click-info-name {name} {
   global infospec EGreport

   if {$name=="" || [string range $name end end]=="/"} then {
      midas-warning "You need to select a spectrum."
      return
   }

   set tmpReport $EGreport
   set EGreport -1

   set infospec $name

   :frame [self frame-name].info :label "Spectrum Information" :transient T

   :panel INFO-PANEL :padx 5 :pady 5
   :layout H; :col-gap 10; :row-gap 10

   :text INFO-NAME :label "Name:" :valuex 70 :w 50 :value "$name"
   :next-row T

   set title [EG "spectrum :name '$name' ?title"]

   :text INFO-TITLE :label "Title:" :valuex 70 :w 50 :value "$title" :read-only T
   :next-row T

   set comment [EG "spectrum :name '$name' ?label"]

   :text INFO-COMMENT :label "Comment:" :valuex 70 :w 50 :value "$comment"
# :focus T
   :next-row T

   set list [EG "spectrum :name '$name' :infonum 3 ?info"]
   set i 0
   foreach pair $list {
      set odd [expr {$i % 2}]
      :text INFO-$i :label "[first $pair]" :valuex 70 :w 16 :value "[second $pair]" :read-only T
      if ($odd) then {:next-row T}
      incr i        
   }

   set list [EG "spectrum :name '$name' ?spec"]
   set dim [first $list]
   set i 0
   while {[incr i] <= $dim} {
      set z [catch {EG "spectrum :name '$name' :dim $i ?cal"} cal]
      if {$z==0} then {
         :next-row T
         :text CAL-$i :label "Calib $i" :valuex 70 :w 50 :value "$cal" :read-only T
      }	
   }
   :show T
   set EGreport $tmpReport
}

proc click-info-comment {comment} {
   global infospec debug
   if {$debug} then {puts stdout "comment $infospec - $comment"}
   EG "spectrum :name '$infospec' :label '$comment'"
}

proc click-info arg {
   global debug
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   switch $w {
	INFO-NAME        {click-info-name $v}
	INFO-COMMENT     {click-info-comment $v}
	default          {puts stdout $arg}
   }
}
