
#    mpxcontrol.defn.tcl
# 	copied from camaccontrol
#	could be used in future for control system MPX subsystem

#    moduledefinition
#        for each module need
#          1.  Type  (used for module choice list - ie  LeCroy 2277)
#          2.  Name  (used when generating register names  -   ie   lc2277
#          3.  taskname  (of monitor/setup window   -  ie  LC2277)
#          4.  Number of Channels (  - ie  32)


#set moduledefinition {                                                     \
#                      {"Facet"            "FACET"      "FACET"     0    }  \
#                      {"LeCroy 2375 DS"   "DS"         "LC2375"    0    }  \
#                      {"LeCroy 2277"      "lc2277"     "LC2277"    32   }  \
#                      {"Fetch"            "FETCH"      "FETCH"     0    }  \
#                      {"LeCroy 2551"      "lc2551"     "LC2551"    0    }  \
#                     }
if {[info exists env(MPXAccessMethod)]} then {
    set MPXAccessMethod .$env(MPXAccessMethod)
} else {
    set MPXAccessMethod ""
}
loadsource common.mpx$MPXAccessMethod

proc define-faraday {} {
	define-mpx-register "FaradayCup" xMPX control "-c0x18 -a0x2d0 -prw -l1 -b15"
}

proc define-buzzer {} {
	define-mpx-register "Buzzer" xMPX switch "-c0x10 -a0x280 -prw"
}

proc define-mpx-controls {} {
  global EGreport
  set TMPreport $EGreport
  set EGreport -1
  if {[llength [query-mpx-names FaradayCup.control]] == 0} then {define-faraday}
  if {[llength [query-mpx-names Buzzer.switch]] == 0} then {define-buzzer}
  set EGreport $TMPreport
}

define-mpx-controls
