#  defn.tcl

proc {Add_Matrix MSDA12_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]

   set CurrentVMEServer  $server


   define-vme-register Detector aVME Volts.Request	"-a$A16addrbase -o0x00 -w16 -d16 -pwo -q  -tV -n0 -r0:0V,0xfff:3.5kV -i0V"
   define-vme-register Detector aVME Current.Request	"-a$A16addrbase -o0x02 -w16 -d16 -pwo -qu -tA -n0 -r0:0A,0xfff:1mA     -i0A"

   define-vme-register $name xVME Channel0		"-a$A16addrbase -o0x00 -w16 -d16 -zd -pwo"
   define-vme-register $name xVME Channel1		"-a$A16addrbase -o0x02 -w16 -d16 -zd -pwo"
   define-vme-register $name xVME Channel2		"-a$A16addrbase -o0x04 -w16 -d16 -zd -pwo"
   define-vme-register $name xVME Channel3		"-a$A16addrbase -o0x06 -w16 -d16 -zd -pwo"
   define-vme-register $name xVME Channel4		"-a$A16addrbase -o0x08 -w16 -d16 -zd -pwo"
   define-vme-register $name xVME Channel5		"-a$A16addrbase -o0x0a -w16 -d16 -zd -pwo"
   define-vme-register $name xVME Channel6		"-a$A16addrbase -o0x0c -w16 -d16 -zd -pwo"
   define-vme-register $name xVME Channel7		"-a$A16addrbase -o0x0e -w16 -d16 -zd -pwo"
}

proc {Matrix MSDA12_DAQ-reset} {args} {
#   MSDA12
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.Channel0] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {Matrix MSDA12_DAQ-flush} {args} {
#   MSDA12
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Matrix MSDA12_DAQ-go} {args} {
#   MSDA12
    global CurrentVMEServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Matrix MSDA12_DAQ-halt} {args} {
#   MSDA12
    global CurrentVMEServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Matrix MSDA12_DAQ-setup} {args} {
#   MSDA12
    global CurrentVMEServer RegisterServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

#   for parameter save/restore
set {Matrix MSDA12_registersavepatterns} {}
