#    MEIS control system
#    June 1996   TK version   VP


set frame DAC
set frametitle "Matrix MS-DA12 DAC"
set icontitle DAC

set server /VME

set register(CHAN0) msda12#1.Channel0
set register(CHAN1) msda12#1.Channel1
set register(CHAN2) msda12#1.Channel2
set register(CHAN3) msda12#1.Channel3
set register(CHAN4) msda12#1.Channel4
set register(CHAN5) msda12#1.Channel5
set register(CHAN6) msda12#1.Channel6
set register(CHAN7) msda12#1.Channel7

set widget(msda12#1.Channel0) CHAN0
set widget(msda12#1.Channel1) CHAN1
set widget(msda12#1.Channel2) CHAN2
set widget(msda12#1.Channel3) CHAN3
set widget(msda12#1.Channel4) CHAN4
set widget(msda12#1.Channel5) CHAN5
set widget(msda12#1.Channel6) CHAN6
set widget(msda12#1.Channel7) CHAN7

proc click-help {} {inform mb goto {MS-DA12 Setup}}

proc update-pair {p} {
	global debug widget

	if {$debug} then {puts stderr $p}

	set reg [first $p]
	set val [second $p]
	update-widget $widget($reg) $val
}

proc click-redisplay {} {
   set list [read-regs msda12#1.*]
   foreach pair $list {update-pair $pair}
}

proc click-on {w v} {
   global  register
   write-reg $register($w) $v
}

proc click arg {
   global debug 
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit; return}
   switch $w {
      HELP      {click-help}
      default   {click-on $w $v}
   }
}


proc make-frame {} {
   :frame [self frame-name] :label "[self frame-title]" :resize F :show-footer T \
       :icon-name "[self icon-title]"

   :panel P :padx 5 :pady 5
   :layout V

   :slider CHAN0 :label "Channel 0:" :min 0 :max 4095 :resolution 1
   :slider CHAN1 :label "Channel 1:" :min 0 :max 4095 :resolution 1
   :slider CHAN2 :label "Channel 2:" :min 0 :max 4095 :resolution 1
   :slider CHAN3 :label "Channel 3:" :min 0 :max 4095 :resolution 1
   :slider CHAN4 :label "Channel 4:" :min 0 :max 4095 :resolution 1
   :slider CHAN5 :label "Channel 5:" :min 0 :max 4095 :resolution 1
   :slider CHAN6 :label "Channel 6:" :min 0 :max 4095 :resolution 1
   :slider CHAN7 :label "Channel 7:" :min 0 :max 4095 :resolution 1
   :button HELP
   :show T
}

proc update-widget {w v} {:modify $w :value $v}

