#    Meis PSU control
#     June 1996    TK version    VP

set frame PSU
set frametitle "Analyser Power Supplies"
set icontitle "PSUs"

set server /VME

#
#                     proc      register           args
#
set table(ENERGY)   {click-slider Analyser.Energy         {1000 6 keV}}
set table(POWER)    {click-int    Analyser.Power          {} }
#
#                                   proc            widgets                args
#
set table(Analyser.Volts+)       {update-psu      VPLUS     {}}
set table(Analyser.Volts-)       {update-psu      VMINUS    {}}
set table(Analyser.Current+)     {update-psu      IPLUS     {}}
set table(Analyser.Current-)     {update-psu      IMINUS    {}}
set table(Analyser.Energy)       {update-slider   ENERGY  1000}
set table(Analyser.Power)        {update-int      POWER     {}}

proc click-help {} {inform mb goto {XVME-560 Setup}}

proc update-psu {w v a} {
   :modify $w-TXT :value "$v"
   :modify $w-GGE :value [scan-int $v]
}

proc click-redisplay {} {
   set list [read-regs Analyser.\[B-Z\]*]
   foreach pair $list {update-pair $pair}
}

proc click arg {
   global debug 
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit; return}
   switch $w  {
      RAMP	{inform psur start}
      REDISPLAY {click-redisplay}
      HELP      {click-help}
      default   {click-on $w $v}
   }
}


proc make-frame {} {

 set gw 130
   
   :frame [self frame-name] :label "[self frame-title]" :resize F :show-footer T  \
         :icon-name "[self icon-title]"

   :panel P :padx 5 :pady 5 
   :layout H; :row-gap 10; :col-gap 10
   :slider  ENERGY  :label "Energy (eV) :" :w 7 :min 0 :max 416667 :resolution 1 :valuex 13c :bold T
   :next-row T
   :text   VPLUS-TXT :w 7 :deaf T :label "Voltage (+) :" :valuex 13c :bold T
   :gauge  VPLUS-GGE :label "" :min 0 :max 25 :max-tick-label 25kV :ticks 6 :gauge-width $gw
   :next-row T
   :text   VMINUS-TXT :w 7 :deaf T :label "Voltage (-) :" :valuex 13c :bold T
   :gauge  VMINUS-GGE :label "" :min 0 :max 25 :max-tick-label 25kV :ticks 6 :gauge-width $gw
   :next-row T
   :text   IPLUS-TXT :w 7 :deaf T :label "Current (+) :" :valuex 13c :bold T
   :gauge  IPLUS-GGE :label "" :min 0 :max 1000 :max-tick-label 1mA :ticks 11 :gauge-width $gw
   :next-row T
   :text   IMINUS-TXT :w 7 :deaf T :label "Current (-) :" :valuex 13c :bold T
   :gauge  IMINUS-GGE :label "" :min 0 :max 1000 :max-tick-label 1mA :ticks 11 :gauge-width $gw
   :next-row T
   :choice  POWER :label "Power:" :strings [list Off On] :exclusive T :valuex 13c
   :button RAMP :label "Ramp Energy..."
   :button REDISPLAY

   :show T
}
