#
#  Patch to add dipfind option
#

set analysismenu {integrate peakfit {"peakfit options..."} brumfit {"brumfit options..."} calibrate... \
  peak/total {"total counts"} {"counts (range)"} {"Co60 peak/total"} {"Co60 auto-calibration"} \
  {"Eu152 auto-calibration"} dipfind peakfind {"peakfind options..."} plot {"plot options..."} \
  {"save cuts"} {"check counts"} {"fix counts"}}


proc run-dipfind spec {
	global peakfindoptions

	set s $spec~

	set z [catch {eg "(spectrum :name '$s' ?spec)"}]
	if {$z==0} then {catch {EG "spectrum :name '$s' !delete"}}

	set-footer "inverting $spec into $s..."
	set z [catch {exec invertspectrum $spec $s} m]
	if {$z!=0} then {set-footer $m; clear-tags; error $m}

	set-footer "finding peaks in $s..."
	set z [catch {eval exec peakfind \
		-spectrum [transparent $s] \
		-limit $peakfindoptions(low-chan) $peakfindoptions(high-chan) \
		-fwhm $peakfindoptions(fwhm) \
		-accept $peakfindoptions(accept) } m]
	if {$z!=0} then {set-footer $m; clear-tags; error $m}

	catch {EG "spectrum :name '$s' !delete"} 

	return $m
}

proc click-dipfind ss {
	global peakfindoptions

	if {[llength $ss]==0 && [select spectrum]==""} then {
		set-footer "no spectrum selected!!!"; clear-tags; return}
	if {[llength $ss]==0} then {set ss [list [select spectrum]]}
	get-peakfind-options
	foreach s $ss {
		set z [catch {run-dipfind $s} m]
		if {$z!=0} then {set-footer $m} else {insert-log $m}
	}
	if {$s==[select spectrum]} then {
		clear-tags
		foreach c [parse-peakfind $m] {make-tag $c}
	}
	clear-footer
}

proc get-spectrum-attribute att {global gallery; return [:spectrum $gallery spectrum $att]}
proc get-spectrum-title {} {return [get-spectrum-attribute title]}
proc get-spectrum-name {} {return [get-spectrum-attribute name]}

