

set frame GON
set frametitle "Goniometer and Analyser Control"
set icontitle Goniometer

set VMEserver /VME
set server $VMEserver

set SpectrumServer VMEhist

# After development will be MAXv status bits
#set statusbits {Complete Home Full Fault Go AtZero} ;# MAXv
set statusbits {Complete Home Full Fault Go Boost Encoder Forwards Enc_Dir Slow Stop} ;# srs122

set gondebug 0
set rot_debug 0

set saveindex 0
set savetime 0
set saveserverlist {disc}
set saveserver [lindex $saveserverlist $saveindex]
set savecomment {}
set savedir specs/meis

set tempReport 0
set afterid ""
set estopping 1

set refreshmessage ""
set scanvisible 0
set statusvisible 0
set savevisible 0
set srvisible 0

set scanSpectrum 0
set scanStarted 0

set scan_energy_active 0
set scan_rot_active 0
set rotStepIncr -1

set analyserpower 0
set align(Rota)  0deg
set align(Spin)  152deg
set align(Tilt)  -1deg
set align(Height) 125mm
set align(Angle) 125deg

set transfer(Rota)  180.75deg
set transfer(Spin)  152.3deg
set transfer(Tilt)  -1deg
set transfer(Height)  125mm
set transfer(Angle) 90.5deg

if {[info exists env(EXPERIMENTDIR)]} then {set srdir  [file join $env(EXPERIMENTDIR) setups goniometer]} \
  else {set srdir [file join $env(MIDASBASE) meis config goniometer]}
set srdirlist {}
set srdefault default
set srfile    $srdefault

#
#                         proc         register                args
#
set table(REQ-ROTA)      {click-number Goniometer.Rota.Request {1 18 deg}}
set table(ZERO-ROTA)     {click-zero   Goniometer.Rota.Zero    {} }
set table(ENA-ROTA)      {click-enable    Goniometer.Rota.Enable  {} }
set table(SCAN-ROTA)     {click-scan   Goniometer.Rota         {1 18 deg} }
set table(SHOW-ROTA)     {click-show   scan.rotation           {} }
set table(REQ-SPIN)      {click-number Goniometer.Spin.Request {1 13 deg}}
set table(ZERO-SPIN)     {click-zero   Goniometer.Spin.Zero    {} }
set table(ENA-SPIN)      {click-enable    Goniometer.Spin.Enable  {} }
set table(SCAN-SPIN)     {click-scan   Goniometer.Spin         {1 13 deg} }
set table(SHOW-SPIN)     {click-show   scan.spin               {} }
set table(REQ-TILT)      {click-number Goniometer.Tilt.Request {1 7 deg}}
set table(ZERO-TILT)     {click-zero   Goniometer.Tilt.Zero    {} }
set table(ENA-TILT)      {click-enable    Goniometer.Tilt.Enable  {} }
set table(SCAN-TILT)     {click-scan   Goniometer.Tilt         {1 7 deg} }
set table(SHOW-TILT)     {click-show   scan.tilt               {} }
set table(REQ-HEIGHT)    {click-number-nocheck Goniometer.Height.Request {1 13 mm}}
set table(ZERO-HEIGHT)   {click-zero   Goniometer.Height.Zero    {} }
set table(ENA-HEIGHT)    {click-enable    Goniometer.Height.Enable  {} }
set table(SCAN-HEIGHT)   {click-height-scan Goniometer.Height  {1 13 mm} }
set table(SHOW-HEIGHT)   {click-show   scan.height           {} }
set table(REQ-ANAL)      {click-number Analyser.Angle.Request {1 18 deg}}
set table(ZERO-ANAL)     {click-zero   Analyser.Angle.Zero     {} }
set table(ENA-ANAL)      {click-enable    Analyser.Angle.Enable   {} }
set table(DEC-ANGLE)     {click-incr   Analyser.Angle.Request  {-27 deg}}
set table(INC-ANGLE)     {click-incr   Analyser.Angle.Request  {27  deg}}
set table(ENERGY-ANAL)   {click-number Analyser.Energy         {1000 6 keV}}
set table(POWER-ENERGY)  {click-int    Analyser.Power          {} }
# inc/dec value changed from 1.0185 SCL 23/7/1999
set table(DEC-ENERGY)    {click-incr   Analyser.Energy         {1.0/1.015 keV}}
set table(INC-ENERGY)    {click-incr   Analyser.Energy         {1.015 keV}}
#
set table(RANGE-ROTA)    {click-slider Goniometer.Rota.Scan.Range {1     1 deg}}
set table(PITCH-ROTA)    {click-slider Goniometer.Rota.Scan.Pitch {1000 18 deg}}
set table(DWELL-ROTA)    {click-slider Goniometer.Rota.Scan.Dwell {10     5   s}}
set table(RANGE-SPIN)    {click-slider Goniometer.Spin.Scan.Range {1     1 deg}}
set table(PITCH-SPIN)    {click-slider Goniometer.Spin.Scan.Pitch {1000 12 deg}}
set table(DWELL-SPIN)    {click-slider Goniometer.Spin.Scan.Dwell {10     5   s}}
set table(RANGE-TILT)    {click-slider Goniometer.Tilt.Scan.Range {10    1 deg}}
set table(PITCH-TILT)    {click-slider Goniometer.Tilt.Scan.Pitch {1000  7 deg}}
set table(DWELL-TILT)    {click-slider Goniometer.Tilt.Scan.Dwell {10     5   s}}
set table(RANGE-HEIGHT)  {click-slider Goniometer.Height.Scan.Range {10   1 mm}}
set table(PITCH-HEIGHT)  {click-slider Goniometer.Height.Scan.Pitch {100 1 mm}}
set table(DWELL-HEIGHT)  {click-slider Goniometer.Height.Scan.Dwell {1    1   s}}
set table(ANGLE-WINDOW)  {click-slider Detector.Angle.Scan.Window  {1 1 %}}
set table(ENERGY-WINDOW) {click-slider Detector.Energy.Scan.Window {1 1 %}}
#
#                                   proc            widgets                args
#
set table(Goniometer.Rota.Request) {update-number   REQ-ROTA                  1}
set table(Goniometer.Rota)         {update-gauge   {POS-ROTA TEXT-ROTA}       1}
set table(Goniometer.Rota.Zero)    {update-choice   ZERO-ROTA                  }
set table(Goniometer.Rota.Scan)    {update-choice   SCAN-ROTA                  }
set table(Goniometer.Rota.Drive)   {update-choice   DRV-ROTA                   }
set table(Goniometer.Rota.Enable)  {update-int      ENA-ROTA                   }
set table(Goniometer.Spin.Request) {update-number   REQ-SPIN                  1}
set table(Goniometer.Spin)         {update-gauge   {POS-SPIN TEXT-SPIN}       1}
set table(Goniometer.Spin.Zero)    {update-choice   ZERO-SPIN                  }
set table(Goniometer.Spin.Scan)    {update-choice   SCAN-SPIN                  }
set table(Goniometer.Spin.Drive)   {update-choice   DRV-SPIN                   }
set table(Goniometer.Spin.Enable)  {update-int      ENA-SPIN                   }
set table(Goniometer.Tilt.Request) {update-number   REQ-TILT                  1}
set table(Goniometer.Tilt)         {update-gauge   {POS-TILT TEXT-TILT}       1}
set table(Goniometer.Tilt.Zero)    {update-choice   ZERO-TILT                  }
set table(Goniometer.Tilt.Scan)    {update-choice   SCAN-TILT                  }
set table(Goniometer.Tilt.Drive)   {update-choice   DRV-TILT                   }
set table(Goniometer.Tilt.Enable)  {update-int      ENA-TILT                   }
set table(Goniometer.Height.Request) {update-number REQ-HEIGHT                1}
set table(Goniometer.Height)         {update-gauge {POS-HEIGHT TEXT-HEIGHT}   1}
set table(Goniometer.Height.Zero)    {update-choice ZERO-HEIGHT                }
#set table(Goniometer.Height.Scan)    {update-choice SCAN-HEIGHT                }
set table(Goniometer.Height.Drive)   {update-choice DRV-HEIGHT                 }
set table(Goniometer.Height.Enable)  {update-int    ENA-HEIGHT                 }
set table(Analyser.Angle.Request)  {update-number   REQ-ANAL                  1}
set table(Analyser.Angle)          {update-gauge   {POS-ANAL TEXT-ANAL}       1}
set table(Analyser.Angle.Drive)    {update-choice   DRV-ANAL                   }
set table(Analyser.Angle.Enable)   {update-int      ENA-ANAL                   }
set table(Analyser.Angle.Zero)     {update-choice   ZERO-ANAL                  }
set table(Analyser.Energy)         {update-number   ENERGY-ANAL            1000}
set table(Analyser.Power)          {update-int      POWER-ENERGY               }
#
set table(Goniometer.Rota.Scan.Range)   {update-slider RANGE-ROTA             1}
set table(Goniometer.Rota.Scan.Pitch)   {update-slider PITCH-ROTA          1000}
set table(Goniometer.Rota.Scan.Dwell)   {update-slider DWELL-ROTA            10}
set table(Goniometer.Spin.Scan.Range)   {update-slider RANGE-SPIN             1}
set table(Goniometer.Spin.Scan.Pitch)   {update-slider PITCH-SPIN          1000}
set table(Goniometer.Spin.Scan.Dwell)   {update-slider DWELL-SPIN            10}
set table(Goniometer.Tilt.Scan.Range)   {update-slider RANGE-TILT            10}
set table(Goniometer.Tilt.Scan.Pitch)   {update-slider PITCH-TILT          1000}
set table(Goniometer.Tilt.Scan.Dwell)   {update-slider DWELL-TILT            10}
set table(Goniometer.Height.Scan.Range) {update-slider RANGE-HEIGHT          10}
set table(Goniometer.Height.Scan.Pitch) {update-slider PITCH-HEIGHT         100}
set table(Goniometer.Height.Scan.Dwell) {update-slider DWELL-HEIGHT           1}
set table(Detector.Angle.Scan.Window)   {update-slider ANGLE-WINDOW           1}
set table(Detector.Energy.Scan.Window)  {update-slider ENERGY-WINDOW          1}
#
set table(Goniometer.Rota.Status)   {update-int   STATUS-ROTA                  }
set table(Goniometer.Spin.Status)   {update-int   STATUS-SPIN                  }
set table(Goniometer.Tilt.Status)   {update-int   STATUS-TILT                  }
set table(Goniometer.Height.Status) {update-int   STATUS-HEIGHT                }
set table(Analyser.Angle.Status)    {update-int   STATUS-ANAL                  }
#
#                                   name      title    step registers
#
set spectrum(Goniometer.Rota.Scan) {scan.rotation Rotation 0.01 Goniometer.Rota.Request}
set spectrum(Goniometer.Spin.Scan) {scan.spin     Spin     0.01 Goniometer.Spin.Request}
set spectrum(Goniometer.Tilt.Scan) {scan.tilt     Tilt     0.01 Goniometer.Tilt.Request}
set spectrum(Goniometer.Height.Scan) {scan.height     Height     0.01 Goniometer.Height.Request}

set inputwidgets {REQ-ROTA REQ-SPIN REQ-ANAL REQ-TILT REQ-HEIGHT ENERGY-ANAL}

# Mode to automatically move height up after each run
# Alternative is use Height scan in One Pass mode.

set auto_height 0

proc force-busy {} {
   global debug EGreport tempReport inputwidgets
   set tempReport $EGreport
   set EGreport -1
   foreach w $inputwidgets {
      :modify $w :inactive T
   }
   clear-footer; set-busy
}

proc release-busy {} {
   global debug EGreport tempReport inputwidgets table
   global VMEserver server debug

   set server $VMEserver
   foreach w $inputwidgets {
      :modify $w :inactive F
      set r [second $table($w)]
      update-pair [list "$r" "[read-reg $r]"]
   }
   set EGreport $tempReport
   clear-busy
}

proc read-beam-current {} {
   global VMEserver server debug

   set server $VMEserver
   set digc  [read-reg Integrator.Current]
   set range [read-reg Integrator.Current.Range]

   set unit "nA"
   scan $range "%f%s" limit unit
   set current [expr {$limit*$digc/0xfff}]

   set dp 1
   if {$limit < 500} then {set dp 2}
   if {$limit < 50}  then {set dp 3}
   if {$limit < 5}   then {set dp 4}
   set current [format %0.*f $dp $current]

   if {$current < 1.0} then {
      set current [expr {$current * 1000}]
      switch $unit {
         mA {set unit uA}
         uA {set unit nA}
         nA {set unit pA}
      }
   }
   return $current$unit
}

proc label-show-scan-spectrum {r} {
   global spectrum VMEserver SpectrumServer
   global scanSpectrum

   set server $VMEserver

   set r $r.Scan

   set run [run-num-read]
   set time [date +%d%h%y-%H:%M]
   set beam    [read-beam-current]
   set dwell   [read-reg $r.Dwell]
   set range   [read-reg $r.Range]
   set pitch   [read-reg $r.Pitch]
   set energy  [read-reg Analyser.Energy]
   set angle   [read-reg Analyser.Angle]
   set ewindow [read-reg Detector.Energy.Scan.Window]
   set awindow [read-reg Detector.Angle.Scan.Window]
   set tilt    [read-reg Goniometer.Tilt]
   set spin    [read-reg Goniometer.Spin]
   set rota    [read-reg Goniometer.Rota]

   set infolist "{Dwell: \"$dwell\"} {Current: \"$beam\"} {Energy: \"$energy\"} {Energy+/-: \"$ewindow\"} {Angle: \"$angle\"} {Angle+/-: \"$awindow\"} {Tilt: \"$tilt\"} {Spin: \"$spin\"} {Rotation: \"$rota\"} {Range+/-: \"$range\"} {Pitch: \"$pitch\"}"

   set sp $spectrum($r)
   set specname [first $sp]
   set name /$SpectrumServer/$specname
   set title "MEIS Goniometer [second $sp] Scan - Run $run - $time"
#   set spec [EG "spectrum :name '$name' ?spec"]

   set m [first $pitch]
   set reg [fourth $sp]
   set val [read-reg $reg]
   set c [expr {[first $val] - [first $range]}]
# sign of m and c reversed for rotation scan
   if {[second $sp] == "Rotation"} then {
	set m [expr {0.0 - $m}]
	set c [expr {[first $val] + [first $range]}]
   }
   set cal "linear deg 2 $c $m"

   EG "spectrum :name '$name' :title '$title'"
   EG "spectrum :name '$name' :dim 1 :cal '$cal'"
   EG "spectrum :name '$name' :infonum 3 :info '$infolist'"
   start-show [first $sp]
   EG "spectrum :name '$name' !zero"

   set d [inform sys inquire specdetails $specname]
   set scanSpectrum [second [second $d]]
}

proc start-show s {
   set a ""
   if {[is-started sd]} then {
      set a [send sd inquire refreshafter]
      send sd stop-refresh
   }

   click-show $s "" ""
   if {$a == ""} then {
      send sd click-refresh 2
   } else {
      send sd start-refresh
   }
}

proc init-reg {r} {
   global VMEserver server

   set server $VMEserver

   set rr $server/$r
   set going [read-reg MEIS.Go]
   if {$going} then {
	display-error-report self "ERROR\n" "MEIS Data Aquisition Going\n" "Attempting to write value $v to register" $rr
	release-busy
	error 1
   }

   set list [read-regs G*Scan]
   foreach pair $list {
	if {[second $pair] != 0} then {
	   if {[first $pair] != $r} then {
		display-error-report self "ERROR\n" "Scan in Progress\n" "Attempting to initialise registers" $rr
		release-busy
		error 1
	   }
	}
   }
   EG "register :pattern '$rr' !initialise"
}

proc write-reg {r v} {
   global VMEserver server

   set server $VMEserver

   set rr $server/$r
   set going [read-reg MEIS.Go]
   if {$going} then {
	display-error-report self "ERROR:" "MEIS Data Aquisition Going\n" "Attempting to write value $v to register" $rr
	release-busy
	error 1
   }

   set list [read-regs G*Scan]
   foreach pair $list {
	if {[second $pair] != 0} then {
	   if {[first $pair] != $r} then {
		display-error-report self "ERROR:" "Scan in Progress\n" "Attempting to write value $v to register" $rr
		release-busy
		error 1
	   }
	}
   }
   EG "register :pattern '$rr' :value '$v'"
}

proc write-reg-gocheck {r v} {
   global VMEserver server

   set server $VMEserver

   set rr $server/$r
   set going [read-reg MEIS.Go]
   if {$going} then {
	display-error-report self "ERROR:" "MEIS Data Aquisition Going\n" "Attempting to write value $v to register" $rr
	release-busy
	error 1
   }

   EG "register :pattern '$rr' :value '$v'"
}

proc write-reg-nocheck {r v} {
   global VMEserver server

   set server $VMEserver
   set rr $server/$r
   EG "register :pattern '$rr' :value '$v'"
}

proc update-number {w v m} {
   global gondebug
   set value [expr {[scan-num $v]*$m}]
   set v1 [first [split $value .]]
   if {$v1 == $value} then  {set value $v1}
   if {$gondebug} then {insert-debug "update-number: $w $v (=> $value) $m"}
   :modify $w :value $value
}

proc update-choice {w v a} {
   global driving

   if {$a!="ignore" && $v!=0} then {set driving 1}
   :modify $w :value $v
}

proc click-scan-default {} {
   init-reg \[D,G\]*Scan*
   set-footer "Goniometer scan parameters reinitialised..."
   click-redisplay
}

proc save-to-file f {
   global VMEserver server srdir

   set server $VMEserver

   set pattern $server/\[An,D,G\]*
   set-footer "Saving parameters $pattern ..."
   if {[file exists $f]} then {
      if {[midas-confirmation "$f already exists.\nAre you sure you wish to continue?"] == 0} then {return}
   }
   catch {file mkdir $srdir} z
   set z [catch {open $f w} file]
   if {$z != 0} then {set-footer $file; return}
   set list [read-regs \[An,D*Scan,G\]*]
   puts $file $list
   puts $file "\n"
   close $file
   set-footer "Parameters saved to $f"
   return "Parameters saved to $f"
}

proc restore-from-file f {
   global VMEserver server debug

   set server $VMEserver

   force-busy
   set-footer "restoring parameters from $f ..."
   set file [open $f r]
   set list [read $file]
   close $file
   foreach pair $list {
	if {$debug} then {puts stdout "$p"}
	set r [first $pair]
	set v [second $pair]
	set part [split [first $pair] .]
	if {[third $part] != "Scan" || [fourth $part] != ""} then {
	   write-reg $r $v
	}
   }
   refresh
   set-footer "Parameters restored from $f"
   return "Parameters restored from $f"
}

proc click-restore {} {
  sr-start-frame
}

proc xxx-click-restore m {
   global debug env srdir srdefault

   if {$m=="Default"} then {
	restore-from-file [file join $srdir $srdefault]
   } else {
	sr-start-frame
   }
}

proc do-number {r v a c} {
   global gondebug refreshmessage
   global VMEserver server debug

   set server $VMEserver

   if {$gondebug} then {puts stderr "click-number $r $v $a"}
   force-busy

   if {![string match *.* $v]} then {set v $v.0}

   set m      [first $a]
   set step   [second $a]
   set unit   [third $a]

   set newv [expr {$v * (1000.0 / $m)}]
   set value [read-reg $r]
   set oldv   [expr {[scan-num $value] * 1000.0}]
   if {$newv > $oldv && $newv < [expr $oldv+$step]} then {
      set newv [expr $oldv+$step] }
   if {$newv < $oldv && $newv > [expr $oldv-$step]} then {
      set newv [expr $oldv-$step] }

   set newv "[expr {$newv / 1000.0}] $unit"
   if {$c} then {write-reg $r $newv} else {write-reg-nocheck $r $newv}
   set refreshmessage "Stepping Complete"
   refresh
   set-footer "$r set to $newv..."
}

proc click-number {r v a} {
   do-number $r $v $a 1
}

proc click-number-nocheck {r v a} {
   do-number $r $v $a 0
}

proc click-scan {r v a} {
   global debug refreshmessage table
   global VMEserver server

   set server $VMEserver

   if {$debug} then {puts stderr "click-scan $r $v"}

   [first $table($r.Scan)] [second $table($r.Scan)] $v $a


   if {$v} then {
      set list [read-regs G*Scan]
      foreach pair $list {
         if {[second $pair] != 0} then {
            display-error-report self "ERROR" "Scan in Progress" "Attempting to Start New Scan"
            return
         }
      }
      force-busy
      set run [run-num-incr]
      label-show-scan-spectrum $r
      start-scan $r $a
      set refreshmessage "Scan Complete"
      refresh
      set-footer "Performing Scan..."
   } else {
#      release-busy
      write-reg $r.Scan 0
      stop-height-scan
   }
}

proc click-enable {r v a} {
   global debug refreshmessage
   if {$debug} then {puts stderr "click-enable $r"}

   click-int $r $v $a
   if {$v} then {
      clear-footer
      set refreshmessage "Stepper Motor now enabled"
      refresh
   } else {
      clear-footer
   }
}

proc click-zero {r v a} {
   global debug refreshmessage
   if {$debug} then {puts stderr "click-zero $r"}

   force-busy
   write-reg $r 1
   set refreshmessage "Stepper Motor now at reference point"
   refresh
   set-footer "Zeroing Stepper Motor..."
}

proc click-incr {r v a} {
   global debug refreshmessage
   global VMEserver server debug

   set server $VMEserver
   if {$debug} then {puts stderr "click-incr $r $v $a"}

   force-busy
   set step  [first $a]
   set unit  [second $a]
   set value [read-reg $r]

   if {$unit=="keV"} then {
	set value [expr [first [split [first $value] k]] * $step]
   } else {
	set value [expr [first [split [first $value] k]] + $step]
   }
   write-reg $r "$value $unit"
   set-footer "Setting analyser to $value $unit..."
   set refreshmessage "Analyser now at new position"
   refresh
}

proc strip-last s {string range $s 0 [expr [string last . $s]-1] }

proc click-redisplay {} {
   global VMEserver server debug

   set server $VMEserver
   set list [read-regs \[An,D,G\]*]
   foreach pair $list {update-pair $pair}
}

proc refresh {} {
   global afterid driving refreshmessage
   global gondebug

   if {$gondebug} then {insert-debug "refresh: waiting to write \"$refreshmessage\""}

   if {$afterid!=""} then {catch {kill-after $afterid};set afterid ""}
   set driving 0
   click-redisplay
   if {$driving} then {
        if {$gondebug} then {insert-debug "refresh: still driving"}
	set afterid [after 2000 refresh]
	set-busy
   } else {
	global scanStarted
        if {$gondebug} then {insert-debug "refresh: stopped driving"}
	:modify DEC-ANGLE :value 0
        :modify INC-ANGLE :value 0
	if {$scanStarted} then {
	   set da [inform sys click-da 0]
	   set scanStarted 0
	   if {[is-started sd]} then {
	      send sd refresh-once; send sd stop-refresh
	   }
	}
        if {$gondebug} then {insert-debug "refresh: writing \"$refreshmessage\""}
	set-footer $refreshmessage
	after 200
	release-busy
	click-redisplay
        if {$gondebug} then {insert-debug "refresh: confirm driving = $driving"}
   }
   :modify DEC-ENERGY :value 0
   :modify INC-ENERGY :value 0
}

proc click-scan-params {} {
#   display extra sub frame
   make-scanframe
   click-redisplay
}   

proc click-motor-status {} {
#   display extra sub frame
   make-statusframe
   click-redisplay
}   

proc click-save-save {} {
   global SpectrumServer saveserver savedir savecomment savespectrum 
   set c 0
   set z 0

   set server /$SpectrumServer

   set savepath /$saveserver/$savedir
   set endpath [string index $savepath [expr {[string length $savepath] - 1}]]
   if {$endpath != "." && $endpath != "/"} then {append savepath /}

   set-footer "saving $server/$savespectrum..."
   set z [catch {exec copy-spectrum $server/$savespectrum $savepath$savespectrum} m]
   set-footer $m
   if {$z==0} then {
	if {$savecomment!={}} then {
	   EG "spectrum :name '$savepath$savespectrum' :label '$savecomment'"
	}
   }
   clear-busy
}

proc click-save-server index {
   global saveserver saveserverlist saveindex
   set saveindex index
   set saveserver [lindex $saveserverlist $index]
   save-repaint
}

proc click-save-dir dir {
   global savedir
   set savedir $dir
   save-repaint
}

proc click-save-comment comment {
   global savecomment
   set savecomment $comment
   save-repaint
}

proc click-save-time on {
   global savetime
   set savetime $on
   save-default-dir
   save-repaint
}

proc save-default-dir {} {
   global savetime savedir savecomment
   if {$savetime} then {
	set savedir specs/meis/run[run-num-read]([date +%d%h%y-%H:%M]).
   } else {
	set savedir specs/meis/run[run-num-read].
   }
}

proc save-repaint {} {
   global savedir savetime saveserver saveindex savecomment savespectrum

   :modify SAVE-SERVER   :value $saveindex
   :modify SAVE-TIME     :value $savetime
   :modify SAVE-SPECTRUM :value $savespectrum
   :modify SAVE-COMMENT  :value "$savecomment"
   :modify SAVE-DIR      :value $savedir
}

proc sr-read-directory {} {
   global srdir srdirlist srfile
   set z [catch {EG "directory :path '$srdir' ?files"} m]
   if {$z!=0} then {
 	display-eg-error-report self $m "Attempting to read directory" $srdir
	error $m
   }
   set srdirlist [lsort [strip-dots [make-list $m]]]
}

proc sr-paint-directory {} {
   global srdirlist srfile
   :modify SR-LIST :append F :strings $srdirlist
   :modify SR-LIST :select  [lsearch $srdirlist $srfile]
}

proc sr-repaint {} {
   global srdir srfile
   :modify SR-DIR  :value $srdir
   :modify SR-FILE :value $srfile
}

proc click-sr-redisplay {} {
   sr-repaint
   sr-read-directory
   sr-paint-directory
}

proc save-start-frame r {
#   display extra sub frame
   global savespectrum  spectrum

   set savespectrum [first $spectrum($r)]
   make-saveframe
   click-redisplay
   save-default-dir
   save-repaint
}   

proc sr-start-frame {} {
#   display extra sub frame

   make-srframe
   click-redisplay
   click-sr-redisplay
} 
  
proc click-sr-directory dir {
   global srdir srdirlist srfile srdefault
   set srdir $dir
   sr-read-directory
   if {[lsearch $srdirlist $srfile] == -1} then {set srfile $srdefault}
   click-sr-redisplay
}

#   if {$name!=""&&[string match d* [first [exec ls -ld $srdir/$name]]]} \
#

proc click-sr-file name {
   global srdir srfile 
   set srfile $name
   click-sr-redisplay
   if {$name!="" && [file isdirectory [file join $srdir $name]]} \
      then {click-sr-directory [file join $srdir $name]}
}

proc click-sr-time-stamp {} {click-sr-file [date +%d-%h-%y(%a)%T]}

proc click-sr-save {} {
   global srdir srfile
   clear-footer
   save-to-file [file join $srdir $srfile]
   click-sr-redisplay
}

proc click-sr-restore {} {
   global srdir srfile
   set-footer "Restoring from [set file [file join $srdir $srfile]]"
   if {![file exists $file]} then {
	display-error-report self "ERROR: Failed to restore" "File does not exist:" $file
	error 1
   }
   if {![file isfile $file]} then {
	display-error-report self "ERROR: Failed to restore" "Bad file name:" $file
	error 2
   }
   restore-from-file $file
		
}

proc click-sr-edit {} {
   global srdir srfile
   set-footer "Editing [set file [file join $srdir $srfile]]"
   if {![file exists $file]} then {
	display-error-report self "ERROR: Failed to edit file" "File does not exist:" $file
	error 1
   }
   if {![file isfile $file]} then {
	display-error-report self "ERROR: Failed to edit file" "Bad file name:" $file
	error 2
   }
   exec textedit $file &
}

proc click-sr-delete {} {
   global srdir srfile
   set-footer "Deleting [set file [file join $srdir $srfile]]"
   if {![file exists $file]} then {
 	display-error-report self "ERROR: Failed to delete file" "File does not exist:" $file
	error 1
   }
   if {![file isfile $file]} then {
	display-error-report self "ERROR: Failed to delete file" "Bad file name:" $file
	error 2
   }
   file delete $file
   click-sr-redisplay
}

proc click arg {
   global debug 
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit $f; return}
   switch $w  {
      SCAN-DEFAULT {click-scan-default}
      REDISPLAY    {click-redisplay}
      RESTORE      {click-restore}
      SR-DIR       {click-sr-directory $v}
      SR-LIST      -
      SR-FILE      {click-sr-file $v}
      SR-TIME      {click-sr-time-stamp}
      SR-SAVE      {click-sr-save}
      SR-RESTORE   {click-sr-restore}
      SR-EDIT      {click-sr-edit}
      SR-DELETE    {click-sr-delete}
      SCAN         {click-scan-params}
      SCAN-ENERGY  {click-scan-energy $v}
      STATUS       {click-motor-status}
      ZSCANDIR     {click-zscan-dir $v}
      ZSCANMODE    {click-zscan-mode $v}
      HELP         {inform mb goto {Goniometer}}
      SCAN-HELP    {inform mb goto {(gon)Scanning}}
      SR-HELP      {inform mb goto {(gonsr)File}}
      SAVE-SAVE    {click-save-save}
      SAVE-QUIT    {click-quit $f}
      SAVE-SERVER  {click-save-server $v}
      SAVE-DIR     {click-save-dir $v}
      SAVE-TIME    {click-save-time $v}
      SAVE-COMMENT {click-save-comment $v}
      default      {click-on $w $v}
   }
}

proc make-frame {} {

  set col1 16

	:frame [self frame-name] :label "[self frame-title]" :resize F :show-footer T \
		:icon-name [self icon-title]

	:container C1 :layout V
# :pady 2
	:panel P1 :layout T :padx 10 :pady 10
        :layout H; :col-gap 10; :row-gap 10

	:message M1 :label "Goniometer"   :bold T :valuex [expr $col1 - 3]c
	:message M2 :label "Request" :w 9 :bold T 
	:message M3 :label "Current" :w 12 :bold T
	:message M4 :label "Drive"   :w 12 :bold T 
	:container end

	:container CR :layout V :relief R :pady 2
	:panel PR :padx 10 :pady 2
        :layout H; :col-gap 10; :row-gap 10
	:number  REQ-ROTA :w 7 :min -100 :max 360 :label "Rotation (deg):" :valuex [set col1]c
	:hskip 5; :gauge   POS-ROTA :min -100 :max 360 :ticks 10 :label ""
	:hskip 5; :choice  DRV-ROTA :strings "On" :exclusive F :deaf T :label ""
	:choice  ENA-ROTA :strings "Enable" :exclusive F :label ""
	:row-gap 8
	:next-row T
	:hskip [expr [winfo x [:path POS-ROTA]] - 1]
	:text    TEXT-ROTA :w 10 :deaf T :label ""; 
	:hskip 5; :choice  SCAN-ROTA :strings "Scan"      :exclusive F :label ""
	:choice  ZERO-ROTA :strings "Reference" :exclusive F :label ""
	:container end

	:container CS :layout V :relief R :pady 2
	:panel PS :padx 10 :pady 2
        :layout H; :col-gap 10; :row-gap 10
	:number  REQ-SPIN :w 7 :min 10 :max 220 :label "Spin (deg):" :valuex [set col1]c
	:hskip 5; :gauge   POS-SPIN :min 10 :max 220 :ticks 5 :label ""
	:hskip 5; :choice  DRV-SPIN :strings "On" :exclusive F :deaf T :label ""
	:choice  ENA-SPIN :strings "Enable" :exclusive F :label ""
	:row-gap 8
	:next-row T
	:hskip [expr [winfo x [:path POS-SPIN]] - 1]
	:text    TEXT-SPIN :w 10 :deaf T :label ""
	:hskip 5; :choice  SCAN-SPIN :strings "Scan" :exclusive F :label ""
	:choice  ZERO-SPIN :strings "Reference" :exclusive F :label ""
	:container end

	:container CT :layout V :relief R :pady 2
	:panel PT :padx 10 :pady 2
        :layout H; :col-gap 10; :row-gap 10
	:number  REQ-TILT :w 7 :min -5.000 :max 5.000 :label "Tilt (deg):" :valuex [set col1]c
	:hskip 5; :gauge   POS-TILT :min -5.000 :max 5.000 :min-tick-label "-5.00" :max-tick-label "5.00" :ticks 3 :label ""
	:hskip 5; :choice  DRV-TILT :strings "On" :exclusive F :deaf T :label ""
	:choice  ENA-TILT :strings "Enable" :exclusive F :label ""
	:row-gap 8
	:next-row T
	:hskip [expr [winfo x [:path POS-TILT]] - 1]
	:text    TEXT-TILT :w 10 :deaf T :label ""
	:hskip 5; :choice  SCAN-TILT :strings "Scan" :exclusive F :label ""
	:choice  ZERO-TILT :strings "Reference" :exclusive F :label ""
	:container end

	:container CH :layout V :relief R :pady 2
	:panel PH :padx 10 :pady 2
        :layout H; :col-gap 10; :row-gap 10
	:number  REQ-HEIGHT :w 7 :min -8 :max 8 :inc 0.1 :label "Height (mm):" :valuex [set col1]c
	:hskip 5; :gauge   POS-HEIGHT :min -8 :max 8 :ticks 5 :label ""
	:hskip 5; :choice  DRV-HEIGHT :strings "On" :exclusive F :deaf T :label ""
	:choice  ENA-HEIGHT :strings "Enable" :exclusive F :label ""
	:row-gap 8
	:next-row T
	:hskip [expr [winfo x [:path POS-HEIGHT]] - 1]
	:text    TEXT-HEIGHT :w 10 :deaf T :label ""
	:hskip 5; :choice  SCAN-HEIGHT :strings "Scan" :exclusive F :label ""
	:choice  ZERO-HEIGHT :strings "Reference" :exclusive F :label ""
	:container end

	:container CA :layout V :relief R :pady 2
	:panel PA :padx 10 :pady 2
        :layout H; :col-gap 10; :row-gap 10
	:number  REQ-ANAL :w 7 :label "Analyser (deg):" :min 0 :max 360 :valuex [set col1]c
	:hskip 5; :gauge   POS-ANAL :min 0 :max 360 :ticks 9 :label ""
	:hskip 5; :choice  DRV-ANAL :strings "On" :exclusive F :deaf T :label ""
	:choice  ENA-ANAL :strings "Enable" :exclusive F :label ""
	:row-gap 8
	:next-row T
	:hskip [expr [winfo x [:path POS-ANAL]] - 1]
	:text    TEXT-ANAL :w 10 :deaf T :label ""
	:hskip 5; :choice  DEC-ANGLE :strings "<-" :exclusive F :label ""
	:choice  INC-ANGLE :strings "->" :exclusive F :label ""
	:choice  ZERO-ANAL :strings "Ref" :exclusive F :label ""
	:container end

	:container CE :layout V :relief R :pady 2
	:panel PE :padx 10 :pady 2
        :layout H; :col-gap 10; :row-gap 10
	:number  ENERGY-ANAL :w 7 :label "Energy (eV):" :min 0 :max 416667 :valuex [set col1]c
	:choice  POWER-ENERGY :label "Power:" :strings [list "Off" "On"] :exclusive T
	:choice  DEC-ENERGY :strings "<-" :exclusive F :label ""
	:choice  INC-ENERGY :strings "->" :exclusive F :label ""
	:hskip 5; :choice  SCAN-ENERGY :strings "Scan" :exclusive F :label ""
	:container end

	:container CB :layout V :pady 2
	:panel PB :padx 10 :pady 5
        :layout H; :col-gap 10; :row-gap 10
	:button REDISPLAY  :label "Redisplay"
	:button RESTORE    :label "Save/Restore..."
	:button SCAN      :label "Scan Parameters..."
	:button STATUS    :label "Motor Status..."
	:container end

  :show T

position-frame 700 70
}

set scanStepInitDirect 1
set scanStepMode 0
set ZscanModes [list "Continuous" "Single Pass" "One Step per Run"]

proc make-scanframe {} {
  global scanStepInitDirect scanStepMode ZscanModes

  global VMEserver server debug
  set server $VMEserver
  write-attributes Goniometer.Height.Scan.Dwell "-us -r0:0,1000000:1000 -i300"

#-umins -r0:0,1800000:30 -i5

  set colA  14c
  set colB1 3c
  set colB2 4c
  set colC1 6c
  set colC2 7c

	:frame [self frame-name].scan :label "Goniometer Scan Parameters" :resize F :transient T

	:panel P :padx 5 :pady 5
        :layout H; :col-gap 10; :row-gap 10

	:message M11 :label "Detector:" :bold T :valuex $colA
	:message M12 :label "Angle (%)" :bold T :w 18
	:message M13 :label "Energy (%)" :bold T :w 30
	:row-gap 2; :next-row T 
	:slider  ANGLE-WINDOW :min 0  :max 100 :resolution 1 :valuex $colA :label "Window:"
	:slider  ENERGY-WINDOW :min 0 :max 100 :resolution 1 :valuex 3c :label ""
        :hskip 50
	:button  SCAN-DEFAULT :label "Defaults"
	:button  SCAN-HELP :label "Help..."

	:row-gap 10; :next-row T 
        :row-gap 1

	:message M1 :label "Scan:"          :bold T :valuex $colA
	:message M2 :label "Range (+/-deg)" :bold T :w 20
	:message M3 :label "Pitch (deg/1000)" :bold T :w 30
	:message M4 :label "Dwell (s/10)"      :bold T :w 30
	:row-gap 2; :next-row T 
	:slider RANGE-ROTA :min 0 :max 90   :resolution 1 :valuex $colA :label "Rotation:"
	:slider PITCH-ROTA :min 0 :max 1000 :resolution 1 :valuex $colB2 :label ""
	:slider DWELL-ROTA :min 0 :max 600   :resolution 1 :valuex $colC1 :label ""
	:row-gap 10; :next-row T 
	:slider RANGE-SPIN :min 0 :max 45   :resolution 1 :valuex $colA :label "Spin:"
	:slider PITCH-SPIN :min 0 :max 1000 :resolution 1 :valuex $colB2 :label ""
	:slider DWELL-SPIN :min 0 :max 600   :resolution 1 :valuex $colC1 :label ""
	:next-row T 
	:slider RANGE-TILT :min 0 :max 32   :resolution 1 :valuex $colA :label "Tilt (deg/10):"
	:slider PITCH-TILT :min 0 :max 100  :resolution 1 :valuex $colB2 :label ""
	:slider DWELL-TILT :min 0 :max 600   :resolution 1 :valuex $colC2 :label ""
	:col-gap 50; :row-gap 20; :next-row T 
	:message M5 :label "Height Scan:"  :bold T :valuex $colA
	:choice ZSCANDIR  :label "Direction:"  :strings [list "Down" "Up"] :value [expr ($scanStepInitDirect + 1) / 2]
	:choice ZSCANMODE  :label "Mode:"  :strings $ZscanModes :value $scanStepMode
	:col-gap 10; :row-gap 10; :next-row T 
	:message M61 :label ""  :bold T :valuex $colA
	:message M62 :label "Range (mm/10)" :bold T :w 20
	:message M63 :label "Pitch (mm/100)" :bold T :w 30
	:message M64 :label "Dwell (s)"     :bold T :w 30
	:row-gap 2; :next-row T 
	:slider RANGE-HEIGHT :min 0 :max 200  :resolution 1 :valuex $colA :label ""
	:slider PITCH-HEIGHT :min 0 :max 200  :resolution 1 :valuex $colB1 :label ""
	:slider DWELL-HEIGHT :min 0 :max 1000 :resolution 1 :valuex $colC2 :label ""

   :show T 
}

proc make-statusframe {} {
   global statusbits

   set colS 10c

	:frame [self frame-name].status :label "Stepper Motor Status" :resize F :transient T

	:panel P :padx 5 :pady 5
        :layout V; :col-gap 10; :row-gap 10

	:choice STATUS-ROTA :strings $statusbits :label "Rotation:" :deaf T :exclusive F :valuex $colS
	:choice STATUS-SPIN :strings $statusbits :label "Spin:" :deaf T :exclusive F :valuex $colS
	:choice STATUS-TILT :strings $statusbits :label "Tilt:" :deaf T :exclusive F :valuex $colS
	:choice STATUS-HEIGHT :strings $statusbits :label "Height:" :deaf T :exclusive F :valuex $colS
	:choice STATUS-ANAL :strings $statusbits :label "Analyser:" :deaf T :exclusive F :valuex $colS

   :show T
}

proc make-saveframe {} {
  global saveindex saveserverlist savetime savedir 

  set col 11c

       :frame [self frame-name].save :label "Goniometer Scan Complete" :resize F :transient T

       :panel P :padx 5 :pady 5
       :layout H; :col-gap 10; :row-gap 10

       :choice-stack SAVE-SERVER :exclusive T :valuex $col :value $saveindex \
            :label "Server:"  :strings $saveserverlist
       :hskip 50
       :checkbox SAVE-TIME :label "Time Stamp:"  :w 35 :value $savetime
       :next-row T
       :text SAVE-DIR :label "Path:" :valuex $col :w 35 :value "$savedir"
       :next-row T
       :text SAVE-SPECTRUM :label "Spectrum:" :valuex $col :w 35 :value ""
       :next-row T
       :text SAVE-COMMENT :label "Comment:" :valuex $col :w 35 :value ""
       :next-row T
       :button SAVE-SAVE :label "Save"

   :show T
}

proc make-srframe {} {
   global srdir 

	:frame [self frame-name].sr :label "Goniometer Save/Restore" :resize F :transient T

	:panel P :padx 5 :pady 5
        :layout H; :col-gap 10; :row-gap 10

       :text SR-DIR :label "Path:" :w 39 :value "$srdir"
       :next-row T
       :list SR-LIST :exclusive T :rows 10 :cols 50
       :next-row T
       :text SR-FILE :label "File:" :w 27 :value ""
       :button SR-TIME :label "Time Stamp"
       :next-row T
       :button SR-SAVE :label "Save"
       :button SR-RESTORE :label "Restore"
       :button SR-EDIT :label "Edit..."
       :button SR-DELETE :label "Delete"
       :button SR-HELP :label "Help..." 

  :show T
}

set aqafterid 0

proc click-scan-energy v {
	global estopping scan_energy_active scan_rot_active

	clear-footer
	if {$v} then {
		if {$scan_rot_active} then {
			midas-warning "Cannot start Energy Scan.\n2D Rotation Scan already running."
			return
		}
		set scan_energy_active 1
		set estopping 0
		if {![inform sys click-acquisition 1]} then {
			scan-energy-refresh -1
			set estopping 1
			return
		}
	} else {
		set estopping 1
	}
	scan-energy-refresh $v
}

proc scan-energy-refresh {v} {
	global aqafterid estopping scan_energy_active
	global VMEserver server debug auto_height

	set server $VMEserver

	clear-footer
	if {$aqafterid!=""} then {catch {kill-after $aqafterid}}
	if {!$scan_energy_active} then {return}

	if {$v==-1} then {
		set-footer "Data Acquisition Stopped"
		:modify SCAN-ENERGY :value 0 :inactive F
		set estopping 1
		if {[is-started sd]} then {send sd refresh-once; send sd stop-refresh}
		set scan_energy_active 0
		return
	}
	if {!$v} then {
		set-footer "Data Acquisition Stopping"
		:modify SCAN-ENERGY :value 1 :inactive T
	}
	set going [send sys inquire going]
	if {$going} then {
		set aqafterid [after 5000 scan-energy-refresh 1]
		if {!$estopping} {
			set-footer "Data Acquisition in Progress"
		}
		:modify SCAN-ENERGY :value 1
	} else {
		set-footer "Data Acquisition Complete"
		set aqsaved [send sys inquire aqsaved]
		if {!$aqsaved} then {
			set aqafterid [after 5000 scan-energy-refresh 1]
			set-footer "Data Being Saved" 
		} else {
			:modify SCAN-ENERGY :inactive F
			if {!$estopping} then {
				if {[read-reg ERDA.Enable] == 1} {
					inform erda set-new-tac-bases
				}
				if {$auto_height} then {
					if {[move-height] == "MoveHeightDone"} {return}
				}
				click-on DEC-ENERGY ""
				click-scan-energy 1
			} else {
				if {[is-started sd]} then {send sd refresh-once; send sd stop-refresh}
				set scan_energy_active 0
				:modify SCAN-ENERGY :value 0
				stop-height-scan
                        }
		}
	}
}

set rotStepRegister Goniometer.Rota
set rotStepNext "0.0 deg"
set rotafterid 0
set rstopping 1
set rsteps 0

proc control-scan-rot v {
    global rsteps scan_energy_active scan_rot_active rotStepRegister rotStepNext
    global VMEserver server debug

    set server $VMEserver
    if {!$v} then {
        click-scan-rot $v
        return
    }
    if {$scan_energy_active} then {
        midas-warning "Cannot start 2D Rotation Scan.\nEnergy Scan already running."
        return
    }
    if {$scan_rot_active} then {
        midas-warning "Cannot start 2D Rotation Scan - already running."
        return
    }
    set rotStepNext [read-reg $rotStepRegister]
    set rsteps 28
    click-scan-rot 1
}

proc click-scan-rot v {
    global rstopping scan_rot_active

    clear-footer
    if {$v} then {
        set scan_rot_active 1
        set rstopping 0
        if {![inform sys click-acquisition 1]} then {
            scan-rot-refresh -1
            set rstopping 1
            return
        }
    } else {
        set rstopping 1
    }
    scan-rot-refresh $v
}

proc scan-rot-refresh {v} {
    global rotafterid rsteps rstopping scan_rot_active rot_debug

    clear-footer
    if {$rotafterid!=""} then {catch {kill-after $rotafterid}}
    if {!$scan_rot_active} then {return}

    if {$v==-1} then {
        set-footer "Data Acquisition Stopped"
#        :modify SCAN-ENERGY :value 0 :inactive F
        set rstopping 1
        if {[is-started sd]} then {send sd refresh-once; send sd stop-refresh}
        release-busy
        click-redisplay
        set scan_rot_active 0
        after 5000 inform operator click-redisplay
        return
    }
    if {!$v} then {
        set-footer "Data Acquisition Stopping"
#        :modify SCAN-ENERGY :value 1 :inactive T
    }
    set going [send sys inquire going]
    if {$going} then {
        set rotafterid [after 5000 scan-rot-refresh 1]
        if {!$rstopping} {
            set-footer "Data Acquisition in Progress"
        }
#        :modify SCAN-ENERGY :value 1
    } else {
        set-footer "Data Acquisition Complete"
        set aqsaved [send sys inquire aqsaved]
        if {!$aqsaved} then {
            set rotafterid [after 5000 scan-rot-refresh 1]
            set-footer "Data Being Saved" 
        } else {
            if {![incr rsteps -1]} then {set rstopping 1} 
            if {!$rstopping} then {move-rotation}
            if {!$rstopping} then {click-scan-rot 1}
            if {$rstopping} then {
               if {[is-started sd]} then {send sd refresh-once; send sd stop-refresh}
               release-busy
               click-redisplay
               set scan_rot_active 0
               after 5000 inform operator click-redisplay
            }
        }
    }
}

proc move-rotation {} {
   global rstopping rotStepRegister rotStepNext rotStepIncr rot_debug
   global VMEserver server debug

   set server $VMEserver

if {$rot_debug} {insert-debug "move-rotation: [second [split $rotStepRegister .]]"}
   force-busy

   set value $rotStepNext
   set unit [second $value]
   set rotStepNext  "[expr [scan-num $value] + $rotStepIncr] $unit"

   set Done 0
   set Full [read-reg $rotStepRegister.Full]
   if {$Full} then {set Done 1}
   set Fault [read-reg $rotStepRegister.Fault]
   if {$Fault} then {set Done 1}

   if {$Done} then {
      set rstopping 1
   } else {
if {$rot_debug} {insert-debug "move-rotation: setting $rotStepRegister.Request to $rotStepNext"}
      write-reg-gocheck $rotStepRegister.Request $rotStepNext

      set-footer "$rotStepRegister set to $rotStepNext..."
      set rstopping [wait_for_step_done]
      click-redisplay
   }
   release-busy
   set-footer "Stepping Complete"
}

set MaxTries 50

proc wait_for_step_done {} {
    global MaxTries rotStepRegister
    global VMEserver server debug

    set server $VMEserver

    set tries 1
    set TASK EXEC
    
    after 1000

    while {$tries < $MaxTries} {

        set-footer "Waiting for stepper to finish moving ($tries)"

        if {![read-reg $rotStepRegister.Drive]} then {
            clear-footer
            return 0
        }
        incr tries
        after 500
    }

    midas-warning "Stepper has not completed moving\nGiving up waiting"
    clear-footer
    return 1
}

proc start-scan {r a} {
   global scanSpectrum scanStarted scan_debug

# Is this the right order?
# 1 set up the spectrum number to be scanned into
   write-reg Detector.Scan.Spectrum $scanSpectrum
# 2 start at channel 0
   write-reg Detector.Scan.Channel 0
# 3 flush the meis DA hardware FIFOs (probably redundant now - done in program)
# DEBUGGING scl 8/10/04
# commented out inform sys...  
   inform sys do_meisflush
# 4 start the DAQ program
   set da [inform sys click-da 1]
   if {$da==-1} then {
      write-reg $r.Scan 0
      write-reg-gocheck Detector.Scan.Spectrum [set scanSpectrum 0]
      return
   }
# 5 tell the system we're doing a scan
#   stepper program sees this and tells DAQ program to collect scan data
#   stepper program sets it back to zero when scan done

# DEBUGGING scl 8/10/04
# added after 1000  
#after 1000
   write-reg $r.Scan 1
# Try to synchronise the Spectrum display - race; doesn't always work
# DEBUGGING scl 8/10/04
# commented out after 5000...  
   after 5000 {send sd refresh-once; send sd click-reset}
   inform sys redisplay-state
   set scanStarted 1
}

# halts it at the end of the present run
proc halt-energy-scan {} {click-scan-energy 0}
# stops it in its tracks
proc stop-energy-scan {} {scan-energy-refresh -1}
proc stop-rot-scan    {} {scan-rot-refresh -1}
proc stop-height-scan {} {}

proc click-height-scan {r v a} {}

proc click-zscan-dir v {}
proc click-zscan-mode v {}

loadsource scanh
