
# command 16 is User Application 1  (loadCorrections() in MEIS DA code)
# command 17 is User Application 2  (MEIS_flush() in MEIS DA code)
proc do_loadcorrections {} {click-special 16}
proc do_meisflush {}       {click-special 17}

proc click-da {v} {
        global debug env VERSION RDOUTstate RDOUThdwre RDOUTEnable TSEnable CAMACEnable VMEEnable VXIEnable
        global meis_debug
        if {$meis_debug} then {puts stderr "setting MIDAS DA to state $v"}

#    First check that the servers have been configured - that is registers for the installed hardware have been created
#    This is performed when the server is installed for VXI

    if {$VMEEnable != 0 && [inform vmecontrol HasBeenConfigured] == 0} then {
         midas-warning "The VME server has not been configured\nIt may recently have been restarted\nUse SETUP first"
         return -1
    }
if {$meis_debug} {insert-debug "Checked VME HasBeenConfigured"}

#    Now if the action is GO ensure that a parameter restore has been performed

    if {$v == 1} {

    if {$VMEEnable != 0 && [inform vmesaverestore HasBeenRestored] == 0} then {
         set r [midas-confirmation "You have not performed a parameter restore for the VME server\nIt may recently have been restarted\n\
                          Do you wish to continue or to abort so that you can SETUP first"]
         if {$r == 0} then {return -1}
    }
if {$meis_debug} {insert-debug "Checked VME HasBeenRestored"}

    }

     if {$RDOUTEnable != 0} then {set RDOUTstate $v}
    set z [catch {
if {$meis_debug} {insert-debug "Changing DA state"}
        if {$v==0} then {
            set-footer "STOPping MIDAS DA [date]"
                Stop_Electronics
                click-vme 0
                click-rdout 0
            set-footer "MIDAS DA STOPped [date]"
#            insert-log "sys: [date] Data Acquisition STOPPED"
         }
         if {$v==1} then {
            if {$RDOUTEnable != 0} then {
                set state [read-register NetVar.DACQ.Sstate]
                if {$state == 2} then {
                    midas-warning "Data Acquisition is already running - Use STOP first"
                    return -1
                }
            }
if {$meis_debug} {insert-debug "Checked NetVar.DACQ.Sstate"}
            set-footer "GOing MIDAS DA [date]"
                Reset_Electronics
if {$meis_debug} {insert-debug "Called Reset_Electronics"}
                if {$RDOUTEnable != 0} then {
                    click-rdout 3
if {$meis_debug} {insert-debug "Called click-rdout 3"}
                    click-rdout 1
if {$meis_debug} {insert-debug "Called click-rdout 1"}
                    if {[read-register NetVar.DACQ.Sstate] != 2} then {
                         midas-warning "Data Acquisition Program not in Going state\n\GO aborted"
                         return -1
                    }
                }
                click-vme 1
if {$meis_debug} {insert-debug "Called click-vme 1"}
                Go_Electronics
if {$meis_debug} {insert-debug "Called Go_Electronics"}
            set-footer "MIDAS DA GOing [date]"
#            insert-log "sys: [date] Data Acquisition GOING"
         }
     } m ]

   set footertext $env(FooterText)
   click-redisplay
   set-footer $footertext

    return [da_state]
}

proc click-rdout  {v} {
   global RDOUTEnable RDOUThdwre

   if {$RDOUTEnable == 0} then {return}

    set z [catch {
        if {$v==0} then {
#    Halt
              after cancel Check-DA
              execute-command 1 "Halt"
        }
        if {$v==1} then {
#    Go
              if {[read-register NetVar.DACQ.Cspectramapped] != 1} then {map_spectra}

              execute-command 2 "Go"
              after 5000 Check-DA
        }
        if {$v==2} then {
#    Setup
              after cancel Check-DA
              execute-command 3 "Setup"
        }
        if {$v==3} then {
#    Reset 
              after cancel Check-DA
              execute-command 9 "Reset"
        }
        wait_for_completion
    } m ]
    redisplay-rdout
    clear-footer
}

