
proc inquire {v args} {
   global $v

   if {"$v"=="started"} then {
       global CSRstarted SSRstarted
       if {$CSRstarted || $SSRstarted} then {
          set [set v] 1
       } else {
          set [set v] 0
       }
   }
   return [if {[llength $args]==0} then {
       set [set v]
   } else {
       set [set v]([first $args])
   }]
}

proc restoreVMEregisters {file} {
   global debug RegisterServer EGreport

   set-footer "restoring from $file..."

   set f [open $file r]
   set l [read $f]
   close $f

   set EGreport_save $EGreport
   set EGreport -1
   set-busy
   set previouscard ""

   foreach item $l {
      if {$debug} then {puts stdout "restore: $item"}
      set register /$RegisterServer/[first $item]
      set value [second $item]
      if {$value == ""} then {continue}
      set card [first [split [first $item] .]]
      if {$card != $previouscard} then {
         set-footer   "restoring parameters to $card"
         set previouscard $card
      }
      if {$debug} then {puts stdout  "restoring parameter $register to value $value"}
      if {[last [split [first $item] .]] == "Bit_Set_2"} then {
         set creg [join [lreplace [split [first $item] .] end end "Bit_Clear_2"] "."]
         set tregister /$RegisterServer/$creg
# 0x79df is all ones with unused bits set to zero
         set z [catch {EG "register :name '$tregister' :value '0x79df'" } list]
      }
      set z [catch {EG "register :name '$register' :value '$value'" } list]
   }
   set EGreport $EGreport_save
   clear-busy

   set-footer "restored module setup from $file"
   insert-log "VME [date] restored module setup from $file"

   record-current-save-file setup $file

   write-registers NetVar_HasBeenRestored 1
}

proc selective-restore {file pattern} {
   global debug RegisterServer EGreport

   set-footer "restoring parameters $pattern from $file..."

   set f [open $file r]
   set l [read $f]
   close $f
 
   set EGreport_save $EGreport
   set EGreport -1
   set-busy

   foreach item $l {
#      puts stdout " $pattern $item "
      if {[match-name $pattern [first $item]]} then {
         set register /$RegisterServer/[first $item]
         set value [second $item]
         set-footer   "restoring parameter $register to value $value"
         if {$debug} then {puts stdout  "restoring parameter $register to value $value"}
         if {[last [split [first $item] .]] == "Bit_Set_2"} then {
            set creg [join [lreplace [split [first $item] .] end end "Bit_Clear_2"] "."]
            set tregister /$RegisterServer/$creg
# 0x79df is all ones with unused bits set to zero
            set z [catch {EG "register :name '$tregister' :value '0x79df'" } list]
         }
         set z [catch {EG "register :name '$register' :value '$value'" } list]
      }
   }
   set EGreport $EGreport_save
   clear-busy

   set-footer "selective restore of setup from $file"
}

