#  defn.tcl

proc {Add_Xycom XVME240_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]

   set CurrentVMEServer  $server

   define-vme-register Analyser aVME Energy		  "-a$A16addrbase -o0x88 -w16 -d16 -prw -qk -teV -n3 -r0:0eV,0xffff:416667eV -i0eV"
   define-vme-register Analyser xVME Power		  "-a$A16addrbase -o0x8a -w16 -d8 -prw -zd -b0 -l1 -i0"
   define-vme-register Goniometer xVME Rota.Select	  "-a$A16addrbase -o0x8a -w16 -d8 -pro -zd -b1 -l1 -i0"
   define-vme-register Goniometer xVME Spin.Select	  "-a$A16addrbase -o0x8a -w16 -d8 -pro -zd -b2 -l1 -i0"
   define-vme-register Goniometer xVME Tilt.Select	  "-a$A16addrbase -o0x8a -w16 -d8 -pro -zd -b3 -l1 -i0"
#   define-vme-register Analyser xVME Angle.Select	  "-a$A16addrbase -o0x00 -w16 -d8 -pro -zd -b4 -l1 -i0"
   define-vme-register Integrator xVME Start		  "-a$A16addrbase -o0x8a -w16 -d8 -prw -zd -b5 -l1 -i1"
   define-vme-register Integrator xVME Stop		  "-a$A16addrbase -o0x8a -w16 -d8 -prw -zd -b6 -l1 -i1"
   define-vme-register Integrator xVME Load		  "-a$A16addrbase -o0x8a -w16 -d8 -prw -zd -b7 -l1 -i0"
   define-vme-register Integrator xVME Running		  "-a$A16addrbase -o0x8b -w16 -d8 -pro -zd -b0 -l1"
   define-vme-register Integrator dosestep Dose.Step	  "-a[expr $A16addrbase+0x8b] -d8 -b1 -l6"
   define-vme-register Integrator pps PPS		  "-a[expr $A16addrbase+0x8b] -d8 -b1 -l2"
   define-vme-register Integrator fullscale Current.Range "-a[expr $A16addrbase+0x8b] -d8 -b3 -l4"
   define-vme-register Integrator xVME Range		  "-a$A16addrbase -o0x8b -w16 -d8 -pro -zd -b3 -l4"
   define-vme-register Integrator percent Percent	  "-a[expr $A16addrbase+0x8c]"
   define-vme-register Integrator xVME Readout		  "-a$A16addrbase -o0x8c -w16 -d16 -pro -zx"
   define-vme-register Integrator xVME Preset		  "-a$A16addrbase -o0x8e -w16 -d16 -prw -zx -i0"
   define-vme-register Integrator dose Dose		  "-a[expr $A16addrbase+0x88]"

   define-vme-register $name xVME Port0			  "-a$A16addrbase -o0x88 -w16 -d8 -prw -zx"
   define-vme-register $name xVME Port1			  "-a$A16addrbase -o0x89 -w16 -d8 -prw -zx"
   define-vme-register $name xVME Port2	 		  "-a$A16addrbase -o0x8a -w16 -d8 -prw -zx"
   define-vme-register $name xVME Port3			  "-a$A16addrbase -o0x8b -w16 -d8 -prw -zx"
   define-vme-register $name xVME Port4			  "-a$A16addrbase -o0x8c -w16 -d8 -prw -zx"
   define-vme-register $name xVME Port5			  "-a$A16addrbase -o0x8d -w16 -d8 -prw -zx"
   define-vme-register $name xVME Port6			  "-a$A16addrbase -o0x8e -w16 -d8 -prw -zx"
   define-vme-register $name xVME Port7			  "-a$A16addrbase -o0x8f -w16 -d8 -prw -zx"

   define-vme-register $name xVME CSR			  "-a$A16addrbase -o0x81 -w16 -d8 -prw -zx"
   define-vme-register $name xVME Red			  "-a$A16addrbase -o0x81 -w16 -d8 -prw -zd -b0 -l1"
   define-vme-register $name xVME Green			  "-a$A16addrbase -o0x81 -w16 -d8 -prw -zd -b1 -l1"
   define-vme-register $name xVME Int.ORPend		  "-a$A16addrbase -o0x81 -w16 -d8 -pro -zd -b2 -l1"
   define-vme-register $name xVME Int.Enable		  "-a$A16addrbase -o0x81 -w16 -d8 -prw -zd -b3 -l1"
   define-vme-register $name xVME Reset			  "-a$A16addrbase -o0x81 -w16 -d8 -prw -zd -b4 -l1"
   define-vme-register $name xVME Int.Input		  "-a$A16addrbase -o0x80 -w16 -d8 -pro -zx"
   define-vme-register $name xVME Int.Pending		  "-a$A16addrbase -o0x82 -w16 -d8 -pro -zx"
   define-vme-register $name xVME Int.Mask		  "-a$A16addrbase -o0x83 -w16 -d8 -prw -zx"
   define-vme-register $name xVME Int.Clear		  "-a$A16addrbase -o0x84 -w16 -d8 -prw -zx"
   define-vme-register $name xVME Int.Vector		  "-a$A16addrbase -o0x85 -w16 -d8 -prw -zd"
   define-vme-register $name xVME Flag			  "-a$A16addrbase -o0x86 -w16 -d8 -prw -zx"
   define-vme-register $name xVME Direction		  "-a$A16addrbase -o0x87 -w16 -d8 -prw -zx"
   define-vme-register $name xVME Port0.Output		  "-a$A16addrbase -o0x87 -w16 -d8 -prw -zd -b0 -l1"
   define-vme-register $name xVME Port1.Output		  "-a$A16addrbase -o0x87 -w16 -d8 -prw -zd -b1 -l1"
   define-vme-register $name xVME Port2.Output		  "-a$A16addrbase -o0x87 -w16 -d8 -prw -zd -b2 -l1"
   define-vme-register $name xVME Port3.Output		  "-a$A16addrbase -o0x87 -w16 -d8 -prw -zd -b3 -l1"
   define-vme-register $name xVME Port4.Output		  "-a$A16addrbase -o0x87 -w16 -d8 -prw -zd -b4 -l1"
   define-vme-register $name xVME Port5.Output		  "-a$A16addrbase -o0x87 -w16 -d8 -prw -zd -b5 -l1"
   define-vme-register $name xVME Port6.Output		  "-a$A16addrbase -o0x87 -w16 -d8 -prw -zd -b6 -l1"
   define-vme-register $name xVME Port7.Output		  "-a$A16addrbase -o0x87 -w16 -d8 -prw -zd -b7 -l1"

   define-vme-register $name bVME ID			  "-a$A16addrbase -o0x00 -w16 -d8 -pro -zc -l48"
}

proc {Xycom XVME240_DAQ-reset} {args} {
#   XVME240
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.CSR] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {Xycom XVME240_DAQ-flush} {args} {
#   XVME240
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Xycom XVME240_DAQ-go} {args} {
#   XVME240
    global CurrentVMEServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Xycom XVME240_DAQ-halt} {args} {
#   XVME240
    global CurrentVMEServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Xycom XVME240_DAQ-setup} {args} {
#   XVME240
    global CurrentVMEServer RegisterServer
    set server [second $args]
    if {$server !=""} then {set CurrentVMEServer $server}
    set module [first $args]
    set RegisterServer $CurrentVMEServer
    write-vme-register $module.Reset 1
    write-vme-register $module.CSR 0
# Green LED on
    write-vme-register $module.Green 1
# Clear all interrupts
    write-vme-register $module.Int.Clear 0xff
# Pports 3,4,5 ip 0,1,2,6,7 op
    write-vme-register $module.Direction 0xc7

    set id [read-vme-register $module.ID]
    if {[Xycom_verify $id "VMEIDXYC240    1"]} then {
# Passed
# Red off (write 1)
       write-vme-register $module.Red 1
# Green off (write 1) Confusing eh?
       write-vme-register $module.Green 1
    } else {
# Failed
       write-vme-register $module.CSR 0
    }
}

#   for parameter save/restore
set {Xycom XVME240_registersavepatterns} {}

proc Xycom_verify {rid tid} {
#   XVME240
    for {set t 0; set r -2} {$t<[string length $tid]} {incr t} {
#        if {[string index $tid $t] != [lindex $rid [incr r 2]]} {return 0}
        if {[string index $tid $t] != [string index $rid [incr r 4]]} {return 0}
    }
    return 1;
}
