#    MEIS control System
#       June 1996    TK   Version  VP


set frame DIO
set frametitle "Xycom XVME-240 Digital I/O Module"
set icontitle  XVME-240

set server /VME

#
#                     proc      register           args
#
set table(RED)       {click-neg xvme240#1.Red          {}}
set table(GREEN)     {click-int xvme240#1.Green        {}}
#set table(VERSION)   {click-txt xvme240#1.Version      {}}
set table(INTENA)    {click-int xvme240#1.Int.Enable   {}}
set table(PENDING)   {click-int xvme240#1.Int.ORPend   {}}
set table(VECTOR)    {click-int xvme240#1.Int.Vector   {}}
set table(INT-INPUT) {click-int xvme240#1.Int.Input    {}}
set table(INT-MASK)  {click-int xvme240#1.Int.Mask     {}}
set table(INT-PEND)  {click-int xvme240#1.Int.Pending  {}}
set table(INT-CLEAR) {click-int xvme240#1.Int.Clear    {}}
set table(FLAG)      {click-int xvme240#1.Flag         {}}
set table(PORT-0-IO) {click-int xvme240#1.Port0.Output {}}
set table(PORT-0)    {click-int xvme240#1.Port0        {}}
set table(PORT-1-IO) {click-int xvme240#1.Port1.Output {}}
set table(PORT-1)    {click-int xvme240#1.Port1        {}}
set table(PORT-2-IO) {click-int xvme240#1.Port2.Output {}}
set table(PORT-2)    {click-int xvme240#1.Port2        {}}
set table(PORT-3-IO) {click-int xvme240#1.Port3.Output {}}
set table(PORT-3)    {click-int xvme240#1.Port3        {}}
set table(PORT-4-IO) {click-int xvme240#1.Port4.Output {}}
set table(PORT-4)    {click-int xvme240#1.Port4        {}}
set table(PORT-5-IO) {click-int xvme240#1.Port5.Output {}}
set table(PORT-5)    {click-int xvme240#1.Port5        {}}
set table(PORT-6-IO) {click-int xvme240#1.Port6.Output {}}
set table(PORT-6)    {click-int xvme240#1.Port6        {}}
set table(PORT-7-IO) {click-int xvme240#1.Port7.Output {}}
set table(PORT-7)    {click-int xvme240#1.Port7        {}}
#
#                                   proc            widgets                args
#
set table(xvme240#1.Red)          {update-neg RED       {}}
set table(xvme240#1.Green)        {update-int GREEN     {}}
set table(xvme240#1.ID)       {update-version VERSION   {}}
set table(xvme240#1.Int.Enable)   {update-int INTENA    {}}
set table(xvme240#1.Int.ORPend)   {update-int PENDING   {}}
set table(xvme240#1.Int.Vector)   {update-int VECTOR    {}}
set table(xvme240#1.Int.Input)    {update-int INT-INPUT {}}
set table(xvme240#1.Int.Mask)     {update-int INT-MASK  {}}
set table(xvme240#1.Int.Pending)  {update-int INT-PEND  {}}
set table(xvme240#1.Int.Clear)    {update-clr INT-CLEAR {}}
set table(xvme240#1.Flag)         {update-int FLAG      {}}
set table(xvme240#1.Port0.Output) {update-int PORT-0-IO {}}
set table(xvme240#1.Port0)        {update-int PORT-0    {}}
set table(xvme240#1.Port1.Output) {update-int PORT-1-IO {}}
set table(xvme240#1.Port1)        {update-int PORT-1    {}}
set table(xvme240#1.Port2.Output) {update-int PORT-2-IO {}}
set table(xvme240#1.Port2)        {update-int PORT-2    {}}
set table(xvme240#1.Port3.Output) {update-int PORT-3-IO {}}
set table(xvme240#1.Port3)        {update-int PORT-3    {}}
set table(xvme240#1.Port4.Output) {update-int PORT-4-IO {}}
set table(xvme240#1.Port4)        {update-int PORT-4    {}}
set table(xvme240#1.Port5.Output) {update-int PORT-5-IO {}}
set table(xvme240#1.Port5)        {update-int PORT-5    {}}
set table(xvme240#1.Port6.Output) {update-int PORT-6-IO {}}
set table(xvme240#1.Port6)        {update-int PORT-6    {}}
set table(xvme240#1.Port7.Output) {update-int PORT-7-IO {}}
set table(xvme240#1.Port7)        {update-int PORT-7    {}}

proc click-help {} {inform mb goto {XVME-240 Setup}}

proc click-reset {} {
   write-reg xvme240#1.Reset 1
   write-reg xvme240#1.Reset 0
   click-redisplay
}

proc click-redisplay {} { 
   set list [read-regs xvme240#1.*]
   foreach pair $list {update-pair $pair}
}

proc click arg {
   global debug 
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit; return}
   switch $w  {
      REDISPLAY {click-redisplay}
      RESET     {click-reset}
      HELP      {click-help}
      default   {click-on $w $v}
   }
}


proc make-frame {} {

set bits {0 1 2 3 4 5 6 7}
set ipop {In Out}

set col1 20c

	:frame [self frame-name] :label "[self frame-title]"  :resize F :show-footer T  \
		:icon-name [self icon-title]

	:panel P1 :layout V :padx 5 :pady 5
        :layout H; :row-gap 10; :col-gap 10

	:choice RED   :strings [list Red] :label "LEDs:" :exclusive F :valuex $col1
	:choice GREEN :strings [list Green] :label "" :exclusive F
	:text   VERSION :w 6 :deaf T :label "Version:" :valuex 11c
	:next-row T
	:choice INTENA  :strings "Enable" :label "Interrupts:" :exclusive F  :valuex $col1
	:choice PENDING :strings "Pending" :label "" :exclusive F
	:number VECTOR  :w 3 :min 0 :max 255 :label "Vector:" :valuex 6c
	:next-row T
	:choice  INT-INPUT :strings $bits :label "Interrupt Inputs:" :exclusive F :deaf T :valuex $col1 :w 2
	:next-row T
	:choice  INT-MASK :strings $bits :label "Interrupt Mask:" :exclusive F  :valuex $col1 :w 2
	:next-row T
	:choice  INT-PEND  :strings $bits :label "Interrupts Pending:" :exclusive F :deaf T :valuex $col1 :w 2
	:next-row T
	:choice  INT-CLEAR :strings $bits :label "Interrupt Clear:" :exclusive F :valuex $col1 :w 2
	:next-row T
	:choice  FLAG :strings  $bits :label "Flag Outputs:" :exclusive F  :valuex $col1 :w 2

	:panel P2 :layout V :padx 35
        :layout H; :row-gap 10; :col-gap 10

        foreach i $bits {
	   :choice  PORT-$i-IO :strings $ipop :label "Port $i:"
	   :choice  PORT-$i    :strings $bits :label "" :exclusive F :w 2
	   :next-row T
        }

	:button REDISPLAY
	:button RESET
        :hskip 80
	:button HELP

    :show T
}

