#  defn.tcl

proc {Add_Xycom XVME560_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
   set A24addrbase [second $addressinfo]
   set A32addrbase [third $addressinfo]

   set CurrentVMEServer  $server

   define-vme-register Analyser xvme560 Volts+		"-a$A16addrbase -c1 -g1 -qk -uV -d2 -r0:0V,0xfff:25kV"
   define-vme-register Analyser xvme560 Volts-		"-a$A16addrbase -c2 -g1 -qk -uV -d2 -r0:0V,0xfff:25kV"
   define-vme-register Analyser xvme560 Current+	"-a$A16addrbase -c3 -g1 -qu -uA -d0 -r0:0A,0xfff:1mA"
   define-vme-register Analyser xvme560 Current-	"-a$A16addrbase -c4 -g1 -qu -uA -d0 -r0:0A,0xfff:1mA"
   define-vme-register Detector xvme560 Volts		"-a$A16addrbase -c5 -g0 -q  -uV -d0 -r0:0V,0xfff:3.5kV"
   define-vme-register Detector xvme560 Current		"-a$A16addrbase -c6 -g0 -qu -uA -d0 -r0:0A,0xfff:1mA"
#   define-vme-register Integrator xvme560 Current	"-a$A16addrbase -c7 -g0 -qu -uA -d0 -r0:0A,0xfff:1mA"
   define-vme-register Integrator xvme560 Current	"-a$A16addrbase -c7 -g0"

   define-vme-register $name xvme560 Zero		"-a$A16addrbase -c1 -g1 -qm -uV -d0 -r0:0V,0xfff:10V"
   define-vme-register $name xvme560 Channel0		"-a$A16addrbase -c1 -g1"
   define-vme-register $name xvme560 Channel1		"-a$A16addrbase -c1 -g1"
   define-vme-register $name xvme560 Channel2		"-a$A16addrbase -c2 -g1"
   define-vme-register $name xvme560 Channel3		"-a$A16addrbase -c3 -g1"
   define-vme-register $name xvme560 Channel4		"-a$A16addrbase -c4 -g1"
   define-vme-register $name xvme560 Channel5		"-a$A16addrbase -c5 -g0"
   define-vme-register $name xvme560 Channel6		"-a$A16addrbase -c6 -g0"
   define-vme-register $name xvme560 Channel7		"-a$A16addrbase -c7 -g0"

   define-vme-register $name xVME CSR			"-a$A16addrbase -o0x81 -w16 -d8  -prw -zx -b0"
   define-vme-register $name xVME Red			"-a$A16addrbase -o0x81 -w16 -d8  -prw -zd -b0 -l1"
   define-vme-register $name xVME Green			"-a$A16addrbase -o0x81 -w16 -d8  -prw -zd -b1 -l1"
   define-vme-register $name xVME Int.Pend		"-a$A16addrbase -o0x81 -w16 -d8  -prw -zd -b2 -l1"
   define-vme-register $name xVME Int.Enable		"-a$A16addrbase -o0x81 -w16 -d8  -prw -zd -b3 -l1"
   define-vme-register $name xVME Reset			"-a$A16addrbase -o0x81 -w16 -d8  -prw -zd -b4 -l1"
   define-vme-register $name xVME Mode			"-a$A16addrbase -o0x81 -w16 -d8  -prw -zd -b5 -l2"
   define-vme-register $name xVME Convert		"-a$A16addrbase -o0x81 -w16 -d8  -prw -zd -b7 -l1"
   define-vme-register $name xVME Int.Vector		"-a$A16addrbase -o0x83 -w16 -d8  -prw -zd"
   define-vme-register $name xVME Channel		"-a$A16addrbase -o0x85 -w16 -d8  -prw -zd -b0 -l6"
   define-vme-register $name xVME Gain			"-a$A16addrbase -o0x85 -w16 -d8  -prw -zd -b6 -l2"
   define-vme-register $name xVME Data			"-a$A16addrbase -o0x86 -w16 -d16 -pro -zx -b0 -l12"

   define-vme-register $name bVME ID			"-a$A16addrbase -o0x00 -w16 -d8  -pro -zc -l48"
}

proc {Xycom XVME560_DAQ-reset} {args} {
#   XVME560
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.CSR] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {Xycom XVME560_DAQ-flush} {args} {
#   XVME560
    global CurrentVMEServer EGallow
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Xycom XVME560_DAQ-go} {args} {
#   XVME560
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Xycom XVME560_DAQ-halt} {args} {
#   XVME560
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

proc {Xycom XVME560_DAQ-setup} {args} {
#   XVME560
    global CurrentVMEServer RegisterServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    set RegisterServer $CurrentVMEServer
    write-vme-register $module.Reset 1
    write-vme-register $module.CSR 0
# Green LED on
    write-vme-register $module.Green 1
# Random mode
    write-vme-register $module.Mode 2
    initialise-registers $module.*
    set id [read-vme-register $module.ID]
    if {[Xycom_verify $id "VMEIDXYC560    1"]} then {
# Passed
       write-vme-register $module.Green 1
       write-vme-register $module.Red 1
       write-vme-register $module.Mode 2
    } else {
# Failed
       write-vme-register $module.Green 0
       write-vme-register $module.Red 0
       write-vme-register $module.Mode 2
    }
}

#   for parameter save/restore
set {Xycom XVME560_registersavepatterns} {}

proc Xycom_verify {rid tid} {
#   XVME560
    for {set t 0; set r -2} {$t<[string length $tid]} {incr t} {
#        if {[string index $tid $t] != [lindex $rid [incr r 2]]} {return 0}
        if {[string index $tid $t] != [string index $rid [incr r 4]]} {return 0}
    }
    return 1;
}
