#    MEIS Control System
#      June 1996   TK Version  VP


set frame AIN
set frametitle "Xycom XVME-560 Analog Input Module"
set icontitle "XVME-560"

set server /VME

#
#                     proc      register           args
#
set table(RED)       {click-neg xvme560#1.Red          {}}
set table(GREEN)     {click-int xvme560#1.Green        {}}
set table(MODE)      {click-int xvme560#1.Mode         {}}
set table(INTENA)    {click-int xvme560#1.Int.Enable   {}}
set table(PENDING)   {click-int xvme560#1.Int.ORPend   {}}
set table(VECTOR)    {click-int xvme560#1.Int.Vector   {}}
set table(GAIN)      {click-con xvme560#1.Gain         {}}
set table(CHAN)      {click-con xvme560#1.Chan         {}}
#
#                                   proc            widgets                args
#
set table(xvme560#1.Red)          {update-neg RED		{}}
set table(xvme560#1.Green)        {update-int GREEN	{}}
set table(xvme560#1.ID)           {update-version VERSION	{}}
set table(xvme560#1.Mode)         {update-int MODE	{}}
set table(xvme560#1.Int.Enable)   {update-int INTENA	{}}
set table(xvme560#1.Int.ORPend)   {update-int PENDING	{}}
set table(xvme560#1.Int.Vector)   {update-int VECTOR	{}}
set table(xvme560#1.Gain)         {update-int GAIN	{}}
set table(xvme560#1.Chan)         {update-int CHAN	{}}
set table(xvme560#1.Data)         {update-txt DATA	{}}
set table(xvme560#1.Channel0)     {update-cha CHAN-0	{}}
set table(xvme560#1.Channel1)     {update-cha CHAN-1	{}}
set table(xvme560#1.Channel2)     {update-cha CHAN-2	{}}
set table(xvme560#1.Channel3)     {update-cha CHAN-3	{}}
set table(xvme560#1.Channel4)     {update-cha CHAN-4	{}}
set table(xvme560#1.Channel5)     {update-cha CHAN-5	{}}
set table(xvme560#1.Channel6)     {update-cha CHAN-6	{}}
set table(xvme560#1.Channel7)     {update-cha CHAN-7	{}}

proc click-help {} {inform mb goto {"XVME-560 Setup}}

proc click-reset {} {
   write-reg xvme560#1.Reset 1
   write-reg xvme560#1.Reset 0
   click-redisplay
}

proc click-convert {} {
   write-reg xvme560#1.Convert 1
   redisplay-data
}

proc click-redisplay {} {
   set list [read-regs xvme560#1*]
   foreach pair $list {update-pair $pair}
}

proc redisplay-data {} {
   set r xvme560#1.Data
   set v [read-reg $r]
   update-pair "$r $v"
}

proc click arg {
   global debug 
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit; return}
   switch $w {
      REDISPLAY {click-redisplay}
      RESET     {click-reset}
      CONVERT   {click-convert}
      HELP      {click-help}
      default   {click-on $w $v}
   }
}


proc make-frame {} {

  set modechoice [list "Single Channel" "Sequential Channel" "Random Channel" "External Trigger"]
  set col1 12c

   :frame [self frame-name] :label "[self frame-title]" :resize F :show-footer T \
	:icon-name "[self icon-title]"

	:panel P :padx 5 :pady 5
        :layout H; :col-gap 5; :row-gap 5

	:text   VERSION :w 5 :deaf T :label "Version:" :valuex $col1
	:next-row T
	:choice RED  :strings [list Red] :label "LEDs:" :exclusive F :valuex $col1
	:choice GREEN :strings [list Green] :label "" :exclusive F
	:next-row T
	:choice INTENA  :strings [list Enable] :label "Interrupts:" :exclusive F  :valuex $col1
	:choice PENDING :strings [list Pending] :label "" :exclusive F
	:next-row T
	:number VECTOR  :w 3 :min 0 :max 255 :label "Vector:" :valuex $col1
	:next-row T
	:choice-stack MODE :label "Mode:" :strings $modechoice :valuex $col1
	:next-row T
	:choice-stack GAIN :label "Gain:" :strings [list "x1" "x2" "x4" "x8"] :valuex $col1
	:next-row T
	:number CHAN :w 3 :min 0 :max 63 :label "Channel:" :valuex $col1
	:next-row T
	:text   DATA :w 6 :deaf T :label "Data:" :valuex $col1
	:next-row T
	:text   CHAN-0-TXT :w 6 :deaf T :label "Channel 0:" :valuex $col1
	:gauge  CHAN-0-GGE :label "" :min 0 :max 4095 :gauge-width 120 :ticks 3
	:next-row T
	:text   CHAN-1-TXT :w 6 :deaf T :label "Channel 1:" :valuex $col1
	:gauge  CHAN-1-GGE :label "" :min 0 :max 4095 :gauge-width 120 :ticks 3
	:next-row T
	:text   CHAN-2-TXT :w 6 :deaf T :label "Channel 2:" :valuex $col1
	:gauge  CHAN-2-GGE :label "" :min 0 :max 4095 :gauge-width 120 :ticks 3
	:next-row T
	:text   CHAN-3-TXT :w 6 :deaf T :label "Channel 3:" :valuex $col1
	:gauge  CHAN-3-GGE :label "" :min 0 :max 4095 :gauge-width 120 :ticks 3
	:next-row T
	:text   CHAN-4-TXT :w 6 :deaf T :label "Channel 4:" :valuex $col1
	:gauge  CHAN-4-GGE :label "" :min 0 :max 4095 :gauge-width 120 :ticks 3
	:next-row T
	:text   CHAN-5-TXT :w 6 :deaf T :label "Channel 5:" :valuex $col1
	:gauge  CHAN-5-GGE :label "" :min 0 :max 4095 :gauge-width 120 :ticks 3
	:next-row T
	:text   CHAN-6-TXT :w 6 :deaf T :label "Channel 6:" :valuex $col1
	:gauge  CHAN-6-GGE :label "" :min 0 :max 4095 :gauge-width 120 :ticks 3
	:next-row T
	:text   CHAN-7-TXT :w 6 :deaf T :label "Channel 7:" :valuex $col1
	:gauge  CHAN-7-GGE :label "" :min 0 :max 4095 :gauge-width 120 :ticks 3
	:next-row T
	:button REDISPLAY
	:button RESET
	:button CONVERT
	:button HELP
	
   :show T
}

proc update-cha {w v a} {
   :modify $w-TXT :value "$v"
   :modify $w-GGE :value $v
}

