	MODULE sparms
!   Array and global variable declarations
!	for sincalc
	implicit none
	integer,dimension(:),   allocatable :: ntypat,nzt
	integer,dimension(:),   allocatable :: kx,ky,kz
	integer,dimension (:,:,:),allocatable :: lattice
	real,dimension (:),     allocatable :: hit_det,hitprob
	real,dimension (:),     allocatable :: x,y,z
	real,dimension (:),     allocatable :: sigx, sigy,sigz
	real,dimension (:),     allocatable :: sigx_1,sigy_1,sigz_1,sigxyz
	real,dimension (:),     allocatable :: d_max2,sc_imp_par,dmax2
	real,dimension (:),     allocatable :: rmt,vx,vy,vz,scthet
	real,dimension (:),     allocatable :: bltot,x_imp,y_imp,z_imp
	real,dimension (:,:),   allocatable :: deflection
	real,dimension (:,:), allocatable,target  :: blocking,bllay, bltyp
	real,dimension (:),  pointer :: block_pt,bll_pt,blt_pt
	real::			 gauss(2001)
	integer::		 arrdim(19),mode(8)
	real,dimension(2) :: 	x_shift,y_shift
	integer,dimension(2) :: lx,ly,lz
	character(80):: status_file,text
        character(24):: hour
        integer::		nat,nan,nel,ngx,ngy,ngz,nx1,ny1,nz1,iat,ian
        integer::		zi,kxpr, kypr, kzpr,choice,iel,nzi,ntypov
	real::			xper,yper
	real::			cor_cof, cor_dis, cor_red, cor_re3
	real::			cov,def_rms
	real::			phi, thet, thet2
	real::			nproj, npreal
	real::			zmin,zmax
	real::			fake_cs, real_cs
	real::			energy, el_loss_fac
	real::			rmi
	real::			degrad,pi
	real::			xpr, ypr, zpr
	real::			sinphi, cosphi, sinth, costh, tanth
	real::			coscos, cossin, sincos, sinsin
	real::			tancos, tansin,chthet,chphi
	real::			sico2, sisi2, coth2
	real::			e1, e2, isignx, isigny
	real::			last_atom, x_cor, y_cor
	real::			xr, yr, zr, d, u
	real::			xt, yt, zt,dmax
	integer	::		numb,ndate
	real::			coulomb,scrlen,fluxc,fluxb,factor,step
	END MODULE sparms
		  
	  MODULE SINC
	  private
	  public sincalc
	  contains
	  subroutine sincalc(input_name,output_name)
	  use sparms
	  IMPLICIT NONE
	  INTEGER :: i,ibd,nprojtot,new
	  REAL    :: zmax1,trajec,e_old,scetmin,scthetc,flux
	  real    :: rmit,scm_old,random
 	  character(80):: input_name,output_name
!------------------------------------ START -----------------------------------
!	input_name='rubulk.in'
!	output_name='rubulk.out'	
        status_file = 'out.status'                       
        call fdate (hour)
        open  (2, file = status_file,status = 'unknown')

! Output to Status File
        write (2, *) 'STATUS-REPORT OF "SINCALC" RUN'
        write (2, *)   'Inputfile:  '// input_name
        write (2, *)   'Outputfile: '// output_name
! Output to Screen
        write (6, *) 'STATUS-REPORT OF "SINCALC" RUN'
	write (6, *)   'Inputfile:  '// input_name
        write (6, *)   'Outputfile: '// output_name
        close (2)
     

! Calculate pi,and degree-radians
        pi = 4.*atan(1.)                                
        degrad = pi/180.                                

!	Generate a general gaussian distribtuion
!	to be used later for vibrational parameters

	call gaussian


         write(*,*) 'Gaussian Array has been generated'
!-------------------------------- INPUT ---------------------------------------*
        open (1, file = input_name, status = 'old',	&
     &  access = 'sequential', form = 'formatted')
! Read in banner 
        read (1, *)		                text
        read (1, *)                     ndate, numb
! Read in options 
        read (1, *)                     (mode(i), i = 1,8)
! Check if its a sincalc input file 
        if (mode(7) .ne. 0 .or. mode(8) .ne. 0) then
          close (1)
          write(6,*) 'Wrong program'
          stop
        end if
! Array dimensions
        read (1, *)                     (arrdim(i), i = 1,19)
	    nat					=arrdim(1)
	    nel					=arrdim(2)
	    ngx					=arrdim(3)
	    ngy					=arrdim(4)
	    ngz					=arrdim(5)
	    nx1					=arrdim(6)
  	    ny1					=arrdim(7)
	    nz1					=arrdim(8)
	    nan					=arrdim(9)
!
!	Allocate the arrays
!
        allocate (x(nat), y(nat), z(nat))
        allocate (ntypat(nat))
        allocate (kx(nat), ky(nat), kz(nat))           
        allocate (sigx(nat), sigy(nat), sigz(nat))       
        allocate (sigx_1(nat), sigy_1(nat), sigz_1(nat)) 
        allocate (sigxyz(nat))
        allocate (hit_det(nat))              
        allocate (hitprob(nat))              
        allocate (blocking(nat, nan))
		allocate (bltyp(nel, nan))
		allocate (bllay(ngz, nan))
        allocate (sc_imp_par(nel),dmax2(nel))           
        allocate (nzt(nel), rmt(nel))        
        allocate (vx(nx1), vy(ny1), vz(nz1)) 
        allocate (scthet(nan))               
        allocate (bltot(nan))                
		allocate (x_imp(nel),y_imp(nel),z_imp(nel))           
		allocate ( lattice(ngx,ngy,ngz) )
		allocate (deflection(nel, 0:10000))
		write(*,*) 'Arrays have been allocated'

        read (1, *)	(nzt(iel), rmt(iel),iel=1,nel)
        read (1, *)	ntypov, cov
        read (1, *)	cor_cof, cor_dis
        do iat = 1,nat
          read (1, *)       x(iat),y(iat),z(iat),		&
     &                      kx(iat),ky(iat),kz(iat),		&
     &                      sigx(iat),sigy(iat),sigz(iat),	&
     &                      ntypat(iat)
        end do
        read (1, *)         xper, yper
	    read (1, *)			(vx(i),i=1,ngx)
        read (1, *)         (vy(i),i=1,ngy)
        read (1, *)         (vz(i),i=1,ngz)
        read (1, *)         phi,chthet,scthet(1),step,factor
        read (1, *)         nzi,rmi,energy, fluxc,fluxb
        close (1)
		write(*,*) 'Input File has beed successfully read in'

		

!	  Finished Readin

     call random_seed()

! Set lattice array to 0
       lattice		= 0

        zmin		= 0.0
        zmax1		= 0.0
										 
 
 !Filling up aux. lattice
        do iat = 1,nat

          lattice( kx(iat), ky(iat), kz(iat) ) = iat     

        end do

! Min and Max Z-coordinate
	zmin		= min (zmin, minval(z))                     
	zmax1		= max (zmax1, maxval(z))                   
!Inverse vibration amps.
        sigx_1(:)	= 1.0/sigx(:)                    
        sigy_1(:)	= 1.0/sigy(:)
        sigz_1(:)	= 1.0/sigz(:)
        sigxyz(:)	= 0.5/(pi*sigx(:)*sigy(:)*sigz(:))  


! Sq of corr. radius
        if (mode(6) .eq. 1) then
          cor_dis	= cor_dis**2                        
          cor_red	= 1./sqrt(1.-cor_cof**2)              
          cor_re3	= cor_red**3
        end if

!The first x,y planes are repeated
        vx(nx1)		= xper 
        vy(ny1)		= yper                                  

! Coverting degrees to radians 
		phi			= phi*degrad                                
        chthet		= chthet*degrad                          


        scthet(1)	= scthet(1)*degrad
        step		= step*degrad

 !Scattering angles


        scthet = (/((scthet(1)+(i-1)*step),i= 1,nan)/)         



!--------------------------------- SHADOWING ----------------------------------*

	call fdate(hour)
        open (unit=2,file =status_file,status='old',position='append')
        write (2, *) hour,' Starting Shadowing calculation now.'
        write (6, *) hour,' Starting Shadowing calculation now.'
        close (2)


	hit_det		= 0.0                                    
        ian		= 0                                     !Scatt. angle nr. 'zero'
        chphi		= phi                                   !Azimuthal angle of beam
        thet		= chthet                                !Polar angle of beam
        scthetc		= (scthet(1)+scthet(nan))*0.5           !Average scatt. angle
        thet2		= thet+scthetc                          !Corresp. polar angle
        nproj		= fluxc*xper*yper*cos(thet)             !Number of ch. ions
        el_loss_fac 	= 1.0  		                        !Energy=primary energy
        e_old		= 1.0


! Calculate a deflection table
        call potent           


!Impact par. for backsc. for angel scthetc (av. scatt. ang)		                          
        call scat_imp (scthetc, sc_imp_par)             


        trajec		= zmax1/cos(thet)                        !Aver. trajectory length
        scetmin		= 0.1/trajec                            !Minimum deflection
        scetmin		= min (scetmin, 0.1*degrad)             ! angle which is to be
        scetmin		= max (scetmin, 0.01*degrad)            ! properly treated
        scm_old		= scetmin

!Maximum imp. parameter i.e imp parameter for smallest deflection angle
        call scat_imp (scetmin, dmax2)                      
	dmax		=0.0
        dmax		= max(dmax, maxval(dmax2))
        dmax2	        = 1.0/(dmax2*dmax2)
!Calculation depth
        zmax		= zmax1+dmax                               
        vz(nz1)		= zmax

!Actual calculation	
        call track                                      
	

        call fdate(hour)
        open  (2, file = status_file,status='old', position ='append')
        write (2, *) hour,' Starting blocking calculation now.'
        write (6, *) hour,' Starting blocking calculation now.'
        close (2)

!Real flux
	
        flux = npreal/(xper*yper*cos(thet))             
        nprojtot = npreal
! Hitting probabilites for shadowing
        hitprob(:)  = hit_det(:)*sigxyz(:)/(fake_cs*flux)
! Reset detection probability
        hit_det		= 0.0
! Hitprob > 4.0 write output
	
!----------------------------------- BLOCKING ---------------------------------*
!
!		Change angles by pi to simulate outward track

!Azimuth changed by pi
!Polar angle of beam
!Ion mass + target mass

        phi		= phi+pi                          
        thet2		= pi-chthet                               
	rmit		= rmi+rmt(ntypat(nat))                     
!Loop over det. angles

angles :do ian = 1, nan                     

!Polar angle of detector
!Number of bl. ions
        thet		= thet2-scthet(ian)                      
        nproj		= fluxb*xper*yper*cos(thet)             
! Elastic energy loss factor
        el_loss_fac = &
		& (rmi*cos(scthet(ian))/rmit		 &		
		& +sqrt((rmi*cos(scthet(ian))/rmit)**2.  &       
		& +(rmt(ntypat(nat))-rmi)/rmit))**2.          

!Calculate New deflection angles if energy change > 0.02

       if (abs(el_loss_fac-e_old) > 0.02) then
	       call potent                                 
            e_old	= el_loss_fac
            new		= 1
       else
            new = 0
       end if

!Impact par. for backsc at scattering angle ian
	  
          call scat_imp (scthet(ian),sc_imp_par)
          trajec	= zmax1/cos(thet)
          scetmin	= 0.1/trajec                          
          scetmin	= min (scetmin, 0.1 *degrad)           
          scetmin	= max (scetmin, 0.01*degrad)
          if (abs(scetmin-scm_old) > 0.01*degrad			&
     &            .or. new .eq. 1) then

          call scat_imp (scetmin, dmax2)

          dmax		= max(dmax, maxval(dmax2))
          dmax2		= 1.0/(dmax2*dmax2)
          scm_old	= scetmin
          zmax		= zmax1+dmax
          vz(nz1)	= zmax
          end if

!Actual calculation to track ions
	  
          call track                                    
	  
	  call fdate(hour)
          open  (2, file = status_file,status='old',position = 'append')
          write (2, *) hour,' Finished with blocking angle :',ian
          write (6, *) hour,' Finished with blocking angle :',ian
          close (2)

          flux = npreal/(xper*yper*cos(thet))
          nprojtot	= nprojtot+npreal

          blocking(:,ian) = hitprob(:)*hit_det(:)*sigxyz(:)/(fake_cs*flux)
		  hit_det(:)	= 0.0

        end do angles      

!------------------------------------- OUTPUT ---------------------------------*
!	put write functions from this in a seperate subroutine
		bltyp(1:nel,1:nan) = 0.0
		bllay(1:ngz,1:nan) = 0.0
        do ian = 1,nan                                  !Loop over angles
          bltot(ian) = 0.
          ibd = 0
          do iat = 1, nat                               !PB - 
            bltot(ian) = bltot(ian)+blocking(iat, ian)
	        bllay(kz(iat), ian)		=			&
			    bllay(kz(iat), ian)				&
			+	blocking(iat, ian)
            bltyp(ntypat(iat), ian) =			&
				bltyp(ntypat(iat), ian)			&
     		+	blocking(iat, ian)
            end do
		  end do
!Loop over angles
        do ian = 1,nan          
            bltot(ian)			= bltot(ian)/factor
			do i=1,ngz
			    bllay(i, ian)	= bllay(i, ian)/factor
			end do
	        do iel = 1, nel
		        bltyp(iel, ian) = bltyp(iel, ian)/factor
			end do
	  end do	

!	write output file

	call write_out(input_name,output_name)


        open  (2, file= status_file, status= 'old',position='append')
        write (2, *) 'JOB SUCCESSFULLY COMPLETED'
        write (6, *) 'JOB SUCCESSFULLY COMPLETED'
        close (2)
        deallocate (x, y, z)
        deallocate (ntypat)
        deallocate (kx, ky, kz)           
        deallocate (sigx, sigy, sigz)       
        deallocate (sigx_1, sigy_1, sigz_1) 
        deallocate (sigxyz)
        deallocate (hit_det)              
        deallocate (hitprob)              
        deallocate (blocking)        
        deallocate (sc_imp_par,dmax2)           
        deallocate (nzt, rmt)        
        deallocate (vx, vy, vz) 
        deallocate (scthet)               
        deallocate (bltot)                
!        deallocate (bllay)
        deallocate (bltyp)
		deallocate (x_imp,y_imp,z_imp)           
		deallocate ( lattice )
		deallocate (deflection)

		end subroutine sincalc
!----------------------------------- STOP -------------------------------------*
        SUBROUTINE TRACK
!********************************************************************************
!*       TTTTTT  RRRRR    AAAA    CCCC   K    K                                 *
!*         TT    R    R  A    A  C    C  K  KK                                  *
!*         TT    RRRRR   AAAAAA  C       KKK                                    *
!*         TT    R  R    A    A  C    C  K  KK                                  *
!*         TT    R   RR  A    A   CCCC   K    K                                 *
!********************************************************************************
	use sparms
	IMPLICIT NONE
	integer :: direct
	logical :: tofar,backscatt
	real    :: a,b,tanphi,cotphi,spread,ystart,xstart,zstart
	real    :: delx,dely,gonio,sgonio,delta,e11,e21
	real    :: z_i1,y_i1,x_i1,sinan,cosan,tasi1
	real    :: taco1,sisi1,sico1,cosi1,coco1
	real    :: tath1,sith1,sith2,coth1,coph1,siph1,random
	integer :: ix,iy,kxstrt,kystrt,numx,numy,isy1,isx1
!-------------------------- GENERAL INITIALIZATION ---------------------------*
        last_atom	= 0
        siph1		= sin(phi)                        
        coph1		= cos(phi)
        sith1		= sin(thet)                       
        coth1		= cos(thet)
        sith2		= sin(thet2)                      
        coth2		= cos(thet2)                      
        tath1		= sith1/coth1
        coco1		= coth1*coph1
        cosi1		= coth1*siph1
        sico1		= sith1*coph1
        sisi1		= sith1*siph1
        sico2		= sith2*coph1
        sisi2		= sith2*siph1
        taco1		= tath1*coph1
        tasi1		= tath1*siph1
        isx1		= int(sign(1., coph1))            !Moving in pos/neg x-direction
        isy1		= int(sign(1., siph1))            !Moving in pos/neg y-direction
!Cosine and Sine of initial scatt. angle
        cosan		= sith1*sith2+coth1*coth2         
        sinan		= sqrt(1.-cosan**2)               
! Unit vector in the (initial) direction of the impact parameter for backscattering
        x_i1		= (sico2-cosan*sico1)/sinan        
        y_i1		= (sisi2-cosan*sisi1)/sinan        
        z_i1		= (coth2-cosan*coth1 )/sinan       
!CS = (sine(scatt.ang./2.))**-4
        fake_cs = 1./((cosan-1.0)**2)            
        x_shift(1) = 0.0
        y_shift(1) = 0.0

!X-comp/Z-comp of initial veloc. Y-comp/Z-comp of initial veloc.
        e11 = abs(taco1)                        
        e21 = abs(tasi1)                        

        if (e11 > 1. .or. e21 > 1.) then  !Initial z-coord. of track for
          zstart = zmin-dmax/sith1              ! start in x- or y-direction
        else                                    ! and for
          zstart = 0.                           ! start in z-direction
        end if

!------------------------------ START MAIN LOOP -------------------------------*
        delta = 1/sqrt(nproj/(xper*yper*coth1)) !The ions are regularly
        gonio = coco1*coco1+siph1*siph1         ! distributed over the surface
        sgonio = sqrt(gonio)                    ! unit cell. To this end the
        numx = max(1, nint(xper*sgonio/delta))  ! total number of ions is
        numy = max(1, nint(yper*coth1&           ! adjusted a little bit.
     &               /(delta*sgonio)))
        npreal = numx*numy                      !Resulting no. of ions
        delx = xper/numx                        !Stepsize in x-direction
        dely = yper/numy                        !Stepsize in y-direction
        
!Random mesh assumed
        kxstrt = 2
!Start positions on mesh
        xstart = -delx/2.0                    

!Loop over x-coord. of startpos.
xloop: do ix = 0, numx-1                   
        xstart = xstart+delx
		do while(vx(kxstrt)<xstart)
		kxstrt = kxstrt+1
        end do
		kystrt = 2
        ystart = -dely/2.

!Loop over y-coord. of startpos.
yloop:  do iy  = 0, numy-1                   
        ystart = ystart+dely
		do while(vy(kystrt)<ystart)
		kystrt = kystrt+1
		end do

!--------------------------- INITIALIZATION PER TRACK -------------------------*
        xpr	= xstart
        ypr = ystart
        call  random_number(random)
        xpr = xpr+random*delx
        call  random_number(random)
        ypr = ypr+random*dely

! Ensure position isn't greater than repeat distance
        if (xpr > xper) xpr = xpr-xper     
        if (ypr > yper) ypr = ypr-yper     
        zpr = zstart
        kxpr = kxstrt
        kypr = kystrt
        kzpr = 1

        if (mode(6) .eq. 1) then
          last_atom = 0
          x_cor = 0.
          y_cor = 0.
        end if

!       The width of the beam spot, 0.5mm/90mm, as well as the  width of the
!       entrance slit, 1.0mm/90mm, are accounted for in the calculation of
!       detection probabilities:
        if (ian .ne. 0) then
          call random_number(random)
          spread = (random-0.5)*.005555555
          call random_number(random)
          spread=spread+(random-0.5)*.01111111
          a = sico1-spread*siph1
          b = sisi1+spread*coph1
          call direction (a, b, coth1)
          call new_gonio                        ! goniometry of track
        else
          cosphi	= coph1
          sinphi	= siph1
          costh		= coth1
          sinth		= sith1
          coscos	= coco1
          cossin	= cosi1
          sincos	= sico1
          tanth		= tath1                        
          tancos	= taco1                       
          tansin	= tasi1
          isignx	= isx1
          isigny	= isy1
          real_cs	= fake_cs
          x_imp(1:nel)		= x_i1*sc_imp_par(1:nel)
          y_imp(1:nel)		= y_i1*sc_imp_par(1:nel)
          z_imp(1:nel)		= z_i1*sc_imp_par(1:nel)
          e1		= e11
          e2		= e21
          sinsin	= sisi1
        end if

! Determine major direction from velocity ratios

        if (e1 > e2 .and. e1 > 1.) then
!	X direction is major direction
          tanphi = sinphi/cosphi
		call seek_plane(vx, nx1, xpr, kxpr)
		if (kxpr .eq. 0) then
			kxpr			= ngx
			xpr			= xpr+xper
			x_cor			= x_cor+xper
		else if (kxpr .eq. nx1) then
			kxpr			= 1
			xpr			    = xpr-xper
			x_cor			= x_cor-xper
		end if
		ypr = ypr+(vx(kxpr)-xpr)*tanphi
		zpr = zpr+(vx(kxpr)-xpr)/tancos
		xpr = vx(kxpr)
          direct=3
        else if (e2 >= e1.and. e2 > 1.) then
!	Y direction is major direction
          cotphi = cosphi/sinphi
		call seek_plane(vy, ny1, ypr, kypr)
		if (kypr .eq. 0) then
			  kypr			= ngy
		          ypr			= ypr+yper
		          y_cor			= y_cor+yper
		else if (kypr .eq. ny1) then
			  kypr			= 1
			  ypr			= ypr-yper
			  y_cor			= y_cor-yper
		end if
	        xpr = xpr+(vy(kypr)-ypr)*cotphi
	        zpr = zpr+(vy(kypr)-ypr)/tansin
	        ypr = vy(kypr)
	  direct=2	
        else
!	Z direction is major direction
          call seek_plane (vx, nx1, xpr, kxpr)
          call seek_plane (vy, ny1, ypr, kypr)
          direct=1	
        end if

!		trace track until its backscattered or it goes
!		past max z value
		backscatt=.false.
		tofar=.false.

		do while(.not.backscatt)
!		backscatt=.true.
!		tofar=.true.

		trace:select case(direct)
!		Trace z direction		
		case(1)
!--------------------------------- Z-DIRECTION --------------------------------*
		lx(1) = kxpr-1
        if (kxpr .eq. nx1) then
          lx(2)			= 1
          x_shift(2)	= -xper
        else
          lx(2)			= kxpr
          x_shift(2)	= 0.0
        end if
        ly(1) = kypr-1
        if (kypr .eq. ny1) then
          ly(2)			= 1
          y_shift(2)	= -yper
        else
          ly(2)			= kypr
          y_shift(2)	= 0.0
        end if
        lz(1) = kzpr
        call impact (2, 2, 1, choice)

! Trace y direction
		case(2)
!--------------------------------- Y-DIRECTION --------------------------------*
        lx(1) = kxpr-1
        if (kxpr .eq. nx1) then
          lx(2)			= 1
          x_shift(2)	= -xper
        else
          lx(2)			= kxpr
          x_shift(2)	= 0.
        end if
        ly(1)			= kypr

        if (kzpr .eq. 1) then
          lz(1)			= 1
          call impact (2, 1, 1,choice)
        else if (kzpr .eq. nz1) then
          lz(1)			= ngz
          call impact (2, 1, 1, choice)
        else
          lz(1)			= kzpr-1
          lz(2)			= kzpr
          call impact (2, 1, 2, choice)
        end if

		case(3)
!----------------------------------- X-DIRECTION ------------------------------*
        lx(1) = kxpr
        ly(1) = kypr-1
        if (kypr .eq. ny1) then
          ly(2)			= 1
          y_shift(2)	= -yper
        else
          ly(2)			= kypr
          y_shift(2)	= 0.0
        end if
		if(kzpr.eq.1) then
          lz(1) = 1
          call impact (1, 2, 1, choice)
		else if (kzpr.eq.nz1) then
          lz(1) = ngz
          call impact (1, 2, 1, choice)
		else
          lz(1) = kzpr-1
          lz(2) = kzpr
          call impact (1, 2, 2, choice)
		end if
		end select trace
		if(choice.eq.3) then 
! Backscattered end this track
			backscatt=.TRUE.
		else
				
!-----------  DEFLECTION / NO DEFLECTION   ------------------------------*
	        if (e1 > e2 .and. e1 > 1.)  	  then 
! Continue in the X direction
				tanphi = sinphi/cosphi
				kxpr=kxpr+isignx
				if (kxpr .eq. 0) then
						kxpr			= ngx
						xpr			= xpr+xper
						x_cor			= x_cor+xper
				else if (kxpr .eq. nx1) then
						kxpr			= 1
						xpr			= xpr-xper
						x_cor			= x_cor-xper
				end if
				ypr = ypr+(vx(kxpr)-xpr)*tanphi
				zpr = zpr+(vx(kxpr)-xpr)/tancos
				xpr = vx(kxpr)
				if (zpr > zmax) then
				tofar=.TRUE.
				backscatt=.TRUE.
				else
!Periodic boundary cond and New plane numbers
		        call period_bound (ypr, yper, y_cor)            
		        call seek_plane (vy, ny1, ypr, kypr)            
				do while(vz(kzpr)<zpr)
				kzpr=kzpr+1
				end do
				end if
				direct=3
	        else if (e2 .ge. e1 .and. e2 > 1.) then
! Continue in the  y-direction

				cotphi = cosphi/sinphi
				kypr = kypr+isigny                              
				if (kypr .eq. 0) then
					  kypr			= ngy
			          ypr			= ypr+yper
			          y_cor			= y_cor+yper
		        else if (kypr .eq. ny1) then
				      kypr			= 1
					  ypr			= ypr-yper
			          y_cor			= y_cor-yper
				end if

		        xpr = xpr+(vy(kypr)-ypr)*cotphi
		        zpr = zpr+(vy(kypr)-ypr)/tansin
		        ypr = vy(kypr)
		        if (zpr > zmax)then
				tofar =.TRUE.
				backscatt=.TRUE.

				else

!Periodic boundary cond and New plane numbers
				call period_bound (xpr, xper, x_cor)            
			    call seek_plane (vx, nx1, xpr, kxpr)            
				do while(vz(kzpr)<zpr)
				kzpr=kzpr+1
				end do
			 	direct=2
				endif
	        else
! Z direction
! Check if at end of crystal if so exit this track
				if (kzpr .eq. ngz) then
  			    tofar=.TRUE.
				backscatt=.TRUE.

				else
! Continue in z direction
		        kzpr = kzpr+1                                   
		        xpr  = xpr+(vz(kzpr)-zpr)*tancos
		        ypr  = ypr+(vz(kzpr)-zpr)*tansin
		        zpr  = vz(kzpr)
!Periodic boundary and New plane numbers
		        call period_bound (xpr, xper, x_cor)            
		        call period_bound (ypr, yper, y_cor)            
		        call seek_plane (vx, nx1, xpr, kxpr)            
		        call seek_plane (vy, ny1, ypr, kypr)            
				endif
				direct=1

	        end if

		 endif

		end do 

!------------------------------- END MAIN LOOP --------------------------------*
		end do yloop
		end do xloop

        return
        end subroutine track


        SUBROUTINE IMPACT (nvx, nvy, nvz,option)
!********************************************************************************
!*       IIIIII  MM    MM  PPPPP    AAAA    CCCC   TTTTTT                       *
!*         II    M M  M M  P    P  A    A  C    C    TT                         *
!*         II    M  MM  M  PPPPP   AAAAAA  C         TT                         *
!*         II    M      M  P       A    A  C    C    TT                         *
!*       IIIIII  M      M  P       A    A   CCCC     TT                         *
!********************************************************************************
	use sparms
	IMPLICIT NONE
	integer,intent(out):: option
	integer,intent(in):: nvx,nvy,nvz
	integer  :: ivx,ivy,ivz,jat,nhulp
	real :: o,p,q,r,s,t,u1,d1,v1
	real :: dred,u_xt,u_yt,u_zt,z_dist,x_dist,y_dist 
	real :: xt1,yt1,zt1,pre_fac,distance
	real :: xr1,yr1,zr1,dred1,random
	real :: xt_cor,yt_cor,zt_cor,z_cor
        iat	= 0
        dred	= 1.0
	call random_number(random)
        u_xt = gauss(1+nint(2000.*random))           !Unit random thermal
        call random_number(random)
        u_yt = gauss(1+nint(2000.*random))           ! displacements
        call random_number(random)
        u_zt = gauss(1+nint(2000.*random))

!-------------------------- LOOP OVER LATTICE POINTS --------------------------
        do ivx = 1,nvx                                  !Search for atom on
          do ivy = 1,nvy                                ! location (ivx,ivy,ivz)
            do ivz = 1,nvz
              jat = lattice(lx(ivx), ly(ivy), lz(ivz))
              if (jat .ne. 0) then

              xr1 = xpr-x(jat)+x_shift(ivx)             !Relative ion coord.
              yr1 = ypr-y(jat)+y_shift(ivy)             ! (xr1,yr1,zr1)
              zr1 = zpr-z(jat)

              o = (xr1-x_imp(ntypat(jat)))*sigx_1(jat)  !Reduced relative ion
              p = (yr1-y_imp(ntypat(jat)))*sigy_1(jat)  ! coordinates (o,p,q),
              q = (zr1-z_imp(ntypat(jat)))*sigz_1(jat)  ! corrected for the imp.
                                                        ! par. for backscatt.

              r = sincos*sigx_1(jat)                    !Reduced direction of
              s = sinsin*sigy_1(jat)                    ! motion (r,s,t)
              t = costh *sigz_1(jat)

!---------------------------- CORRELATED VIBRATIONS ---------------------------*
              if (last_atom .ne. 0) then
                x_dist = x_cor-x(jat)+x_shift(ivx)      !Distances between jat
                y_dist = y_cor-y(jat)+y_shift(ivy)      ! and last atom from
                z_dist = z_cor-z(jat)                   ! which ion was deflect.
                distance = x_dist**2&                   !Square of total
     &                 +y_dist**2&                      ! distance
     &                 +z_dist**2
              else
                distance = 1.E37                        !Fools next if-statement
              end if

              if (distance <= cor_dis) then           !Changed equilibrium
                o = (o-cor_cof*xt_cor)*cor_red          ! position and vibration
                p = (p-cor_cof*yt_cor)*cor_red          ! amplitudes in case of
                q = (q-cor_cof*zt_cor)*cor_red          ! correlated vibrations
                r = r*cor_red
                s = s*cor_red
                t = t*cor_red
                pre_fac = cor_re3
              else
                pre_fac = 1.                            !No correlations
              end if

!------------------------ HITTING/DETECTION PROBABILITY -----------------------*
!Contribution to hitting probability of atom jat
              hit_det(jat) = hit_det(jat)+exp(0.5*((o*r+p*s+q*t)**2&                  
     &       /(r*r+s*s+t*t)-o*o-p*p-q*q))*real_cs*pre_fac/(sqrt(r*r+s*s+t*t))


              if (distance <= cor_dis) then           
! Thermal displacements Correllated Vibrations
                xt1 = (cor_cof*xt_cor+cor_red*u_xt)*sigx(jat) 
                yt1 = (cor_cof*yt_cor+cor_red*u_yt)*sigy(jat)          
                zt1 = (cor_cof*zt_cor +cor_red*u_zt)*sigz(jat)
              else
! Thermal displacements Uncorrelated vibrations
                xt1 = u_xt*sigx(jat)                    
                yt1 = u_yt*sigy(jat)                    
                zt1 = u_zt*sigz(jat)                    
              end if

! New relative ion position
              xr1 = xr1-xt1                             
              yr1 = yr1-yt1                             
              zr1 = zr1-zt1

              u1 = xr1*coscos+yr1*cossin-zr1*sinth      !Projections normal to
              v1 = yr1*cosphi-xr1*sinphi                ! ion track
              d1 = u1**2+v1**2                          !Square of imp.parameter
              nhulp = ntypat(jat)
              dred1 = d1*dmax2(nhulp)                   !Reduced sq. imp.par.

!             Is atom jat closer than previous atoms? And if so, is it also
!             close enough for a non-negligible deflection?
              if (dred1 < dred) then 
!
!------------------------------- COLLISION PARTNER ----------------------------*
              iat = jat                                 !Closest atom iat:
              dred = dred1                              ! reduced sq. imp.par.
              d = d1                                    ! square of impact par.
              u = u1                                    ! impact coordinate
              xr = xr1                                  ! relative x, y and z
              yr = yr1                                  ! coordinates of the ion
              zr = zr1                                  ! and
              xt = xt1                                  ! thermal displacements
              yt = yt1                                  ! in x, y and z
              zt = zt1                                  ! directions
!
			  end if	
			 end if

!------------------------ END LOOP OVER LATTICE POINTS ------------------------*
            end do
          end do
        end do

!------------------------------- DEFLECTION? ----------------------------------*
        if (iat .eq. 0) then
          option=1                                      !No deflection
        else
          call collision (option)                          !Deflection
          if (mode(6) .eq. 1) then                      !In case of correlations
            last_atom = iat                             ! remember last
            x_cor = x(iat)                              ! deflecting atom,
            y_cor = y(iat)                              ! its x, y, and z
            z_cor = z(iat)                              ! coordinates and
            xt_cor = u_xt                               ! unit thermal
            yt_cor = u_yt                               ! displacement vector
            zt_cor = u_zt
          end if
!	Collision will return
!           option=2                                      !Normal deflection
!           option=3                                      !Backscattering
        end if

        end subroutine impact

        SUBROUTINE COLLISION (scatt)
!********************************************************************************
!*        CCCC    OOOO   LL      LL      IIIIII   SSSSS  IIIIII   OOOO   NN    N*
!*       C    C  O    O  LL      LL        II    S         II    O    O  N N   N*
!*       C       O    O  LL      LL        II     SSSS     II    O    O  N  N  N*
!*       C    C  O    O  LL      LL        II         S    II    O    O  N   N N*
!*        CCCC    OOOO   LLLLLL  LLLLLL  IIIIII  SSSSS   IIIIII   OOOO   N    NN*
!********************************************************************************
	use sparms
	IMPLICIT NONE
	integer,intent(out) :: scatt
	REAL :: t,tan_def,s,delfac,a,b
!Impact parameter
        t = sqrt(d)                                    

! Tangent of deflection angle
        tan_def		= deflection(ntypat(iat), nint(min(10000., 2000.*t)))           
        s		= u*tanth
        delfac		= tan_def/(t-s*tan_def)


! Backscattered ---stop track
        if (delfac < 0.) then
		scatt=3
	else                                          

!       Relative coordinates with respect to atom iat of point with z-coordinate
!       equal to that of atom iat:

        xr			= xr-zr*tancos
        yr			= yr-zr*tansin

!Absolute coordinates of inflection point
        xpr			= xr+xt+x(iat)-sincos*s                     
        ypr			= yr+yt+y(iat)-sinsin*s                     
        zpr			= zt+z(iat)-costh *s
        kxpr			= kx(iat)
        kypr			= ky(iat)
        kzpr			= kz(iat)

!Distances for new goniometry
        a			= sincos+delfac*xr                            
        b			= sinsin+delfac*yr                            

        call direction (a, b, costh)
        call new_gonio
	scatt=2
	end if
        return
        end subroutine collision


        SUBROUTINE DIRECTION (a, b, c)
!********************************************************************************
!*       DDDDD   IIIIII  RRRRR   EEEEEE   CCCC   TTTTTT  IIIIII   OOOO   NN    N*
!*       D    D    II    R    R  E       C    C    TT      II    O    O  N N   N*
!*       D    D    II    RRRRR   EEEEEE  C         TT      II    O    O  N  N  N*
!*       D    D    II    R  R    E       C    C    TT      II    O    O  N   N N*
!*       DDDDD   IIIIII  R   R   EEEEEE   CCCC     TT    IIIIII   OOOO   N    NN*
!********************************************************************************
	use sparms
	IMPLICIT NONE
	REAL :: a,b,c,disxy,disxyz

        disxy		= sqrt((a*a)+(b*b))
        disxyz		= sqrt((a*a)+(b*b)+(c*c))

        if(disxy.eq.0.0) disxy  = 1.e-6

        if(disxyz.eq.0.0) disxyz = 1.e-6

        cosphi		= a/disxy
        sinphi		= b/disxy
        costh		= c/disxyz
        sinth		= disxy/disxyz
        coscos		= costh*cosphi
        cossin		= costh*sinphi
        sincos		= sinth*cosphi
        sinsin		= sinth*sinphi

        return
        end subroutine direction


        SUBROUTINE NEW_GONIO
!********************************************************************************
!*       NN    N  EEEEEE  WW      W       GGGG    OOOO   NN    N  IIIIII   OOOO *
!*       N N   N  E        WW     W      G    G  O    O  N N   N    II    O    O*
!*       N  N  N  EEEEEE    WW WW W      G       O    O  N  N  N    II    O    O*
!*       N   N N  E          WWWWWW  --- G   GG  O    O  N   N N    II    O    O*
!*       N    NN  EEEEEE      WW WW  ---  GGGGG   OOOO   N    NN  IIIIII   OOOO *
!********************************************************************************

	use sparms
	IMPLICIT NONE
	REAL :: sinan,cosan

        if (costh .ne. 0.) then
          tanth  = sinth/costh
        else
          tanth = sinth*1.e-6
        end if
        tancos		= tanth*cosphi
        tansin		= tanth*sinphi
        isignx		= int(sign(1., cosphi))
        isigny		= int(sign(1., sinphi))
        cosan		= sico2*sincos+sisi2*sinsin+coth2*costh
        sinan		= sqrt(1.-cosan*cosan)
        real_cs		= 1./((cosan-1.)**2)
        x_imp(:)   	= sc_imp_par(:)*(sico2-cosan*sincos)/sinan
        y_imp(:)   	= sc_imp_par(:)*(sisi2-cosan*sinsin)/sinan
        z_imp(:)    	= sc_imp_par(:)*(coth2-cosan*costh )/sinan
        e1		= abs(tancos)
        e2		= abs(tansin)

        return
        end subroutine new_gonio


        SUBROUTINE SEEK_PLANE (plane, nr_of_planes, position, i_plane)
!*******************************************************************************
!        SSSSS  EEEEEE  EEEEEE  K    K       PPPPP   LL       AAAA   NN    N   *
!       S       E       E       K  KK        P    P  LL      A    A  N N   N   *
!        SSSS   EEEEEE  EEEEEE  KKK          PPPPP   LL      AAAAAA  N  N  N   *
!            S  E       E       K  KK   ---  P       LL      A    A  N   N N  .*
!       SSSSS   EEEEEE  EEEEEE  K    K  ---  P       LLLLLL  A    A  N    NN  .*
!*******************************************************************************
!		determines plane next to /greater than current ion position

	use sparms
	IMPLICIT NONE
!	real,dimension(1) :: ans
!	real :: position
!        real,dimension(nr_of_planes) :: plane
!       integer :: nr_of_planes,i_plane
!	ans=minloc(plane,mask=(plane-position)>=0.)
!	i_plane=ans(1)
!	if(i_plane.eq.0.0) i_plane=min(i_plane + 1, nr_of_planes)

	integer :: nr_of_planes,i_plane
	real,dimension(nr_of_planes) ::plane
	real :: position,test
	test=position-plane(i_plane)	

	if(test.lt.0.0) then
	   
	   do while(plane(i_plane).gt.position)	
	    i_plane=i_plane-1
	   end do
	   i_plane=i_plane+1

	 else if(test.eq.0.0) then

	  i_plane=min(i_plane+1,nr_of_planes)

	 else
	  
	  do while(plane(i_plane).lt.position)
	   i_plane=i_plane+1
	  end do

	 end if

         end subroutine seek_plane


        SUBROUTINE PERIOD_BOUND (position, period, change)
!*******************************************************************************
!       PPPPP   EEEEEE  RRRRR   IIIIII   OOOO   DDDDD        BBBBB    OOOO     *
!       P    P  E       R    R    II    O    O  D    D       B    B  O    O    *
!       PPPPP   EEEEEE  RRRRR     II    O    O  D    D       BBBBB   O    O    *
!       P       E       R  R      II    O    O  D    D  ---  B    B  O    O  ..*
!       P       EEEEEE  R   RR  IIIIII   OOOO   DDDDD   ---  BBBBB    OOOO   ..*
!*******************************************************************************
		IMPLICIT NONE
		real :: shift,position,change,period

        shift		= -period*nint(position/period-0.5)
        position	=  position+shift
        change		=  change+shift

        return
        end subroutine period_bound


        SUBROUTINE POTENT
!********************************************************************************
!*       PPPPP    OOOO   TTTTTT  EEEEEE  NN    N  TTTTTT                        *
!*       P    P  O    O    TT    E       N N   N    TT                          *
!*       PPPPP   O    O    TT    EEEEEE  N  N  N    TT                          *
!*       P       O    O    TT    E       N   N N    TT                          *
!*       P        OOOO     TT    EEEEEE  N    NN    TT                          *
!********************************************************************************
!
!	subroutine calculates a deflection table by integrating 
!	the collision integral using gauss-mehler method
!	Ref : 
!
	
	use sparms
	IMPLICIT NONE
	real :: weight,v,f,g,ang1,ang2,s,qm,l,r
	real :: ener,relen
	integer i_defl,i
        ener = el_loss_fac*energy                       !Elastic energy loss
        zi   = nzi                                        !Ion atomic number

element : do iel = 1,nel
          zt = nzt(iel)                                 !Target atomic number
          qm = rmi/rmt(iel)                             !Ion/target mass ratio
          relen = ener*rmt(iel)/(rmt(iel)+rmi)          !Relative energy (29/6/87)
          call screening_length                         !Evaluate scrlen
          coulomb = .014402*zt*zi
          deflection(iel, 0) = -1.E-6
s_parm :  do i_defl = 1,10000
            s = i_defl/2000.                            !Impact parameter
            r = rclose(s, relen)                        !Dist. of closest appr.
            deflection(iel, i_defl) = 0.                !Numerical evaluation collision integral
	    f=0.0
integrate :	do i=1,30
			l=30.0-i+1
			ang1=(2.*l-1)*(pi/120.0)
			ang2=(2.*i-1)*(pi/120.0)
			weight=cos(ang1)
			v=cos(ang2)
			g=1.0/sqrt(1-(pot(r/v)/relen)-((s**2)*(v**2)/(r**2)))
			f=f+(weight*g)
		end do integrate

        f=f*pi/(60.0*r)
        deflection(iel, i_defl) =pi-2.*s*f

!       Conversion CM-system -> LAB-system. Subroutine 'COLLISION' only
!       needs the tangent of the LAB-deflection angle:

        deflection(iel, i_defl)=sin(deflection(iel, i_defl))/(cos(deflection(iel,i_defl))+qm)
		end do s_parm
        end do element
        return
        end subroutine potent


        FUNCTION RCLOSE (s, relen)
!********************************************************************************
!*       RRRRR    CCCC   LL       OOOO    SSSSS  EEEEEE                         *
!*       R    R  C    C  LL      O    O  S       E                              *
!*       RRRRR   C       LL      O    O   SSSS   EEEEEE                         *
!*       R  R    C    C  LL      O    O       S  E                              *
!*       R   R    CCCC   LLLLLL   OOOO   SSSSS   EEEEEE                         *
!********************************************************************************
	
		IMPLICIT NONE
!
!		Find distance of closest approach rclose
!		i.e value of r when f=1-s^2/r^2-pot(r)/E =0 
        real:: step,f
		real:: rclose,r,s,relen
        r = s
        step = .1
		do while(step>1.E-8)
		f = 1.-s*s/(r*r)-pot(r)/relen
		if(f<0.) then
		r=r+step
		else
		step=step*0.5
		r=r-step
		endif
		end do
        rclose = r-step*0.5



        return
        end function RCLOSE


        FUNCTION POT (r)
!******************************************************************************
!*       PPPPP    OOOO   TTTTTT                                                 *
!*       P    P  O    O    TT                                                   *
!*       PPPPP   O    O    TT                                                   *
!*       P       O    O    TT                                                   *
!*       P        OOOO     TT                                                   *
!********************************************************************************
!	Calculates Moliere or Biersack potential
	
	use sparms
	IMPLICIT NONE
	real ::		r,r_redt,pot
        pot		= coulomb/r
        r_redt		= r*scrlen

		potential: select case (mode(3))
		case(0)
          pot		= pot*			&
			& (.10*exp(-6.0*r_redt)	&
			& +.55*exp(-1.2*r_redt)	&	
			& +.35*exp(-0.3*r_redt))

		case(1)
          pot		= pot*				&
			& (.1818  *exp(-3.2*r_redt)	&
			& +.5099  *exp(-0.9423*r_redt)	&
			& +.2802  *exp(-0.4029*r_redt)	&
			& +.02817 *exp(-0.2016*r_redt))
		
		end select potential		
		return
        end function pot


        SUBROUTINE SCAT_IMP (angle, dist)
!********************************************************************************
!*        SSSSS   CCCC    AAAA   TTTTTT       IIIIII  MM    MM  PPPPP           *
!*       S       C    C  A    A    TT           II    M M  M M  P    P          *
!*        SSSS   C       AAAAAA    TT           II    M  MM  M  PPPPP           *
!*            S  C    C  A    A    TT    ---    II    M      M  P               *
!*       SSSSS    CCCC   A    A    TT    ---  IIIIII  M      M  P               *
!********************************************************************************
!
! returns scattering impact parameter for a given element for a given angle
! by looking angle up in the deflection table.

	
	use sparms
	IMPLICIT NONE
	real:: dist(nel)
	real:: angle,deflect
	integer:: i_defl
	logical:: found

        do iel = 1,nel                                  
		found=.FALSE.
        i_defl		= 0                                    
	do while(.not.found)
	  found=.TRUE.
          deflect= atan(deflection(iel, i_defl))		  
	  if (deflect < 0.)	 deflect = deflect+pi
          if (deflect > angle) then
		i_defl= i_defl+1
		found=.FALSE.
	  endif
	end do
         dist(iel) = i_defl/2000.
        end do
        return
        end subroutine scat_imp



!        subroutine dump
!********************************************************************************
!*       DDDDD   U    U  MM    MM  PPPPP                                        *
!*       D    D  U    U  M M  M M  P    P                                       *
!*       D    D  U    U  M  MM  M  PPPPP                                        *
!*       D    D  U    U  M      M  P                                            *
!*       DDDDD    UUUU   M      M  P                                            *
!********************************************************************************
!

! In the event of a crash , insult the user
!
	
!	use sparms
!	IMPLICIT NONE

!        if (istatus) return                             !Everything ok

!        write(6,*) 'JOB CRASHED !!!!!'
!        open (2, file = status_file,status='old',position = 'append')
!        write(2,*) 'JOB CRASHED!!!!!!'
!        close(2)
!        return
!        end subroutine dump



        SUBROUTINE SCREENING_LENGTH
!********************************************************************************
!*       SSSSSS   CCCC  RRRR   EEEEE  EEEEE  N   N  II  N   N  GGGGGG         L *
!*       S       C      R   R  E      E      NN  N  II  NN  N  G              L *
!*       SSSSSS  C      RRRR   EEEE   EEEE   N N N  II  N N N  G  GGG         L *
!*            S  C      R   R  E      E      N  NN  II  N  NN  G    G ------- L *
!*       SSSSSS   CCCC  R   R  EEEEE  EEEEE  N   N  II  N   N  GGGGGG ------- L *
!********************************************************************************
!  Calculate (1 / (screening lenght)) for the different choices of potential
!  Mode(3) determines if Moliere or Biersack is used
	use sparms
	implicit none
        if (mode(3) .eq. 0) then                                
		if ( zi .eq. 1.) then                             
                 scrlen = ( zt ** 0.333333333) / (0.88534*0.529)
               else                                             
                scrlen = (0.5*zi)**0.5 + zt**0.5
                scrlen = scrlen**0.666666667
                scrlen = scrlen / (0.88534*0.529)
               endif
        else                                                    
	          scrlen = (zi**0.23+zt**0.23)/(0.88534*0.529)

        endif

        return
        end  subroutine	SCREENING_LENGTH
        
        
	subroutine gaussian
! ==========================================
! Generates a general gaussian distribution
! from which the vibrations are calculated
! ==========================================
	use sparms,only : gauss
	IMPLICIT NONE		
	REAL :: dx,dg,ix,grens,cum1,cum2,prefac,x1,x2
	INTEGER :: ig,choice
	
        dx			= 0.0001                             
        dg			= 0.0005                             
        ig			= 1002                              
        ix			= 0.0                                
        grens		= dg                             
        cum1		= 0.0
        cum2		= 0.0
        prefac		= dx/sqrt(8.*atan(1.))
	choice		= 1
	do while(ig.ne.2002)
	select case(choice)
		case(1)
			ix		= ix+1
			x1		= (ix-0.5)*dx
			x2		= ix*dx
			cum2		= cum1+exp(-x1*x1*.5)*prefac
			choice		= 2
		case(2)
		        if ((cum2-grens)<0.) then			
		        cum1		= cum2
		        choice		= 1
			else
			choice		= 3
			end if				
		case(3)
			gauss(ig)	= x2-dx*(cum2-grens)/(cum2-cum1)
			ig		= ig+1
			grens		= (ig-1001)*dg
			if (ig .eq. 2001) grens = grens-0.1*dg
			choice=2
		end select
		end do
        gauss(1001)   =  0.0
	gauss(1:1000) = -gauss(1002:2001)	
	
	end subroutine gaussian




	subroutine write_out(input_name,output_name)
!*********************************************************************************
!
!		subroutine to write output file
!
!*********************************************************************************
	
	use sparms
	implicit none
	integer :: igx,igy,igz
	real    :: chlay,chtot
 	character(80):: input_name,output_name
!	write output file
	                            
    open  (1, file = output_name, status='unknown')
	          write (1,'(1X,A,1X,A)') 'Angle   Total Yield',	& 
						   'Yield per atom (Layers)'
	write(1,'(/)')
	do ian=1,nan
	     write (1,'(100F8.3)') scthet(ian)/degrad,		&
                bltot(ian),(blocking(iat,ian),iat=1,nat)
	end do

	write(1,'(//)')
! Layer by Layer  output    
	write (1,'(1X,A,1X,A)') 'Angle   Total Yield',	& 
							'Yield per layer (Layers)'
	write(1,'(/)')
	do ian=1,nan	 
          write (1,'(100F8.3)') scthet(ian)/degrad,		&
			     bltot(ian),(bllay(igz,ian),igz=1,ngz)
	end do


! Element by element
	write(1,'(//)')
    write (1,'(1X,A,1X,A)') 'Angle   Total Yield'	,	&
							'Yield per element (Layers)'

	write(1,'(/)')	
	do ian=1,nan
          write (1,'(100F8.3)') scthet(ian)/degrad,		&
                bltot(ian),(bltyp(iel,ian),iel=1,nel)
	end do

	  
! End outputfile

        write (1, 250) fluxb                       



        write (1, '(1X,8I3)')		mode
        write (1, '(1X,19I4)')      arrdim		 
		write (1, 100) input_name, output_name,text,   &
					    nzi,rmi,energy,fluxc
					   


        if (mode(1) .eq. 0) then
          write (1, 110) 'regular'
        else
          write (1, 110) 'random'
        end if

        write (1, 120) chthet/degrad, chphi/degrad
        if (mode(3) .eq. 0) then
          write (1, 130) 'Moliere'
        else
          write (1, 130) 'Biersack universal'
        end if
        if (mode(4) .eq. 0) write (1, 140)
        write (1, 150)
        do iel = 1, nel
          write (1, 160) iel, nzt(iel), rmt(iel)
        end do
        write (1, 170) xper, yper, factor
        if (mode(6) .eq. 1) write (1, 180) sqrt(cor_dis)&
     &       , cor_cof

        write (1, 200)                              !start of shadowing output

        chtot = 0.                                      !Shadowing output
        do igz = 1, ngz
          chlay = 0.
          write (1, 210)
          do igx = 1, ngx
            do igy = 1, ngy
              iat = lattice(igx, igy, igz)
              if (iat .ne. 0) then
                write (1, 220) iat, ntypat(iat)&
     &       , x(iat), y(iat), z(iat)&
     &       , sigx(iat), sigy(iat), sigz(iat)&
     &       , hitprob(iat)
                chlay = chlay+hitprob(iat)
              end if
            end do
          end do
          chlay = chlay/factor
          chtot = chtot+chlay
          write (1, 230) igz, chlay
        end do
        write (1, 240) ngz, chtot


	 close(1)

!---------------------------- FORMAT STATEMENTS -------------------------*
100     format  (1X,/,' GENERAL INFORMATION:'&
     &  ,/, ' --------------------'		&
     &  ,/, ' Output from SINCALC ' 	&
     &  ,/, ' Inputfile :  ', A			&
     &  ,/, ' Outputfile:  ', A			&
     &  ,/, ' Comment   :  ', A			&
     &  ,/,/								&
     &  ,/, ' BEAM PARAMETERS:'				&
     &  ,/, ' ----------------'				&
     &	,/,	' Ions with atomic number', I2	&
     &	,/,	' atomic mass', F6.3, ' and energy ', F6.1, ' keV'	&
     &	,/,	' Flux = ', E8.3, ' ions/square angstrom.')

110   format(' Ions impinge from ', A, ' starting positions.')
120   format(' Polar angle (with respect to normal)   =  ', F7.2	&
     &     ,/' Azimuthal angle (with resp to x-axis)  =  ', F7.2)
130   format(' ', A, ' scattering potential')
140   format(' In and outgoing ion trajectories are not connected.')
150   format(/&
     &       ,/, ' TARGET PARAMETERS:'					&
     &       ,/, ' ------------------'					&
     &       ,/, ' Atom-type  atomic number  atomic mass')
160   format  (5X, I1, 13X, I2, 9X, F7.2)
170   format  (/, ' X-repeat distance =  ', F8.3			&
     &       ,/, ' Y-repeat distance =  ', F8.3				&
     &       ,/, ' Nr. of atoms per layer =', F6.1)
180   format(/, ' Atoms within a distance of ', F8.3,' vibrate with a'  &
     &         , ' correlation coefficient of ', F4.2)
190   format(/, 'An amorphous overlayer, containing', E10.2,'		&
	 &  atoms/cm2', ' of type ', I1,' covers the substrate.'	&
     & ,/, ' Rms  deflection angle in overlayer = ',E12.5,'  degree')
200     format  (/							&
     &       ,/, ' SHADOWING OUTPUT:'					&
     &       ,/, ' -----------------'					&
     &       ,/								&
     &       ,/, ' Atom Type     X        Y        Z      sigma-X'	&
     &         , ' sigma-Y sigma-Z        Hitting probability'		&
     &       ,/, ' ')
210   format  (1X,60('-'))

220   format(1X, I3, 4X, I1, 3(1X, F8.3), 2X, 3(2X, F6.3), 15X, F7.3)
230   format(1X,60('-'),/,'Hitting probability of layer ', I3,'=', F7.3,/)
240   format(1X,60('-'),/,'Summed hitting probability(', I3, ' layers)  = ',F7.3)

250   format  (/,/,/,/,/,/,'BLOCKING OUTPUT:',/,20('-'),/,' ', E8.3,    &
     & ' ions/sq.angst. per detection angle.',/)
255   format  (/&
     &       ,/,  '  Angle   Total signal'				&
     &         ,'  atom 1    atom 2    atom 3    atom 4    atom 5  '	&
     &         , '  atom 6    atom 7    atom 8    atom 9    atom 10'	&
     &       ,/, ' ',  ' (deg)     (layers)    ', 97('-')		&
     &       ,/, ' ')
270     format  (1X, F7.2, 1X, F7.3, 1X, 100(F7.3, 1X))			
280     format  (23X, 100(F7.3, 3X))
400     format  (//,' Bad results:',/,60('-'),/,'values greater than 10 = ',I4,/,60('-'),/,' ')
500     format  (1X,49('-'),A,49('-'))


	end subroutine write_out
	
	
	subroutine nxtfour(dir)	
! ==============================================
! This subroutine determines the closest 4 atoms 
! to the current ion
! Just subroutine off code from track to neaten
! the processes .
! Also might try to provide an array of 
! size 4 with the atom numbers in it
! as opposed to three arrays of two.
! ==============================================
	use sparms
	implicit none
	integer,dimension(4)::atom
	real,dimension(4)::xshifts,yshifts
	integer ::dir,xplane,yplane,zplane,natoms
	real :: yshft,xshft
	
	direct :select case(dir)
	case(1)
! Z direction	
           if (kxpr .eq. nx1) then
               xplane=1		
   	      xshft=-xper
          else
              xplane=kxpr	
	      xshft=0.0
          end if
          if (kypr .eq. ny1) then
	     yplane=1
             yshft	= -yper
          else
             yplane=kypr
             yshft	= 0.0
          end if
           natoms=4
	   atom(1)=lattice(kxpr-1,kypr-1,kzpr)
	   xshifts(1)=0.0
	   yshifts(1)=0.0
           atom(2)=lattice(xplane,kypr-1,kzpr)
	   xshifts(2)=xshft
	   yshifts(2)=0.0
	   atom(3)=lattice(kxpr-1,yplane,kzpr)
	   xshifts(3)=0.0
	   yshifts(3)=yshft
	   atom(4)=lattice(xplane,yplane,kzpr)
	   xshifts(4)=xshft
	   yshifts(4)=yshft
	case(2)
! Y Direction
	if(kxpr.eq.nx1) then
	xplane=1
	xshft=-xper
	else
	xplane=kxpr
	xshft=0.0
	end if
	
	if(kzpr.eq.1) then
	zplane=1
	natoms=2
	else if(kzpr.eq.nz1) then
	zplane=ngz
	natoms=2
	else
	natoms=4
	zplane=kzpr-1
	end if
	if(natoms.eq.2) then
  	   atom(1)=lattice(kxpr-1,kypr,zplane)
           xshifts(1)=0.0
           yshifts(1)=0.0
           atom(2)=lattice(xplane,kypr,zplane)
	   xshifts(2)=xshft
	   yshifts(2)=0.0
	else
	   atom(1)=lattice(kxpr-1,kypr,zplane)
           xshifts(1)=0.0
           yshifts(1)=0.0
           atom(2)=lattice(xplane,kypr,zplane)
	   xshifts(2)=xshft
	   yshifts(2)=0.0
	   atom(3)=lattice(kxpr-1,kypr,kzpr)
	   xshifts(3)=0.0
	   yshifts(3)=0.0
	   atom(4)=lattice(xplane,kypr,kzpr)
	   xshifts(4)=xshft
	   yshifts(4)=0.0
	end if
	case(3)
! X direction	

        
        if (kypr .eq. ny1) then
          yplane	= 1
          yshft		= -yper
        else
          yplane	= kypr
          yshft		= 0.0
        end if
	if(kzpr.eq.1) then
          zplane = 1
          natoms=2
        else if (kzpr.eq.nz1) then
          natoms=2
          zplane = ngz
        else
        natoms=4  
        end if   

	if(natoms.eq.2) then
  	   atom(1)=lattice(kxpr,kypr-1,zplane)
           xshifts(1)=0.0
           yshifts(1)=yshft
           atom(2)=lattice(kxpr,yplane,zplane)
	   xshifts(2)=0.0
	   yshifts(2)=yshft
	else
          atom(1)=lattice(kxpr,kypr-1,kzpr-1)
          xshifts(1)=0.0
          yshifts(1)=0.0
          atom(2)=lattice(kxpr,kypr-1,kzpr-1)
	  xshifts(2)=0.0
	  yshifts(2)=0.0
	  atom(3)=lattice(kxpr,yplane,kzpr)
	  xshifts(3)=0.0
	  yshifts(3)=yshft
	  atom(4)=lattice(kxpr,yplane,kzpr)
	  xshifts(4)=0.0
	  yshifts(4)=yshft
	end if		

	end select direct	
	
	end subroutine nxtfour

   END MODULE sinc
