
catch {package require v4lng}

proc :webcam args {
###########
###########
  global frame
  global debug _frame _panel _container _layout _xposn _yposn _placed _pack _colgap _rowgap
  global _charh _charw

#    :webcam name :x ? :y ? :w ? :h ? :valuex ? :label ? :min ? :max ? :value ?
#          :ticks ? ":colour ?

  set placed $_placed
  set width 0
  set bold 0
  set xp $_xposn; set yp $_yposn
  set xw 0; set xh 0; set vx 0; set min 0; set max 100; set vl 0
  set inactive "T"; set help "T"
  set ll ""
  set variable ""

  set name [string tolower [lindex $args 0]]
  set helpitem [lindex $args 0]

  if {$_container == ""} then {
     if {$_panel == ""} then {
        set win $_frame.$name
     } else {
        set win $_frame.$_panel.$name
     }
  } else {
     if {$_panel == ""} then {
        set win $_frame.$_container.$name
     } else {
        set win $_frame.$_container.$_panel.$name
     }
  }

  global _classname _winname
  set _classname($name) "webcam"
  set _winname($name)  $win

  :_pre-updateposn;  set xp $_xposn; set yp $_yposn

#  frame $win -relief flat
  if {$debug} then {$win configure -relief raised -bd 1}

  set i 1
  while {$i < [llength $args]} {
    set p [lindex $args $i]
    set v [lindex $args [expr $i + 1]]
    switch $p {

      :x  {set xp $v; set placed 1}
      :y  {set yp $v; set placed 1}
      :h  {set xh $v}
      :w  {set xw $v}
      :valuex {set vx $v}
      :label  {set ll "$v"}
      :value  {set vl $v}
      :min {set min $v}
      :max {set max $v}

      :show {}
      :help {
        switch $v {
          T    {set help "T"}
          F    {set help "F"}
          default {:help $helpitem $v}
        }
      }
      :helpitem {set helpitem $v}
      :inactive {
        switch $v {
          T    {set inactive "T"}
          F    {set inactive "F"}
          default {puts stderr ":webcam :inactive - unknown option $v"}
        }
      }
      :after  {set _pack " -after  [:path $v] "}
      :before {set _pack " -before [:path $v] "}

      default {puts stderr ":webcam - unknown arg $p"}
    }
    set i [expr $i + 2]
  }

  if {$ll != ""} then {
    label $win.label -text "$ll"

    if {$vx == 0} then {
       pack $win.label  -side left  -fill y
    } else {
       if {[string match *c $vx] == 0} then {
          set lw [expr $vx/$_charw]
       } else {
          set lw [string trim $vx c]
       }
       $win.label configure -anchor ne -width $lw
       pack $win.label  -side left  -anchor ne -fill y
    }

    :_set-font $win.label label $bold N

    :_set-color $win.label label
  }

  v4lng $win -width $xw -height $xh
  $win geometry $xw $xh

  if {$help == "T"} then {:_help $helpitem $win Scale}

  bind $win <ButtonRelease-1> ":webcam-event $win $name"

  pack $win -side top -fill x

  if {$debug} then {insert-debug ":webcam created $win"}

  :_set-color $win frame

  :_position-widget $placed $win $xp $yp

  :_post-updateposn $placed $win $xp $yp

  if {$inactive == "F"} then {set act 1} {set act 0}
  $win capture $act
}

proc :modify_webcam {win name args} {
  global debug

#    options -   :inactive T|F

  set args [lindex $args 0]
  if {$debug} then {insert-debug ":modify_webcam called with  $win $name $args"}

  set i 0
  while {$i < [llength $args]} {
    set p [lindex $args $i]
    set vl [lindex $args [expr $i + 1]]
    switch $p {

      :inactive  {
        switch $vl {
          T {$win capture 0}
          F {$win capture 1}
          default {puts stderr ":modify_webcam  :inactive  - unknown option $vl"}
        }
      }
      default {puts stderr ":modify_webcam - unknown arg $p"}
    }
    set i [expr $i + 2]
  }

}

proc :query_webcam {win name args} {
  global debug $name.value

#    settings -    :label :min :max :min-tick-label :max-tick-label :value

  set args [lindex $args 0]
  if {$debug} then {insert-debug ":query_webcam called with  $win $name $args"}

  switch [set p [lindex $args 0]] {
    :inactive {set cap [$win capture]; set cap [expr $cap]; if {$cap} {return "F"} {return "T"}}

    default {puts stderr ":query_webcam $win - unknown arg $p"}
  }
}

proc :webcam-event {win name} {
  global _commandname debug

  if {$debug} then {insert-debug ":webcam-event called with  $win $name"}
# toggles capturing
    set cap [$win capture]
    set cap [expr !$cap]
    $win capture $cap

#  if {[info exists _commandname($name)]} then {
#     eval $_commandname($name) [list [string toupper $name]  [set $name.value]]
#  } else {
#     click [list $frame "" [string toupper $name]  [set $name.value]]
#  }

}
