        PROGRAM MULTICALC
********************************************************************************
*       TTTTTT   AAAA    SSSSS  TTTTTT  EEEEEE  LL      EEEEEE   SSSSS   SSSSS *
*         TT    A    A  S         TT    E       LL      E       S       S      *
*         TT    AAAAAA   SSSS     TT    EEEEEE  LL      EEEEEE   SSSS    SSSS  *
*         TT    A    A       S    TT    E       LL      E            S       S *
*         TT    A    A  SSSSS     TT    EEEEEE  LLLLLL  EEEEEE  SSSSS   SSSSS  *
********************************************************************************
*
*               nat                                     !Number of atoms
*               nel                                     !Number of elements
*               ngx                                     !Number of X-groups
*               ngy                                     !Number of Y-groups
*               ngz                                     !Number of Z-groups
*               nx1                                     ! ngx+1
*               ny1                                     ! ngy+1
*               nz1                                     ! ngz+1
*               nan                                     !Number of bl. angles
*               nst                                     !Number of structures
*               nvi                                     !Number of vib. models
*               nps                                     !Nr. of str. parameters
*               npv                                     !Nr. of vib. parameters
*               nas                                     !Nr. of atoms 'affected'
*               nav                                     ! by str./vib. models
*               mps                                     !Max(1, nps)
*               mpv                                     !Max(1, npv)
*               mas                                     !Max(1, nas)
*               mav                                     !Max(1, nav)
*               nto                                     !PB - total number of models
*               ibd                                     !PB - number of 'bad's, i.e. values above 10
        include 'multicalc.dim'                         !Array dimensions
*
        dimension mode(8)                               !Run mode (see VEGAS)
        dimension idim(19)                              !Array dimensions
        dimension nvs(mps)                              !# values of str. param.
        dimension nvv(mpv)                              !# values of vib. param.
        dimension vals(mps, nst)                        !Values of str.parameter
        dimension valv(mpv, nvi)                        !Values of vib.parameter
        dimension mats(mps, nst)                        !Value nr. for given str
        dimension matv(mpv, nvi)                        !Value nr. for given vib
        dimension x(nat), y(nat), z(nat)                !Atom coordinates
        dimension ntypat(nat)                           !Atom type
        dimension i_differ(nat)                         !Type str./vib. differen
        dimension kx(nat), ky(nat), kz(nat)             !Group numbers of atoms
        dimension rel_x(nst, mas)                       !Relative x, y and z-
        dimension rel_y(nst, mas)                       ! coordinates for each
        dimension rel_z(nst, mas)                       ! structure model
        dimension sig(nat)                              !vibration amplitudes
        dimension sig2(nat)                             ! and related arrays
        dimension vib2(nvi, mav), vibquo(nvi, mav)
        dimension hit_det(nvi, nst, nat)              !Hitting/detection prob.
        dimension hitprob(nvi, nst, nat)                !Hitting probability
        dimension blocking(nvi, nst, nat, nan)          !Blocking profiles
        dimension h_max2(nat)                           !see below
        dimension d_max2(nel)                           !see below
        dimension sc_imp_par(nel)                       !Impact par. for backsc.
        dimension nzt(nel), rmt(nel)                    !Target at.nr. and mass
        dimension vx(nx1), vy(ny1), vz(nz1)             !X-, Y- and Z-planes
        dimension scthet(nan)                           !Scattering angles
        dimension bltot(nan)                            !Total blocking profile
        dimension bllay(ngz, nan)                       !Profile for layers
        dimension bltyp(nel, nan)                       !Profile for elements
        dimension gauss(0:2000)                         !Inv. cum. Gauss distr.
        dimension expo(-25000:5000)                     !Faster expon.function
        integer*2 lattice(ngx, ngy, ngz)             !Auxiliary lattice
     1       , iroot(0:400000)                       !Sqrt array
        integer time                                 !PB - need this!!!
*
        character text*80, input_name*80
     1       , output_name*80, output_file*80
     1       , multipr_nam*80, multipr_fil*80
     1       , status_file*80, hour*24
     1       , nams(mps)*20, namv(mpv)*20
     1       , numb_mul*3, name_mul*80               !PB - multiparameter output files
*
        include 'multicalc.io'                       !In/output file names
*
        parameter (ln33e3 = 10.4)
*
        common  /crystal/  x, y, z, ntypat, xper, yper
     1       /rel_pos/  rel_x, rel_y, rel_z
     1       /vibrati/  sig
     1       /sigsq_1/  sig2, vib2
     1       /vib_rat/  vibquo
     1       /differ/   i_differ
     1       /overlay/  cov, ntypov, def_rms
     1       /aux_lat/  lattice
     1       /hitdet/   hit_det
     1       /planes/   vx, vy, vz, kx, ky, kz
     1       /angles/   phi, thet, thet2, ian
     1       /no_ions/  nproj, npreal
     1       /distanc/  zmin, zmax
     1       /imp_par/  sc_imp_par
      common    /max_max/  dmax
     1       /imp_max/  d_max2
     1       /dis_max/  h_max2
     1       /crossec/  fake_cs, real_cs
     1       /collide/  energy, el_loss_fac
     1       /at_nr_m/  nzt, nzi, rmt, rmi
     1       /random/   iran
     1       /displac/  gauss
     1       /exponen/  expo
     1       /squarrt/  iroot
     1       /constan/  pi
     1       /modus/    mode
     1       /dumpcblk/     istatus, status_file
     1       /plot/     scthet, bltot, blmax, degrad, nan_f
*
*------------------------------------ START -----------------------------------*
*
        status_file = output_name                       !A Status_File will
        if (status_file .eq. '...')                     ! keep us informed of
     1       status_file = multipr_nam               ! the progress (we hope)
        i_dot = max(1, index(status_file, ']'))
        do while (i_dot .le. 50
     1       .and. status_file(i_dot:i_dot) .ne. ' ' !Its name is the name of
     1       .and. status_file(i_dot:i_dot) .ne. '.')! the output_file with
          i_dot = i_dot+1                               ! the extension 'status'
        end do
        status_file(i_dot:57) = '.status'
*
        call fdate (hour)
        open  (2, file = status_file, type = 'new'
     1       , form = 'formatted', err = 1)
        goto 2
1       open  (2, file = 'dump.status', type = 'new'
     1       , form = 'formatted')
2       inquire (2, name = status_file)
        write (2, *) '---------------'
     1       ,' STATUS-REPORT OF "MULTICALC" RUN'
     1       ,' ---------------'
        write (2, *) 'Inputfile:  '// input_name
        write (2, *) 'Outputfile: '// output_name
        write (2, *) 'Multi.file: '// multipr_nam
        write (2, *) hour, '  Starting shadowing calculation.'
        write (6, *) '---------------'
     1       ,' STATUS-REPORT OF "MULTICALC" RUN'
     1       ,' ---------------'
        write (6, *) 'Inputfile:  '// input_name
        write (6, *) 'Outputfile: '// output_name
        write (6, *) 'Multi.file: '// multipr_nam
        write (6, *) hour, '  Starting shadowing calculation.'
        close (2)
*
        pi = 4.*atan(1.)                                !Calculation of pi
        degrad = pi/180.                                !Degrees -> radians
*
        cum_1 = 0.                                      !Production of the array
        cum_2 = 0.                                      ! 'GAUSS', which is the
        total = 5.e-4                                   ! inverse of the
        ig = 1001                                       ! cumulative gauss
        ix = 0                                          ! distribution
        prefac = 1.e-4/sqrt(8.*atan(1.))
10      ix = ix+1
        x1 = (ix-0.5)*1.e-4
        x2 = ix*1.e-4
        cum_2 = cum_1+prefac*exp(-0.5*(x1**2))
20      if (cum_2 .lt. total) then
          cum_1 = cum_2
          goto 10
        else
          gauss(ig) = x2-(1.e-4)*(cum_2-total)
     1                       /(cum_2-cum_1)
          ig = ig+1
          total = (ig-1000)*5.e-4
          if (ig .eq. 2000) total = total-5.e-5
          if (ig .eq. 2001) goto 30
          goto 20
        end if
30      do ig = 0, 999
          gauss(ig) = -gauss(2000-ig)
        end do
        gauss(1001) = 0.
*
        do i= -25000,-1                                 !Speeds up the
          expo(i) = exp((i-0.5)/125.)                   ! calculation of
        end do                                          ! exponents by a factor
        expo(0) = 1.                                    ! five
        do i = 1,5000
          expo(i) = exp((i+0.5)/125.)
        end do
*
        do i = 0,400000                                 !Speeds up function SQRT
          iroot(i) = nint(sqrt(i+0.5))                  ! by a factor six
        end do
*
*-------------------------------- INPUT ---------------------------------------*
        open (1, file = INPUT_NAME, type = 'old'
     1       , access = 'sequential'
     1       , form = 'formatted'
     1       , err = 31)
        goto 32
*
31      open  (2, file = status_file, type = 'old'
     1       , form = 'formatted')
        write (2, *) '--Error opening inputfile!--'
        write (2, *) '------------------------'
     1       , ' JOB CRASHED!'
     1       , ' ------------------------'
        write (6, *) '--Error opening inputfile!--'
        write (6, *) '------------------------'
     1       , ' JOB CRASHED!'
     1       , ' ------------------------'
        close (2)
        write(6, 300)
        stop
*
32      read (1, '(1X,A)')              text
        read (1, *)                     ndate, numb
        read (1, *)                     (mode(i), i = 1,8)
        if   (mode(4) .ne. 0
     1.or. mode(5) .ne. 0
     1.or. mode(6) .ne. 0
     1.or. mode(7) .ne. 0
     1.or. mode(8) .ne. 1) then
          close (1)
          open  (2, file = status_file, type = 'old'
     1       , form = 'formatted')
          write (2, *) '--Wrong program!--'
          write (2, *) '------------------------'
     1       , ' JOB CRASHED!'
     1       , ' ------------------------'
          write (6, *) '--Wrong program!--'
          write (6, *) '------------------------'
     1       , ' JOB CRASHED!'
     1       , ' ------------------------'
          close (2)
          write(6, 300)
          stop
        end if
        read (1, *)                     (idim(i), i = 1,19)
        do iel = 1,nel
          read (1, *)                   nzt(iel), rmt(iel)
        end do
        read (1, *)                     ntypov, cov
        read (1, *)                     dummy1, dummy2
        do iat = 1,nat
          i_differ(iat) = 1
          read (1, *)                   x(iat),y(iat),z(iat)
     1                             , kx(iat),ky(iat),kz(iat)
     1                             , sig(iat),dummy1, dummy2
     1                             , ntypat(iat)
        end do
        read (1, *)                     xper, yper
        read (1, *)                     (vx(igx), igx = 1,ngx)
        read (1, *)                     (vy(igy), igy = 1,ngy)
        read (1, *)                     (vz(igz), igz = 1,ngz)
        read (1, *)                     phi,chthet,scthet(1),step,factor
        read (1, *)                     nzi,rmi,energy, fluxc,fluxb
*       ....................multimodel parameters..................
        if (nps .gt. 0) then
          do ips = 1,nps
            read (1,'(1X,A,I)')        nams(ips), nvs(ips)
            read (1, *)                 (vals(ips, iva)
     1                               , iva = 1,nvs(ips))
            read (1, *)                 (mats(ips, ist), ist = 1,nst)
          end do
        end if
        if (npv .gt. 0) then
          do ipv = 1,npv
            read (1,'(1X,A,I)')        namv(ipv), nvv(ipv)
            read (1, *)                 (valv(ipv, iva)
     1                               , iva = 1,nvv(ipv))
            read (1, *)                 (matv(ipv, ivi), ivi = 1,nvi)
          end do
        end if
        do ist = 1,nst
          read (1, *)                   (rel_x(ist, iat)
     1                               , rel_y(ist, iat)
     1                               , rel_z(ist, iat), iat = 1,mas)
        end do
        do ivi = 1,nvi
          read (1, *)                   (vib2(ivi, i), i = 1,mav)
        end do
        read (1, *)                     modout
*
        close (1)
*
        iran = time()                                   !PB - random seed
        iran1 = rand(iran)
*        iran1 = iran                                   !initial value of iran
        do igx = 1, ngx
          do igy = 1, ngy
            do igz = 1, ngz
              lattice(igx, igy, igz) = 0                !Blanking aux. lattice
            end do
          end do
        end do
*
        if (mode(2) .eq. 1) then                        !Number of elements
          ntype = nel-1                                 ! in the crystalline
          do iat = 1,nat                                ! part of the substrate,
            if (ntypat(iat) .eq. ntypov) ntype = nel    ! not including the
          end do                                        ! amorphous overlayer.
        else
          ntype = nel
        end if
*
        zmin = 0.
        zmax1 = 0.
*
        do ist = 1,nst
          do iat = 1,mas
            sum = z(iat)+rel_z(ist, iat)
            zmin = min(zmin, sum)                       !Minimum z-coordinate.
            zmax1 = max(zmax1, sum)                     !Maximum z-coordinate.
            if (rel_z(ist, iat) .ne. 0.)
     1     i_differ(iat) = 3
            if (rel_x(ist, iat) .ne. 0.
     1  .or. rel_y(ist, iat) .ne. 0.)
     1     i_differ(iat) = 5
          end do
        end do
*
        do ivi = 1,nvi
          do iat = 1,mav
            if (vib2(ivi, iat) .ne. vib2(1, iat)
     1   .and. (i_differ(iat) .eq. 1 .or.
     1          i_differ(iat) .eq. 3 .or.
     1          i_differ(iat) .eq. 5))
     1     i_differ(iat) = i_differ(iat)+1
          end do
        end do
*
        do iat = 1,nat
          zmin = min (zmin, z(iat))                     !Minimum z-coordinate
          zmax1 = max (zmax1, z(iat))                   !Maximum z-coordinate
          lattice(kx(iat), ky(iat), kz(iat)) = iat      !Filling up aux. lattice
          sig2(iat) = 125./(2.*sig(iat)**2)             !For calc. hitting probs
        end do
*
        do ivi = 1,nvi
          do iat = 1,mav
            vib2(ivi, iat) = 125.                       !Like sig2, for calc. of
     1                    /(2.*vib2(ivi, iat)**2)       ! hitting probabilities.
            vibquo(ivi, iat) = vib2(ivi, iat)/sig2(iat) !Ratio vib2/sig2.
          end do
        end do
*
        do iat = 1,nat
          relmax=0.
          vibmax=0.
          do ist = 1,nst
            if (iat .le. mas) then
              relat = rel_x(ist, iat)**2
     1            +rel_y(ist, iat)**2
     1            +rel_z(ist, iat)**2
            else
              relat = 0.
            end if
            relmax = max(relmax, relat)                 !Maximum structural
          end do                                        ! displacement of atom
          do ivi = 1,nvi                                ! iat from its average
            if (iat .le. mav) then                      ! position.
              vibat = 1./vib2(ivi, iat)
            else
              vibat = 1./sig2(iat)
            end if
            vibmax = max(vibmax, vibat)                 !Maximum vibration
          end do                                        ! amplitude of atom iat.
          vibmax = vibmax*125.
          h_max2(iat) = (sqrt(relmax)                   !Minimum sq. impact par.
     1              +sqrt(vibmax*ln33e3))**2            ! for contribution to
        end do                                          ! hit./det. probs.
*
        vx(nx1) = xper                                  !The first x,y planes
        vy(ny1) = yper                                  ! are repeated
*
        phi = phi*degrad                                !Conversion
        chthet = chthet*degrad                          ! degrees -> radians
        scthet(1) = scthet(1)*degrad
        step = step*degrad
        do ian = 1,nan
          scthet(ian) = scthet(1)+(ian-1)*step          !Scattering angles
        end do
*
        nan_f = 0
*
*
*--------------------------------- SHADOWING ----------------------------------*
        do iat = 1, nat
          do ist = 1,nst
            do ivi = 1,nvi
              hit_det(ivi, ist, iat) = 0.               !Set hitt.probs. to zero
            end do
          end do
        end do
        if (mode(2) .eq. 1) then                        !Set rms. defl. angle in
          def_rms = 0.                                  ! overlayer to zero
        end if
        ian = 0                                         !Scatt. angle nr. 'zero'
        chphi = phi                                     !Azimuthal angle of beam
        thet = chthet                                   !Polar angle of beam
        scthetc = (scthet(1)+scthet(nan))*0.5           !Average scatt. angle
        thet2 = thet+scthetc                            !Corresp. polar angle
        nproj = fluxc*xper*yper*cos(thet)               !Number of ch. ions
*
        el_loss_fac = 1.                                !Energy=primary energy
        e_old = 1.
*
        call potent                                     !Calc. deflection table
        call scat_imp (scthetc, sc_imp_par)             !Impact par. for backsc.
*
        trajec = zmax1/cos(thet)                        !Aver. trajectory length
        scetmin = 0.1/trajec                            !Minimum deflection
        scetmin = min (scetmin, 0.1*degrad)             ! angle which is to be
        scetmin = max (scetmin, 0.01*degrad)            ! properly treated
        scm_old = scetmin
        call scat_imp (scetmin, d_max2)                 !Maximum imp. parameter
        do iel = 1,nel
          dmax = max(dmax, d_max2(iel))
          d_max2(iel) = 1./(d_max2(iel)**2)
        end do
        zmax = zmax1+dmax                               !Calculation depth
        vz(nz1) = zmax
*
        call exclusion                                  !Probs. for no collision
*
        call track(*50)                                 !Actual calculation
*
        call fdate (hour)
        open  (2, file = status_file, type = 'old'
     1       , form = 'formatted', access = 'append'
     1       , err = 33)
        goto 34
33      open  (2, file = 'dump.status', type = 'new'
     1       , form = 'formatted')
        inquire (2, name = status_file)
34      continue
      write (2, *) hour
     1       , '  Starting blocking'
     1       , ' calculation now.'
      write (6, *) hour
     1       , '  Starting blocking'
     1       , ' calculation now.'
       close (2)
*
        flux = npreal/(xper*yper*cos(thet))             !Real flux
        nprojtot = npreal
        do iat = 1,mav
          do ist = 1,nst
            do ivi = 1,nvi
              hitprob(ivi, ist, iat) =                  !hitting probabilities
     1               hit_det(ivi, ist, iat)             ! are normalized
     1               *vib2(ivi, iat)
     1               /(125.*pi*fake_cs*flux)
              hit_det(ivi, ist, iat) = 0.
            end do
          end do
        end do
        if (mav .lt. nat) then
          do iat = mav+1,nat
            do ist = 1,nst
              do ivi = 1,nvi
                hitprob(ivi, ist, iat) =
     1               hit_det(ivi, ist, iat)
     1               *sig2(iat)
     1               /(125.*pi*fake_cs*flux)
                hit_det(ivi, ist, iat) = 0.
              end do
            end do
          end do
        end if
*
        do iat = 1,nat                                !Checks for large hitting probability
          do ist = 1,nst
            do ivi = 1,nvi
              if (hitprob(ivi, ist, iat) .gt. 5.0) then
                write (6, *) '------------------------'
                write (6, *) '  Unfeasably large hitting probability of ', hitprob(ivi, ist, iat)
                write (6, *) '  For atom ', iat
     1           , '  at vibration model ', ivi
     1           , '  and structure model ' ,ist
                open  (2, file = status_file, type = 'old'
     1           , form = 'formatted', access = 'append')
                write (2, *) '------------------------'
                write (2, *) '  Unfeasably large hitting probability of ', hitprob(ivi, ist, iat)
                write (2, *) '  For atom ', iat
     1           , '  at vibration model ', ivi
     1           , '  and structure model ' ,ist
                close (2)
              end if
            end do
          end do
        end do
*
*----------------------------------- BLOCKING ---------------------------------*
        phi = phi+pi                                    !Azimuth changed by pi
        thet2 = pi-chthet                               !Polar angle of beam
        rmit = rmi+rmt(ntypat(nat))                     !Ion mass + target mass
*
        do ian = 1, nan                                 !Loop over det. angles
          thet = thet2-scthet(ian)                      !Polar angle of detector
          nproj = fluxb*xper*yper*cos(thet)             !Number of bl. ions
          el_loss_fac = (rmi*cos(scthet(ian))/rmit      !Elastic
     1 +sqrt((rmi*cos(scthet(ian))/rmit)**2.            ! energy loss
     1 +(rmt(ntypat(nat))-rmi)/rmit))**2.               ! factor
          if (abs(el_loss_fac-e_old) .gt. 0.02) then
            call potent                                 !New deflection angles
            e_old = el_loss_fac
            new = 1
          else
            new = 0
          end if
          call scat_imp (scthet(ian), sc_imp_par)       !Impact par. for backsc.
          trajec = zmax1/cos(thet)
          scetmin = 0.1/trajec                          !See shadowing part
          scetmin = min (scetmin, 0.1*degrad)           ! for comments.
          scetmin = max (scetmin, 0.01*degrad)
          if (abs(scetmin-scm_old) .gt. 0.01*degrad
     1                 .or. new .eq. 1) then
            call scat_imp (scetmin, d_max2)
            do iel = 1,nel
              dmax = max(dmax, d_max2(iel))
              d_max2(iel) = 1./(d_max2(iel)**2)
            end do
            scm_old = scetmin
            zmax = zmax1+dmax
            vz(nz1) = zmax
            call exclusion                              !Probs. for no collision
          end if
*
          call track(*40)                               !Actual calculation
*
          call fdate (hour)
          open  (2, file = status_file, type = 'old'
     1       , form = 'formatted', access = 'append'
     1       , err = 35)
          goto 36
35        open  (2, file = 'dump.status', type = 'new'
     1       , form = 'formatted')
          inquire (2, name = status_file)
36      continue
        write (2, *) hour
     1       , '  Finished blocking angle    '
     1       ,ian
        write (6, *) hour
     1       , '  Finished blocking angle    '
     1       ,ian
          close (2)
*
          flux = npreal/(xper*yper*cos(thet))
          nprojtot = nprojtot+npreal
          do iat = 1,mav
            do ist = 1,nst
              do ivi = 1,nvi
                blocking(ivi, ist, iat, ian) =          !Backscattering signal
     1               hitprob(ivi, ist, iat)             ! = hitting probability
     1               *hit_det(ivi, ist, iat)            ! * detect. probability
     1               *vib2(ivi, iat)
     1               /(125.*pi*fake_cs*flux)
                hit_det(ivi, ist, iat) = 0.
              end do
            end do
          end do
          if (mav .lt. nat) then
            do iat = mav+1,nat
              do ist = 1,nst
                do ivi = 1,nvi
                  blocking(ivi, ist, iat, ian) =
     1               hitprob(ivi, ist, iat)
     1               *hit_det(ivi, ist, iat)
     1               *sig2(iat)
     1               /(125.*pi*fake_cs*flux)
                  hit_det(ivi, ist, iat) = 0.
                end do
              end do
            end do
          end if
*
          nan_f = ian                                   !Nr. of finished angles
*
        end do                                          !End loop det. angles
*
*------------------------------------- OUTPUT ---------------------------------*
40      if (nan_f .eq. 0) goto 50                       !First angle not ready
*
        if (modout .eq. 2 .or. modout .eq. 3) then
        open  (1, file = output_name, type = 'new'
     1               , access = 'sequential'
     1               , form = 'unformatted', err = 41)
          goto 42
41        open  (1, file = 'dump.multi', type = 'new'
     1               , access = 'sequential'
     1               , form = 'unformatted')
          open  (2, file = status_file, type = 'old'
     1       , form = 'formatted', access = 'append'
     1       )
          write (2, *) 'Error opening '// multipr_nam
          write (6, *) 'Error opening '// multipr_nam
          inquire (1, name = multipr_fil)
          write (2, *) 'File written  '// multipr_fil
          write (6, *) 'File written  '// multipr_fil
          close (2)
42        write (1) ndate, numb, nst, nvi, nan_f, nel
     1               , nps, npv
          write (1) text
          write (1) (scthet(ian)/degrad, ian = 1,nan_f)
          if (nps .gt. 0) then
            do ips = 1,nps
              write (1) nams(ips)
              write (1) nvs(ips)
              write (1) (vals(ips, ivs)
     1               , ivs = 1,nvs(ips))
              write (1) (mats(ips, ist)
     1               , ist = 1,nst)
            end do
          end if
          if (npv .gt. 0) then
            do ipv = 1,npv
              write (1) namv(ipv)
              write (1) nvv(ipv)
              write (1) (valv(ipv, ivv)
     1               , ivv = 1,nvv(ipv))
              write (1) (matv(ipv, ivi)
     1               , ivi = 1,nvi)
            end do
          end if
*
          do ist = 1,nst
            do ivi = 1,nvi
              do ian = 1,nan_f
                do iel = 1,nel
                  bltyp(iel, ian) = 0.
                end do
                do iat = 1,nat
                  bltyp(ntypat(iat), ian) =
     1           bltyp(ntypat(iat), ian)
     1           +blocking(ivi, ist, iat, ian)
                end do
              end do
              do iel = 1,nel
                do ian = 1,nan_f
                  bltyp(iel, ian) = bltyp(iel, ian)/factor
                end do
                write (1) (bltyp(iel, ian), ian = 1,nan_f)
              end do
            end do
          end do
*
          close (1)
*
        end if
*
        if (modout .eq. 1 .or. modout .eq. 3) then
          nto = 0
          do ist = 1,nst
            do ivi = 1,nvi
*
              nto = nto + 1                            !PB - 
              write (numb_mul,'(I3)') nto    !converts multiparameter counter to string 'numb_mul'
              if (nto .lt. 10) then
                 numb_mul(1:2) = '00'
              end if
              if (nto .ge. 10 .and. nto .lt. 100) then
                 numb_mul(1:1) = '0'
              end if

              name_mul = output_name                   !name_mul is the multimodel output file name
              do while (i_dot .le. 50
     1           .and. name_mul(i_dot:i_dot) .ne. ' '
     1           .and. name_mul(i_dot:i_dot) .ne. '.')
                 i_dot = i_dot+1
              end do

              name_mul(i_dot:57) = '.'//numb_mul       !adds multiparameter number to filename
              write (6, *) name_mul
              open  (1, file = name_mul, status = 'new'  !creates file
     1             , access = 'sequential'
     1             , form = 'formatted', err = 43)
              inquire (1, name = output_file)
              goto 44
43            open  (1, file = 'dump.out', status = 'new'
     1               , access = 'sequential'
     1               , form = 'formatted')
              open  (2, file = status_file, status = 'old'
     1               , form = 'formatted'
     1               , access = 'append')
              write (2, *) 'Error opening '// output_name
              write (6, *) 'Error opening '// output_name
              inquire (1, name = output_file)
              write (2, *) 'File written  '// output_file
              write (6, *) 'File written  '// output_file
              close (2)

44            nout = int((nat+0.5)/10.)*10

              blmax = 0.
              ibd = 0
              do ian = 1,nan_f                          !Loop over angles
                bltot(ian) = 0.
                do igz = 1, ngz
                  bllay(igz, ian) = 0.
                end do
                do iel = 1, nel
                  bltyp(iel, ian) = 0.
                end do
                do iat = 1, nat                              !PB -
                          if (blocking(ivi, ist, iat, ian) .gt. 9.999) then
                              blocking(ivi, ist, iat, ian) = 9.999
                              ibd = ibd + 1                  !counter for values greater than 10
                          end if
                     bltot(ian) =
     1               bltot(ian)
     1               +blocking(ivi, ist, iat, ian)
                      bllay(kz(iat), ian) =
     1               bllay(kz(iat), ian)
     1               +blocking(ivi, ist, iat, ian)
                     bltyp(ntypat(iat), ian) =
     1               bltyp(ntypat(iat), ian)
     1               +blocking(ivi, ist, iat, ian)
                end do
                bltot(ian) = bltot(ian)/factor
                blmax = max (blmax, bltot(ian))
                do igz = 1, ngz
                  bllay(igz, ian) =
     1               bllay(igz, ian)/factor
                end do
                do iel = 1, nel
                  bltyp(iel, ian) =
     1               bltyp(iel, ian)/factor
                end do

             end do
C Element by Element output             
 	 write (1, 256)                            !Start of blocking output
 	 do ian=1,nan_f	
		write(1,'(1X, F7.2, 1X, F7.3, 1X, 6(F7.3, 1X)))') scthet(ian),bltot(ian),(bltyp(iel,ian), iel=1,nel)
	end do
C layer by layer output             
 	 write (1, 257)                            !Start of blocking output
 	 do ian=1,nan_f	
		write(1,'(1X, F7.2, 1X, F7.3, 1X, 6(F7.3, 1X)))') scthet(ian),bltot(ian),(bllay(igz,ian), igz=1,ngz)
	end do
             		
C Atom by atom output             
 	 write (1, 255)                            !Start of blocking output
 	 do ian=1,nan_f	
                do iout = 0, nat-1, 100                !PB - will put 100 columns on one line
                  if (iout .eq. 0) write (1, 270) scthet(ian)/degrad, bltot(ian),
     1               (blocking(ivi, ist, iat, ian), iat =
     1               iout+1,min(nat, iout+100))
                  if (iout .ne. 0) write (1, 280)
     1               (blocking(ivi, ist, iat, ian), iat =
     1               iout+1, min(nat, iout+10))
                end do
	end do

	       	              
              blmax = 1.1*blmax
              write (1, 400) ibd                   !PB - bad values
*
              write (1, 250) fluxb                 !End of blocking output
*
              write (1, 100) mode, idim                 !General output
     1             , ndate, numb
     1             , input_name, output_file, text
              if (nps .gt. 0) then
                write (1, 101) ist
                do ips = 1,nps
                  write (1, 102) nams(ips)
     1             , vals(ips, mats(ips, ist))
                end do
              end if
              if (npv .gt. 0) then
                write (1, 103) ivi
                do ipv = 1,npv
                  write (1, 104) namv(ipv)
     1             , valv(ipv, matv(ipv, ivi))
                end do
              end if
              write (1, 105) nzi, rmi, energy, fluxc
              if (mode(1) .eq. 0) then
                write (1, 110) 'regular'
              else
                 write (1, 110) 'random'
              end if
              write (1, 120) chthet/degrad, chphi/degrad
              if (mode(3) .eq. 0) then
                write (1, 130) 'Moliere'
              else
                write (1, 130) 'Biersack universal'
              end if
              write (1, 140)
              write (1, 150)
              do iel = 1, nel
                write (1, 160) iel, nzt(iel), rmt(iel)
              end do
              write (1, 170) xper, yper, factor
              if (mode(2) .eq. 1) then                  !Amorphous overlayer:
                def_rms = sqrt(def_rms/nprojtot)/degrad ! rms deflection angle
                write (1, 190) cov, ntypov, def_rms
              end if
*
              write (1, 200)                       !Start of shadowing output
*
              chtot = 0.                                !Shadowing output
              do igz = 1, ngz
                chlay = 0.
                write (1, 210)
                do igx = 1, ngx
                  do igy = 1, ngy
                    iat = lattice(igx, igy, igz)
                    if (iat .ne. 0) then
                      if (iat .le. mas) then
                        xpos = x(iat)+rel_x(ist, iat)
                        ypos = y(iat)+rel_y(ist, iat)
                        zpos = z(iat)+rel_z(ist, iat)
                      else
                        xpos = x(iat)
                        ypos = y(iat)
                        zpos = z(iat)
                      end if
                      if (iat .le. mav) then
                        vibr = sqrt(125.
     1                       /(2.*vib2(ivi, iat)))
                      else
                        vibr = sig(iat)
                      end if
                      write (1, 220) iat, ntypat(iat)
     1                       , xpos, ypos, zpos
     1                       , vibr, vibr, vibr
     1                       , hitprob(ivi, ist, iat)
                      chlay = chlay
     1                       +hitprob(ivi, ist, iat)
                    end if
                  end do
                end do
                chlay = chlay/factor
                chtot = chtot+chlay
                write (1, 230) igz, chlay
              end do
              write (1, 240) ngz, chtot                 !End of shadowing output
*
              close (1)                                 !End outputfile
*
            end do                                      !End loop over strucs.
          end do                                        !End loop over vibs.
        end if
*
        open  (2, file = status_file, type = 'old'
     1       , form = 'formatted', access = 'append'
     1       )
50        write (2, *) '-----------------'
     1       , ' JOB SUCCESSFULLY COMPLETED'
     1       , ' -----------------'
          write (6, *) '-----------------'
     1       , ' JOB SUCCESSFULLY COMPLETED'
     1       , ' -----------------'
        close (2)
*
*----------------------------------- STOP -------------------------------------*
        stop
*
*---------------------------- FORMAT STATEMENTS -------------------------------*
100     format  (1X, 8I2, 19I4
     1       ,/,/
     1       ,/, ' GENERAL INFORMATION:'
     1       ,/, ' --------------------'
     1       ,/, ' Output from MULTICALC dd ', I6, ' run ', I2, '.'
     1       ,/, ' Inputfile :  ', A
     1       ,/, ' Outputfile:  ', A
     1       ,/, ' Comment   :  ', A
     1       ,/,/
     1       ,/, ' THIS IS OUTPUT FROM A MULTIPARAMETER CALCULATION:'
     1       ,/, ' -------------------------------------------------')
101     format  (   ' Structure model ', I3, ', corresponding to:')
102     format  (   ' - ', A, ' = ', E9.3)
103     format  (   ' Vibration model ', I3, ', corresponding to:')
104     format  (   ' - ', A, ' = ', E9.3)
105     format  (/
     1       ,/, ' BEAM PARAMETERS:'
     1       ,/, ' ----------------'
     1       ,/, ' Ions with atomic number', I2
     1         , ' , atomic mass', F6.3, ' and energy ', F6.1, ' keV'
     1       ,/, ' Flux = ', E8.3, ' ions/square angstrom.')
110     format  (   ' Ions impinge from ', A, ' starting positions.')
120     format  (   ' Polar angle (with respect to normal)   =  ', F7.2
     1       ,/, ' Azimuthal angle (with resp to x-axis)  =  ', F7.2)
130     format  (' ', A, ' scattering potential')
140     format  (   ' In and outgoing ion trajectories are not connected.')
150     format  (/
     1       ,/, ' TARGET PARAMETERS:'
     1       ,/, ' ------------------'
     1       ,/, ' Atom-type  atomic number  atomic mass')
160     format  (5X, I1, 13X, I2, 9X, F7.2)
170     format  (/, ' X-repeat distance =  ', F8.3
     1       ,/, ' Y-repeat distance =  ', F8.3
     1       ,/, ' Nr. of atoms per layer =', F6.1)
190     format  (/, ' An amorphous overlayer, containing', E10.2,' atoms/cm2'
     1         , ' of type ', I1,' covers the substrate.'
     1       ,/, ' Rms  deflection angle in overlayer = ',E,'  degree')
200     format  (/
     1       ,/, ' SHADOWING OUTPUT:'
     1       ,/, ' -----------------'
     1       ,/
     1       ,/, ' Atom Type     X        Y        Z      sigma-X'
     1         , ' sigma-Y sigma-Z        Hitting probability'
     1       ,/, ' ')
210     format  (   ' -------------------------------------------------'
     1         , '-------------')
220     format  (1X, I3, 4X, I1, 3(1X, F8.3), 2X, 3(2X, F6.3), 15X, F7.3)
230     format  (   ' -------------------------------------------------'
     1         , '-------------'
     1       ,/, ' Hitting probability of layer ', I3, '  = ', F7.3
     1       ,/, ' ')
240     format  (   ' -------------------------------------------------'
     1         , '-------------'
     1       ,/, ' Summed hitting probability('
     1         , I3, ' layers)  = ', F7.3)
250     format  (/,/,/,/,/
     1       ,/, ' BLOCKING OUTPUT:'
     1       ,/, ' ----------------'
     1       ,/, ' ', E8.3, ' ions/sq.angst. per detection angle.'
     1       ,/,/)
255     format  (/
     1       ,/,  '  Angle   Total signal'
     1         ,'  atom 1    atom 2    atom 3    atom 4    atom 5  '
     1         , '  atom 6    atom 7    atom 8    atom 9    atom 10  '
     1       ,/, ' ',  ' (deg)     (layers)    ', 97('-')
     1       ,/, ' ')
256     format  (/							
     1       ,/,  '  Angle   Total signal Elements'			
     1       ,/, ' ',  ' (deg)     (layers)    ', 97('-')		
     1       ,/, ' ')
257     format  (/							
     1        ,/,  '  Angle   Total signal Layers'			
     1        ,/, ' ',  ' (deg)     (layers)    ', 97('-')		
     1        ,/, ' ')
*260     format  (111X, F7.2, 4X, F7.3)
270     format  (1X, F7.2, 1X, F7.3, 1X, 100(F5.3, 1X))
280     format  (23X, 20(F7.3, 3X))
300     format  (' ************************************************'
     1       ,/, ' **** YOU''VE MADE AT LEAST ONE SERIOUS ERROR ****'
     1       ,/, ' *********** Sorry I cannot help more ************')
400     format  (//
     1       ,/, ' Bad results:'
     1       ,/, ' -------------------------------------------------'
     1       ,/, ' values greater than 10 = ', I4
     1       ,/, ' -------------------------------------------------'
     1       ,/,) 
*
        end
*
*
        SUBROUTINE TRACK(*)
********************************************************************************
*       TTTTTT  RRRRR    AAAA    CCCC   K    K                                 *
*         TT    R    R  A    A  C    C  K  KK                                  *
*         TT    RRRRR   AAAAAA  C       KKK                                    *
*         TT    R  R    A    A  C    C  K  KK                                  *
*         TT    R   RR  A    A   CCCC   K    K                                 *
********************************************************************************
*
        include 'multicalc.dim'
*
        dimension x(nat), y(nat), z(nat)
     1       , kx(nat), ky(nat), kz(nat)
     1       , ntypat(nat)
     1       , vx(nx1), vy(ny1), vz(nz1)
     1       , sc_imp_par(nel)
     1       , x_imp(nel), y_imp(nel), z_imp(nel)
     1       , lx(2), ly(2), lz(2)
     1       , x_shift(2), y_shift(2)
     1       , deflection(nel, 0:10000)
     1       , contri(nvi, nst)
     1       , mode(8)
*
        common  /crystal/  x, y, z, ntypat, xper, yper
     1       /overlay/  cov, ntypov, def_rms
     1       /planes/   vx, vy, vz, kx, ky, kz
     1       /angles/   phi, thet, thet2, ian
     1       /no_ions/  nproj, npreal
     1       /distanc/  zmin, zmax
     1       /max_max/  dmax
     1       /imp_par/  sc_imp_par
     1       /imp_pro/  x_imp, y_imp, z_imp
     1       /crossec/  fake_cs, real_cs
      common      /random/   iran
     1       /ion_abs/  xpr, ypr, zpr, kxpr, kypr, kzpr
     1       /search/   lx, ly, lz, x_shift, y_shift
     1       /goniome/  sinphi, cosphi, sinth, costh, tanth
     1                , coscos, cossin, sincos, sinsin
     1                , tancos, tansin
     1       /gonio_2/  sico2, sisi2, coth2
     1       /directi/  e1, e2, isignx, isigny
     1       /scatter/  deflection
     1       /weight/   contri
     1       /modus/    mode
*
*--------------------------- GENERAL INITIALIZATION ---------------------------*
        siph1 = sin(phi)                        !phi = initial azimuthal angle
        coph1 = cos(phi)
        sith1 = sin(thet)                       !thet = initial polar angle
        coth1 = cos(thet)
        sith2 = sin(thet2)                      !thet2 = polar angle after
        coth2 = cos(thet2)                      ! backscattering
        tath1 = sith1/coth1
        coco1 = coth1*coph1
        cosi1 = coth1*siph1
        sico1 = sith1*coph1
        sisi1 = sith1*siph1
        sico2 = sith2*coph1
        sisi2 = sith2*siph1
        taco1 = tath1*coph1
        tasi1 = tath1*siph1
        isx1  = int(sign(1., coph1))            !Moving in pos/neg x-direction
        isy1  = int(sign(1., siph1))            !Moving in pos/neg y-direction
        cosan = sith1*sith2+coth1*coth2         !Cosine of initial scatt. angle
        sinan = sqrt(1.-cosan**2)               !Sine of initial scatt. angle
        x_i1 = (sico2-cosan*sincos)/sinan       !Unit vector in the direction of
        y_i1 = (sisi2-cosan*sinsin)/sinan       ! the (initial) impact parameter
        z_i1 = (coth2-cosan*costh )/sinan       ! for backscattering
        fake_cs = 1./((cosan-1.)**2)            !CS = (sine(scatt.ang./2.))**-4
        x_shift(1) = 0.
        y_shift(1) = 0.
        e11 = abs(taco1)                        !X-comp/Z-comp of initial veloc.
        e21 = abs(tasi1)                        !Y-comp/Z-comp of initial veloc.
*
        if (e11 .gt. 1. .or. e21 .gt. 1.) then  !Initial z-coord. of track for
          zstart = zmin-dmax/sith1              ! start in x- or y-direction
        else                                    ! and for
          zstart = 0.                           ! start in z-direction
        end if
*
*       Projection of amorphous overlayer perpendicular to the beam. The full
*       overlayer is divided into 'nover' layers with a density of approximately
*       1 atom per 2.5x2.5 sq.Angstrom, such that the total number of atoms per
*       cm**2 encountered by the ions corresponds to the required coverage
*       density 'cov':
        if (mode(2) .eq. 1) then
          over = cov*1.e-16/coth1               !Nr. of atoms/A**2 perp. to beam
          nover = 1+int(over*6.25)              !Nr. of layers
          oversize = sqrt(float(nover)/over)    !'Unit cell' size in the layers
        end if
*
*------------------------------ START MAIN LOOP -------------------------------*
        delta = 1/sqrt(nproj/(xper*yper*coth1)) !The ions are regularly
        gonio = coco1*coco1+siph1*siph1         ! distributed over the surface
        sgonio = sqrt(gonio)                    ! unit cell. To this end the
        numx = max(1, nint(xper*sgonio/delta))  ! total number of ions is
        numy = max(1, nint(yper*coth1           ! adjusted a little bit.
     1               /(delta*sgonio)))
        npreal = numx*numy                      !Resulting no. of ions
        delx = xper/numx                        !Stepsize in x-direction
        dely = yper/numy                        !Stepsize in y-direction
*
        kxstrt = 2
        if (mode(1) .eq. 0) then
          xstart = -delx/2.                     !Start positions on mesh
        else
          xstart = -delx                        !Start positions random
        end if
*
        do 100 ix = 0, numx-1                   !Loop over x-coord. of startpos.
        xstart = xstart+delx
        do while (vx(kxstrt) .lt. xstart)
          kxstrt = kxstrt+1
        end do
*
        kystrt = 2
        if (mode(1) .eq. 0) then
          ystart = -dely/2.
        else
          ystart = -dely
        end if
*
*
        do 100 iy = 0, numy-1                   !Loop over y-coord. of startpos.
        ystart = ystart+dely
        do while (vy(kystrt) .lt. ystart)
          kystrt = kystrt+1
        end do
*
*--------------------------- INITIALIZATION PER TRACK -------------------------*
        xpr = xstart
        ypr = ystart
        if (mode(1) .eq. 1) then
          xpr = xpr+rand(0)*delx
          ypr = ypr+rand(0)*dely
          if (xpr .gt. xper) xpr = xpr-xper     !This might occur due to
          if (ypr .gt. yper) ypr = ypr-yper     ! rounding errors.
        end if
        zpr = zstart
        kxpr = kxstrt
        kypr = kystrt
        kzpr = 1
*
*       The width of the beam spot, 0.5mm/90mm, as well as the  width of the
*       entrance slit, 1.0mm/90mm, are accounted for in the calculation of
*       detection probabilities:
        if (ian .ne. 0) then
          spread = (rand(0)-0.5)*.005555555   !Out of plane angle of detection
     1 +(rand(0)-0.5)*.01111111
          a = sico1-spread*siph1
          b = sisi1+spread*coph1
          call direction (a, b, coth1)
          new_dir = 1
        else
          cosphi = coph1
          sinphi = siph1
          costh  = coth1
          sinth  = sith1
          coscos = coco1
          cossin = cosi1
          sincos = sico1
          sinsin = sisi1
          new_dir = 0
        end if
*
        if (mode(2) .eq. 1) then                !Deflection in amorph overlayer
          sico3 = sincos
          sisi3 = sinsin
          coth3 = costh
          do iover = 1,nover
            u = oversize*(rand(0)-0.5)        !Relative coordinates of ion
            v = oversize*(rand(0)-0.5)        ! with respect to overlayer atom
            t = sqrt(u*u+v*v)                   !Impact parameter
            tan_def = deflection                !Deflection contribution in
     1       (ntypov, nint(2000.*t))         ! layer nover
            dur = tan_def*u/t                   !Total deflection in u-direction
            dvr = tan_def*v/t                   !Total deflection in v-direction
            if (costh-dur*sinth .le. 0.)        !Stop in case of backscattering
     1       goto 100
            a = sincos+dur*coscos-dvr*sinphi    !Compute new direction
            b = sinsin+dur*cossin+dvr*cosphi
            call direction (a, b, costh)
          end do
          cosdef = sincos*sico3+sinsin*sisi3    !Cosine of deflection angle in
     1          +costh*coth3                 ! overlayer
          cosdef = min(1., cosdef)              !Avoiding rounding errors
          def_rms = def_rms+(acos(cosdef))**2   !Total squared deflection angle
          new_dir = 1
        end if
*
        real_cs = fake_cs                       !Initialization of the weight
        do ivi = 1,nvi                          ! factors for each of the
          do ist = 1,nst                        ! structure/vibration models
            contri(ivi, ist) = real_cs
          end do
        end do
*
        if (new_dir .eq. 1) then                !If necessary calculate new
          call new_gonio                        ! goniometry of track
        else
          tanth  = tath1                        !Otherwise use initial
          tancos = taco1                        ! goniometry
          tansin = tasi1
          isignx = isx1
          isigny = isy1
          do iel = 1, nel
            x_imp(iel) = x_i1*sc_imp_par(iel)
            y_imp(iel) = y_i1*sc_imp_par(iel)
            z_imp(iel) = z_i1*sc_imp_par(iel)
          end do
          e1 = e11
          e2 = e21
        end if
*
        if (e1 .gt. e2 .and. e1 .gt. 1.) then
          tanphi = sinphi/cosphi
          if (mode(1) .eq. 1) call seek_plane
     1       (vx, nx1, xpr, kxpr)
          goto 80
        else if (e2 .ge. e1. and. e2 .gt. 1.) then
          cotphi = cosphi/sinphi
          if (mode(1) .eq. 1) call seek_plane
     1       (vy, ny1, ypr, kypr)
          goto 50
        else
          if (mode(1) .eq. 1) then
            call seek_plane (vx, nx1, xpr, kxpr)
            call seek_plane (vy, ny1, ypr, kypr)
          end if
          goto 20
        end if
*
*---------------------------- EXTRAPOLATION OF TRACK --------------------------*
*
*--------------------------------- Z-DIRECTION --------------------------------*
10      if (kzpr .eq. ngz) goto 100
        kzpr = kzpr+1                                   !Step to next z-plane
        xpr = xpr+(vz(kzpr)-zpr)*tancos
        ypr = ypr+(vz(kzpr)-zpr)*tansin
        zpr = vz(kzpr)
*
        call period_bound (xpr, xper)                   !Periodic boundary
        call period_bound (ypr, yper)                   ! conditions xpr,ypr
*
        call seek_plane (vx, nx1, xpr, kxpr)            !New plane numbers
        call seek_plane (vy, ny1, ypr, kypr)            ! kxpr,kypr
*
*       Seek for the closest atom. Calculate hitting probabilities. If one of
*       the atoms is close enough compute deflection.
*       No deflection  -> continue in this direction,   i.e. goto 10:
*       Deflection     -> find new direction,           i.e. goto 90:
*       Backscattering -> stop this ion track,          i.e. goto 100:
20      lx(1) = kxpr-1
        if (kxpr .eq. nx1) then
          lx(2) = 1
          x_shift(2) = -xper
        else
          lx(2) = kxpr
          x_shift(2) = 0.
        end if
        ly(1) = kypr-1
        if (kypr .eq. ny1) then
          ly(2) = 1
          y_shift(2) = -yper
        else
          ly(2) = kypr
          y_shift(2) = 0.
        end if
        lz(1) = kzpr
        call impact (2, 2, 1, *10, *90, *100)
*
*--------------------------------- Y-DIRECTION --------------------------------*
30      cotphi = cosphi/sinphi
*
40      kypr = kypr+isigny                              !Step to next y-plane
50      if (kypr .eq. 0) then
          kypr = ngy
          ypr = ypr+yper
        else if (kypr .eq. ny1) then
          kypr = 1
          ypr = ypr-yper
        end if
        xpr = xpr+(vy(kypr)-ypr)*cotphi
        zpr = zpr+(vy(kypr)-ypr)/tansin
        ypr = vy(kypr)
        if (zpr .gt. zmax) goto 100
*
        call period_bound (xpr, xper)                   !Periodic boundary cond
*
        call seek_plane (vx, nx1, xpr, kxpr)            !New plane numbers
        do while (vz(kzpr) .lt. zpr)                    ! kxpr,kzpr
          kzpr = kzpr+1
        end do
*
*       Seek for the closest atom. Calculate hitting probabilities. If one of
*       the atoms is close enough compute deflection.
*       No deflection  -> continue in this direction,   i.e. goto 40:
*       Deflection     -> find new direction,           i.e. goto 90:
*       Backscattering -> stop this ion track,          i.e. goto 100:
        lx(1) = kxpr-1
        if (kxpr .eq. nx1) then
          lx(2) = 1
          x_shift(2) = -xper
        else
          lx(2) = kxpr
          x_shift(2) = 0.
        end if
        ly(1) = kypr
        if (kzpr .eq. 1) then
          lz(1) = 1
          call impact (2, 1, 1, *40, *90, *100)
        else if (kzpr .eq. nz1) then
          lz(1) = ngz
          call impact (2, 1, 1, *40, *90, *100)
        else
          lz(1) = kzpr-1
          lz(2) = kzpr
          call impact (2, 1, 2, *40, *90, *100)
        end if
*
*----------------------------------- X-DIRECTION ------------------------------*
60      tanphi = sinphi/cosphi
*
70      kxpr = kxpr+isignx                              !Step to next x-plane
80      if (kxpr .eq. 0) then
          kxpr = ngx
          xpr = xpr+xper
        else if (kxpr .eq. nx1) then
          kxpr = 1
          xpr = xpr-xper
        end if
        ypr = ypr+(vx(kxpr)-xpr)*tanphi
        zpr = zpr+(vx(kxpr)-xpr)/tancos
        xpr = vx(kxpr)
        if (zpr .gt. zmax) goto 100
*
        call period_bound (ypr, yper)                   !Periodic boundary cond
*
        call seek_plane (vy, ny1, ypr, kypr)            !New plane numbers
        do while (vz(kzpr) .lt. zpr)                    ! kypr,kzpr
          kzpr = kzpr+1
        end do
*
*       Seek for the closest atom. Calculate hitting probabilities. If one of
*       the atoms is close enough compute deflection.
*       No deflection  -> continue in this direction,   i.e. goto 70:
*       Deflection     -> find new direction,           i.e. goto 90:
*       Backscattering -> stop this ion track,          i.e. goto 100:
        lx(1) = kxpr
        ly(1) = kypr-1
        if (kypr .eq. ny1) then
          ly(2) = 1
          y_shift(2) = -yper
        else
          ly(2) = kypr
          y_shift(2) = 0.
        end if
        if (kzpr .eq. 1) then
          lz(1) = 1
          call impact (1, 2, 1, *70, *90, *100)
        else if (kzpr .eq. nz1) then
          lz(1) = ngz
          call impact (1, 2, 1, *70, *90, *100)
        else
          lz(1) = kzpr-1
          lz(2) = kzpr
          call impact (1, 2, 2, *70, *90, *100)
        end if
*
*----------------------------- AFTER A COLLISION ------------------------------*
90      if (e1 .gt. e2 .and. e1 .gt. 1.) then           !Find main velocity
          goto 60                                       ! component
        else if (e2 .ge. e1 .and. e2 .gt. 1.) then
          goto 30
        else
          goto 10
        end if
*
*------------------------------- END MAIN LOOP --------------------------------*
100     continue
*
        return                                          !Normal completion
110     return 1                                        !Emergency exit
*
        end
*
*
        SUBROUTINE IMPACT (nvx, nvy, nvz, *, *, *)
********************************************************************************
*       IIIIII  MM    MM  PPPPP    AAAA    CCCC   TTTTTT                       *
*         II    M M  M M  P    P  A    A  C    C    TT                         *
*         II    M  MM  M  PPPPP   AAAAAA  C         TT                         *
*         II    M      M  P       A    A  C    C    TT                         *
*       IIIIII  M      M  P       A    A   CCCC     TT                         *
********************************************************************************
*
        include 'multicalc.dim'
*
        dimension x(nat), y(nat), z(nat)
     1       , rel_x(nst, mas), rel_y(nst, mas), rel_z(nst, mas)
     1       , sig(nat)
     1       , sig2(nat), vib2(nvi, mav), vibquo(nvi, mav)
     1       , i_differ(nat)
     1       , hit_det(nvi, nst, nat)
     1       , ntypat(nat)
     1       , d_max2(nel)
     1       , h_max2(nat)
     1       , pnsig(650, mav), pnvib(650, nvi, mav)
     1       , x_imp(nel), y_imp(nel), z_imp(nel)
     1       , contri(nvi, nst)
     1       , lx(2), ly(2), lz(2)
     1       , x_shift(2), y_shift(2)
     1       , gauss(0:2000)
     1       , expo(-25000:5000)
     1       , mode(8)
        integer*2 lattice(ngx, ngy, ngz)
     1       , iroot(0:400000)
*
        common  /crystal/  x, y, z, ntypat, xper, yper
     1       /rel_pos/  rel_x, rel_y, rel_z
     1       /vibrati/  sig
     1       /sigsq_1/  sig2, vib2
     1       /vib_rat/  vibquo
     1       /differ/   i_differ
     1       /weight/   contri
     1       /no_defl/  pnsig, pnvib
     1       /aux_lat/  lattice
     1       /hitdet/   hit_det
     1       /crossec/  fake_cs, real_cs
     1       /ion_abs/  xpr, ypr, zpr, kxpr, kypr, kzpr
     1       /ion_rel/  xr, yr, zr, d, u, iat
      common     /search/   lx, ly, lz, x_shift, y_shift
     1       /goniome/  sinphi, cosphi, sinth, costh, tanth
     1                , coscos, cossin, sincos, sinsin
     1                , tancos, tansin
     1       /ran_dis/  xt, yt, zt
     1       /imp_pro/  x_imp, y_imp, z_imp
     1       /imp_max/  d_max2
     1       /dis_max/  h_max2
     1       /random/   iran
     1       /displac/  gauss
     1       /exponen/  expo
     1       /squarrt/  iroot
     1       /modus/    mode
*
        iat = 0
        dred = 1000.
*
        u_xt = gauss(nint(2000.*rand(0)))             !Unit random thermal
        u_yt = gauss(nint(2000.*rand(0)))             ! displacements
        u_zt = gauss(nint(2000.*rand(0)))
*
*-------------------------- LOOP OVER LATTICE POINTS --------------------------*
        do ivx = 1,nvx                                  !Search for atom on
          do ivy = 1,nvy                                ! location (ivx,ivy,ivz)
            do ivz = 1,nvz
              jat = lattice(lx(ivx), ly(ivy), lz(ivz))
              if (jat .eq. 0) goto 10
*
              xr0 = xpr-x(jat)+x_shift(ivx)             !Relative ion coord.
              yr0 = ypr-y(jat)+y_shift(ivy)             ! (xr1,yr1,zr1)
              zr0 = zpr-z(jat)
*
              xt1 = u_xt*sig(jat)                       !Thermal displacement of
              yt1 = u_yt*sig(jat)                       ! atom jat
              zt1 = u_zt*sig(jat)
*
              xr1 = xr0-xt1                             !New relative position
              yr1 = yr0-yt1                             ! of the ion
              zr1 = zr0-zt1
*
              u1 = xr1*coscos+yr1*cossin-zr1*sinth      !Projections normal to
              v1 = yr1*cosphi-xr1*sinphi                ! ion track
              d1 = u1*u1+v1*v1                          !Square of imp.parameter
              nhulp = ntypat(jat)
              dred1 = d1*d_max2(nhulp)                  !Reduced sq. imp.par.
*
*             Is atom jat closer than previous atoms? And if so, is it also
*             close enough for a non-negligible deflection?
              if (dred1 .gt. dred) goto 10
*
*------------------------------- COLLISION PARTNER ----------------------------*
              iat = jat                                 !Closest atom iat:
              dred = dred1                              ! reduced sq. imp.par.
              d = d1                                    ! square of impact par.
              u = u1                                    ! impact coordinate
              xr = xr1                                  ! relative x, y and z
              yr = yr1                                  ! coordinates of the ion
              zr = zr1                                  ! and
              xt = xt1                                  ! thermal displacements
              yt = yt1                                  ! in x, y and z
              zt = zt1                                  ! directions
*
              u_con = xr0*coscos+yr0*cossin-zr0*sinth   !Projected relative ion
              v_con = yr0*cosphi-xr0*sinphi             ! position wrt eq.pos.
*
              u_hit = (xr0-x_imp(ntypat(jat)))*coscos   !Projected relative ion
     1            +(yr0-y_imp(ntypat(jat)))*cossin   ! position with respect
     1            -(zr0-z_imp(ntypat(jat)))*sinth    ! to equilibrium
              v_hit = (yr0-y_imp(ntypat(jat)))*cosphi   ! position, corrected
     1            -(xr0-x_imp(ntypat(jat)))*sinphi   ! for impact parameter
*
              u_vib = xt1*coscos+yt1*cossin-zt1*sinth   !Projected thermal
              v_vib = yt1*cosphi-xt1*sinphi             ! displacement
*
10            continue
*
*------------------------ END LOOP OVER LATTICE POINTS ------------------------*
            end do
          end do
        end do
*
        if (iat .eq. 0) return 1                        !No collision partner
*
*---------------------------TREATMENT OF CLOSEST ATOM--------------------------*
*       Four situations are possible:
*       - The ion passes the equilibrium position of atom 'iat' close enough for
*         a non-negligible contribution to the hitting probabilities, and it
*         passes the actual (= thermally displaced) position of the atom close
*         enough to be deflected over a non-negligible angle.
*       - The ion passes the equilibrium position of atom 'iat' close enough for
*         a non-negligible contribution to the hitting probabilities, but it
*         passes the actual (= thermally displaced) position of the atom too far
*         to be deflected over a non-negligible angle.
*       - The ion passes the equilibrium position of atom 'iat' too far for a
*         non-negligible contribution to the hitting probabilities, but it
*         passes the actual (= thermally displaced) position of the atom close
*         enough to be deflected over a non-negligible angle.
*       - The ion passes the equilibrium position of atom 'iat' too far for a
*         non-negligible contribution to the hitting probabilities, and it
*         passes the actual (= thermally displaced) position of the atom too far
*         to be deflected over a non-negligible angle.
*
        hitprob_deflect = 1
*
        if (u_hit**2+v_hit**2 .gt. h_max2(iat))         !Is atom iat too far for
     1       hitprob_deflect = 3                     ! contr. to hit.probs.?
        if (dred .gt. 1.) hitprob_deflect               !Is atom iat too far for
     1       = hitprob_deflect+1                     ! deflection?
*
        goto (20, 30, 40, 50), hitprob_deflect
*
*-------------------------HITTING PROBS. AND DEFLECTION------------------------*
20      if (i_differ(iat) .eq. 1) then                  !Positions and vib.amps.
          em = expo(int                                 ! same in all structure/
     1       (-(u_hit**2+v_hit**2)*sig2(iat)))          ! vibration models
          do ist = 1, nst
            do ivi = 1, nvi
              hit_det(ivi, ist, iat) =
     1       hit_det(ivi, ist, iat)
     1       +contri(ivi, ist)*em
            end do
          end do
*
        else if (i_differ(iat) .eq. 2) then             !Positions same, but
          do ivi = 1, nvi                               ! vibration amplitudes
            do ist = 1, nst                             ! different
              hit_det(ivi, ist, iat) =
     1       hit_det(ivi, ist, iat)
     1       +contri(ivi, ist)
     1       *expo(int(-(u_hit**2+v_hit**2)
     1       *vib2(ivi, iat)))
*
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *expo(int((u_vib**2+v_vib**2)
     1       *(sig2(iat)-vib2(ivi, iat))))
     1       *vibquo(ivi, iat)
            end do
          end do
*
        else if (i_differ(iat) .eq. 3) then             !Only vertical position
          do ist = 1, nst                               ! differences; vibration
            do ivi = 1, nvi                             ! amplitudes same
              hit_det(ivi, ist, iat) =
     1       hit_det(ivi, ist, iat)
     1       +contri(ivi, ist)
     1       *expo(int
     1       (-((u_hit+rel_z(ist, iat)*sinth)**2
     1       +v_hit**2)
     1       *vib2(1, iat)))
*
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *expo(int((u_vib**2+v_vib**2)
     1       *sig2(iat)
     1       -((u_vib+rel_z(ist, iat)*sinth)**2
     1       +v_vib**2)
     1       *vib2(1, iat)))
     1       *vibquo(1, iat)
            end do
          end do
*
        else if (i_differ(iat) .eq. 4) then             !Only vertical position
          do ist = 1, nst                               ! differences; vibration
            do ivi = 1, nvi                             ! amplitudes different
              hit_det(ivi, ist, iat) =
     1       hit_det(ivi, ist, iat)
     1       +contri(ivi, ist)
     1       *expo(int
     1       (-((u_hit+rel_z(ist, iat)*sinth)**2
     1       +v_hit**2)
     1       *vib2(ivi, iat)))
*
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *expo(int((u_vib**2+v_vib**2)
     1       *sig2(iat)
     1       -((u_vib+rel_z(ist, iat)*sinth)**2
     1       +v_vib**2)
     1       *vib2(ivi, iat)))
     1       *vibquo(ivi, iat)
            end do
          end do
*
        else if (i_differ(iat) .eq. 5) then             !Lateral positions
          do ist = 1, nst                               ! different; vibration
            do ivi = 1, nvi                             ! amplitudes same
              hit_det(ivi, ist, iat) =
     1       hit_det(ivi, ist, iat)
     1       +contri(ivi, ist)
     1       *expo(int
     1       (-( (u_hit
     1       -rel_x(ist, iat)*coscos
     1       -rel_y(ist, iat)*cossin
     1       +rel_z(ist, iat)*sinth)**2
     1       +(v_hit
     1       +rel_x(ist, iat)*sinphi
     1       -rel_y(ist, iat)*cosphi)**2)
     1       *vib2(1, iat)))
*
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *expo(int((u_vib**2+v_vib**2)
     1       *sig2(iat)
     1       -((u_vib
     1       -rel_x(ist, iat)*coscos
     1       -rel_y(ist, iat)*cossin
     1       +rel_z(ist, iat)*sinth)**2
     1       +(v_vib
     1       +rel_x(ist, iat)*sinphi
     1       -rel_y(ist, iat)*cosphi)**2)
     1       *vib2(1, iat)))
     1       *vibquo(1, iat)
            end do
          end do
*
        else if (i_differ(iat) .eq. 6) then             !Lateral positions and
          do ist = 1, nst                               ! vibration amplitudes
            do ivi = 1, nvi                             ! different
              hit_det(ivi, ist, iat) =
     1       hit_det(ivi, ist, iat)
     1       +contri(ivi, ist)
     1       *expo(int
     1       (-((u_hit
     1       -rel_x(ist, iat)*coscos
     1       -rel_y(ist, iat)*cossin
     1       +rel_z(ist, iat)*sinth)**2
     1       +(v_hit
     1       +rel_x(ist, iat)*sinphi
     1       -rel_y(ist, iat)*cosphi)**2)
     1       *vib2(ivi, iat)))
*
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *expo(int((u_vib**2+v_vib**2)
     1       *sig2(iat)
     1       -((u_vib
     1       -rel_x(ist, iat)*coscos
     1       -rel_y(ist, iat)*cossin
     1       +rel_z(ist, iat)*sinth)**2
     1       +(v_vib
     1       +rel_x(ist, iat)*sinphi
     1       -rel_y(ist, iat)*cosphi)**2)
     1       *vib2(ivi, iat)))
     1       *vibquo(ivi, iat)
            end do
          end do
*
        end if
        goto 60
*
*-----------------------HITTING PROBS. BUT NO DEFLECTION-----------------------*
30      if (i_differ(iat) .eq. 1) then                  !Positions and vibration
          em = expo(int                         ! amplitudes same in al
     1       (-(u_hit**2+v_hit**2)*sig2(iat)))       ! structure/vibration
          do ist = 1, nst                               ! models
            do ivi = 1, nvi
              hit_det(ivi, ist, iat) =
     1       hit_det(ivi, ist, iat)
     1       +contri(ivi, ist)*em
            end do
          end do
*
        else if (i_differ(iat) .eq. 2) then             !Positions same; but
          pns = pnsig(iroot(int(10000.                  ! vibration amplitudes
     1       *(u_con**2+v_con**2))), iat)            ! differ
          do ivi = 1, nvi
            do ist = 1, nst
              hit_det(ivi, ist, iat) =
     1       hit_det(ivi, ist, iat)
     1       +contri(ivi, ist)
     1       *expo(int(-(u_hit**2+v_hit**2)
     1       *vib2(ivi, iat)))
*
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *pnvib(iroot(int(10000.
     1       *(u_con**2+v_con**2))), ivi, iat)
     1       *pns
            end do
          end do
*
        else if (i_differ(iat) .eq. 3) then             !Only vertical position
          pns = pnsig(iroot(int(10000.                  ! differences; vibration
     1       *(u_con**2+v_con**2))), iat)            ! amplitudes different
          do ist = 1, nst
            do ivi = 1, nvi
              hit_det(ivi, ist, iat) =
     1       hit_det(ivi, ist, iat)
     1       +contri(ivi, ist)
     1       *expo(int
     1       (-((u_hit+rel_z(ist, iat)*sinth)**2
     1       +v_hit**2)
     1       *vib2(1, iat)))
*
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *pnvib(iroot(int(10000.*
     1       ((u_con+rel_z(ist, iat)*sinth)**2
     1       +v_con**2))), 1, iat)
     1       *pns
            end do
          end do
*
        else if (i_differ(iat) .eq. 4) then             !Vertical position
          pns = pnsig(iroot(int(10000.                  ! differences, and
     1       *(u_con**2+v_con**2))), iat)            ! different vibration
          do ist = 1, nst                               ! amplitudes
            do ivi = 1, nvi
              hit_det(ivi, ist, iat) =
     1       hit_det(ivi, ist, iat)
     1       +contri(ivi, ist)
     1       *expo(int
     1       (-((u_hit+rel_z(ist, iat)*sinth)**2
     1       +v_hit**2)
     1       *vib2(ivi, iat)))
*
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *pnvib(iroot(int(10000.*
     1       ((u_con+rel_z(ist, iat)*sinth)**2
     1       +v_con**2))), ivi, iat)
     1       *pns
            end do
          end do
*
        else if (i_differ(iat) .eq. 5) then             !Lateral positions
          pns = pnsig(iroot(int(10000                   ! different; vibration.
     1       *(u_con**2+v_con**2))), iat)            ! amplitudes same
          do ist = 1, nst
            do ivi = 1, nvi
              hit_det(ivi, ist, iat) =
     1       hit_det(ivi, ist, iat)
     1       +contri(ivi, ist)
     1       *expo(int
     1       (-( (u_hit
     1       -rel_x(ist, iat)*coscos
     1       -rel_y(ist, iat)*cossin
     1       +rel_z(ist, iat)*sinth)**2
     1       +(v_hit
     1       +rel_x(ist, iat)*sinphi
     1       -rel_y(ist, iat)*cosphi)**2)
     1       *vib2(1, iat)))
*
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *pnvib(iroot(int(10000.*
     1       ((u_con
     1       -rel_x(ist, iat)*coscos
     1       -rel_y(ist, iat)*cossin
     1       +rel_z(ist, iat)*sinth)**2
     1       +(v_con
     1       +rel_x(ist, iat)*sinphi
     1       -rel_y(ist, iat)*cosphi)**2))), 1, iat)
     1       *pns
            end do
          end do
*
        else if (i_differ(iat) .eq. 6) then             !Lateral position as
          pns = pnsig(iroot(int(10000.                  ! well as vibration
     1       *(u_con**2+v_con**2))), iat)            ! amplitudes different
          do ist = 1, nst
            do ivi = 1, nvi
              hit_det(ivi, ist, iat) =
     1       hit_det(ivi, ist, iat)
     1       +contri(ivi, ist)
     1       *expo(int
     1       (-((u_hit
     1       -rel_x(ist, iat)*coscos
     1       -rel_y(ist, iat)*cossin
     1       +rel_z(ist, iat)*sinth)**2
     1       +(v_hit
     1       +rel_x(ist, iat)*sinphi
     1       -rel_y(ist, iat)*cosphi)**2)
     1       *vib2(ivi, iat)))
*
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *pnvib(iroot(int(10000.*
     1       ((u_con
     1       -rel_x(ist, iat)*coscos
     1       -rel_y(ist, iat)*cossin
     1       +rel_z(ist, iat)*sinth)**2
     1       +(v_con
     1       +rel_x(ist, iat)*sinphi
     1       -rel_y(ist, iat)*cosphi)**2)))
     1       , ivi, iat)
     1       *pns
            end do
          end do
*
        end if
        return 1
*
*-----------------------DEFLECTION BUT NO HITTING PROBS.-----------------------*
40      if (i_differ(iat) .eq. 1) then                  !Pos. and vib.amps. same
          continue
*
        else if (i_differ(iat) .eq. 2) then             !Positions same, but
          do ivi = 1, nvi                               ! vibration amplitudes
            do ist = 1, nst                             ! different
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *expo(int((u_vib**2+v_vib**2)
     1       *(sig2(iat)-vib2(ivi, iat))))
     1       *vibquo(ivi, iat)
            end do
          end do
*
        else if (i_differ(iat) .eq. 3) then             !Only vertical position
          do ist = 1, nst                               ! differences; vibration
            do ivi = 1, nvi                             ! amplitudes same
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *expo(int((u_vib**2+v_vib**2)
     1       *sig2(iat)
     1       -((u_vib+rel_z(ist, iat)*sinth)**2
     1       +v_vib**2)
     1       *vib2(1, iat)))
     1       *vibquo(1, iat)
            end do
          end do
*
        else if (i_differ(iat) .eq. 4) then             !Vertical positions as
          do ist = 1, nst                               ! well as vibration
            do ivi = 1, nvi                             ! amplitudes differ
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *expo(int((u_vib**2+v_vib**2)
     1       *sig2(iat)
     1       -((u_vib+rel_z(ist, iat)*sinth)**2
     1       +v_vib**2)
     1       *vib2(ivi, iat)))
     1       *vibquo(ivi, iat)
            end do
          end do
*
        else if (i_differ(iat) .eq. 5) then             !Lateral position
          do ist = 1, nst                               ! differences; vibration
            do ivi = 1, nvi                             ! amplitudes same
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *expo(int((u_vib**2+v_vib**2)
     1       *sig2(iat)
     1       -((u_vib
     1       -rel_x(ist, iat)*coscos
     1       -rel_y(ist, iat)*cossin
     1       +rel_z(ist, iat)*sinth)**2
     1       +(v_vib
     1       +rel_x(ist, iat)*sinphi
     1       -rel_y(ist, iat)*cosphi)**2)
     1       *vib2(1, iat)))
     1       *vibquo(1, iat)
            end do
          end do
*
        else if (i_differ(iat) .eq. 6) then             !Lateral positions as
          do ist = 1, nst                               ! well as vibration
            do ivi = 1, nvi                             ! amplitudes differ
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *expo(int((u_vib**2+v_vib**2)
     1       *sig2(iat)
     1       -((u_vib
     1       -rel_x(ist, iat)*coscos
     1       -rel_y(ist, iat)*cossin
     1       +rel_z(ist, iat)*sinth)**2
     1       +(v_vib
     1       +rel_x(ist, iat)*sinphi
     1       -rel_y(ist, iat)*cosphi)**2)
     1       *vib2(ivi, iat)))
     1       *vibquo(ivi, iat)
            end do
          end do
*
        end if
        goto 60
*
*----------------------NO HITTING PROBS. AND NO DEFLECTION---------------------*
50      if (i_differ(iat) .eq. 1) then                  !Pos. and vib.amps. same
          continue
*
        else if (i_differ(iat) .eq. 2) then             !Positions same; but
          pns = pnsig(iroot(int(10000.                  ! vibration amplitudes
     1       *(u_con**2+v_con**2))), iat)            ! different
          do ivi = 1, nvi
            do ist = 1, nst
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *pnvib(iroot(int(10000.
     1       *(u_con**2+v_con**2))), ivi, iat)
     1       *pns
            end do
          end do
*
        else if (i_differ(iat) .eq. 3) then             !Only vertical position
          pns = pnsig(iroot(int(10000.                  ! differences; vibration
     1       *(u_con**2+v_con**2))), iat)            ! ampliudes same
          do ist = 1, nst
            do ivi = 1, nvi
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *pnvib(iroot(int(10000.*
     1       ((u_con+rel_z(ist, iat)*sinth)**2
     1       +v_con**2))), 1, iat)
     1       *pns
            end do
          end do
*
        else if (i_differ(iat) .eq. 4) then             !Vertical positions as
          pns = pnsig(iroot(int(10000.                  ! well as vibration
     1       *(u_con**2+v_con**2))), iat)            ! amplitudes differ
          do ist = 1, nst
            do ivi = 1, nvi
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *pnvib(iroot(int(10000.*
     1       ((u_con+rel_z(ist, iat)*sinth)**2
     1       +v_con**2))), ivi, iat)
     1       *pns
            end do
          end do
*
        else if (i_differ(iat) .eq. 5) then             !Lateral position
          pns = pnsig(iroot(int(10000.                  ! differences; vibration
     1       *(u_con**2+v_con**2))), iat)            ! amplitudes same
          do ist = 1, nst
            do ivi = 1, nvi
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *pnvib(iroot(int(10000.*
     1       ((u_con
     1       -rel_x(ist, iat)*coscos
     1       -rel_y(ist, iat)*cossin
     1       +rel_z(ist, iat)*sinth)**2
     1       +(v_con
     1       +rel_x(ist, iat)*sinphi
     1       -rel_y(ist, iat)*cosphi)**2))), 1, iat)
     1       *pns
            end do
          end do
*
        else if (i_differ(iat) .eq. 6) then             !Lateral positions as
          pns = pnsig(iroot(int(10000.                  ! well as vibration
     1       *(u_con**2+v_con**2))), iat)            ! amplitudes differ
          do ist = 1, nst
            do ivi = 1, nvi
              contri(ivi, ist) =
     1       contri(ivi, ist)
     1       *pnvib(iroot(int(10000.*
     1       ((u_con
     1       -rel_x(ist, iat)*coscos
     1       -rel_y(ist, iat)*cossin
     1       +rel_z(ist, iat)*sinth)**2
     1       +(v_con
     1       +rel_x(ist, iat)*sinphi
     1       -rel_y(ist, iat)*cosphi)**2)))
     1       , ivi, iat)
     1       *pns
            end do
          end do
*
        end if
        return 1
*
*------------------------------- DEFLECTION -----------------------------------*
60      call collision (*70)                            !Deflection
        return 2                                        !Normal deflection
70      return 3                                        !Backscattering
*
        end
*
*
        SUBROUTINE COLLISION (*)
********************************************************************************
*        CCCC    OOOO   LL      LL      IIIIII   SSSSS  IIIIII   OOOO   NN    N*
*       C    C  O    O  LL      LL        II    S         II    O    O  N N   N*
*       C       O    O  LL      LL        II     SSSS     II    O    O  N  N  N*
*       C    C  O    O  LL      LL        II         S    II    O    O  N   N N*
*        CCCC    OOOO   LLLLLL  LLLLLL  IIIIII  SSSSS   IIIIII   OOOO   N    NN*
********************************************************************************
*
        include 'multicalc.dim'
*
        dimension x(nat), y(nat), z(nat)
     1       , kx(nat), ky(nat), kz(nat)
     1       , ntypat(nat)
     1       , vx(nx1), vy(ny1), vz(nz1)
     1       , deflection(nel, 0:10000)
*
        common  /crystal/  x, y, z, ntypat, xper, yper
     1       /planes/   vx, vy, vz, kx, ky, kz
     1       /ion_abs/  xpr, ypr, zpr, kxpr, kypr, kzpr
     1       /ion_rel/  xr, yr, zr, d, u, iat
     1       /ran_dis/  xt, yt, zt
     1       /goniome/  sinphi, cosphi, sinth, costh, tanth
     1                , coscos, cossin, sincos, sinsin
     1                , tancos, tansin
     1       /scatter/  deflection
*
        t = sqrt(d)                                     !Impact parameter
*
*       Deflection angle xphi:
        tan_def = deflection(ntypat(iat)                !Tangent of deflection
     1       , nint(2000.*t))                        ! angle
*
        s = u*tanth
        delfac = tan_def/(t-s*tan_def)
*
        if (delfac .lt. 0.) return 1                    !Stop track in case of
*                                                       ! backscattering
*       Relative coordinates with respect to atom iat of point with z-coordinate
*       equal to that of atom iat:
        xr = xr-zr*tancos
        yr = yr-zr*tansin
*
        xpr = xr+xt+x(iat)-sincos*s                     !Absolute coordinates of
        ypr = yr+yt+y(iat)-sinsin*s                     ! inflection point
        zpr =    zt+z(iat)-costh *s
        kxpr = kx(iat)
        kypr = ky(iat)
        kzpr = kz(iat)
*
        a = sincos+delfac*xr                            !Distances for new
        b = sinsin+delfac*yr                            ! goniometry
*
        call direction (a, b, costh)
        call new_gonio
*
        return
        end
*
*
        SUBROUTINE DIRECTION (a, b, c)
********************************************************************************
*       DDDDD   IIIIII  RRRRR   EEEEEE   CCCC   TTTTTT  IIIIII   OOOO   NN    N*
*       D    D    II    R    R  E       C    C    TT      II    O    O  N N   N*
*       D    D    II    RRRRR   EEEEEE  C         TT      II    O    O  N  N  N*
*       D    D    II    R  R    E       C    C    TT      II    O    O  N   N N*
*       DDDDD   IIIIII  R   R   EEEEEE   CCCC     TT    IIIIII   OOOO   N    NN*
********************************************************************************
*
        common  /goniome/  sinphi, cosphi, sinth, costh, tanth
     1                , coscos, cossin, sincos, sinsin
     1                , tancos, tansin
*
        d = sqrt(a**2+b**2)
        if (d .eq. 0.) d = 1.e-6
        e = sqrt(a**2+b**2+c**2)
        if (e .eq. 0.) e = 1.e-6
*
        cosphi = a/d
        sinphi = b/d
        costh  = c/e
        sinth  = d/e
        coscos = costh*cosphi
        cossin = costh*sinphi
        sincos = sinth*cosphi
        sinsin = sinth*sinphi
*
        return
        end
*
*
        SUBROUTINE NEW_GONIO
********************************************************************************
*       NN    N  EEEEEE  WW      W       GGGG    OOOO   NN    N  IIIIII   OOOO *
*       N N   N  E        WW     W      G    G  O    O  N N   N    II    O    O*
*       N  N  N  EEEEEE    WW WW W      G       O    O  N  N  N    II    O    O*
*       N   N N  E          WWWWWW  --- G   GG  O    O  N   N N    II    O    O*
*       N    NN  EEEEEE      WW WW  ---  GGGGG   OOOO   N    NN  IIIIII   OOOO *
********************************************************************************
*
        include 'multicalc.dim'
*
        dimension sc_imp_par(nel), x_imp(nel), y_imp(nel), z_imp(nel)
     1       , contri(nvi, nst)
*
        common  /crossec/  fake_cs, real_cs
     1       /imp_par/  sc_imp_par
     1       /imp_pro/  x_imp, y_imp, z_imp
     1       /goniome/  sinphi, cosphi, sinth, costh, tanth
     1                , coscos, cossin, sincos, sinsin
     1                , tancos, tansin
     1       /gonio_2/  sico2, sisi2, coth2
     1       /directi/  e1, e2, isignx, isigny
     1       /weight/   contri
*
        if (costh .ne. 0.) then
          tanth  = sinth/costh
        else
          tanth = sinth*1.e-6
        end if
        tancos = tanth*cosphi
        tansin = tanth*sinphi
        isignx = int(sign(1., cosphi))
        isigny = int(sign(1., sinphi))
        cosan = sico2*sincos+sisi2*sinsin+coth2*costh
        sinan = sqrt(1.-cosan*cosan)
*
        real_cs_old = real_cs
        real_cs = 1./((cosan-1.)**2)
*
        do ivi = 1,nvi
          do ist = 1,nst
            contri(ivi, ist) = contri(ivi, ist)
     1                      *real_cs/real_cs_old
          end do
        end do
*
        do iel = 1, nel
          x_imp(iel) = sc_imp_par(iel)*(sico2-cosan*sincos)/sinan
          y_imp(iel) = sc_imp_par(iel)*(sisi2-cosan*sinsin)/sinan
          z_imp(iel) = sc_imp_par(iel)*(coth2-cosan*costh )/sinan
        end do
        e1 = abs(tancos)
        e2 = abs(tansin)
*
        return
        end
*
*
        SUBROUTINE SEEK_PLANE (plane, nr_of_planes, position, i_plane)
********************************************************************************
*        SSSSS  EEEEEE  EEEEEE  K    K       PPPPP   LL       AAAA   NN    N   *
*       S       E       E       K  KK        P    P  LL      A    A  N N   N   *
*        SSSS   EEEEEE  EEEEEE  KKK          PPPPP   LL      AAAAAA  N  N  N   *
*            S  E       E       K  KK   ---  P       LL      A    A  N   N N  .*
*       SSSSS   EEEEEE  EEEEEE  K    K  ---  P       LLLLLL  A    A  N    NN  .*
********************************************************************************
*
        dimension plane(nr_of_planes)
*
        if (position-plane(i_plane)) 10, 20, 30
*
10      i_plane = i_plane-1
        if (plane(i_plane) .gt. position) goto 10
        i_plane = i_plane+1
        return
*
20      i_plane = min (i_plane+1, nr_of_planes)
        return
*
30      i_plane = i_plane+1
        if (plane(i_plane) .lt. position) goto 30
        return
*
        end
*
*
        SUBROUTINE PERIOD_BOUND (position, period)
********************************************************************************
*       PPPPP   EEEEEE  RRRRR   IIIIII   OOOO   DDDDD        BBBBB    OOOO     *
*       P    P  E       R    R    II    O    O  D    D       B    B  O    O    *
*       PPPPP   EEEEEE  RRRRR     II    O    O  D    D       BBBBB   O    O    *
*       P       E       R  R      II    O    O  D    D  ---  B    B  O    O  ..*
*       P       EEEEEE  R   RR  IIIIII   OOOO   DDDDD   ---  BBBBB    OOOO   ..*
********************************************************************************
*
        shift = -period*nint(position/period-0.5)
        position = position+shift
*
        return
        end
*
*
        SUBROUTINE POTENT
********************************************************************************
*       PPPPP    OOOO   TTTTTT  EEEEEE  NN    N  TTTTTT                        *
*       P    P  O    O    TT    E       N N   N    TT                          *
*       PPPPP   O    O    TT    EEEEEE  N  N  N    TT                          *
*       P       O    O    TT    E       N   N N    TT                          *
*       P        OOOO     TT    EEEEEE  N    NN    TT                          *
********************************************************************************
*
        include 'multicalc.dim'
*
        dimension nzt(nel), rmt(nel)
     1       , x_knot(20), weight(20), deflection(nel, 0:10000)
*
        data (x_knot(knot), knot = 1, 20)
     1       / 0.038772417506050821933, 0.116084070675255208483
     1       , 0.192697580701371099716, 0.268152185007253681141
     1       , 0.341994090825758473007, 0.413779204371605001525
     1       , 0.483075801686178712909, 0.549467125095128202076
     1       , 0.612553889667980237953, 0.671956684614179548379
     1       , 0.727318255189927103281, 0.778305651426519387695
     1       , 0.824612230833311663196, 0.865959503212259503821
     1       , 0.902098806968874296728, 0.932812808278676533361
     1       , 0.957916819213791655805, 0.977259949983774262663
     1       , 0.990726238699457006453, 0.998237709710559200350 /
*
        data (weight(i), i = 1, 20)
     1       / 0.077505947978424811264, 0.077039818164247965588
     1       , 0.076110361900626242372, 0.074723169057968264200
     1       , 0.072886582395804059061, 0.070611647391286779695
     1       , 0.067912045815233903826, 0.064804013456601038075
     1       , 0.061306242492928939167, 0.057439769099391551367
     1       , 0.053227846983936824355, 0.048695807635072232061
     1       , 0.043870908185673271992, 0.038782167974472017640
     1       , 0.033460195282547847393, 0.027937006980023401098
     1       , 0.022245849194166957262, 0.016421058381907888713
     1       , 0.010498284531152813615, 0.004521277098533191258 /
*
        common  /collide/  energy, el_loss_fac
     1       /at_nr_m/  nzt, nzi, rmt, rmi
     1       /scatter/  deflection
     1       /constan/  pi
     1       /screen/   zt, zi
     1                , scrlen, coulomb
*
        ener = el_loss_fac*energy                       !Elastic energy loss
        zi = nzi                                        !Ion atomic number
*
        do iel = 1,nel
          zt = nzt(iel)                                 !Target atomic number
          qm = rmi/rmt(iel)                             !Ion/target mass ratio
          relen = ener*rmt(iel)/(rmt(iel)+rmi)          !Relative energy
          call screening_length
          coulomb = .014402*zt*zi
*
          deflection(iel, 0) = -1.E-6
          do i_defl = 1,10000
            s = i_defl/2000.                            !Impact parameter
            r = rclose(s, relen)                        !Dist. of closest appr.
            vr = pot(r)                                 !Potential at that dist.
*
            deflection(iel, i_defl) = 0.                !Numerical evaluation of
            do knot = 1, 20                             ! the collision integral
              u = x_knot(knot)**2.
              f = 1./sqrt(s*s*(2.-u)
     1         +r*r*(vr-pot(r/(1.-u)))
     1         /(relen*u))
              deflection(iel,i_defl) =
     1       deflection(iel, i_defl) +f*weight(knot)
            end do
            deflection(iel, i_defl) =
     1       pi-4.*s*deflection(iel, i_defl)
*
*           Conversion CM-system -> LAB-system. Subroutine 'COLLISION' only
*           needs the tangent of the LAB-deflection angle:
            deflection(iel, i_defl) =
     1       sin(deflection(iel, i_defl))
     1       /(cos(deflection(iel, i_defl))+qm)
          end do
        end do
*
        return
        end
*
*
        FUNCTION RCLOSE (s, relen)
********************************************************************************
*       RRRRR    CCCC   LL       OOOO    SSSSS  EEEEEE                         *
*       R    R  C    C  LL      O    O  S       E                              *
*       RRRRR   C       LL      O    O   SSSS   EEEEEE                         *
*       R  R    C    C  LL      O    O       S  E                              *
*       R   R    CCCC   LLLLLL   OOOO   SSSSS   EEEEEE                         *
********************************************************************************
*
        real*8 r, step, f
*
        n = 0
        r = s
        step = .1
*
10      f = 1.-s*s/(r*r)-pot(r)/relen
        if (f .lt. 0.) then
          r = r+step
          if (n .eq. 0) goto 10
        end if
        n = 1
*
        if (step .gt. 1.E-8) then
          step = step*0.5
          r = r-step
          goto 10
        end if
*
        rclose = r-step*0.5
*
        return
        end
*
*
        FUNCTION POT (r)
********************************************************************************
*       PPPPP    OOOO   TTTTTT                                                 *
*       P    P  O    O    TT                                                   *
*       PPPPP   O    O    TT                                                   *
*       P       O    O    TT                                                   *
*       P        OOOO     TT                                                   *
********************************************************************************
*
        dimension mode(8)
*
        common  /modus/    mode
     1       /screen/   zt, zi
     1                , scrlen, coulomb
*
*       Coulomb-factor :
        pot = coulomb/r
*
        r_redt = r*scrlen
*
        if (mode(3) .eq. 0) then                        !Moliere potential
          pot = pot*
     1       (.10*exp(-6.0*r_redt)
     1       +.55*exp(-1.2*r_redt)
     1       +.35*exp(-0.3*r_redt))
          return
*
        else                                            !Biersack & Ziegler pot.
          pot = pot*
     1       (.1818  *exp(-3.2*r_redt)
     1       +.5099  *exp(-0.9423*r_redt)
     1       +.2802  *exp(-0.4029*r_redt)
     1       +.02817 *exp(-0.2016*r_redt))

*
          return
*
        end if
*
        end
*
*
        SUBROUTINE SCAT_IMP (angle, dist)
********************************************************************************
*        SSSSS   CCCC    AAAA   TTTTTT       IIIIII  MM    MM  PPPPP           *
*       S       C    C  A    A    TT           II    M M  M M  P    P          *
*        SSSS   C       AAAAAA    TT           II    M  MM  M  PPPPP           *
*            S  C    C  A    A    TT    ---    II    M      M  P               *
*       SSSSS    CCCC   A    A    TT    ---  IIIIII  M      M  P               *
********************************************************************************
*
        include 'multicalc.dim'
*
        dimension deflection(nel, 0:10000), dist(nel)
*
        common  /scatter/  deflection
     1       /constan/  pi
*
        do iel = 1,nel                                  !Find impact parameter
          i_defl = 0                                    ! necessary for
10        deflect = atan(deflection(iel, i_defl))       ! scattering over angle
          if (deflect .lt. 0.) deflect = deflect+pi     ! angle
          if (deflect .gt. angle) then
            i_defl = i_defl+1
            goto 10
          end if
          dist(iel) = i_defl/2000.
        end do
*
        return
        end
*
*

        SUBROUTINE PRINT_PLOT (blsub, n_blsub, ndim, contribution)
********************************************************************************
*       PPPPP   RRRRR   IIIIII  NN    N  TTTTTT     PPPPP   LL       OOOO   TTT*
*       P    P  R    R    II    N N   N    TT       P    P  LL      O    O    T*
*       PPPPP   RRRRR     II    N  N  N    TT       PPPPP   LL      O    O    T*
*       P       R  R      II    N   N N    TT  ---  P       LL      O    O    T*
*       P       R   R   IIIIII  N    NN    TT  ---  P       LLLLLL   OOOO     T*
********************************************************************************
*
        include 'multicalc.dim'
*
        dimension bltot(nan), blsub(ndim, nan), ibinx(nan)
     1       , scthet(nan)
        character line*119, contribution*(*), y_axis(0:50)
        data (y_axis(i), i = 50,0,-1)
     1       / ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '
     1       , ' ', ' ', ' ', ' ', ' ', 'N', 'R', '.', ' ', 'O'
     1       , 'F', ' ', 'V', 'I', 'S', 'I', 'B', 'L', 'E', ' '
     1       , 'L', 'A', 'Y', 'E', 'R', 'S', ' ', ' ', ' ', ' '
     1       , ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '
     1       , ' '/
*
        common  /plot/     scthet, bltot, blmax, degrad, nan_f
*
        do ian = 1, nan_f
          ibinx(ian) = nint(100.*(ian-1.)/max(1., (nan_f-1.)))+14
        end do
        ybin = blmax/50.
        yup = blmax+ybin/2.
        write (1, '(''1'', 37X, ''Total profile and ''
     1         , ''contributions from different '', A
     1       ,/,/
     1       ,/, 14X, ''I'', 4(24X, ''I'')
     1       ,/, 11X, 107(''-''))') contribution
        do ibiny = 50, 0, -1
          ylo = yup-ybin
          line = ' '//y_axis(ibiny)
          if (ibiny .ne. 0) then
            line(12:12)   = 'I'
            line(118:118) = 'I'
          end if
          if (int(2.*yup) .gt. int(2.*ylo)) then
            write (line(5:9), '(F5.1)') float(int(2.*yup))/2.
            line(11:11)   = '-'
            line(119:119) = '-'
          end if
*
          do ian = 1,nan_f
            ifill = 0
            if (bltot(ian) .lt. yup .and.
     1       bltot(ian) .ge. ylo) then
              ntab = ibinx(ian)
              line(ntab:ntab) = 'T'
              ifill = 1
            end if
          end do
          if (ifill .eq. 1) then
            write (1, '(A119)') line
            line = '+'
          end if
          do i_blsub = 1, n_blsub
            ifill = 0
            do ian = 1, nan_f
              if (blsub(i_blsub, ian) .lt. yup .and.
     1       blsub(i_blsub, ian) .ge. ylo) then
                if (i_blsub .lt. 10) then
                  ntab = ibinx(ian)
                  line(ntab:ntab) = char(i_blsub+48)
                else if (i_blsub .lt. 100) then
                  ntab = ibinx(ian)-1
                  idig1 = int((i_blsub+0.5)/10.)
                  idig2 = i_blsub-10*idig1
                  line(ntab:ntab+1) =
     1               char(idig1+48)//char(idig2+48)
                else if (i_blsub .lt. 1000) then
                  ntab = ibinx(ian)-2
                  idig1 = int((i_blsub+0.5)/100.)
                  idig1 = int((i_blsub-100*idig1+0.5)/10.)
                  idig3 = i_blsub-100*idig1-10*idig2+0.5
                  line(ntab:ntab+2) =
     1               char(idig1+48)//char(idig2+48)//char(idig3+48)
                else
                  ntab = ibinx(ian)-2
                  line(ntab:ntab+2) = '***'
                end if
              ifill = 1
              end if
            end do
            if (ifill .eq. 1) then
              write (1, '(A119)') line
              line = '+'
            end if
          end do
          if (line(1:1) .ne. '+') write (1,'(A119)') line
          if (ibiny .eq. 0) write (1, '(''+'', 10X, 107(''-''))')
          yup = yup-ybin
        end do
*
        write (1, '(14X, ''I'', 4(24X,''I'')
     1       ,/, 11X, F6.1, 4(19X, F6.1))')
     1       ((scthet(1)+i*(scthet(nan_f)-scthet(1))/4.)/degrad
     1       , i = 0, 4)
        write (1, '(/,56X, ''Scattering angle'')')
*
        return
        end
*
*
        SUBROUTINE EXCLUSION
********************************************************************************
*       EEEEEE  XX   XX   CCCC   LL      U    U   SSSSS  IIIIII   OOOO   NN    *
*       E        XX XX   C    C  LL      U    U  S         II    O    O  N N   *
*       EEEEEE    XXX    C       LL      U    U   SSSS     II    O    O  N  N  *
*       E        XX XX   C    C  LL      U    U       S    II    O    O  N   N *
*       EEEEEE  XX   XX   CCCC   LLLLLL   UUUU   SSSSS   IIIIII   OOOO   N    N*
********************************************************************************
*
        include 'multicalc.dim'
*
        dimension sig2(nat), vib2(nvi, mav)
     1       , pnvib(650, nvi, mav), poutv(nvi)
     1       , pnsig(650, mav)
     1       , x(nat), y(nat), z(nat)
     1       , d_max2(nel)
     1       , ntypat(nat)
     1       , expo(-25000:5000)
*
        common  /imp_max/  d_max2
     1       /crystal/  x, y, z, ntypat, xper, yper
     1       /no_defl/  pnsig, pnvib
     1       /exponen/  expo
     1       /sigsq_1/  sig2, vib2
     1       /constan/  pi
*
        do iat = 1,mav
          dmax = sqrt(1./d_max2(ntypat(iat)))           !Maximum imp. par for a
          idis = 0                                      ! deflection
*
10        idis = idis+1
          if (idis .gt. 650) goto 20
          dis = idis/100.                               !Distance to equilibrium
          pnsig(idis, iat) = 0.                         ! position
          pouts = 1.
          do ivi = 1,nvi
            pnvib(idis, ivi, iat) = 0.
            poutv(ivi) = 1.
          end do
          disdif = dmax-dis
          if (disdif .gt. 0.) then                      !Eq. pos. close enough
            delta = dis/75.                             ! for a deflection
            pouts = expo(-min(25000                     !Probs. for finding atom
     1       , nint(sig2(iat)*disdif**2)))           ! iat outside circle
            do ivi = 1,nvi                              ! with radius 'dmax-dis'
              poutv(ivi) = expo(-min(25000              ! around eq. position
     1       , nint(vib2(ivi, iat)*disdif**2)))
            end do
            do ir = 1,150                               !Loop over remaining
              r = (ir-0.5)*delta+disdif                 ! part of circle with
              alfa = acos((r**2+dis**2-dmax**2)         ! radius 'dmax' and with
     1       /(2.*r*dis))                            ! centre 'dis' away from
              pnsig(idis, iat) = pnsig(idis, iat)       ! the equilibrium pos
     1       +expo(-min(25000
     1       , nint(sig2(iat)*r**2)))*alfa*r
              do ivi = 1,nvi
                pnvib(idis, ivi, iat) =
     1               pnvib(idis, ivi, iat)
     1               +expo(-min(25000
     1               , nint(vib2(ivi, iat)*r**2)))
     1               *alfa*r
              end do
            end do
          else                                          !Eq. pos. too far for a
            delta = dmax/75.                            ! deflection
            do ir = 1,150                               !Loop over circle with
              r = (ir-0.5)*delta-disdif                 ! radius 'dmax' and with
              alfa = acos((r**2+dis**2-dmax**2)         ! centre 'dis' away from
     1       /(2.*r*dis))                            ! the equilibrium pos.
              pnsig(idis, iat) = pnsig(idis, iat)
     1       +expo(-min(25000
     1       , nint(sig2(iat)*r**2)))*alfa*r
              do ivi = 1,nvi
                pnvib(idis, ivi, iat) =
     1               pnvib(idis, ivi, iat)
     1               +expo(-min(25000
     1               , nint(vib2(ivi, iat)*r**2)))
     1               *alfa*r
              end do
            end do
          end if
          pnsig(idis, iat) = 1./max(1.e-34              !Probs. for atom iat to
     1       , pouts-2.*pnsig(idis, iat)             ! be outside circle with
     1       *delta*sig2(iat)/125./pi)               ! radius 'dmax' and with
          do ivi = 1,nvi                                ! centre 'dis' away from
            pnvib(idis, ivi, iat) = max(1.e-34,         ! the equilibrium
     1       poutv(ivi)-2.*pnvib(idis, ivi, iat)     ! position
     1       *delta*vib2(ivi, iat)/125./pi)
          end do
          if (pnsig(idis, iat) .ge. 1.01) goto 10
          do ivi = 1,nvi
            if (pnvib(idis, ivi, iat) .le. 0.99) goto 10
          end do
          if (idis .lt. 650) then
            do i = idis+1,650
              pnsig(i, iat) = 1.
              do ivi = 1,nvi
                pnvib(i, ivi, iat) = 1.
              end do
            end do
          end if
20        continue
        end do
*
        return
        end
*
*
        SUBROUTINE DUMP
********************************************************************************
*       DDDDD   U    U  MM    MM  PPPPP                                        *
*       D    D  U    U  M M  M M  P    P                                       *
*       D    D  U    U  M  MM  M  PPPPP                                        *
*       D    D  U    U  M      M  P                                            *
*       DDDDD    UUUU   M      M  P                                            *
********************************************************************************
*
        character status_file*80
*
        common  /dumpcblk/     istatus, status_file
*
        if (istatus) return                             !Everything ok
*
        write(6, 10 )                                       !Everything NOT ok
10      format
     1   (' ************************************************'
     1,/, ' **** YOU''VE MADE AT LEAST ONE SERIOUS ERROR ****'
     1,/, ' *********** Sorry I cannot help more ************')
*
        open  (2, file = status_file, type = 'old'
     1       , form = 'formatted', access = 'append'
     1       )
        write (2,*) '------------------------'
     1       , ' JOB CRASHED!'
     1       , ' ------------------------'
        write (6,*) '------------------------'
     1       , ' JOB CRASHED!'
     1       , ' ------------------------'
       close (2)
*
        return
        end
*
*
        SUBROUTINE SCREENING_LENGTH
********************************************************************************
*       SSSSSS   CCCC  RRRR   EEEEE  EEEEE  N   N  II  N   N  GGGGGG         L *
*       S       C      R   R  E      E      NN  N  II  NN  N  G              L *
*       SSSSSS  C      RRRR   EEEE   EEEE   N N N  II  N N N  G  GGG         L *
*            S  C      R   R  E      E      N  NN  II  N  NN  G    G ------- L *
*       SSSSSS   CCCC  R   R  EEEEE  EEEEE  N   N  II  N   N  GGGGGG ------- L *
********************************************************************************
*
        dimension mode(8)
*
        common  /modus/    mode
     1       /screen/   zt, zi
     1                , scrlen, coulomb
*
*  Calculate (1 / (screening lenght)) for the different choices of potential
        if (mode(3) .eq. 0) then                                ! Moliere pot
          if ( zi .eq. 1.) then                                 ! ion is H
                scrlen = ( zt ** 0.333333333) / (0.88534*0.529)
               else                                             ! ion is He
                scrlen = (0.5*zi)**0.5 + zt**0.5
                scrlen = scrlen**0.666666667
                scrlen = scrlen / (0.88534*0.529)
               endif
         else                                                   ! Biersack pot
          scrlen = (zi**0.23+zt**0.23)/(0.88534*0.529)
         endif
*
        return
        end

