#!/usr/local/bin/wish
#############################################################################
# Visual Tcl v1.20 Project
#

#################################
# GLOBAL VARIABLES
#
global XVeg; 
global block; 
global modout; 
global natoms; 
global shad; 
global xrep; 
global yrep; 
global widget; 

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {
global natoms xrep yrep
global modout mode
global shad block
global XVeg
#package require BLT
set natoms 0
set shad 0
set block 0
set xrep 0
set yrep 0
set XVeg(VEGAS_HOME) [ pwd ]
set modout 1
for {set i 0} {$i < 8} {incr i 1} {
set mode($i) 0
}

}

init $argc $argv


proc {aboutit} {} {
set textmsg [format %s "Sincalc XVegas MEIS Simulation software\n"]
append textmsg  [format %s "by Paul Quinn : Oct 2000\n"]
append textmsg  [format %s "Based of software kindly donated by\n"] 
append textmsg  [format %s "the F.O.M. institute.\n"] 
append textmsg  [format %s "Please acknowledge the use of this software in any resulting publications\n"] 
append textmsg  [format %s "For further details email :sppq@spec.warwick.ac.uk \n"] 
append textmsg  [format %s "or view the website at http://www.phys.warwick.ac.uk/~sppq/meis.html\n"] 
set answer [tk_messageBox -message $textmsg -type ok -icon question -title "About XVegas"]
}

proc {addatom} {} {
global atopt natoms typ sigz
Window show .xyzinf
set val 0.0
set val 0.00
foreach value { .xyzinf.cpd17.02 .xyzinf.cpd18.02 .xyzinf.cpd19.02  .xyzinf.cpd20.02 .xyzinf.cpd22.02 .xyzinf.cpd23.02} {
$value delete 0 end 		
$value insert 0 $val
}		
if {$natoms == 0 } {
set vib 0.07
.xyzinf.cpd20.02 insert 0 $vib
.xyzinf.cpd22.02 insert 0 $vib
.xyzinf.cpd23.02 insert 0 $vib
.xyzinf.cpd17.02 insert 0 "CU"
} else {
set atom $typ([expr $natoms-1])
set vib $sigz([expr $natoms-1])
.xyzinf.cpd20.02 insert 0 $vib
.xyzinf.cpd22.02 insert 0 $vib
.xyzinf.cpd23.02 insert 0 $vib
.xyzinf.cpd17.02 insert 0 $atom
} 
set atopt 0
}

proc {addtolist} {} {
global natoms
set sel [.dispvib.cpd20.01 curselection]

set val [.dispvib.cpd21.01 index end]
 if {$val > 0} {
             
     foreach i [.dispvib.cpd20.01 curselection] {
                set okay 1
                for {set j 0} { $j < $val} {incr j 1} {
                scan [.dispvib.cpd21.01 get $j] "%d" temp
                set temp [expr $temp-1]
                 if {$temp == $i} {
                    set okay 0
                    }
                 }   
                if {$okay == 0} {
                    .dispvib.tex22 configure -state normal
                    .dispvib.tex22 delete 1.0 2.0 
                    .dispvib.tex22 insert insert "Some atoms already selected"
                    .dispvib.tex22 configure -state disabled
                  } else {
                    .dispvib.cpd21.01 insert end [expr $i+1]
                }
                            
               }
                   
 } else {
    foreach i [.dispvib.cpd20.01 curselection] {
        .dispvib.cpd21.01 insert end [expr [.dispvib.cpd20.01 index $i]+1]
        }
 }
}

proc {altcrys} {} {
global x y z sigx sigy sigz natoms selectedButton

set err 0

foreach value { .dispvib.cpd22.02 .dispvib.cpd23.02 .dispvib.cpd24.02 } {
if { [ scan [$value get] "%f" temp ] < 0 } {
.dispvib.tex22 configure -state normal
.dispvib.tex22 delete 1.0 2.0 
.dispvib.tex22 insert insert "X Y or Z values unspecified"
.dispvib.tex22 configure -state disabled
set err 1
break
}
}


if { [.dispvib.cpd21.01 index end] <= 0 } {
.dispvib.tex22 configure -state normal
.dispvib.tex22 delete 1.0 2.0 
.dispvib.tex22 insert insert "No atoms selected !!!"
.dispvib.tex22 configure -state disabled
set err 1
} 



if { $err < 1 } {
  set val [.dispvib.cpd21.01 index end]
  scan [.dispvib.cpd22.02 get] "%f" xval
  scan [.dispvib.cpd23.02 get] "%f" yval
  scan [.dispvib.cpd24.02 get] "%f" zval
    
    if { $selectedButton == 1} {
        for {set i 0} { $i < $val } {incr i 1} {
        scan [.dispvib.cpd21.01 get $i] "%d" temp
        set temp [expr $temp-1]
        set x($temp) [expr $x($temp)+ [format "%8.3f" $xval]]
        set y($temp) [expr $y($temp)+ $yval]
        set z($temp) [expr $z($temp)+ $zval]
        }
    } else {
    for {set i 0 } {$i < $val} {incr i 1} {
        scan [.dispvib.cpd21.01 get $i] "%d" temp
        set temp [expr $temp-1]
        set sigx($temp) $xval
        set sigy($temp) $yval
        set sigz($temp) $zval
        }
    } 

.dispvib.tex22 configure -state normal
.dispvib.tex22 delete 1.0 2.0 
.dispvib.tex22 insert insert "Crystal Altered"
.dispvib.tex22 configure -state disabled
sortbyz

}
}

proc {altervibdisp} {} {
global x y z sigx sigy sigz natoms typ

if {$natoms > 0} {
Window show .dispvib
.dispvib.cpd20.01 delete 0 end
.dispvib.cpd21.01 delete 0 end
.dispvib.cpd22.02 delete 0 end
.dispvib.cpd23.02 delete 0 end
.dispvib.cpd24.02 delete 0 end
set err 0
   for {set i 0} {$i < $natoms} {incr i 1} {
  .dispvib.cpd20.01 insert $i [format "%4d %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %s" [expr $i+1] $x($i) $y($i) $z($i) $sigx($i) $sigy($i) $sigz($i) $typ($i)]
       }	
} else {
.crys.tex21 configure -state normal
.crys.tex21 delete 1.0 2.0
.crys.tex21 insert insert "There are no atoms to alter !!"
.crys.tex21 configure -state disabled


}
}

proc {atomtom} {attyp} {
set atom [string toupper [string trim attyp] ]
set zmass 0.0
if {$atom == "H"} { 
set zmass 1.008 
}
if {$atom == "HE"} { 
set zmass 4.003
}
if {$atom == "LI"} { 
set zmass 6.940
}
if {$atom == "BE"} { 
set zmass 9.012
}
if {$atom == "B"} { 
set zmass 10.810
}
if {$atom == "C"} { 
set zmass 12.011
}
if {$atom == "C"} { 
set zmass 14.007
}
if {$atom == "O"} { 
set zmass 15.999
}
if {$atom == "F"} { 
set zmass 18.998
}

if {$atom == "NE"} { 
set zmass 20.179
}

if {$atom == "NA"} { 
set zmass 22.990
}

if {$atom == "MG"} { 
set zmass 24.305
}
if {$atom == "AL"} { 
set zmass 26.982
}
if {$atom == "SI"} { 
set zmass 28.086
}
if {$atom == "P"} { 
set zmass 30.974
}
if {$atom == "S"} { 
set zmass 32.060
}
if {$atom == "CL"} { 
set zmass 35.453
}
if {$atom == "AR"} { 
set zmass 39.948
}
if {$atom == "K"} { 
set zmass 39.098
}
if {$atom == "CA"} { 
set zmass 40.080
}

if {$atom == "SC"} { 
set zmass 44.956
}
  
if {$atom == "TI"} { 
set zmass 47.900
}
if {$atom == "V"} { 
set zmass 50.941
}
if {$atom == "CR"} { 
set zmass 51.996
}
if {$atom == "MN"} { 
set zmass 54.938
}
if {$atom == "FE"} { 
set zmass 55.847
}
if {$atom == "CO"} { 
set zmass 58.933
}
if {$atom == "NI"} { 
set zmass 58.710
}
if {$atom == "CU"} { 
set zno 29
set zmass 63.546
}
if {$atom == "ZN"} { 
set zmass 65.380
}
if {$atom == "GA"} { 
set zmass 69.720
}
if {$atom == "GE"} { 
set zmass 72.590
}
if {$atom == "AS"} { 
set zmass 74.922
}
if {$atom == "SE"} { 
set zmass 78.960
}
if {$atom == "BR"} { 
set zmass 79.904
}
if {$atom == "KR"} { 
set zmass 83.800
}
if {$atom == "RB"} { 
set zmass 85.467
}
if {$atom == "SR"} { 
set zmass 87.620
}
if {$atom == "Y"} { 
set zmass 88.906
}
if {$atom == "ZR"} { 
set zmass 91.220
}
if {$atom == "NB"} { 
set zmass 92.906
}
if {$atom == "MO"} { 
set zmass 95.940
}
if {$atom == "TC"} { 
set zmass 98.906
}
if {$atom == "RU"} { 
set zmass 101.070
}
if {$atom == "RH"} { 
set zmass 102.906
}
if {$atom == "PD"} { 
set zmass 106.400
}
if {$atom == "AG"} { 
set zmass 107.868
}
if {$atom == "CD"} { 
set zmass 112.410
}
if {$atom == "IN"} { 
set zmass 114.820
}
if {$atom == "SN"} { 
set zmass 118.690
}
if {$atom == "SB"} { 
set zmass 121.750
}
if {$atom == "TE"} { 
set zmass 127.600
}
if {$atom == "I"} { 
set zmass 126.905
}
if {$atom == "XE"} { 
set zmass 131.300
}
if {$atom == "CS"} { 
set zmass 132.905
}
if {$atom == "BA"} { 
set zmass 137.330
}
if {$atom == "LA"} { 
set zmass 138.906
}
if {$atom == "CE"} { 
set zmass 140.120
}
if {$atom == "ND"} { 
set zmass 144.240
}

if {$atom == "PM"} { 
set zno 61
set zmass 145.000
}
  
if {$atom == "SM"} { 
set zmass 150.400
}
if {$atom == "EU"} { 
set zmass 151.960
}
if {$atom == "GD"} { 
set zmass 157.250
}
if {$atom == "TB"} { 
set zmass 158.925
}
if {$atom == "DY"} { 
set zmass 162.500
}
if {$atom == "HO"} { 
set zmass 164.930
}
if {$atom == "ER"} { 
set zmass 167.260
}
if {$atom == "TM"} { 
set zmass 168.934
}
if {$atom == "YB"} { 
set zmass 173.040
}
if {$atom == "LU"} { 
set zmass 174.970
}
if {$atom == "HF"} { 
set zmass 178.490
}
if {$atom == "TA"} { 
set zmass 180.947
}
if {$atom == "W"} { 
set zmass 183.850
}
if {$atom == "RE"} { 
set zmass 186.200
}
if {$atom == "OS"} { 
set zmass 190.200
}
if {$atom == "IR"} { 
set zmass 192.220
}
if {$atom == "PT"} { 
set zmass 195.090
}
if {$atom == "AU"} { 
set zmass 196.967
}
if {$atom == "HG"} { 
set zmass 200.590
}
if {$atom="TI"} { 
set zmass 204.370
}
if {$atom == "PB"} { 
set zmass 207.200
}
if {$atom == "BI"} { 
set zmass 208.981
}
if {$atom == "PO"} { 
set zmass 209.000
}
if {$atom == "AT"} { 
set zmass 210.000
}
if {$atom == "RN"} { 
set zmass 222.000
}
if {$atom == "FR"} { 
set zmass 223.000
}
if {$atom == "RA"} { 
set zmass 226.025
}
if {$atom == "AC"} { 
set zmass 227.000
}
if {$atom == "TH"} { 
set zmass 232.038
}
if {$atom == "PA"} { 
set zmass 231.038
}
if {$atom == "U"} { 
set zmass 238.029
}
return $zmass
}

proc {atomtoz} {attyp} {
global zno
set atom [string toupper [string trim $attyp] ]

set zno(0) ""
set zno(1) "H"
set zno(2) "HE"
set zno(3) "LI"
set zno(4) "BE"
set zno(5) "B"
set zno(6) "C"
set zno(7) "N"
set zno(8) "O"
set zno(9) "F"
set zno(10) "NE"
set zno(11) "NA"
set zno(12) "MG"
set zno(13) "AL"
set zno(14) "SI"
set zno(15) "P"
set zno(16) "S"
set zno(17) "CL"
set zno(18) "AR"
set zno(19) "K"
set zno(20) "CA"
set zno(21) "SC"
set zno(22) "TI"
set zno(23) "V"
set zno(24) "CR"
set zno(25) "MN"
set zno(26) "FE"
set zno(27) "CO"
set zno(28) "NI"
set zno(29) "CU"
set zno(30) "ZN"
set zno(31) "GA"
set zno(32) "GE"
set zno(33) "AS"
set zno(34) "SE"
set zno(35) "BR"
set zno(36) "KR"
set zno(37) "RB"
set zno(38) "SR"
set zno(39) "Y"
set zno(40) "ZR"
set zno(41) "NB"
set zno(42) "MO"
set zno(43) "TC"
set zno(44) "RU"
set zno(45) "RH"
set zno(46) "PD"
set zno(47) "AG"
set zno(48) "CD"
set zno(49) "IN"
set zno(50) "SN"
set zno(51) "SB"
set zno(52) "TE"
set zno(53) "I"
set zno(54) "XE"
set zno(55) "CS"
set zno(56) "BA"
set zno(57) "LA"
set zno(58) "CE"
set zno(59) "PR"
set zno(60) "ND"
set zno(61) "PM"
set zno(62) "SM"
set zno(63) "EU"
set zno(64) "GD"
set zno(65) "TB"
set zno(66) "DY"
set zno(67) "HO"
set zno(68) "ER"
set zno(69) "TM"
set zno(70) "YB"
set zno(71) "LU"
set zno(72) "HF"
set zno(73) "TA"
set zno(74) "W"
set zno(75) "RE"
set zno(76) "OS"
set zno(77) "IR"
set zno(78) "PT"
set zno(79) "AU"
set zno(80) "HG"
set zno(81) "TL"
set zno(82) "PB"
set zno(83) "BI"
set zno(84) "PO"
set zno(85) "AT"
set zno(86) "RN"
set zno(87) "FR"
set zno(88) "RA"
set zno(89) "AC"
set zno(90) "TH"
set zno(91) "PA"
set zno(92) "U"
set value 0
for {set i 0} {$i < 93} {incr i 1 } {
if {[string compare $atom $zno($i)] == 0} { 
set value $i
}
}
return $value
}

proc {beamok} {} {
global lower upper step factor shad block ioneng beamerr
global azi zi ionm polar modout mode pottype conntrack
set err 0
set beamerr 0
# check that boxes are not empty
foreach value {.beam.iontype .beam.lowang .beam.upang .beam.angstep .beam.polang .beam.azimuth .beam.fluxs .beam.fluxb .beam.energy .beam.expatoms } {
if { [ scan [$value get] "%f" temp ] < 0 } {
	.beam.tex18 configure -state normal
	.beam.tex18 delete 1.0 2.0 
	.beam.tex18 insert insert "ERROR : A box is empty or invalid value"
	.beam.tex18 configure -state disabled
	set beamerr 1
	set err 1
	return 1
	}
}
if {$err < 1} {
scan [.beam.iontype get] "%s" ion
set zi [eval atomtoz $ion]
if {$zi == 0} {
set err 1
.beam.tex18 configure -state normal
.beam.tex18 delete 1.0 2.0 
.beam.tex18 insert insert "ERROR : A box is empty or contains an invalid value"
.beam.tex18 configure -state disabled
set beamerr 1
}
}




if {$err < 1 } {
set zi [eval atomtoz $ion]
set ionm [eval ztomass $zi]
scan [.beam.lowang get] "%f" lower
scan [.beam.upang get] "%f" upper
scan [.beam.angstep get] "%f" step
scan [.beam.polang get] "%f" polar
scan [.beam.azimuth get] "%f" azi
scan [.beam.fluxs get] "%f" shad
scan [.beam.fluxb get] "%f" block
scan [.beam.energy get] "%f" ioneng
scan [.beam.expatoms get] "%f" factor

# check validity of input values

if {$polar < 0.0 || $polar > 90.0} {
set err 1
.beam.tex18 configure -state normal -background red
.beam.tex18 delete 1.0 2.0 
.beam.tex18 insert insert "ERROR : Polar angle should be between 0 and 90 degrees"
.beam.tex18 configure -state disabled
set beamerr 1
}

if { [expr $polar+$lower] <= 90.0 || $lower > 180.0 || $upper > 180.0 || $upper < $lower} {
set err 1
.beam.tex18 configure -state normal -background red
.beam.tex18 delete 1.0 2.0 
set rangev [format "%5.2f -> %5.2f" [expr 90.0-$polar] 180.0]
.beam.tex18 insert insert "ERROR : Scattering Angles should be in the interval $rangev"
.beam.tex18 configure -state disabled
set beamerr 1
}
}                    

if {$err < 1} {
set mode(2) $pottype 
set mode(6) $conntrack                  
}                   
                    
if {$err < 1 } {
# check whether they're good values
.beam.tex18 configure -state normal -background white
.beam.tex18 delete 1.0 2.0 
.beam.tex18 insert insert "Values accepted [clock format [clock seconds] -format "%a %b %d %H:%M:%S %Y"]"
.beam.tex18 configure -state disabled


}
}

proc {compileit} {} {
global XVeg tcl_platform runflag mode mystatus

.sincout.cpd24.03 delete 1.0 end 
set mystatus 0 
.sincout.runit  configure -text "Start Simulation" 

if {$mode(6) == 0} {
##############################################################################
# In the event of a single calculation
##############################################################################

##############################################################################
# UNIX platform
##############################################################################

if { $tcl_platform(platform) == "unix"} {
    if { [catch {package require BLT} result] } {
# f77 it 	
	if { [catch {exec "sincomp.bat" <@stdin >@stdout 2>@stderr} result]} {
         catch {.sincout.cpd24.03 insert end "Error running program !!!\n"}
          .sincout.runit  configure -text "Start Simulation" 

         }
    } else {
# Run f90 executable 
        if { [catch {blt::bgexec mystatus -onoutput writeit -onerror writerr \ 
             [file join $XVeg(VEGAS_HOME) "sincalcx.exe"]} result]  } {
             catch {.sincout.cpd24.03 insert end "Error running program !!!\n"}
             .sincout.runit  configure -text "Start Simulation" 

           }
    }
} else { 
##############################################################################
# Windows platform
##############################################################################
     if { [catch {package require BLT} result] } {
# run f77 in background
	if { [catch {exec "conncomp.bat" } result]} {
         catch {.sincout.cpd24.03 insert end "Error running program !!!\n"}
          .sincout.runit  configure -text "Start Simulation" 

         }
     } else {
# Run f90 executable
	     if { [catch {blt::bgexec mystatus  -onoutput writeit -onerror writerr  [file join $XVeg(VEGAS_HOME) "sincalcx.exe"]} result] } {
             catch {.sincout.cpd24.03 insert end "Error running program !!!\n"}
		.sincout.runit  configure -text "Start Simulation" 

           }
    }

}
} else {
##############################################################################
# In the event of a conneted track calculation
##############################################################################

##############################################################################
# UNIX platform
##############################################################################

if { $tcl_platform(platform) == "unix"} {
    if { [catch {package require BLT} result] } {
# f77 it 	
	if { [catch {exec "conncomp.bat" <@stdin >@stdout 2>@stderr} result]} {
         catch {.sincout.cpd24.03 insert end "Error running program !!!\n"}
	    .sincout.runit  configure -text "Start Simulation" 

         }
    } else {
# Run f90 executable 
        if { [catch {blt::bgexec mystatus -onoutput writeit -onerror writerr \ 
             [file join $XVeg(VEGAS_HOME) "conncalcx.exe"]} result]  } {
             catch {.sincout.cpd24.03 insert end "Error running program !!!\n"}
		 .sincout.runit  configure -text "Start Simulation" 

           }
    }
} else { 
##############################################################################
# Windows platform
##############################################################################
     if { [catch {package require BLT} result] } {
# run f77 in background
	if { [catch {exec "conncomp.bat" } result]} {
         catch {.sincout.cpd24.03 insert end "Error running program !!!\n"}
	     .sincout.runit  configure -text "Start Simulation" 
	
         }
     } else {
# Run f90 executable
	     if { [catch {blt::bgexec mystatus  -onoutput writeit -onerror writerr  [file join $XVeg(VEGAS_HOME) "conncalcx.exe"]} result] } {
             catch {.sincout.cpd24.03 insert end "Error running program !!!\n"}
             .sincout.runit  configure -text "Start Simulation" 

           }
    }
}


#tkwait variable mystatus
#.sincout.runit  configure -text "Start Simulation" 









}
}

proc {crysok} {} {
global natoms xrep yrep
# accept crystal values
set err 0
foreach value {.crys.xper .crys.yper } {
if { [ scan [$value get] "%f" temp ] < 0 } {
.crys.tex21 configure -state normal -background red
.crys.tex21 delete 1.0 2.0 
.crys.tex21 insert insert "A box is empty or invalid value"
.crys.tex21 configure -state disabled
set err 1
break
}
}

if { $err < 1} {
scan [.crys.xper get] "%f" xrep
scan [.crys.yper get] "%f" yrep
groupcrys
}
}

proc {delatom} {} {
global x y z sigx sigy sigz natoms typ
set sel [.crys.cpd17.01 curselection]
if { $sel>=0 & $sel < $natoms} {
.crys.cpd17.01 delete $sel 
for {set i $sel} {$i< [expr $natoms-1]} {incr i 1} {
set next [expr $i+1]
set x($i) $x($next)
set y($i) $y($next)
set z($i) $z($next)
set sigx($i) $sigx($next)
set sigy($i) $sigy($next)
set sigz($i) $sigz($next)
set typ($i) $typ($next)
}
set natoms [expr $natoms-1]
}
}

proc {editatom} {} {
global x y z sigx sigy sigz typ sel atopt natoms

if { $natoms > 0 } {
set sel [.crys.cpd17.01 curselection]
if { $sel >= 0 & $sel < $natoms} {
Window show .xyzinf
.xyzinf.cpd18.02 delete 0 end
.xyzinf.cpd18.02 insert 0 $x($sel)
.xyzinf.cpd24.02 delete 0 end
.xyzinf.cpd24.02 insert 0 $y($sel)
.xyzinf.cpd19.02 delete 0 end
.xyzinf.cpd19.02 insert 0 $z($sel)
.xyzinf.cpd20.02 delete 0 end 
.xyzinf.cpd20.02 insert 0 $sigx($sel)
.xyzinf.cpd22.02 delete 0 end 
.xyzinf.cpd22.02 insert 0 $sigy($sel)
.xyzinf.cpd23.02 delete 0 end
.xyzinf.cpd23.02 insert 0 $sigz($sel)
.xyzinf.cpd17.02 delete 0 end
.xyzinf.cpd17.02 insert 0 $typ($sel)
set atopt 1
}
} else {
.crys.tex21 configure -state normal
.crys.tex21 delete 1.0 2.0
.crys.tex21 insert insert "No atoms to edit"
.crys.tex21 configure -state disabled
}
}

proc {groupcrys} {} {
global x y z natoms kx ky kz vx vy vz ngx ngy ngz

set crit 0.8

########################################################
# group x
#######################################################
#######################################################
# sort the x values first 
#######################################################

for {set i 0} {$i < $natoms} {incr i 1} {
    set xtmp($i) $x($i)
    set ktmp($i) 1
    set kx($i) 1
}

set k 0
set sorted 0
while {$sorted == 0} {
    set sorted 1
    set k [expr $k+1]
    for {set j 0} { $j < [expr $natoms-$k]  } {incr j 1} {
        if { $xtmp($j) > $xtmp([expr $j+1]) } {
               set temp  $xtmp([expr $j+1])
               set xtmp([expr $j+1]) $xtmp($j)
               set xtmp($j)  $temp
               set sorted  0
        }
    }
}



        set problem 1

        while {$problem > 0} {
            set problem 0
            set numgr   1
            set ktmp(0) 1
            set numat   1
            for {set i 0} {$i < $natoms} {incr i 1} {
                set ktmp($i) 1
                set kx($i) 1
            }
        



        for {set numat  1} { $numat < $natoms } {incr numat 1} {
            set perror  1
            set looptop [expr $numat-1]
            for {set i 0} { $i <=$looptop } {incr i 1} {
                set dist [expr  abs([expr $xtmp($numat) - $xtmp($i)])]
                if { $dist < $crit } {
                      set ktmp($numat) $ktmp($i)
                      set perror  0
                }       
            }
            
            
            if { $perror > 0 } {
                set numgr [expr $numgr + 1]
                set ktmp($numat) $numgr
            }
            
        }


         for {set i 1} { $i <= $numgr } {incr i 1} {                               
                for {set j 0} { $j < $natoms} {incr j 1} {                               
                           set xmin  $xtmp(0)
                            set xmax $xtmp(0)   
                
                           if {$ktmp($j) == 1} {
                             if {$xtmp($j) > $xmax } {
                                 set xmax $xtmp($j)
                             }
                             if {$xtmp($j) < $xmin } {
                                 set xmin $xtmp($j)
                             }
                        }  
                        set tdist [expr abs([expr $xmax - $xmin])]
                        if { $tdist > $crit} {
                            set crit [expr $crit*0.9]
                            set problem 1
                        }           
                                             
                }             
         }    
    
              
         }   
         # end of while

        
        
        
        for {set i 0} {$i < $natoms} {incr i 1} {
            for {set k 0} {$k < $natoms} {incr k 1} {
                  if { $x($i) == $xtmp($k) } {
                      set kx($i) $ktmp($k)
                  }
            }
        }

       set ngx $numgr

       for {set igr 1 } { $igr <= $ngx } {incr igr 1} {
           set number 0
           set ind [expr $igr-1]
           set vx($ind) 0.0
           for {set i 0 } { $i < $natoms } {incr i 1} {    
               if {$kx($i) == $igr } {
                    set vx($ind) [expr $vx($ind)+ $x($i)]           
                    set number [expr $number + 1]     
               }
           }    
           if {$number > 1} {
           set vx($ind) [expr $vx($ind)/$number] 
           }   
       }

       for {set iat 0} { $iat < $natoms } { incr iat 1 } {
             set x($iat) [expr $x($iat)- $vx(0)]     
        }

        if {$ngx >= 2} {
            for {set igr 1 } {$igr < $ngx} {incr igr 1} {
                 set vx($igr) [expr $vx($igr)- $vx(0)]     
            }
        }
        set vx(0) 0



 
################################################
# group y positions
################################################
for {set i 0} {$i < $natoms} {incr i 1} {
set ytmp($i) $y($i)
set ktmp($i) 1
set ky($i) 1
}

set k 0
set sorted 0
while {$sorted == 0} {
    set sorted 1
    set k [expr $k+1]
    for {set j 0} { $j < [expr $natoms-$k]  } {incr j 1} {
        if { $ytmp($j) > $ytmp([expr $j+1]) } {
               set temp  $ytmp([expr $j+1])
               set ytmp([expr $j+1]) $ytmp($j)
               set ytmp($j)  $temp
               set sorted  0
        }
    }
}

                        
        set problem 1
        while {$problem > 0} {
            set problem 0
            set numgr   1
            set ktmp(0) 1
            for {set i 0} {$i < $natoms} {incr i 1} {
                set ktmp($i) 1
                set ky($i) 1
            }
        
        for {set numat 1} { $numat < $natoms } {incr numat 1} {
            set perror  1
            set looptop [expr $numat-1]
            for {set i 0} { $i <= $looptop } {incr i 1} {
                set dist [expr  abs([expr $ytmp($numat) - $ytmp($i)])]
                if { $dist < $crit } {
                      set ktmp($numat) $ktmp($i)
                      set perror  0
                }       
            }
            
            
            if { $perror > 0 } {
                set numgr [expr $numgr + 1]
                set ktmp($numat) $numgr
            }
            
        }

         
         for {set i 1} { $i <= $numgr } {incr i 1} {                               
                for {set j 0} { $j < $natoms} {incr j 1} {                               
                           set ymin $ytmp(0)
                            set ymax $ytmp(0)   
                
                           if {$ktmp($j) == 1} {
                             if {$ytmp($j) > $ymax } {
                                 set ymax $ytmp($j)
                             }
                             if {$ytmp($j) < $ymin } {
                                 set ymin $ytmp($j)
                             }
                        }  
                        set tdist [expr abs([expr $ymax - $ymin])]
                        if { $tdist > $crit} {
                            set crit [expr $crit*0.9]
                            set problem 1
                        }           
                                             
                }             
         }    
    
              
         }   
         # end of while
                                
                                        
                                                
                                                        
             
        for {set i 0} {$i < $natoms} {incr i 1} {
        for {set k 0} {$k < $natoms} {incr k 1} {
          if { $y($i) == $ytmp($k) } {
          set ky($i) $ktmp($k)
          }
        }
        }
       set ngy $numgr

       for {set igr 1 } { $igr <= $ngy } {incr igr 1} {
       set number 0
       set ind [expr $igr-1]
       set vy($ind) 0
           for {set i 0 } { $i < $natoms } {incr i 1} {    
               if {$ky($i) == $igr } {
                    set vy($ind) [expr $vy($ind)+ $y($i)]           
                    set number [expr $number + 1]     
               }
           }    
           if {$number > 1} {
           set vy($ind) [expr $vy($ind)/$number] 
           }   
       }

       for {set iat 0} { $iat < $natoms } { incr iat 1 } {
         set y($iat) [expr $y($iat)- $vy(0)]     
        }

        if {$ngy >= 2} {
        for {set igr 1 } {$igr < $ngy} {incr igr 1} {
         set vy($igr) [expr $vy($igr)- $vy(0)]     
        }
        }
        set vy(0) 0

################################################################
# ################################################################
# group z
# ##############################################################
for {set i 0} {$i < $natoms} {incr i 1} {
set ztmp($i) $z($i)
set ktmp($i) 1
set kz($i) 1
}

set k 0
set sorted 0
while {$sorted == 0} {
    set sorted 1
    set k [expr $k+1]
    for {set j 0} { $j < [expr $natoms-$k]  } {incr j 1} {
        if { $ztmp($j) > $ztmp([expr $j+1]) } {
               set temp  $ztmp([expr $j+1])
               set ztmp([expr $j+1]) $ztmp($j)
               set ztmp($j)  $temp
               set sorted  0
        }
    }
}


        set problem 1
        while {$problem > 0} {
            set problem 0
            set numgr   1
            set ktmp(0) 1
            for {set i 0} {$i < $natoms} {incr i 1} {
                set ktmp($i) 1
                set kz($i) 1
            }
        
        for {set numat 1} { $numat < $natoms } {incr numat 1} {
            set perror  1
            set looptop [expr $numat-1]
            for {set i 0} { $i <= $looptop } {incr i 1} {
                set dist [expr  abs([expr $ztmp($numat) - $ztmp($i)])]
                if { $dist < $crit } {
                      set ktmp($numat) $ktmp($i)
                      set perror  0
                }       
            }
            
            
            if { $perror > 0 } {
                set numgr [expr $numgr + 1]
                set ktmp($numat) $numgr
            }
            
        }

         
         for {set i 1} { $i <= $numgr } {incr i 1} {                               
                for {set j 0} { $j < $natoms} {incr j 1} {                               
                           set zmin $ztmp(0)
                            set zmax $ztmp(0)   
                
                           if {$ktmp($j) == 1} {
                             if {$ztmp($j) > $zmax } {
                                 set zmax $ztmp($j)
                             }
                             if {$ztmp($j) < $zmin } {
                                 set zmin $ztmp($j)
                             }
                        }  
                        set tdist [expr abs([expr $zmax - $zmin])]
                        if { $tdist > $crit} {
                            set crit [expr $crit*0.9]
                            set problem 1
                        }           
                                             
                }             
         }    
    
              
         }   
         # end of while

        
        
        
        
        
        for {set i 0} {$i < $natoms} {incr i 1} {
        for {set k 0} {$k < $natoms} {incr k 1} {
          if { $z($i) == $ztmp($k) } {
          set kz($i) $ktmp($k)
         }
        }
        }
       set ngz $numgr

       for {set igr 1 } { $igr <= $ngz } {incr igr 1} {
       set number 0
       set ind [expr $igr-1]
       set vz($ind) 0
           for {set i 0 } { $i < $natoms } {incr i 1} {    
               if {$kz($i) == $igr } {
                    set vz($ind) [expr $vz($ind)+ $z($i)]           
                    set number [expr $number + 1]     
               }
           }    
           if {$number > 1} {
           set vz($ind) [expr $vz($ind)/$number] 
           }   
       }

       for {set iat 0} { $iat < $natoms } { incr iat 1 } {
         set z($iat) [expr $z($iat)- $vz(0)]     
        }

        if {$ngz >= 2} {
        for {set igr 1 } {$igr < $ngz} {incr igr 1} {
         set vz($igr) [expr $vz($igr)- $vz(0)]     
        }
        }
        set vz(0) 0
        
        
        
        
#############################################################
# Clean up 
#############################################################     
     .crys.tex21 configure -state normal -background white
     .crys.tex21 delete 1.0 2.0
     .crys.tex21 insert insert "Crystal Grouped Successfully [clock format [clock seconds] -format "%a %b %d %H:%M:%S %Y"]"
     .crys.tex21 configure -state disabled
}

proc {groupmass} {} {
global natoms typ ngm km zt zmass
# Get no of elements and atom orders
########################################################
# group mass
#######################################################

for {set i 0} {$i < $natoms} {incr i 1} {
set m($i) [eval atomtoz $typ($i)]
set mtmp($i) [eval atomtoz $typ($i)]
set ktmp($i) 1
set km($i) 1
}
#sort first
for {set k 1} { $k < [expr $natoms-1]  } {incr k 1} {
for {set j 0} { $j < [expr $natoms-$k]  } {incr j 1} {

if {$mtmp($j) > $mtmp([expr $j+1]) } {

# x
set temp $mtmp($j)
set mtmp($j) $mtmp([expr $j+1])
set mtmp([expr $j+1]) $temp

} 
}

}


set numgr   1
set numat   1
set ktmp(0) 1
        for {set numat 1} {$numat < $natoms} {incr numat 1} {
        set perror  1
        set looptop [expr $numat - 1 ]
        for {set i 0} {$i <= $looptop} {incr i 1} {
            set dist [expr  $mtmp($numat) - $mtmp($i)]
            if {$dist < 0} {
            set dist [expr -1*$dist]
            }
            if {$dist < 0.1} {
              set ktmp($numat) $ktmp($i)
              set perror  0
            }
        }

        if {$perror > 0} {
        set numgr [expr $numgr + 1]
        set ktmp($numat) $numgr
        }
        }

        for {set i 0} {$i < $natoms} {incr i 1} {
        for {set k 0} {$k < $natoms} {incr k 1} {
          if { $m($i) == $mtmp($k) } {
         set km($i) $ktmp($k)
        }
       }
       }

        set ngm $numgr
        for {set i 1} {$i <= $ngm} {incr i 1} {
        for {set k 0} {$k < $natoms} {incr k 1} {               
        if {$km($k) == $i} {
        set zt($i) $m($k)
        set zmass($i) [eval ztomass $m($k)]
        }
        }
        }
}

proc {growcrys} {} {
global x y z sigx sigy sigz natoms typ xrep yrep
global selectedButton



set err 0

foreach value { .vibdisp.cpd17.02 .vibdisp.cpd18.02 } {
if { [ scan [$value get] "%f" temp ] < 0 } {
.vibdisp.tex17 configure -state normal
.vibdisp.tex17 delete 1.0 2.0 
.vibdisp.tex17 insert insert "A value has not been correctly specified"
.vibdisp.tex17 configure -state disabled
set err 1
break
}
}


if { $selectedButton < 1} {
.vibdisp.tex17 configure -state normal
.vibdisp.tex17 delete 1.0 2.0 
.vibdisp.tex17 insert insert "X Y or Z axes hasn't been specified"
.vibdisp.tex17 configure -state disabled
set err 1 
}


if { $err < 1 } {


scan [.vibdisp.cpd17.02 get] %d nreps
scan [.vibdisp.cpd18.02 get] %f zrep



for {set irep 1} {$irep<=$nreps} {incr irep 1} {
for {set i [expr $natoms*$irep]} {$i < [expr $natoms * [expr $irep+1] ] } {incr i 1} {
set x($i) $x([expr $i-$natoms])
set y($i) $y([expr $i-$natoms])
set z($i) $z([expr $i-$natoms])
set sigx($i) $sigx([expr $i-$natoms])
set sigy($i) $sigy([expr $i-$natoms])
set sigz($i) $sigz([expr $i-$natoms])
set typ($i) $typ([expr $i-$natoms])
if { $selectedButton == 1 } {
    set x($i) [expr $x($i)+$zrep]
    } elseif { $selectedButton == 2 } {
    set y($i) [expr $y($i)+$zrep]
    } elseif { $selectedButton == 3 } {
    set z($i) [expr $z($i)+$zrep]
    }

}
}
set natoms [expr [expr $nreps+1]*$natoms]

if { $selectedButton == 1 } {
    set xrep [expr $xrep*[expr $nreps+1]]
    } elseif { $selectedButton == 2 } {
    set yrep [expr $yrep*[expr $nreps+1]]
    } 


sortbyz
Window show .crys
.crys.xper delete 0 end
.crys.yper delete 0 end
.crys.xper insert 0 [format "%6.3f" $xrep]
.crys.yper insert 0 [format "%6.3f" $yrep]
.crys.cpd17.01 delete 0 end
    for {set i 0} {$i < $natoms} {incr i 1} {
    .crys.cpd17.01 insert $i [format "%4d %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %s" [expr $i+1] $x($i) $y($i) $z($i) $sigx($i) $sigy($i) $sigz($i) $typ($i)]
    }
.vibdisp.tex17 configure -state normal
.vibdisp.tex17 delete 1.0 2.0 
.vibdisp.tex17 insert insert "Crystal grown"
.vibdisp.tex17 configure -state disabled

}
}

proc {newsim} {} {
global natoms shad block pottype conntrack mode

set conntrack 0
set pottype 0
set natoms 0
set shad 0
set block 0
for {set i 0} {$i < 8} {incr i 1} {
set mode($i) 0
}
set mode(0) 1
Window show .crys
Window show .beam
.crys.cpd17.01 delete 0 end
.crys.xper delete 0 end
.crys.yper delete 0 end
foreach value {.beam.iontype .beam.lowang .beam.upang .beam.angstep .beam.azimuth .beam.polang .beam.fluxs .beam.fluxb .beam.energy .beam.expatoms } {
$value delete 0 end
}
}

proc {opencrys} {fileId} {
global x y z sigx sigy sigz typ natoms xrep yrep
    gets $fileId tmp
    if {[scan $tmp %d natoms ] < 1 } {
    return 1
    }
    .crys.cpd17.01 delete 0 end
    for {set i 0} {$i < $natoms} {incr i 1} {
    gets $fileId xyz
    if { [scan $xyz "%f %f %f %s" x($i) y($i) z($i) typ($i)] < 4 } {
    return 1
    }
#    set sigx($i) 0.000
#    set sigy($i) 0.000
#    set sigz($i) 0.000         	 	
#    .crys.cpd17.01 insert $i [format "%4d %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %s" [expr $i+1] $x($i) $y($i) $z($i) $sigx($i) $sigy($i) $sigz($i) $typ($i)]
	
       }	
    gets $fileId tmp
    if {[scan $tmp "%f %f" xrep yrep] < 2 } {
    return 1
    }
    .crys.xper delete 0 end
    .crys.xper insert 0 [format "%6.3f" $xrep]
    .crys.yper delete 0 end
    .crys.yper insert 0 [format "%6.3f" $yrep]
    
# Test to see if vibrations have been amended to file 
 
    gets $fileId tmp
    if {[scan $tmp "%f %f %f" sigx(0) sigy(0) sigz(0)] == 3 } {
        for {set i 1} {$i < $natoms} {incr i 1} {
            gets $fileId sxyz
            if { [scan $sxyz "%f %f %f" sigx($i) sigy($i) sigz($i)] < 3 } {
            return 1
            }
        }
    } else {
        for {set i 0} {$i < $natoms} {incr i 1} {
            set sigx($i) 0.000
            set sigy($i) 0.000
            set sigz($i) 0.000         	 	
        }
    
    }
         
    close $fileId 
    for {set i 0} {$i < $natoms} {incr i 1} {
    .crys.cpd17.01 insert $i [format "%4d %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %s" [expr $i+1] $x($i) $y($i) $z($i) $sigx($i) $sigy($i) $sigz($i) $typ($i)]    
    }
    for {set i $natoms} {$i < 1000} {incr i 1} {
    set x($i) 0
    set y($i) 0
    set z($i) 0
    set sigx($i) 0
    set sigy($i) 0
    set sigz($i) 0
    set typ($i) 0
    }
    
     .crys.tex21 configure -state normal
     .crys.tex21 delete 1.0 2.0
     .crys.tex21 insert insert "Crystal Opened Successfully"
     .crys.tex21 configure -state disabled
}

proc {opensim} {fileId} {
global x y z sigx sigy sigz typ natoms xrep yrep zno nel cor_cof cor_dis
global lower upper step factor shad block ioneng zt zmass
global azi zi ionm polar pottype conntrack
global mode idim

    # Open the file ...
#         set fileId [open $simname r] 	
# # File title    
        gets $fileId tmp
        gets $fileId tmp
# Mode 1-8     
        gets $fileId tmp
        if { [scan $tmp "%d %d %d %d %d %d %d %d" mode(0) mode(1) mode(2) mode(3) mode(4) mode(5) mode(6) mode(7)] < 8 } {
            return 1
            }
        
        
        gets $fileId tmp
        if { [scan $tmp "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d" idim(0) idim(1) idim(2) idim(3) idim(4) idim(5) idim(6) idim(7) idim(8) idim(9) idim(10) idim(11) idim(12) idim(13) idim(14) idim(15) idim(16) idim(17) idim(18)] < 19 } {
            return 1
            }
        set natoms $idim(0)
        set nel $idim(1)
        set ngx $idim(2)
        set ngy $idim(3)
        set ngz $idim(4)        
        for {set i 0} {$i < $idim(1)} {incr i 1} {
            gets $fileId tmp
            if { [scan $tmp "%d %f" zt($i) zmass($i)] < 2 } {
            return 1
                }
            }
        
        gets $fileId tmp
        gets $fileId tmp
        if { [scan $tmp "%f %f" cor_cof cor_dis] < 2 } {
        return 1
        }
        
# x y z sigx sigy sigz atom type    
        for {set i 0} {$i < $idim(0)} {incr i 1} {
            gets $fileId xyz
            if { [scan $xyz "%f %f %f %d %d %d %f %f %f %d" x($i) y($i) z($i) tmp1 tmp2 tmp2  sigx($i) sigy($i) sigz($i) temp] < 7 } {
            return 1
                } 	 	
          	 	
            set j [expr $temp-1]   	 	
            set typ($i)  [eval ztoatom $zt($j)]

            }	
        gets $fileId tmp      	
    
        if { [scan $tmp "%f %f"  xrep yrep] < 2 } {
        return 1
            }
# x group , y group, z group
        set gh [expr [expr $ngx-1]/8.0]
        set gh [expr int($gh)]
        for {set i 0} {$i <= $gh} {incr i 1} {
        gets $fileId tmp
        }

        set gh [expr [expr $ngy-1]/8.0]
        set gh [expr int($gh)]
        for {set i 0} {$i <= $gh} {incr i 1} {
        gets $fileId tmp	
        }
        
        
        set gh [expr [expr $ngz-1]/8.0]
        set gh [expr int($gh)]
        for {set i 0} {$i <= $gh} {incr i 1} {        
        gets $fileId tmp
        }
# get angles              	
        gets $fileId tmp      	
            
        if { [scan $tmp "%f %f %f %f %f" azi polar lower step factor] < 5 } {
        return 1
        }
        gets $fileId tmp      	
    
        if { [scan $tmp "%d %f %f %f %f" zi ionm ioneng shad block] < 5 } {
        return 1
        }    


#        gets $fileId tmp      	        
#        if { [scan $tmp "%d" modout] < 1 } {
#	set modout 1
#        return 1
#        }    
                    
        
        close $fileId
        Window show .crys
        Window show .beam        
        groupcrys
        recrys
# Set Crystal Values
#        .crys.cpd17.01 delete 0 end
# x y z sigx sigy sigz atom type    

#        for {set i 0} {$i < $idim(0)} {incr i 1} {
#            .crys.cpd17.01 insert $i [format "%6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %s" $x($i) $y($i) $z($i) $sigx($i) $sigy($i) $sigz($i) $typ($i)]
#            }	
        .crys.xper delete 0 end
        .crys.yper delete 0 end
        .crys.xper insert 0 $xrep
        .crys.yper insert 0 $yrep  
# Set Beam Values
        .beam.iontype delete 0 end
        .beam.iontype insert 0 [eval ztoatom $zi]
        .beam.fluxs delete 0 end
        .beam.fluxs insert 0 $shad
        .beam.fluxb delete 0 end
        .beam.fluxb insert 0 $block
        .beam.azimuth delete 0 end
        .beam.azimuth insert 0 $azi
        .beam.polang delete 0 end
        .beam.polang insert 0 $polar
        .beam.lowang delete 0 end
        .beam.lowang insert 0 $lower
        .beam.upang delete 0 end
        .beam.upang insert 0 [expr $lower+$step*$idim(8)]
        .beam.energy delete 0 end
        .beam.energy insert 0 $ioneng
        .beam.expatoms delete 0 end
        .beam.expatoms insert 0 $factor
        .beam.angstep delete 0 end
        .beam.angstep insert 0 $step
         set pottype $mode(2)
         set conntrack $mode(6)
         beamok
}

proc {readcrys} {} {
set types {
    {{Crystal Files}       {.crs}   }
    {{All Files}         {.*  }        }
}
set filename [tk_getOpenFile -filetypes $types]


if {$filename != "" } {
set fileId [open $filename r]
if { [eval opencrys $fileId] > 0 } {
.crys.tex21 configure -state normal
.crys.tex21 delete 1.0 2.0
.crys.tex21 insert insert "Error opening file :$filename"
.crys.tex21 configure -state disabled

} else {
  groupcrys
}
}
}

proc {readsim} {} {
set types {
    {{Input Files}       {.in }        }
    {{All Files}         {.*  }        }
}
set simname [tk_getOpenFile -filetypes $types]

if {$simname != "" } {
set fileId [open $simname r] 	
if { [eval opensim $fileId] > 0 } {
set answer [tk_messageBox -message "Error opening simulation file" -type ok -icon warning -title "File Error"]
} else {

.main.tex18 configure -state normal
.main.tex18 delete 1.0 2.0 
.main.tex18 insert insert "Simulation opened ok"
.main.tex18 configure -state disabled
}

}
}

proc {recrys} {} {
global natoms x y z sigx sigy sigz typ
if {$natoms > 0} {
.crys.cpd17.01 delete 0 end
 for {set i 0} {$i < $natoms} {incr i 1} {
.crys.cpd17.01 insert $i [format "%4d %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %s" [expr $i+1] $x($i) $y($i) $z($i) $sigx($i) $sigy($i) $sigz($i) $typ($i)]
}
}
#############################################################
# Clean up 
#############################################################     
     .crys.tex21 configure -state normal
     .crys.tex21 delete 1.0 2.0
     .crys.tex21 insert insert "Crystal sorted and redisplayed [clock format [clock seconds] -format "%a %b %d %H:%M:%S %Y"]"
     .crys.tex21 configure -state disabled
}

proc {redispvib} {} {
# Refresh dispvib crystal display
global natoms x y z sigx sigy sigz typ
.dispvib.cpd20.01 delete 0 end
 for {set i 0} {$i < $natoms} {incr i 1} {
.dispvib.cpd20.01 insert $i [format "%4d %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %s" [expr $i+1] $x($i) $y($i) $z($i) $sigx($i) $sigy($i) $sigz($i) $typ($i)]
}
}

proc {runfromfile} {} {
global ngx ngy ngz lower upper natoms nel step mode
global XVeg


set types {
    {{Input Files}       {.in }        }
    {{All Files}         {.*  }        }
}
set simname [tk_getOpenFile -filetypes $types]

if {$simname != "" } {
set fileId [open $simname r]
if { [eval opensim $fileId] > 0 } {
    close $fileId
    set answer [tk_messageBox -message "Error opening simulation file" -type ok -icon warning -title "File Error"]
} else {
    set nan [expr [expr $upper-$lower]/$step] 
    set nan [expr int($nan)]
    set nx1 [expr $ngx +1]
    set ny1 [expr $ngy +1]
    set nz1 [expr $ngz +1]
    set fname2 [file rootname $simname]
    append fname2 ".out"    
    if {$mode(6) == 0} {
    set fileId [open [file join $XVeg(VEGAS_HOME) "sincalc.dim"] w]
    puts $fileId [format "        parameter"]
    puts $fileId [format "     1  (nat = %d,nel=%d,ngx=%d,"   $natoms $nel $ngx]
    puts $fileId [format "     1   ngy=%d,ngz=%d,nx1=%d,"     $ngy $ngz $nx1]
    puts $fileId [format "     1   ny1=%d,nz1=%d,nan=%d)"     $ny1 $nz1 $nan]
    close $fileId
    
    set fileId [open [file join $XVeg(VEGAS_HOME) "sincalc1.io"] w]
    puts $fileId [format "%s"  [file nativename $simname]]
    puts $fileId [format "%s"  [file nativename $fname2]]
    close $fileId
    set fileId [open [file join $XVeg(VEGAS_HOME) "sincalc.io"] w]
    puts $fileId [format "       parameter "]
    puts $fileId [format "     1 (input_name='%s'," [file nativename $simname]]
    puts $fileId [format "     1  output_name='%s')" [file nativename $fname2]]
    close $fileId
    } else {
    set fileId [open [file join $XVeg(VEGAS_HOME) "conncalc.dim"] w]
    puts $fileId [format "        parameter"]
    puts $fileId [format "     1  (nat = %d,nel=%d,ngx=%d,"   $natoms $nel $ngx]
    puts $fileId [format "     1   ngy=%d,ngz=%d,nx1=%d,"     $ngy $ngz $nx1]
    puts $fileId [format "     1   ny1=%d,nz1=%d,nan=%d)"     $ny1 $nz1 $nan]
    close $fileId
    
    set fileId [open [file join $XVeg(VEGAS_HOME) "conncalc1.io"] w]
    puts $fileId [format "%s"  [file nativename $simname]]
    puts $fileId [format "%s"  [file nativename $fname2]]
    close $fileId
    set fileId [open [file join $XVeg(VEGAS_HOME) "conncalc.io"] w]
    puts $fileId [format "       parameter "]
    puts $fileId [format "     1 (input_name='%s'," [file nativename $simname]]
    puts $fileId [format "     1  output_name='%s')" [file nativename $fname2]]
    close $fileId
    
    } 
     
    Window show .sincout
    .sincout.runit configure -text "Start Simulation"

    } 
}
}

proc {runsimulation} {} {
global natoms lower upper ngx ngy ngz ngm xrep yrep step mode
global shad block beamerr
global XVeg


if {$natoms == 0 || $shad == 0 || $block == 0 || $xrep == 0 || $yrep == 0 } {
.main.tex18 configure -state normal
.main.tex18 delete 1.0 2.0 
.main.tex18 insert insert "Input not complete"
.main.tex18 configure -state disabled
} else {
# prompt for file name
set types {
    {{Input Files}       {.in }        }
    {{All Files}         {.*  }        }
}

set simname [tk_getSaveFile -filetypes $types]

if { $simname != "" } {
set simname [file rootname $simname]
append simname ".in"


set fileId [open $simname w]
savesim $fileId
.main.tex18 configure -state normal
.main.tex18 delete 1.0 2.0 
.main.tex18 insert insert "Simulation stored ok"
.main.tex18 configure -state disabled

set nan [expr [expr $upper-$lower]/$step]
set nan [expr int($nan)]
set nx1 [expr $ngx +1]
set ny1 [expr $ngy +1]
set nz1 [expr $ngz +1]
set fileId [open [file join $XVeg(VEGAS_HOME) "sincalc.dim"] w]
puts $fileId [format "        parameter"]
puts $fileId [format "     1 (nat = %d,nel=%d,ngx=%d,"   $natoms $ngm $ngx]
puts $fileId [format "     1  ngy=%d,ngz=%d,nx1=%d,"     $ngy $ngz $nx1]
puts $fileId [format "     1  ny1=%d,nz1=%d,nan=%d)"     $ny1 $nz1 $nan]
close $fileId

set fname2 [format "%s" [file rootname $simname]]
append fname2 ".out"

if {$mode(6)== 0 } {
set fileId [open [file join $XVeg(VEGAS_HOME) "sincalc1.io"] w]
puts $fileId [format "%s" [file nativename $simname]]
puts $fileId [format "%s" [file nativename $fname2]]
close $fileId
set fileId [open [file join $XVeg(VEGAS_HOME) "sincalc.io"] w]
puts $fileId [format "       parameter "]
puts $fileId [format "     1 (input_name='%s'," [file nativename $simname]]
puts $fileId [format "     1  output_name='%s')" [file nativename $fname2]]
close $fileId
} else {
set fileId [open [file join $XVeg(VEGAS_HOME) "conncalc.dim"] w]
    puts $fileId [format "        parameter"]
    puts $fileId [format "     1  (nat = %d,nel=%d,ngx=%d,"   $natoms $ngm $ngx]
    puts $fileId [format "     1   ngy=%d,ngz=%d,nx1=%d,"     $ngy $ngz $nx1]
    puts $fileId [format "     1   ny1=%d,nz1=%d,nan=%d)"     $ny1 $nz1 $nan]
    close $fileId
    set fileId [open [file join $XVeg(VEGAS_HOME) "conncalc1.io"] w]
    puts $fileId [format "%s"  [file nativename $simname]]
    puts $fileId [format "%s"  [file nativename $fname2]]
    close $fileId
    set fileId [open [file join $XVeg(VEGAS_HOME) "conncalc.io"] w]
    puts $fileId [format "       parameter "]
    puts $fileId [format "     1 (input_name='%s'," [file nativename $simname]]
    puts $fileId [format "     1  output_name='%s')" [file nativename $fname2]]
    close $fileId
}
Window show .sincout
.sincout.runit configure -text "Start Simulation"





}

}
}

proc {savecrys} {} {
global x y z sigx sigy sigz typ natoms xrep yrep
set types {
    {{Crystal Files}       {.crs}     }
    {{All Files}       {.*}     }
}

# accept crystal values
foreach value {.crys.xper .crys.yper } {
if { [ scan [$value get] "%f" temp ] < 0 } {
.crys.tex21 configure -state normal
.crys.tex21 delete 1.0 2.0 
.crys.tex21 insert insert "A box is empty or invalid value"
.crys.tex21 configure -state disabled
return 1
}
}

set filename [tk_getSaveFile -filetypes $types]
if { [file tail $filename] != ".crs" } {
append filename ".crs"
}

if {$filename != ""} {
    # Save the crystal file ...
    set fileId [open $filename w] 	
    puts $fileId [format %3d $natoms]
    for {set i 0} {$i < $natoms} {incr i 1} {
    puts $fileId [format "%6.3f %6.3f %6.3f %s" $x($i) $y($i) $z($i) $typ($i)]
    }	
    scan [.crys.xper get] "%f" xrep
    scan [.crys.yper get] "%f" yrep
    puts $fileId [format "%6.3f %6.3f" $xrep $yrep]
    for {set i 0} {$i < $natoms} {incr i 1} {
        puts $fileId [format "%6.3f %6.3f %6.3f" $sigx($i) $sigy($i) $sigz($i)]
    }	
    close $fileId
   .crys.tex21 configure -state normal
   .crys.tex21 delete 1.0 2.0
   .crys.tex21 insert insert "Crystal Saved"
   .crys.tex21 configure -state disabled

}
}

proc {saveplot} {} {
global x y z typ natoms xrep yrep
set types {
    {{All Files}       {.*}     }
}

# accept crystal values
set err 0
foreach value {.crys.xper .crys.yper } {
if { [ scan [$value get] "%f" temp ] < 0 } {
.crys.tex21 configure -state normal
.crys.tex21 delete 1.0 2.0 
.crys.tex21 insert insert "A box is empty or invalid value"
.crys.tex21 configure -state disabled
set err 1
break
}
}
if {$err < 1} {
    set filename [tk_getSaveFile -filetypes $types]
    if {$filename != ""} {
            set simname [file rootname $filename]
            append simname ".plt"
            set fileId [open $simname w]
            saveplot3d $fileId    
    }
}
}

proc {saveplot3d} {fileId} {
global x y z typ natoms xrep yrep 
global ngm km zt
groupmass

# File title
set test "plot3d input file"
puts $fileId [format "%s" $test]
set zmax $z([expr $natoms -1])
puts $fileId [format "%5d%15.9f%15.9f%15.9f" $natoms $xrep $yrep $zmax]
for {set i 0} {$i < $natoms} {incr i 1} {
    set zno $zt($km($i))
    set zer 0.0
    puts $fileId [format "%15.9f%15.9f%15.9f%15.9f%4d" $x($i) $y($i) $z($i) 1.0 $zno]
}
puts $fileId [format "%12.5f%12.5f%12.5f%12.5f%12.5f%12.5f" 0.0 0.0 0.0 1.0 3.0 0.0]
puts $fileId [format "%5d%5d%5d%5d%5d"  6 2 1 0 0 0 0 0]
close $fileId
}

proc {savesim} {fileId} {
global x y z sigx sigy sigz typ natoms xrep yrep 
global vx vy vz kx ky kz ngx ngy ngz ngm km conntrack pottype
global lower upper step factor shad block ioneng zt zmass
global azi ionm zi polar
global mode idim

groupmass 
for {set i 0} { $i < 19 } {incr i 1} {
 set idum($i) 0
}
set  mode(0) 1
set  mode(6) $conntrack
set mode(2) $pottype
set idum(0) $natoms
set idum(1) $ngm
set idum(2) $ngx
set idum(3) $ngy
set idum(4) $ngz
set idum(5) [expr $ngx + 1]
set idum(6) [expr $ngy + 1]
set idum(7) [expr $ngz + 1]
set idum(8) [expr int([expr [expr [expr $upper - $lower] / $step]])]


    # Open the file ...
#         set fileId [open $filename w] 	
# # File title
        set test "Sincalc [clock format [clock seconds] -format "%a %b %d %H%M %Y"]"
        puts $fileId [format "%s" $test]
        puts $fileId  [format "%8d %8d" "0" "0"]
# Mode 1-8     
        for {set i 0} { $i < 8 } {incr i 1} {
        puts -nonewline $fileId [format "%2d" $mode($i)]
        }
        
        puts $fileId ""	
        for {set i 0} { $i < 19 } {incr i 1} {
        puts -nonewline $fileId [format "%4d" $idum($i)]
        }
        puts $fileId ""	
        for {set i 1} {$i <= $ngm} {incr i 1} {
            puts $fileId [format "%3d %8.3f" $zt($i) $zmass($i)]
        }
#        puts $fileId ""	        
        puts $fileId [format "%3d %8.3f" 0 0.0]
        puts $fileId [format "%8.3f %8.3f" 0.0 0.0] 
# x y z sigx sigy sigz atom type    
        for {set i 0} {$i < $natoms} {incr i 1} {
            puts $fileId [format "%8.3f %8.3f %8.3f %3d %3d %3d %8.3f %8.3f %8.3f %s" $x($i) $y($i) $z($i) $kx($i) $ky($i) $kz($i) $sigx($i) $sigy($i) $sigz($i) $km($i)]
            }	
        puts $fileId [format "%8.3f %8.3f" $xrep $yrep]
        
        set neights [expr int([expr [expr $ngx-1]/8])]
        for {set j 0} {$j <= $neights} {incr j 1} {
        if {$j > 0} {
        set lowlim [expr $j*8]
        set uplim [expr [expr $j*8]+8]
        } else {
        set lowlim 0
        set uplim 8
        } 
        if {$uplim > $ngx} {
        set uplim $ngx
        }
        for {set i $lowlim} {$i < $uplim} {incr i 1} {
            puts -nonewline $fileId [format "%8.3f" $vx($i)]
        }
        puts $fileId ""	
             	
        }	
        	
        set neights [expr int([expr [expr $ngy-1]/8])]        
        for {set j 0} {$j <= $neights} {incr j 1} {
        if {$j > 0} {
        set lowlim [expr $j*8]
        set uplim [expr [expr $j*8]+8]
        } else {
        set lowlim 0
        set uplim 8
        } 
        if {$uplim > $ngy} {
        set uplim $ngy
        }
        

        for {set i $lowlim} {$i < $uplim} {incr i 1} {
            puts -nonewline $fileId [format "%8.3f" $vy($i)]
        }
        	
        puts $fileId ""	
        }
        
        
        
        set neights [expr int([expr [expr $ngz-1]/8])]
        for {set j 0} {$j <= $neights} {incr j 1} {
        if {$j > 0} {
        set lowlim [expr $j*8]
        set uplim [expr [expr $j*8]+8]
        } else {
        set lowlim 0
        set uplim 8
        } 
        if {$uplim > $ngz} {
        set uplim $ngz
        }
        
        
        for {set i $lowlim} {$i < $uplim} {incr i 1} {
            puts -nonewline $fileId [format "%8.3f" $vz($i)]
        }	
        	
        puts $fileId ""	
        }
        
        
        
        
        puts $fileId [format "%8.3f %8.3f %8.3f %8.3f %8.3f" $azi $polar $lower $step $factor]
        puts $fileId [format "%3d %8.3f %8.3f %8.3f %8.3f" $zi $ionm $ioneng $shad $block]
                   
                           
        close $fileId
}

proc {showgrow} {} {
global natoms
if {$natoms > 1} {
Window show .vibdisp
} else {
.crys.tex21 configure -state normal -background red
.crys.tex21 delete 1.0 2.0
.crys.tex21 insert insert "No atoms to grow"
.crys.tex21 configure -state disabled
}
}

proc {sortbyz} {} {
global x y z natoms sigx sigy sigz typ 
#
# sorts x y z by z positions
# simple bubble sort
#
#


for {set k 1} { $k <= [expr $natoms-1]  } {incr k 1} {
for {set j 0} { $j < [expr $natoms-$k]  } {incr j 1} {

if {$z($j) > $z([expr $j+1]) } {
# z
set temp $z($j)
set z($j) $z([expr $j+1])
set z([expr $j+1]) $temp

# x
set temp $x($j)
set x($j) $x([expr $j+1])
set x([expr $j+1]) $temp

#y
set temp $y($j)
set y($j) $y([expr $j+1])
set y([expr $j+1]) $temp


#sigz
set temp $sigz($j)
set sigz($j) $sigz([expr $j+1])
set sigz([expr $j+1]) $temp

#sigy
set temp $sigy($j)
set sigy($j) $sigy([expr $j+1])
set sigy([expr $j+1]) $temp


#sigx
set temp $sigx($j)
set sigx($j) $sigx([expr $j+1])
set sigx([expr $j+1]) $temp

#typ
set temp $typ($j)
set typ($j) $typ([expr $j+1])
set typ([expr $j+1]) $temp

} 
#end of for
}
# end of while
}
}

proc {storesim} {} {
global natoms xrep yrep beamerr
global shad block


if {$natoms == 0 || $shad == 0 || $block == 0 || $xrep == 0 || $yrep == 0} {
.main.tex18 configure -state normal
.main.tex18 delete 1.0 2.0 
.main.tex18 insert insert "Input not complete"
.main.tex18 configure -state disabled
return 1
} else {
# prompt for file name
set types {
    {{Input Files}       {.in }        }
    {{All Files}         {.*  }        }
}
set filename [tk_getSaveFile -filetypes $types]
if { $filename != "" } {
set filename [file rootname $filename]
append filename ".in"


set fileId [open $filename w]
savesim $fileId
.main.tex18 configure -state normal
.main.tex18 delete 1.0 2.0 
.main.tex18 insert insert "Simulation stored ok"
.main.tex18 configure -state disabled

}

}
}

proc {vddeselall} {} {
global natoms
.dispvib.cpd20.01 selection clear 0 [expr $natoms-1]
}

proc {vdselall} {} {
global natoms
.dispvib.cpd20.01 selection set 0 [expr $natoms-1]
}

proc {vibdisp} {opt} {
global x y z sigx sigy sigz natoms

.dispvib.cpd20.01 delete 0 end
.dispvib.cpd21.01 delete 0 endv
}

proc {writeerr} {data} {
.sincout.runit  configure -text "Start Simulation"
}

proc {writeit} {data} {
catch {.sincout.cpd24.03 insert end "$data\n"}
catch {.sincout.cpd24.03 yview scroll 1 units}
.sincout.runit  configure -text "Stop Simulation"
}

proc {xyzinfok} {} {
global x y z sigx sigy sigz typ atopt sel natoms
set err 0
foreach value {.xyzinf.cpd18.02 .xyzinf.cpd24.02 .xyzinf.cpd19.02 .xyzinf.cpd20.02 .xyzinf.cpd22.02 .xyzinf.cpd23.02 } {
if { [scan [$value get] "%f" temp] < 1  } {
.xyzinf.tex19 configure -state normal
.xyzinf.tex19 delete 1.0 2.0 
.xyzinf.tex19 insert insert "A box is empty or invalid value"
.xyzinf.tex19 configure -state disabled
set err 1
break
}
}
if {[scan .xyzinf.cpd17.02 "%s" temp] < 1 } {
set err 1
.xyzinf.tex19 configure -state normal
.xyzinf.tex19 delete 1.0 2.0 
.xyzinf.tex19 insert insert "A box is empty or invalid value"
.xyzinf.tex19 configure -state disabled

}



if { $err < 1 } {
# check whether they're good values
if {$atopt==0} {
   set natoms [expr $natoms+1]
   set at [expr $natoms-1]
   scan [.xyzinf.cpd18.02 get] "%f" x($at)
   scan [.xyzinf.cpd24.02 get] "%f" y($at)
   scan [.xyzinf.cpd19.02 get] "%f" z($at)
   scan [.xyzinf.cpd20.02 get] "%f" sigx($at)
   scan [.xyzinf.cpd22.02 get] "%f" sigy($at)
   scan [.xyzinf.cpd23.02 get] "%f" sigz($at)
   scan [.xyzinf.cpd17.02 get] "%s" typ($at)
   sortbyz
#   groupcrys
   recrys
}  else {
   scan [.xyzinf.cpd18.02 get] "%f" x($sel)
   scan [.xyzinf.cpd24.02 get] "%f" y($sel)
   scan [.xyzinf.cpd19.02 get] "%f" z($sel)
   scan [.xyzinf.cpd20.02 get] "%f" sigx($sel)
   scan [.xyzinf.cpd22.02 get] "%f" sigy($sel)
   scan [.xyzinf.cpd23.02 get] "%f" sigz($sel)
   scan [.xyzinf.cpd17.02 get] "%s" typ($sel)   
   sortbyz
#   groupcrys
   recrys
}

.xyzinf.tex19 configure -state normal
.xyzinf.tex19 delete 1.0 2.0 
.xyzinf.tex19 insert insert "Values accepted"
.xyzinf.tex19 configure -state disabled
}
}

proc {ztoatom} {zno} {
# convert z no t ostring atom
set atom ""
if {$zno == 1} { 
set atom "H"
}
if {$zno == 2} { 
set atom "HE"
}
if {$zno == 3} { 
set atom "LI"
}
if {$zno == 4} { 
set atom "BE"
}
if {$zno == 5} { 
set atom "B"
}
if {$zno == 6} { 
set atom "C"
}
if {$zno == 7} { 
set atom "C"
}
if {$zno == 8} { 
set atom "O"
}
if {$zno == 9} { 
set atom  "F"
}
if {$zno == 10} { 
set atom "NE"
}
if {$zno == 11} { 
set atom "NA"
}
if {$zno == 12} { 
set atom  "MG"
}
if {$zno == 13} { 
set atom "AL"
}
if {$zno == 14} { 
set atom "SI"
}
if {$zno == 15} { 
set atom "SI"
}
if {$zno == 16} { 
set atom  "S"
}
if {$zno == 17} { 
set atom "CL"
}
if {$zno == 18} { 
set atom "AR"
}
if {$zno == 19} { 
set atom "K"
}
if {$zno == 20} { 
set atom "CA"
}
if {$zno == 21} { 
set atom  "SC"
}
if {$zno == 22} { 
set atom "TI"
}
if {$zno == 23} { 
set atom "V"
}
if {$zno == 24} { 
set atom  "CR"
}
if {$zno == 25} { 
set atom "MN"
}
if {$zno == 26} { 
set atom "FE"
}
if {$zno == 27} { 
set atom "CO"
}
if {$zno == 28} { 
set atom "NI"
}
if {$zno == 29} { 
set atom "CU"
}
if {$zno == 30} { 
set atom "ZN"
}
if {$zno == 31} { 
set atom "GA"
}
if {$zno == 32} { 
set atom "GE"
}
if {$zno == 33} { 
set atom "AS"
}
if {$zno == 34} { 
set atom "SE"
}
if {$zno == 35} { 
set atom "BR"
}
if {$zno == 36} { 
set atom "KR"
}
if {$zno == 37} { 
set atom "RB"
}
if {$zno == 38} { 
set atom "SR"
}
if {$zno == 39} { 
set atom "Y"
}
if {$zno == 40} { 
set atom "ZR"
}
if {$zno == 41} { 
set atom "NB"
}
if {$zno == 42} { 
set atom "MO"
}
if {$zno == 43} { 
set atom "TC"
}
if {$zno == 44} { 
set atom "RU"
}
if {$zno == 45} { 
set atom "RH"
}
if {$zno == 46} { 
set atom "PD"
}
if {$zno == 47} { 
set atom "AG"
}
if {$zno == 48} { 
set atom "CD"
}
if {$zno == 49} { 
set atom "IN"
}
if {$zno == 50} { 
set atom "SN"
}
if {$zno == 51} { 
set atom "SB"
}
if {$zno == 52} { 
set atom "TE"
}
if {$zno == 53} { 
set atom "I"
}
if {$zno == 54} { 
set atom "XE"
}
if {$zno == 55} { 
set atom "CS"
}
if {$zno == 56} { 
set atom "BA"
}
if {$zno == 57} { 
set atom "LA"
}
if {$zno == 58} { 
set atom "CE"
}
if {$zno == 60} { 
set atom "ND"
}
if {$zno == 61} { 
set atom "PM"
}
if {$zno == 62} { 
set atom "SM"
}
if {$zno == 63} { 
set atom "EU"
}
if {$zno == 64} { 
set atom "GD"
}
if {$zno == 65} { 
set atom "TB"
}
if {$zno == 66} { 
set atom "DY"
}
if {$zno == 67} { 
set atom "HO"
}
if {$zno == 68} { 
set atom "ER"
}
if {$zno == 69} { 
set atom "TM"
}
if {$zno == 70} { 
set atom "YB"
}
if {$zno == 71} { 
set atom "LU"
}
if {$zno == 72} { 
set atom "HF"
}
if {$zno == 73} { 
set atom "TA"
}
if {$zno == 74} { 
set atom "W"
}
if {$zno == 75} { 
set atom  "RE"
}
if {$zno == 76} { 
set atom "OS"
}
if {$zno == 77} { 
set atom "IR"
}
if {$zno == 78} { 
set atom "PT"
}
if {$zno == 79} { 
set atom "AU"
}
if {$zno == 80} { 
set atom "HG"
}
if {$zno == 81} { 
set $atom "TI"
}
if {$zno == 82} { 
set atom "PB"
}
if {$zno == 83} { 
set atom "BI"
}
if {$zno == 84} { 
set atom "PO"
}
if {$zno == 85} { 
set atom "AT"
}
if {$zno == 86} { 
set atom "RN"
}
if {$zno == 87} { 
set atom "FR"
}
if {$zno == 88} { 
set atom "RA"
}
if {$zno == 89} { 
set atom "AC"
}
if {$zno == 90} { 
set atom "TH"
}
if {$zno == 91} { 
set atom "PA"
}
if {$zno == 92} { 
set atom "U"
} 
return $atom
}

proc {ztomass} {zno} {
set zmass(0) 0.000 
set zmass(1) 1.008 
set zmass(2) 4.003
set zmass(3) 6.940
set zmass(4) 9.012
set zmass(5) 10.810
set zmass(6) 12.011
set zmass(7) 14.007
set zmass(8) 15.999
set zmass(9) 18.998
set zmass(10) 20.179
set zmass(11) 22.990
set zmass(12) 24.305
set zmass(13) 26.982
set zmass(14) 28.086
set zmass(15) 30.974
set zmass(16) 32.060
set zmass(17) 35.453
set zmass(18) 39.948
set zmass(19) 39.098
set zmass(20) 40.080
set zmass(21) 44.956
set zmass(22) 47.900
set zmass(23) 50.941
set zmass(24) 51.996
set zmass(25) 54.938
set zmass(26) 55.847
set zmass(27) 58.933
set zmass(28) 58.710
set zmass(29) 63.546
set zmass(30) 65.380
set zmass(31) 69.720
set zmass(32) 72.590
set zmass(33) 74.922
set zmass(34) 78.960
set zmass(35) 79.904
set zmass(36) 83.800
set zmass(37) 85.467
set zmass(38) 87.620
set zmass(39) 88.906
set zmass(40) 91.220
set zmass(41) 92.906
set zmass(42) 95.940
set zmass(43) 98.906
set zmass(44) 101.070
set zmass(45) 102.906
set zmass(46) 106.400
set zmass(47) 107.868
set zmass(48) 112.410
set zmass(49) 114.820
set zmass(50) 118.690
set zmass(51) 121.750
set zmass(52) 127.600
set zmass(53) 126.905
set zmass(54) 131.300
set zmass(55) 132.905
set zmass(56) 137.330
set zmass(57) 138.906
set zmass(58) 140.120
set zmass(60) 144.240
set zmass(61) 145.000
set zmass(62) 150.400
set zmass(63) 151.960
set zmass(64) 157.250
set zmass(65) 158.925
set zmass(66) 162.500
set zmass(67) 164.930
set zmass(68) 167.260
set zmass(69) 168.934
set zmass(70) 173.040
set zmass(71) 174.970
set zmass(72) 178.490
set zmass(73) 180.947
set zmass(74) 183.850
set zmass(75) 186.200
set zmass(76) 190.200
set zmass(77) 192.220
set zmass(78) 195.090
set zmass(79) 196.967
set zmass(80) 200.590
set zmass(81) 204.370
set zmass(82) 207.200
set zmass(83) 208.981
set zmass(84) 209.000
set zmass(85) 210.000
set zmass(86) 222.000
set zmass(87) 223.000
set zmass(88) 226.025
set zmass(89) 227.000
set zmass(90) 232.038
set zmass(91) 231.038
set zmass(92) 238.029

return $zmass($zno)
}

proc {main} {argc argv} {

}

proc {Window} {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 1x1+0+0
    wm maxsize $base 785 570
    wm minsize $base 114 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm withdraw $base
    wm title $base "vt.tcl"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.beam {base} {
    if {$base == ""} {
        set base .beam
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel  -background #C200BB00A700 -menu .beam.m17 
    wm focusmodel $base passive
    wm geometry $base 427x289+677+128
    wm maxsize $base 785 270
    wm minsize $base 112 2
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "Beam Parameters"
    button $base.beamok  -background #C200BB00A700 -command beamok  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text Accept 
    button $base.beamcanc  -background #C200BB00A700 -command {Window hide .beam}  -font -*-times-medium-r-normal-*-*-*-*-*-*-**-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text Close 
    entry $base.iontype  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    entry $base.fluxs  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    label $base.i01  -background #C200BB00A700 -borderwidth 1  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -text {Ion type} 
    label $base.i02  -background #C200BB00A700 -borderwidth 1  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -text {Shadowing Flux} 
    entry $base.fluxb  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    label $base.i03  -background #C200BB00A700 -borderwidth 1  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -text {Blocking Flux} 
    entry $base.lowang  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    label $base.i04  -background #C200BB00A700 -borderwidth 1  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -text {Lower Angle} 
    entry $base.upang  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -textvariable upper 
    label $base.i05  -background #C200BB00A700 -borderwidth 1  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -text {Upper Angle} 
    entry $base.angstep  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    label $base.i06  -background #C200BB00A700 -borderwidth 1  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -text {Step Size} 
    entry $base.energy  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    label $base.i07  -background #C200BB00A700 -borderwidth 1  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -text Energy 
    entry $base.expatoms  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    label $base.i08  -background #C200BB00A700 -borderwidth 1  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -text Atoms/layer 
    entry $base.azimuth  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    label $base.azinote  -background #C200BB00A700 -borderwidth 1  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -text {Azimuthal Angle} 
    entry $base.polang  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    label $base.poltxt  -background #C200BB00A700 -borderwidth 1  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -text {Polar Angle} 
    menu $base.m17  -background #C200BB00A700 -cursor {}  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    text $base.tex18  -background white -cursor fleur  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief flat -state disabled 
    radiobutton $base.moliere  -background #C200BB00A700  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -text {Moliere or} -value 0  -variable pottype 
    radiobutton $base.biersack  -background #C200BB00A700  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -text {Biersack Potential} -value 1  -variable pottype 
    checkbutton $base.conntrack  -background #C200BB00A700  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -text {Connect Ingoing-Outgoing Tracks}  -variable conntrack 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.beamok  -x 315 -y 215 -width 93 -height 33 -anchor nw -bordermode ignore 
    place $base.beamcanc  -x 30 -y 215 -width 88 -height 33 -anchor nw -bordermode ignore 
    place $base.iontype  -x 115 -y 5 -width 90 -height 24 -anchor nw -bordermode ignore 
    place $base.fluxs  -x 115 -y 95 -width 90 -height 24 -anchor nw -bordermode ignore 
    place $base.i01  -x 50 -y 5 -width 58 -height 23 -anchor nw -bordermode ignore 
    place $base.i02  -x 10 -y 95 -width 97 -height 23 -anchor nw -bordermode ignore 
    place $base.fluxb  -x 320 -y 95 -width 90 -height 24 -anchor nw -bordermode ignore 
    place $base.i03  -x 220 -y 95 -width 96 -height 23 -anchor nw -bordermode ignore 
    place $base.lowang  -x 115 -y 35 -width 90 -height 24 -anchor nw -bordermode ignore 
    place $base.i04  -x 35 -y 35 -width 77 -height 23 -anchor nw -bordermode ignore 
    place $base.upang  -x 320 -y 35 -width 90 -height 24 -anchor nw -bordermode ignore 
    place $base.i05  -x 230 -y 35 -width 80 -height 23 -anchor nw -bordermode ignore 
    place $base.angstep  -x 115 -y 65 -width 90 -height 24 -anchor nw -bordermode ignore 
    place $base.i06  -x 45 -y 65 -width 66 -height 23 -anchor nw -bordermode ignore 
    place $base.energy  -x 115 -y 125 -width 90 -height 24 -anchor nw -bordermode ignore 
    place $base.i07  -x 65 -y 125 -width 46 -height 23 -anchor nw -bordermode ignore 
    place $base.expatoms  -x 320 -y 125 -width 90 -height 24 -anchor nw -bordermode ignore 
    place $base.i08  -x 230 -y 125 -width 86 -height 23 -anchor nw -bordermode ignore 
    place $base.azimuth  -x 320 -y 65 -width 90 -height 24 -anchor nw -bordermode ignore 
    place $base.azinote  -x 205 -y 65 -width 111 -height 23 -anchor nw -bordermode ignore 
    place $base.polang  -x 320 -y 5 -width 90 -height 24 -anchor nw -bordermode ignore 
    place $base.poltxt  -x 230 -y 5 -width 86 -height 23 -anchor nw -bordermode ignore 
    place $base.tex18  -x 0 -y 250 -width 426 -height 25 -anchor nw -bordermode ignore 
    place $base.moliere  -x 115 -y 185 -width 103 -height 21 -anchor nw -bordermode ignore 
    place $base.biersack  -x 220 -y 185 -width 153 -height 21 -anchor nw -bordermode ignore 
    place $base.conntrack  -x 115 -y 160 -width 255 -height 21 -anchor nw -bordermode ignore
}

proc vTclWindow.crys {base} {
    if {$base == ""} {
        set base .crys
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel  -background #C200BB00A700 -menu .crys.m17 
    wm focusmodel $base passive
    wm geometry $base 491x355+620+101
    wm maxsize $base 785 355
    wm minsize $base 112 2
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "Crystal Parameters"
    entry $base.xper  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -textvariable Hello 
    label $base.xtxt  -anchor e -background #C200BB00A700 -borderwidth 1  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief raised -text {X repeat distance} 
    button $base.opcrys  -background #C200BB00A700 -command readcrys  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text Open 
    label $base.xdists  -background #C200BB00A700 -borderwidth 1  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief ridge -text {X repeat distance} 
    label $base.ydist  -background #C200BB00A700 -borderwidth 1  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief ridge -text {Y repeat distance} 
    entry $base.yper  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    button $base.group  -background #C200BB00A700 -command groupcrys  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text Group 
    button $base.addatom  -background #C200BB00A700 -command addatom  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text {Add atom} 
    button $base.delatom  -background #C200BB00A700 -command delatom  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text {Delete Atom} 
    button $base.edatom  -background #C200BB00A700 -command editatom  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text {Edit Atom} 
    button $base.vibra  -background #C200BB00A700 -command altervibdisp  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text {Alter Some} 
    button $base.savecrys  -background #C200BB00A700 -command savecrys  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text Save 
    button $base.closecrys  -background #C200BB00A700 -command {Window hide .crys}  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text Close 
    button $base.okcrys  -background #C200BB00A700 -command crysok  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text Accept 
    button $base.growcrs  -background #C200BB00A700 -command showgrow  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text Grow 
    frame $base.cpd17  -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised  -width 30 
    listbox $base.cpd17.01  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -xscrollcommand {.crys.cpd17.02 set}  -yscrollcommand {.crys.cpd17.03 set} 
    scrollbar $base.cpd17.02  -background #C200BB00A700 -borderwidth 1  -command {.crys.cpd17.01 xview} -orient horiz 
    scrollbar $base.cpd17.03  -background #C200BB00A700 -borderwidth 1  -command {.crys.cpd17.01 yview} -orient vert -width 12 
    text $base.tex21  -background white -cursor fleur  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief flat -state disabled 
    button $base.refresh  -background #C200BB00A700 -command {sortbyz 
recrys}  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -text Refresh 
    menu $base.m17  -background #C200BB00A700 -cursor {}  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    button $base.plot3d  -background #C200BB00A700 -command saveplot  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -text Plot3D 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.xper  -x 155 -y 10 -width 85 -height 24 -anchor nw -bordermode ignore 
    place $base.xtxt  -x -436 -y -4 -width 566 -height 78 -anchor e -bordermode ignore 
    place $base.opcrys  -x 385 -y 255 -width 82 -height 33 -anchor nw -bordermode ignore 
    place $base.xdists  -x 30 -y 10 -width 126 -height 23 -anchor nw -bordermode ignore 
    place $base.ydist  -x 245 -y 10 -width 128 -height 23 -anchor nw -bordermode ignore 
    place $base.yper  -x 375 -y 10 -width 85 -height 24 -anchor nw -bordermode ignore 
    place $base.group  -x 385 -y 215 -width 79 -height 33 -anchor nw -bordermode ignore 
    place $base.addatom  -x 30 -y 215 -width 84 -height 33 -anchor nw -bordermode ignore 
    place $base.delatom  -x 120 -y 215 -width 84 -height 33 -anchor nw -bordermode ignore 
    place $base.edatom  -x 210 -y 215 -width 79 -height 33 -anchor nw -bordermode ignore 
    place $base.vibra  -x 295 -y 215 -width 84 -height 33 -anchor nw -bordermode ignore 
    place $base.savecrys  -x 295 -y 255 -width 84 -height 33 -anchor nw -bordermode ignore 
    place $base.closecrys  -x 30 -y 295 -width 83 -height 33 -anchor nw -bordermode ignore 
    place $base.okcrys  -x 385 -y 295 -width 84 -height 33 -anchor nw -bordermode ignore 
    place $base.growcrs  -x 30 -y 255 -width 84 -height 33 -anchor nw -bordermode ignore 
    place $base.cpd17  -x 30 -y 40 -width 430 -height 170 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd17 0 -weight 1
    grid rowconf $base.cpd17 0 -weight 1
    grid $base.cpd17.01  -in .crys.cpd17 -column 0 -row 0 -columnspan 1 -rowspan 1  -sticky nesw 
    grid $base.cpd17.02  -in .crys.cpd17 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd17.03  -in .crys.cpd17 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.tex21  -x 0 -y 330 -width 491 -height 25 -anchor nw -bordermode ignore 
    place $base.refresh  -x 120 -y 255 -width 85 -height 33 -anchor nw -bordermode ignore 
    place $base.plot3d  -x 210 -y 255 -width 80 -height 33 -anchor nw -bordermode ignore
}

proc vTclWindow.dispvib {base} {
    if {$base == ""} {
        set base .dispvib
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel  -background #C200BB00A700 
    wm focusmodel $base passive
    wm geometry $base 482x341+369+423
    wm maxsize $base 785 570
    wm minsize $base 112 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Vibrations/Diplacements"
    frame $base.cpd20  -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised  -width 30 
    listbox $base.cpd20.01  -background #C200BB00A700 -exportselection 0  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -selectmode multiple  -xscrollcommand {.dispvib.cpd20.02 set}  -yscrollcommand {.dispvib.cpd20.03 set} 
    scrollbar $base.cpd20.02  -background #C200BB00A700 -borderwidth 1  -command {.dispvib.cpd20.01 xview} -orient horiz 
    scrollbar $base.cpd20.03  -background #C200BB00A700 -borderwidth 1  -command {.dispvib.cpd20.01 yview} -orient vert 
    frame $base.cpd21  -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised  -width 30 
    listbox $base.cpd21.01  -background #C200BB00A700 -exportselection 0  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -xscrollcommand {.dispvib.cpd21.02 set}  -yscrollcommand {.dispvib.cpd21.03 set} 
    scrollbar $base.cpd21.02  -background #C200BB00A700 -borderwidth 1  -command {.dispvib.cpd21.01 xview} -orient horiz 
    scrollbar $base.cpd21.03  -background #C200BB00A700 -borderwidth 1  -command {.dispvib.cpd21.01 yview} -orient vert 
    frame $base.cpd22  -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised  -width 30 
    label $base.cpd22.01  -anchor w -background #C200BB00A700  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -relief groove -text X 
    entry $base.cpd22.02  -background #C200BB00A700 -cursor {}  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 
    frame $base.cpd23  -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised  -width 30 
    label $base.cpd23.01  -anchor w -background #C200BB00A700  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -relief groove -text Y 
    entry $base.cpd23.02  -background #C200BB00A700 -cursor {}  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 
    frame $base.cpd24  -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised  -width 30 
    label $base.cpd24.01  -anchor w -background #C200BB00A700  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -relief groove -text Z 
    entry $base.cpd24.02  -background #C200BB00A700 -cursor {}  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 
    button $base.addto  -background #C200BB00A700 -command addtolist  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -padx 9 -pady 3 -text -> 
    button $base.takefrom  -background #C200BB00A700  -command {catch { foreach i [.dispvib.cpd21.01 curselection] { 
.dispvib.cpd21.01 delete $i 
}
}}  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -padx 9 -pady 3 -text {< -} 
    radiobutton $base.vibopt  -background #C200BB00A700  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -text {XYZ Positions} -value 1 
    radiobutton $base.dispopt  -background #C200BB00A700  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -text {XYZ Vibrations} -value 2 
    button $base.ok  -background #C200BB00A700 -command altcrys  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -padx 9 -pady 3 -text Ok 
    text $base.tex22  -background #C200BB00A700  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -relief flat -state disabled 
    button $base.but18  -background #C200BB00A700 -command {Window hide .dispvib}  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -text Close 
    button $base.refresh  -background #C200BB00A700 -command redispvib  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -text Refresh 
    button $base.clear  -background #C200BB00A700 -command {.dispvib.cpd21.01 delete 0 end}  -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*}  -foreground #000000000000 -text {Clear List} 
    button $base.dispsellall  -background #C200BB00A700 -command vdselall  -font {{MS Sans Serif} 12} -foreground #000000000000  -text {Select All} 
    button $base.disdeselall  -background #C200BB00A700 -command vddeselall  -font {{MS Sans Serif} 12} -foreground #000000000000  -text {Deselect All} 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.cpd20  -x 15 -y 5 -width 345 -height 160 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd20 0 -weight 1
    grid rowconf $base.cpd20 0 -weight 1
    grid $base.cpd20.01  -in .dispvib.cpd20 -column 0 -row 0 -columnspan 1 -rowspan 1  -sticky nesw 
    grid $base.cpd20.02  -in .dispvib.cpd20 -column 0 -row 1 -columnspan 1 -rowspan 1  -sticky ew 
    grid $base.cpd20.03  -in .dispvib.cpd20 -column 1 -row 0 -columnspan 1 -rowspan 1  -sticky ns 
    place $base.cpd21  -x 400 -y 10 -width 75 -height 155 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd21 0 -weight 1
    grid rowconf $base.cpd21 0 -weight 1
    grid $base.cpd21.01  -in .dispvib.cpd21 -column 0 -row 0 -columnspan 1 -rowspan 1  -sticky nesw 
    grid $base.cpd21.02  -in .dispvib.cpd21 -column 0 -row 1 -columnspan 1 -rowspan 1  -sticky ew 
    grid $base.cpd21.03  -in .dispvib.cpd21 -column 1 -row 0 -columnspan 1 -rowspan 1  -sticky ns 
    place $base.cpd22  -x 20 -y 230 -width 115 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd22.01  -in .dispvib.cpd22 -anchor center -expand 0 -fill none -padx 2  -pady 2 -side left 
    pack $base.cpd22.02  -in .dispvib.cpd22 -anchor center -expand 1 -fill x -padx 2 -pady 2  -side right 
    place $base.cpd23  -x 165 -y 230 -width 115 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd23.01  -in .dispvib.cpd23 -anchor center -expand 0 -fill none -padx 2  -pady 2 -side left 
    pack $base.cpd23.02  -in .dispvib.cpd23 -anchor center -expand 1 -fill x -padx 2 -pady 2  -side right 
    place $base.cpd24  -x 325 -y 230 -width 115 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd24.01  -in .dispvib.cpd24 -anchor center -expand 0 -fill none -padx 2  -pady 2 -side left 
    pack $base.cpd24.02  -in .dispvib.cpd24 -anchor center -expand 1 -fill x -padx 2 -pady 2  -side right 
    place $base.addto  -x 365 -y 35 -width 29 -height 33 -anchor nw -bordermode ignore 
    place $base.takefrom  -x 365 -y 95 -width 29 -height 33 -anchor nw -bordermode ignore 
    place $base.vibopt  -x 15 -y 200 -anchor nw -bordermode ignore 
    place $base.dispopt  -x 160 -y 200 -anchor nw -bordermode ignore 
    place $base.ok  -x 340 -y 275 -width 99 -height 38 -anchor nw -bordermode ignore 
    place $base.tex22  -x 0 -y 315 -width 481 -height 25 -anchor nw -bordermode ignore 
    place $base.but18  -x 20 -y 275 -width 101 -height 36 -anchor nw -bordermode ignore 
    place $base.refresh  -x 15 -y 165 -width 110 -height 23 -anchor nw -bordermode ignore 
    place $base.clear  -x 400 -y 165 -width 75 -height 23 -anchor nw -bordermode ignore 
    place $base.dispsellall  -x 125 -y 165 -width 110 -height 23 -anchor nw -bordermode ignore 
    place $base.disdeselall  -x 235 -y 165 -width 105 -height 23 -anchor nw -bordermode ignore
}

proc vTclWindow.main {base} {
    if {$base == ""} {
        set base .main
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #C200BB00A700 -cursor xterm 
    wm focusmodel $base passive
    wm geometry $base 151x235+715+166
    wm maxsize $base 785 570
    wm minsize $base 112 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm deiconify $base
    wm title $base "XVegas"
    menubutton $base.rmenu \
        -background #C200BB00A700 \
        -font -*-times-medium-r-normal-*-*-*-*-*-*-* \
        -foreground #000000000000 -indicatoron 1 -menu .main.rmenu.m -padx 4 \
        -pady 3 -relief raised -text Run 
    menu $base.rmenu.m \
        -background #C200BB00A700 -cursor {} \
        -font -*-times-medium-r-normal-*-*-*-*-*-*-* \
        -foreground #000000000000 -tearoff 0 
    $base.rmenu.m add command \
        -command runfromfile -label {Run from File} 
    $base.rmenu.m add command \
        -command runsimulation -label {Run Simulation} 
    menubutton $base.smenu \
        -background #C200BB00A700 \
        -font -*-times-medium-r-normal-*-*-*-*-*-*-* \
        -foreground #000000000000 -indicatoron 1 -menu .main.smenu.m -padx 4 \
        -pady 3 -relief raised -text Simulation 
    menu $base.smenu.m \
        -background #C200BB00A700 -cursor {} \
        -font -*-times-medium-r-normal-*-*-*-*-*-*-* \
        -foreground #000000000000 -tearoff 0 
    $base.smenu.m add command \
        -command newsim -label {New Simulation} 
    $base.smenu.m add command \
        -command readsim -label {Open Simulation} 
    $base.smenu.m add command \
        -command storesim -label {Store Simulation} 
    menubutton $base.basemenu \
        -background #C200BB00A700 \
        -font -*-times-medium-r-normal-*-*-*-*-*-*-* \
        -foreground #000000000000 -indicatoron 1 -menu .main.basemenu.m \
        -padx 4 -pady 3 -relief raised -text Basis 
    menu $base.basemenu.m \
        -background #C200BB00A700 -cursor {} \
        -font -*-times-medium-r-normal-*-*-*-*-*-*-* \
        -foreground #000000000000 -tearoff 0 
    $base.basemenu.m add command \
        -command {Window show .crys} -label {Crystal Menu} 
    $base.basemenu.m add command \
        -command {Window show .beam} -label {Beam Menu} 
    menubutton $base.exmenu \
        -background #C200BB00A700 \
        -font -*-times-medium-r-normal-*-*-*-*-*-*-* \
        -foreground #000000000000 -indicatoron 1 -menu .main.exmenu.m -padx 4 \
        -pady 3 -relief raised -text Exit 
    menu $base.exmenu.m \
        -background #C200BB00A700 -cursor {} \
        -font -*-times-medium-r-normal-*-*-*-*-*-*-* \
        -foreground #000000000000 -tearoff 0 
    $base.exmenu.m add command \
        \
        -command {set answer [tk_messageBox -message "Really quit?" -type yesno -icon question -title "Exiting XVegas"]
case $answer {
    yes exit
    }} \
        -label {Exit XVegas} 
    text $base.tex18 \
        -background #C200BB00A700 \
        -font -*-times-medium-r-normal-*-*-*-*-*-*-* \
        -foreground #000000000000 -relief flat -state disabled 
    menubutton $base.about \
        -background #C200BB00A700 \
        -font -*-times-medium-r-normal-*-*-*-*-*-*-* \
        -foreground #000000000000 -indicatoron 1 -menu .main.about.m -padx 5 \
        -pady 4 -relief raised -text About 
    menu $base.about.m \
        -background #C200BB00A700 -cursor {} \
        -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*} \
        -foreground #000000000000 -tearoff 0 
    $base.about.m add command \
        -command aboutit -label {About Sincalc} 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.rmenu \
        -x 5 -y 45 -width 139 -height 34 -anchor nw -bordermode ignore 
    place $base.smenu \
        -x 5 -y 5 -width 140 -height 34 -anchor nw -bordermode ignore 
    place $base.basemenu \
        -x 5 -y 85 -width 140 -height 34 -anchor nw -bordermode ignore 
    place $base.exmenu \
        -x 5 -y 165 -width 141 -height 34 -anchor nw -bordermode ignore 
    place $base.tex18 \
        -x 0 -y 205 -width 151 -height 28 -anchor nw -bordermode ignore 
    place $base.about \
        -x 5 -y 125 -width 140 -height 35 -anchor nw -bordermode ignore 
}

proc vTclWindow.sincout {base} {
    if {$base == ""} {
        set base .sincout
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #C200BB00A700 
    wm focusmodel $base passive
    wm geometry $base 381x262+18+135
    wm maxsize $base 804 585
    wm minsize $base 106 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Run Simulation"
    frame $base.cpd24 \
        -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised \
        -width 30 
    scrollbar $base.cpd24.01 \
        -background #C200BB00A700 -borderwidth 1 \
        -command {.sincout.cpd24.03 xview} -orient horiz 
    scrollbar $base.cpd24.02 \
        -background #C200BB00A700 -borderwidth 1 \
        -command {.sincout.cpd24.03 yview} -orient vert 
    text $base.cpd24.03 \
        -background #C200BB00A700 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -foreground #000000000000 -height 1 -width 8 \
        -xscrollcommand {.sincout.cpd24.01 set} \
        -yscrollcommand {.sincout.cpd24.02 set} 
    button $base.runit \
        -background #C200BB00A700 -command compileit \
        -font {-dt-interface user-medium-r-normal-s*-*-*-*-*-*-*-*-*} \
        -foreground #000000000000 -text {Stop Simulation} 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.cpd24 \
        -x 10 -y 5 -width 363 -height 201 -anchor nw 
    grid columnconf $base.cpd24 0 -weight 1
    grid rowconf $base.cpd24 0 -weight 1
    grid $base.cpd24.01 \
        -in .sincout.cpd24 -column 0 -row 1 -columnspan 1 -rowspan 1 \
        -sticky ew 
    grid $base.cpd24.02 \
        -in .sincout.cpd24 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -sticky ns 
    grid $base.cpd24.03 \
        -in .sincout.cpd24 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    place $base.runit \
        -x 10 -y 210 -width 365 -height 48 -anchor nw -bordermode ignore 
}

proc vTclWindow.vibdisp {base} {
    if {$base == ""} {
        set base .vibdisp
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel  -background #C200BB00A700 -cursor xterm 
    wm focusmodel $base passive
    wm geometry $base 240x190+312+207
    wm maxsize $base 785 570
    wm minsize $base 112 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Grow Crystal"
    frame $base.cpd17  -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised  -width 30 
    label $base.cpd17.01  -anchor w -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief groove -text {No of Repititions} 
    entry $base.cpd17.02  -background #C200BB00A700 -cursor {}  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    frame $base.cpd18  -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised  -width 30 
    label $base.cpd18.01  -anchor w -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief groove -text {Repeat distance} 
    entry $base.cpd18.02  -background #C200BB00A700 -cursor {}  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -width 92 
    button $base.growcanc  -background #C200BB00A700 -command {Window hide .vibdisp}  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text Close 
    button $base.growit  -background #C200BB00A700 -command growcrys  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text Ok 
    radiobutton $base.xaxes  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -text X -value 1 
    radiobutton $base.yaxes  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -text Y -value 2 
    radiobutton $base.zaxes  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -text Z -value 3 
    text $base.tex17  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief flat -state disabled 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.cpd17  -x 30 -y 10 -width 185 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd17.01  -in .vibdisp.cpd17 -anchor center -expand 0 -fill none -padx 2  -pady 2 -side left 
    pack $base.cpd17.02  -in .vibdisp.cpd17 -anchor center -expand 1 -fill x -padx 2 -pady 2  -side right 
    place $base.cpd18  -x 30 -y 55 -width 185 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd18.01  -in .vibdisp.cpd18 -anchor center -expand 0 -fill none -padx 2  -pady 2 -side left 
    pack $base.cpd18.02  -in .vibdisp.cpd18 -anchor center -expand 1 -fill x -padx 2 -pady 2  -side right 
    place $base.growcanc  -x 30 -y 130 -width 66 -height 33 -anchor nw -bordermode ignore 
    place $base.growit  -x 160 -y 130 -width 64 -height 33 -anchor nw -bordermode ignore 
    place $base.xaxes  -x 25 -y 95 -anchor nw -bordermode ignore 
    place $base.yaxes  -x 105 -y 95 -anchor nw -bordermode ignore 
    place $base.zaxes  -x 170 -y 95 -anchor nw -bordermode ignore 
    place $base.tex17  -x 5 -y 165 -width 231 -height 23 -anchor nw -bordermode ignore
}

proc vTclWindow.xyzinf {base} {
    if {$base == ""} {
        set base .xyzinf
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel  -background #C200BB00A700 -cursor fleur 
    wm focusmodel $base passive
    wm geometry $base 374x218+402+528
    wm maxsize $base 785 570
    wm minsize $base 112 2
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "XYZinformation"
    button $base.xyzok  -background #C200BB00A700 -command xyzinfok  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text Ok 
    button $base.xyzclose  -background #C200BB00A700 -command {Window hide .xyzinf}  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -padx 9 -pady 3 -text Close 
    frame $base.cpd18  -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised  -width 30 
    label $base.cpd18.01  -anchor w -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief groove -text X 
    entry $base.cpd18.02  -background #C200BB00A700 -cursor {}  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -width 21 
    frame $base.cpd19  -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised  -width 30 
    label $base.cpd19.01  -anchor w -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief groove -text Z 
    entry $base.cpd19.02  -background #C200BB00A700 -cursor {}  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    frame $base.cpd20  -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised  -width 30 
    label $base.cpd20.01  -anchor w -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief groove -text {Vib X} 
    entry $base.cpd20.02  -background #C200BB00A700 -cursor {}  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    frame $base.cpd22  -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised  -width 30 
    label $base.cpd22.01  -anchor w -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief groove -text {Vib Y} 
    entry $base.cpd22.02  -background #C200BB00A700 -cursor {}  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    frame $base.cpd23  -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised  -width 30 
    label $base.cpd23.01  -anchor w -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief groove -text {Vib Z} 
    entry $base.cpd23.02  -background #C200BB00A700 -cursor {}  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    frame $base.cpd24  -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised  -width 30 
    label $base.cpd24.01  -anchor w -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief groove -text Y 
    entry $base.cpd24.02  -background #C200BB00A700 -cursor {}  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    frame $base.cpd17  -background #C200BB00A700 -borderwidth 1 -height 30 -relief raised  -width 30 
    label $base.cpd17.01  -anchor w -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief groove -text Element 
    entry $base.cpd17.02  -background #C200BB00A700 -cursor {}  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 
    text $base.tex19  -background #C200BB00A700  -font -*-times-medium-r-normal-*-*-*-*-*-*-*  -foreground #000000000000 -relief flat -state disabled 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.xyzok  -x 280 -y 155 -width 83 -height 38 -anchor nw -bordermode ignore 
    place $base.xyzclose  -x 15 -y 155 -width 83 -height 38 -anchor nw -bordermode ignore 
    place $base.cpd18  -x 15 -y 25 -width 105 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd18.01  -in .xyzinf.cpd18 -anchor center -expand 0 -fill none -padx 2 -pady 2  -side left 
    pack $base.cpd18.02  -in .xyzinf.cpd18 -anchor center -expand 1 -fill x -padx 2 -pady 2  -side right 
    place $base.cpd19  -x 255 -y 25 -width 105 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd19.01  -in .xyzinf.cpd19 -anchor center -expand 0 -fill none -padx 2 -pady 2  -side left 
    pack $base.cpd19.02  -in .xyzinf.cpd19 -anchor center -expand 1 -fill x -padx 2 -pady 2  -side right 
    place $base.cpd20  -x 15 -y 70 -width 105 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd20.01  -in .xyzinf.cpd20 -anchor center -expand 0 -fill none -padx 2 -pady 2  -side left 
    pack $base.cpd20.02  -in .xyzinf.cpd20 -anchor center -expand 1 -fill x -padx 2 -pady 2  -side right 
    place $base.cpd22  -x 140 -y 70 -width 105 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd22.01  -in .xyzinf.cpd22 -anchor center -expand 0 -fill none -padx 2 -pady 2  -side left 
    pack $base.cpd22.02  -in .xyzinf.cpd22 -anchor center -expand 1 -fill x -padx 2 -pady 2  -side right 
    place $base.cpd23  -x 255 -y 70 -width 105 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd23.01  -in .xyzinf.cpd23 -anchor center -expand 0 -fill none -padx 2 -pady 2  -side left 
    pack $base.cpd23.02  -in .xyzinf.cpd23 -anchor center -expand 1 -fill x -padx 2 -pady 2  -side right 
    place $base.cpd24  -x 140 -y 25 -width 105 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd24.01  -in .xyzinf.cpd24 -anchor center -expand 0 -fill none -padx 2 -pady 2  -side left 
    pack $base.cpd24.02  -in .xyzinf.cpd24 -anchor center -expand 1 -fill x -padx 2 -pady 2  -side right 
    place $base.cpd17  -x 15 -y 115 -width 105 -height 25 -anchor nw -bordermode ignore 
    pack $base.cpd17.01  -in .xyzinf.cpd17 -anchor center -expand 0 -fill none -padx 2 -pady 2  -side left 
    pack $base.cpd17.02  -in .xyzinf.cpd17 -anchor center -expand 1 -fill x -padx 2 -pady 2  -side right 
    place $base.tex19  -x 0 -y 195 -width 371 -height 25 -anchor nw -bordermode ignore
}

Window show .
Window show .main

main $argc $argv
